package Abstract;

import java.lang.Exception;
import java.lang.String;

/**
* JATLite ConnectionException class
* @see java.lang.Exception
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 
public class ConnectionException extends Exception  {
	public static final int INPUTOPEN = 10000;
	public static final int INPUTREAD = 10001;
	public static final int INPUTCLOSE = 10002;
	
	public static final int OUTPUTOPEN = 11000;
	public static final int OUTPUTWRITE = 11001;
	public static final int OUTPUTCLOSE = 11002;
	
	public static final int SOCKETOPEN = 30000;
	public static final int SOCKETCLOSE = 30001;
	public static final int SOCKETINPUT = 30002;
	
	public static final int SERVERSOCKET = 32000;
	public static final int SERVERSOCKETOPEN = 32001;
	public static final int SERVERSOCKETCLOSE = 32002;
	public static final int SERVERSOCKETMETHOD = 32003;
	public static final int HOSTUNKNOWN = 32004;
	
	public static final int NULLPOINTER = 20000;
	public static final int NULLMSGQUEUE = 20001;
	public static final int NULLCTABLE = 20002;
	public static final int NULLINPUT = 20003;
	public static final int NULLOUTPUT = 20004;
	public static final int NULLADDRESS = 20005;
	
	public static final int MESSAGE = 40000;
	public static final int MSGENDWITH = 40001;
	public static final int MSGLENGTH = 40002;
	
	public static final int THREAD = 50000;
	public static final int THREADSTART = 50001;
	public static final int THREADCLOSE = 50002;
	public static final int RECEIVERINIT = 50003;

	public static final int ADDRESSNOTFOUND = 60000;
	public static final int SECURITYCHECKFAIL = 60001;
	
	int _code = 0;
	
	/**
	* Default Constructor without Error Message
	*/
	public ConnectionException()  {
		super();
	}
	
	/**
	* Constructor which passes Error Message
	* @param s Error Message
	*/
	public ConnectionException(String s)  {
		super(s);
	}
	
	/**
	  * Constructor with error code
	  * @param code Integer error code
	  */
	public ConnectionException(int code)  {
		super(Integer.toString(code));
		_code = code;
	}		  
	
	public int getCode()  {
		return _code;
	}	
}			