package KQMLLayer.Example.SASyncApplet;

import Abstract.*;
import BaseLayer.*;
import KQMLLayer.*;

import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;


/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class SASyncAppletExample extends KQMLAgentAction  {
	
	// applet communication
	SASyncApplet _applet;	
	
	public SASyncAppletExample(Address hostaddr,String id,SASyncApplet applet)   {
		super(id);
		_applet = applet;
			
		try  {	
			// For convenience, addressTable would be define first, then
			// the security will be created. Order is important.
			// If the order is reverse, you should use setAddressTable()
			// method of Security to set address table
			_addresses = new BAddressTable();
			_addresses.addAddress(hostaddr);
			// add my address to the address book only as a client
			_addresses.addAddress(new Address(id,null,-1,"BRecvThread","Client"));
		
			_security = new KQMLSecurity(_addresses);
			_connections = new BConnectionTable();
			_queue = new BMessageBuffer();
			_endWith = '\004';
			_durationTime = -1;
			
			createReceiverThread(hostaddr.getID(),Thread.NORM_PRIORITY);
		} catch (Exception e)  {
System.out.println(e.toString());		
		}		
	}

	public void processMessage(String a,Object obj)  {
		// no implementation
	}	
	
	protected boolean Act(Object o)   {
		try  {
			KQMLmessage kqml = new KQMLmessage((String)o);
			
			////////////////////////////////
			// use performative,		
			// invoke appropriate method 
			////////////////////////////////
			
			// For this example, agentFrame will echo the message to the text area
			_applet.processMessage(kqml);
			String perf = kqml.getValue("performative");
			/////////////////////////////////////////
			if(perf.equals("disconnected"))  {
				String args[] = new String[1];
				args[0] = kqml.getValue("sender");
				_connections.removeConnection(args[0]);
			}	
		} catch (ParseException e)  {
		}	
		return true;
	}
}	
		