package KQMLLayer;

import java.util.*; 
import java.io.*; 

  /** KQMLList is representation of KQML list and a parser of 
      KQML list 
  */
/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <mailto:raquet@cdr.stanford.edu>Andreas Raquet</A>
*  @version Java(tm) 1.1
*/

public class KQMLList extends KQMLExpression {
  public Vector expressions;
  /** KQMLList constructor
      @param exprs Vector of KQMLExpression
  */
  public KQMLList(Vector exprs) {expressions=exprs; }
  /** see KQMLExpression
   */
  public static KQMLExpression parse(KQMLStreamTokenizer parser) throws IOException,ParseException { 
    parser.consume('(');
    Vector expressions=new Vector();
    while (!parser.testToken(')')) {
      KQMLExpression expr = KQMLExpression.parse(parser);
      expressions.addElement(expr);}
    parser.consume(')');
    return new KQMLList(expressions);
  }

  public String toString() { 
    StringBuffer list = new StringBuffer(128);
    list.append("(");
    Enumeration enum = expressions.elements();
    while(enum.hasMoreElements()) {
       list.append(enum.nextElement().toString()).append(" ");}
    list.append(")");
    return list.toString(); 
  }
}