package KQMLLayer;

import java.net.*;
import java.io.*;
import java.util.*;

import Abstract.*;
import BaseLayer.*;

/**
* KQMLServerThread is a thread which accept() connection from the other
* agents. Then it will generate KQMLRecvThread to listen and send message
* @see KQMLLayer.KQMLRecvThread
* @see BaseLayer.BServerThread
* <P>
*/
/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class KQMLServerThread extends BServerThread   {

	/**
	* Default constructor
	*/
	public KQMLServerThread()  {
		super();
	}
		 
  /**
  * Constructor using Address object
  * @param address Address object which contains port number
  * @param connections connection table
  * @param mesg the message queue
  * @param security Security object to be used to check connection protocol
  */
  public KQMLServerThread(Address address,
  											 ConnectionTable connections,
  										   MessageBuffer mesg,
  										   Security security)
	throws ConnectionException,UnknownHostException,IOException	   {
		super(address,connections,mesg,security);
	}	

	/**
	* Create receiver thread using the socket, accepted by the 'run()' method.
	* @param socket Socket, accepted by the ServerSocket
	* @exception ConnectionException if occurs
	*/
  protected synchronized void createReceiverThread(Socket socket)  {
  	try  {
			BRecvThread c = new KQMLRecvThread(socket,
									Thread.NORM_PRIORITY,_myaddress,_connections, _queue,_security);

			// do not forget to set end with character if it is not '\n'					
			c.setEndWith(_endWith);					
			if(_durationTime != -1)  {
				c.setDurationTime(_durationTime);
			}	
				
			c.start();
		} catch (ConnectionException c)  {
		}	
  } 	
  
}