package ProtocolLayer.Example.CAD;

import Abstract.*;
import BaseLayer.*;
import KQMLLayer.*;
import RouterLayer.Router.*;
import RouterLayer.AgentClient.*;
import ProtocolLayer.*;
import ProtocolLayer.Example.IPRCApplet.*;

import java.net.*;
import java.io.*;
import java.util.*;

/**
* A RouterClient example. This example implements the Act(Object) and processMessage(String,String[]),
* those are declared as abstract in the RouterClientAction class. The Act(Object) method will pass
* the received message to the RCApplet object to display the message.
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class CADAgentAction extends IPRCActionExample  {

	public CADAgentAction()  {
		super();
	}

	/**
	* Normally invoked by a stand-alone agent
	*/
	public CADAgentAction(Address myaddress,
						   Address routeraddress,
						   Address registraraddress,
						   int durationTime)  {
		super(myaddress,routeraddress,registraraddress,durationTime);
	}

	/**
	* Will be invoked by an aglet
	*/
	public CADAgentAction(Address routeraddress,Address registraraddress,int durationTime)  {
		super(routeraddress,registraraddress,durationTime);
	}



	/**
	* Applet Callback implementation. Write CAD objects to the output stream
	*/
  public void FTPStore(String fileName,/*OutputStream out*/ObjectOutputStream out) throws ConnectionException  {
  	((CADAgentFrame)_agentFrame).FTPStore(fileName,out);
  }

	/**
	* Applet append callback implementation.
	*/
  public void FTPAppend(String fileName,/*OutputStream out*/ObjectOutputStream out) throws ConnectionException  {
  	((CADAgentFrame)_agentFrame).FTPAppend(fileName,out);
  }

	/**
	* Applet Callback implementation
	*/
  public void FTPRetrieve(String fileName,/*InputStream in*/ObjectInputStream in) throws ConnectionException {
  	((CADAgentFrame)_agentFrame).FTPRetrieve(fileName,in);
  }


}
