package ProtocolLayer.Example.CAD;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;
import java.io.*;

import Abstract.*;
import ProtocolLayer.*;
import ProtocolLayer.Example.IPRCApplet.*;
/*
/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class CADApplet extends Applet implements Runnable,ButtonBarApplet {

		// script file path for communication with router
		// will be passed by applet parameter
		String _scriptFilePath = null;

		String _helpFileURL = null;

		// for applets
		Address _routerAddress = null;
		Address _registrarAddress = null;

		// for applet example
//		FTPCon _appletFTPCon = null;
		Vector _cons;

		// false for applet case
		boolean _standAlone = true;

		CADAgentFrame _agentFrame = null;

		static final int TOLEFT = 1;
		static final int TORIGHT = 2;
		static final int UP = 3;
		static final int DOWN = 4;
		static final int ZOOMIN = 5;
		static final int ZOOMOUT = 6;

		MediaTracker _tracker;
		ViewCanvas _canvas;
		Image[] _image;
		int _isMoving = 0;

		int _tipHeight,_tipWidth,_imageX,_imageY;
		Font _tipFont = new Font("Dialog",Font.PLAIN,10);
		String _tip = null;

		Thread _fetcher;

		ButtonBar _upperBar; //,_lowerBar;

		public CADApplet()  {
		}

		public ViewCanvas getCanvas()  {
			return _canvas;
		}

    public void init() {

    	URL url = getDocumentBase();

/*  For installation test, this isn't appropriate.
			String hostname = url.getHost();

    	// check whether the applet is loaded from file or http
    	// if loaded from file, stand alone is assumed.
    	// for stand-alone agent, address information will be included in the ScriptFileParameter
    	if((hostname != null) && (!hostname.equals("")))  {
    		_standAlone = false;
    	}
_standAlone = false;
    	if(_standAlone)  {
    		_scriptFilePath = getParameter("SCRIPTFILEPATH");
    	}
*/
			_scriptFilePath = getParameter("SCRIPTFILEPATH");
			if(_scriptFilePath == null)  {
				_standAlone = false;
    		try  {
		    	String routername = getParameter("RouterName");
    			String host = getParameter("RouterHost");
    			String port = getParameter("RouterPort");
    			String regname = getParameter("RegistrarName");
    			String regport = getParameter("RegistrarPort");
    			String description = getParameter("Description");
    			_helpFileURL = getParameter("HelpFileURL");

	    		if((routername == null) || (host == null) || (port == null) || (regport == null))  {
						showStatus("Invalid Applet Parameters. Check the parameters");
						System.out.println("Invalid Applet Parameters. Check the parameters");

						destroy();
    			}

					// I set CADStandAlone, as the same as file receiver
					String ftpConId = getParameter("FTPConName");
					String ftpConRemotePath = getParameter("RemotePath");
					String ftpConUserName = getParameter("UserName");
					String ftpConHost = getParameter("FTPHost");
					String ftpConPort = getParameter("FTPPort");

					// for extended test from CDR ftp site
					String cdrConId = getParameter("CDRFTPConName");
					String cdrConRemotePath = getParameter("CDRRemotePath");
					String cdrConUserName = getParameter("CDRUserName");
					String cdrConHost = getParameter("CDRFTPHost");
					String cdrConFile = getParameter("CDRFTPCadObject");

					String[] files = new String[1];
					files[0] = cdrConFile;
					FTPCon cdrFTP = new FTPCon(cdrConId,
																		 cdrConRemotePath,
																		 cdrConHost,
																		 21,
																		 cdrConUserName,
																		 "JATLite@cdr",
																		 null,
																		 files,
																		 FTPCon.ISGETMODE | FTPCon.ISAPPLET);

					int ftpportno = 21;
					if(ftpConPort != null)  {
						ftpportno = Integer.valueOf(ftpConPort).intValue();
					}

					FTPCon appletFTPCon = new FTPCon(ftpConId,ftpConRemotePath,ftpConHost,ftpportno,ftpConUserName,null,null,null,0);

					_cons = new Vector();
					_cons.addElement(appletFTPCon);
					_cons.addElement(cdrFTP);

    			_routerAddress = new Address(routername,host,Integer.valueOf(port).intValue(),"MessageRouter",description);
    			_registrarAddress = new Address(regname,host,Integer.valueOf(regport).intValue(),"MessageRouter",description);
    		} catch (Exception e)  {
    			System.out.println("Bad Address file URL " + e.toString());
    			destroy();
    		}
    	}

			_tracker = new MediaTracker(this);

			setFont(_tipFont);
			_tipHeight = getFontMetrics(getFont()).getHeight() + 2;

      setLayout(new BorderLayout());

//    	_canvas = new ViewCanvas();

    	_image = new Image[76];
    	for(int i=0 ; i < 76; i+=4)   {
    		_image[i] = getImage(url,"ProtocolLayer/Example/CAD/image/button" + i + ".gif");
    		_image[i+1] = getImage(url,"ProtocolLayer/Example/CAD/image/button" + (i+1) + ".gif");
    		_image[i+2] = getImage(url,"ProtocolLayer/Example/CAD/image/button" + (i + 2) + ".gif");
    		_image[i+3] = getImage(url,"ProtocolLayer/Example/CAD/image/button" + (i + 3) + ".gif");

    		_tracker.addImage(_image[i],0);
    		_tracker.addImage(_image[i+1],0);
    		_tracker.addImage(_image[i+2],0);
    		_tracker.addImage(_image[i+3],0);

			}

    	try  {
    		showStatus("Button Image Loading...");
		  	_tracker.waitForID(0);
		  	showStatus("Image loading done");
		  } catch (Exception e)  {
		  	System.out.println(e.toString());
		  }

    	_upperBar = new ButtonBar(this,600,44);
    	_upperBar.addButton("Open",_image[0],_image[1],_image[2],_image[3]);
    	_upperBar.addButton("Save",_image[4],_image[5],_image[6],_image[7]);
    	_upperBar.addSpace();
    	// disable open, save button for the applet case
    	if(!_standAlone)  {
    		_upperBar.setPersistentButton("Open",3);
    		_upperBar.setPersistentButton("Save",3);
			}

    	_upperBar.addButton("Connect",_image[8],_image[9],_image[10],_image[11]);
    	_upperBar.addSpace();

    	_upperBar.addButton("Box",_image[12],_image[13],_image[14],_image[15]);
    	_upperBar.addButton("Cylinder",_image[16],_image[17],_image[18],_image[19]);
    	_upperBar.addButton("Cone",_image[20],_image[21],_image[22],_image[23]);
    	_upperBar.addButton("Sphere",_image[24],_image[25],_image[26],_image[27]);
    	_upperBar.addButton("Extrusion",_image[28],_image[29],_image[30],_image[31]);
    	_upperBar.addButton("Axys-sym",_image[32],_image[33],_image[34],_image[35]);
    	_upperBar.addSpace();

			_upperBar.addButton("Help",_image[36],_image[37],_image[38],_image[39]);
    	_upperBar.addSpace();


//				    	_lowerBar = new ButtonBar(this,600,40);
    	_upperBar.addButton("To-Left",_image[40],_image[41],_image[42],_image[43]);
    	_upperBar.addButton("Reset",_image[44],_image[45],_image[46],_image[47]);
    	_upperBar.addButton("To-Right",_image[48],_image[49],_image[50],_image[51]);
    	_upperBar.addButton("Up",_image[52],_image[53],_image[54],_image[55]);
    	_upperBar.addButton("Down",_image[56],_image[57],_image[58],_image[59]);
    	_upperBar.addButton("Zoom-Out",_image[60],_image[61],_image[62],_image[63]);
    	_upperBar.addButton("Zoom-In",_image[64],_image[65],_image[66],_image[67]);
    	_upperBar.addButton("Remove",_image[68],_image[69],_image[70],_image[71]);
			_upperBar.addButton("Select",_image[72],_image[73],_image[74],_image[75]);

/*
    	_lowerBar = new ButtonBar(this,600,40);
    	_lowerBar.addButton("To-Left",_image[40],_image[41],_image[42],_image[43]);
    	_lowerBar.addButton("Reset",_image[44],_image[45],_image[46],_image[47]);
    	_lowerBar.addButton("To-Right",_image[48],_image[49],_image[50],_image[51]);
    	_lowerBar.addButton("Up",_image[52],_image[53],_image[54],_image[55]);
    	_lowerBar.addButton("Down",_image[56],_image[57],_image[58],_image[59]);
    	_lowerBar.addButton("Zoom-In",_image[60],_image[61],_image[66],_image[67]);
    	_lowerBar.addButton("Zoom-Out",_image[64],_image[65],_image[66],_image[67]);
    	_lowerBar.addButton("Remove",_image[68],_image[69],_image[70],_image[71]);
			_lowerBar.addButton("Select",_image[72],_image[73],_image[74],_image[75]);

*/
			add(_upperBar,"North");
// 			add(_lowerBar,"South");
			add(_canvas,"Center");

	    resize(650,450);
   	}

   	protected Frame getFrame()  {
    	Object frame = getParent();
       	while (!(frame instanceof Frame))
          	frame = ((Component) frame).getParent();
        return (Frame)frame;
   	}

   	public void processButtonReleased(String id,MouseEvent e)  {
   		_isMoving = 0;
    	if(id.equals("Open"))  {
    		openAction();
			}
    	else
    	if(id.equals("Save"))  {
    		saveAction();
    	}
    	else
    	if(id.equals("Box"))  {
    		ObjectFrame o = new ObjectFrame(_canvas,CADObject.BOX);
    	}
    	else
    	if(id.equals("Cylinder"))  {
    		ObjectFrame o = new ObjectFrame(_canvas,CADObject.CYLINDER);
    	}
    	else
    	if(id.equals("Cone"))  {
    		ObjectFrame o = new ObjectFrame(_canvas,CADObject.CONE);
    	}
    	else
    	if(id.equals("Sphere"))  {
    		ObjectFrame o = new ObjectFrame(_canvas,CADObject.SPHERE);
    	}
    	else
    	if(id.equals("Extrusion"))  {
    		ExtrusionFrame f = new ExtrusionFrame(_canvas);
    	}
    	else
    	if(id.equals("Axys-sym"))  {
    		AxisSymFrame f = new AxisSymFrame(_canvas);
    	}
    	else
    	if(id.equals("Select"))  {
    		// toggle
    		boolean selmode = _canvas.getSelectMode();
    		if(selmode == true)  {
    			_canvas.setSelectMode(false);
//    			_lowerBar.setPersistentButton("Select",-1);
    			_upperBar.setPersistentButton("Select",-1);

    		}
    		else  {
    			_canvas.setSelectMode(true);
//    			_lowerBar.setPersistentButton("Select",2);
    			_upperBar.setPersistentButton("Select",2);


    		}
    	}
    	else
    	if(id.equals("Remove"))  {
    		_canvas.removeCADObject();
    	}
    	else
    	if(id.equals("Reset"))  {
    		_canvas.reset();
    	}
			else
    	if(id.equals("Help"))  {
				try  {
					if(_helpFileURL != null)  {
						getAppletContext().showDocument(new URL(_helpFileURL),"_blank");
					}
				}  catch (Exception eeee)  {}
    	}
    	else
	if(id.equals("Connect"))  {
   			try  {
		   		if(_standAlone)  {
  //  				_agentFrame = new CADAgentFrame(this,_scriptFilePath);
    			}
    			else  {
//	   				_agentFrame = new CADAgentFrame(this,_routerAddress,_registrarAddress,_cons);
    			}
    				// set connect button disabled.
    			_upperBar.setPersistentButton("Connect",3);
   			}  catch (Exception ee)  {
   				System.out.println(ee.toString());
   			}
   		}
	  }


   	protected void openAction()  {
			FileDialog fd = new FileDialog(getFrame(),"Open CAD File");
			fd.show();
			String dir = fd.getDirectory();
			String file = fd.getFile();
			String filepath = dir + file;
			try  {
				DataInputStream in = new DataInputStream(new FileInputStream(filepath));
				//_canvas.readObjects(file,in);
				in.close();
			}  catch (Exception ee)  {
				MessageBox b = new MessageBox("Open file error <" + file + "> " + ee.toString(),getFrame());
			}
   	}

   	protected void saveAction()  {
			FileDialog fd = new FileDialog(getFrame(),"Save CAD File",FileDialog.SAVE);
			fd.show();
			String dir = fd.getDirectory();
			String file = fd.getFile();
			String filepath = dir + file;
			try  {
				DataOutputStream out = new DataOutputStream(new FileOutputStream(filepath,false));
				//_canvas.writeObjects(file,out);
				out.close();
			}  catch (Exception ee)  {
				//MessageBox b = new MessageBox("Save file error <" + file + "> " + ee.toString(),getFrame());
			}
   	}

	  public void processButtonPressed(String id,MouseEvent e)  {
	   	if(id.equals("To-Left"))  {
    		_isMoving = TOLEFT;
    	}
			else
    	if(id.equals("Zoom-In"))  {
    		_isMoving = ZOOMIN;
    	}
    	else
    	if(id.equals("Zoom-Out"))  {
    		_isMoving = ZOOMOUT;
    	}
    	else
    	if(id.equals("To-Right"))  {
    		_isMoving = TORIGHT;
    	}
    	else
    	if(id.equals("Up"))  {
    		_isMoving = UP;
    	}
    	else
    	if(id.equals("Down"))  {
    		_isMoving = DOWN;
    	}
	  }


    public void run() {
			try {
	  	  Thread.currentThread().setPriority(Thread.NORM_PRIORITY);
	  	  while(true)  {
	  	  	switch(_isMoving)  {
	  	  		case TOLEFT: _canvas.translate(-2,0); break;
	  	  		case TORIGHT: _canvas.translate(2,0); break;
	  	  		case UP: _canvas.translate(0,-1); break;
	  	  		case DOWN: _canvas.translate(0,1); break;
	  	  		case ZOOMIN: _canvas.zoom(1.01f); break;
	  	  		case ZOOMOUT: _canvas.zoom(0.99f); break;
					}
					_fetcher.sleep(10);
				}
			} catch(Exception e) {
			}
    }

		public void addCADObject(CADObject obj)  {
			_canvas.addCADObject(obj);
		}

		// release disabled condition. Invoked by destroying IPRCFrame.
		public void releaseConnectButton()  {
 			_upperBar.setPersistentButton("Connect",-1);
 			_agentFrame = null;
		}

    public void start() {
    	_fetcher = new Thread(this);
    	_fetcher.start();
	  }

    public void stop() {
    	if((_fetcher != null) && (_fetcher.isAlive()))  {
    		_fetcher.stop();
    		_fetcher = null;
    	}

    	if(_agentFrame != null)  {
    		_agentFrame.dispose();
    		_agentFrame = null;
    	}
    	destroy();
    }
}
