package ProtocolLayer.Example.CAD;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class CADAppletHelp extends Applet implements ButtonBarAppletOld {

		MediaTracker _tracker;
		Image[] _image;

		int _tipHeight,_tipWidth,_imageX,_imageY;
		Font _tipFont = new Font("Dialog",Font.PLAIN,10);
		String _tip = null;

		ButtonBarOld _upperBar; //,_lowerBar;

		String opendoc,savedoc,connectdoc,boxdoc,cylinderdoc,
		 conedoc,spheredoc,extrusiondoc,axissymdoc,helpdoc,
		 leftdoc,adjustdoc ,rightdoc,updoc,downdoc,zoomoutdoc,
		 zoomindoc,removedoc,selectdoc;

		 String windowName;



		public CADAppletHelp()  {
		}

    public void init() {
			// document files
			opendoc = getParameter("OPEN");
			savedoc = getParameter("SAVE");
			connectdoc = getParameter("CONNECT");
			boxdoc = getParameter("BOX");
			cylinderdoc = getParameter("Cylinder");
			conedoc = getParameter("conedoc");
			spheredoc = getParameter("SPHERE");
			extrusiondoc = getParameter("EXTRUSION");
			axissymdoc = getParameter("AXISSYM");
			helpdoc = getParameter("HELP");
			leftdoc = getParameter("LEFT");
			rightdoc = getParameter("RIGHT");
			adjustdoc = getParameter("ADJUST");
			updoc = getParameter("UP");
			downdoc = getParameter("DOWN");
			zoomindoc = getParameter("ZOOMIN");
			zoomoutdoc = getParameter("ZOOMOUT");
			removedoc = getParameter("REMOVE");
			selectdoc = getParameter("SELECT");
			windowName = getParameter("DOCWINDOW");

    	URL url = getDocumentBase();

    	_tracker = new MediaTracker(this);

			setFont(_tipFont);
			_tipHeight = getFontMetrics(getFont()).getHeight() + 2;

      setLayout(new BorderLayout());

    	_image = new Image[76];
    	for(int i=0 ; i < 76; i+=4)   {
    		_image[i] = getImage(url,"ProtocolLayer/Example/CAD/image/button" + i + ".gif");
    		_image[i+1] = getImage(url,"ProtocolLayer/Example/CAD/image/button" + (i+1) + ".gif");
    		_image[i+2] = getImage(url,"ProtocolLayer/Example/CAD/image/button" + (i + 2) + ".gif");
    		_image[i+3] = getImage(url,"ProtocolLayer/Example/CAD/image/button" + (i + 3) + ".gif");

    		_tracker.addImage(_image[i],0);
    		_tracker.addImage(_image[i+1],0);
    		_tracker.addImage(_image[i+2],0);
    		_tracker.addImage(_image[i+3],0);

			}

    	try  {
    		showStatus("Button Image Loading...");
		  	_tracker.waitForID(0);
		  	showStatus("Image loading done");
		  } catch (Exception e)  {
		  	System.out.println(e.toString());
		  }

    	_upperBar = new ButtonBarOld(this,600,44);
    	_upperBar.addButton("Open",_image[0],_image[1],_image[2],_image[3]);
    	_upperBar.addButton("Save",_image[4],_image[5],_image[6],_image[7]);
    	_upperBar.addSpace();

    	_upperBar.addButton("Connect",_image[8],_image[9],_image[10],_image[11]);
    	_upperBar.addSpace();

    	_upperBar.addButton("Box",_image[12],_image[13],_image[14],_image[15]);
    	_upperBar.addButton("Cylinder",_image[16],_image[17],_image[18],_image[19]);
    	_upperBar.addButton("Cone",_image[20],_image[21],_image[22],_image[23]);
    	_upperBar.addButton("Sphere",_image[24],_image[25],_image[26],_image[27]);
    	_upperBar.addButton("Extrusion",_image[28],_image[29],_image[30],_image[31]);
    	_upperBar.addButton("Axys-sym",_image[32],_image[33],_image[34],_image[35]);
    	_upperBar.addSpace();

			_upperBar.addButton("Help",_image[36],_image[37],_image[38],_image[39]);
    	_upperBar.addSpace();

    	_upperBar.addButton("To-Left",_image[40],_image[41],_image[42],_image[43]);
    	_upperBar.addButton("Reset",_image[44],_image[45],_image[46],_image[47]);
    	_upperBar.addButton("To-Right",_image[48],_image[49],_image[50],_image[51]);
    	_upperBar.addButton("Up",_image[52],_image[53],_image[54],_image[55]);
    	_upperBar.addButton("Down",_image[56],_image[57],_image[58],_image[59]);
    	_upperBar.addButton("Zoom-Out",_image[60],_image[61],_image[62],_image[63]);
    	_upperBar.addButton("Zoom-In",_image[64],_image[65],_image[66],_image[67]);
    	_upperBar.addButton("Remove",_image[68],_image[69],_image[70],_image[71]);
			_upperBar.addButton("Select",_image[72],_image[73],_image[74],_image[75]);

			add("Center",_upperBar);
	    resize(650,60);
   	}

   	public void processButtonPressed(String id,int x,int y)  {
    	if(id.equals("Open"))  {
    		showHelper(opendoc);
			}
    	else
    	if(id.equals("Save"))  {
    		showHelper(savedoc);
    	}
    	else
    	if(id.equals("Box"))  {
    		showHelper(boxdoc);
    	}
    	else
    	if(id.equals("Cylinder"))  {
    		showHelper(cylinderdoc);
    	}
    	else
    	if(id.equals("Cone"))  {
    		showHelper(conedoc);
    	}
    	else
    	if(id.equals("Sphere"))  {
    		showHelper(spheredoc);
    	}
    	else
    	if(id.equals("Extrusion"))  {
    		showHelper(extrusiondoc);
    	}
    	else
    	if(id.equals("Axys-sym"))  {
    		showHelper(axissymdoc);
    	}
    	else
    	if(id.equals("Select"))  {
    		showHelper(selectdoc);
    	}
    	else
    	if(id.equals("Remove"))  {
    		showHelper(removedoc);
    	}
    	else
	   	if(id.equals("To-Left"))  {
    		showHelper(leftdoc);
    	}
    	else
    	if(id.equals("Reset"))  {
    		showHelper(adjustdoc);
    	}
    	else
    	if(id.equals("To-Right"))  {
    		showHelper(rightdoc);
    	}
    	else
    	if(id.equals("Up"))  {
    		showHelper(updoc);
    	}
    	else
    	if(id.equals("Down"))  {
    		showHelper(downdoc);
    	}
    	else
    	if(id.equals("Zoom-In"))  {
    		showHelper(zoomindoc);
    	}
    	else
    	if(id.equals("Zoom-Out"))  {
    		showHelper(zoomoutdoc);
    	}
    	else
    	if(id.equals("Help"))  {
    		showHelper(helpdoc);
    	}
    	else
    	if(id.equals("Connect"))  {
    		showHelper(connectdoc);
   		}
	  }

   	public void processButtonReleased(String bname,int x,int y)  {}

  	protected void showHelper(String url)  {
			try  {
				// "second" parameter should be defined in the Frame main window
				getAppletContext().showDocument(new URL(url),windowName);
			}  catch (Exception eeee)  {}
		}
}
