package ProtocolLayer.Example.CAD;

import java.awt.*;
import java.awt.event.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class ColorPicker extends Canvas  implements MouseListener  {
	
	Color[] _color;
	Rectangle[] _rect;
	
	public ColorPicker()  {
	
		addMouseListener((MouseListener)this);
		
		_rect = new Rectangle[13];
		int inset = 7;
		int size = 30;
		
		for(int i=0; i < 12; i+=2)  {
			_rect[i] = new Rectangle((i/2)*size+ inset,inset,size - inset,size - inset);
			_rect[i+1] = new Rectangle((i/2)*size + inset, size + inset,size - inset,size - inset);
		}
		
		_rect[12] = new Rectangle(size*6 + 10,size/2,size,size); 
		
		_color = new Color[13];
		_color[0] = Color.black;
		_color[1] = Color.darkGray;
		_color[2] = Color.white;
		_color[3] = Color.lightGray;
		_color[4] = Color.cyan;
		_color[5] = Color.green;
		_color[6] = Color.magenta;
		_color[7] = Color.orange;
		_color[8] = Color.pink;
		_color[9] = Color.red;
		_color[10] = Color.yellow;
		_color[11] = Color.blue;
		_color[12] = Color.black;
		
		setSize(size*7 + inset, (size+inset)*2);
  }	

	public void setPickedColor(Color c)  {
		_color[12] = c;
	}
	
	public Color getPickedColor()  {
		return _color[12];
	}
	
  public void mousePressed(MouseEvent e) {
  }
    
  public void mouseReleased(MouseEvent e)  {
  }
    
  public void mouseClicked(MouseEvent e)  {
		for(int i=0; i < 12; i++)  {
			if(_rect[i].contains(e.getPoint()))  {
				_color[12] = _color[i];
				break;
			}
		}		
		repaint();	
  }
    
    
  public void mouseEntered(MouseEvent e)  {
  }
   
  public void mouseExited(MouseEvent e)  {
  }
	
	public void paint(Graphics g)  {	
		Color old = g.getColor();
		g.setColor(Color.black);
		g.drawRect(2,2,size().width-4,size().height-4);
		g.fillRect(_rect[0].x,_rect[0].y,_rect[0].width,_rect[0].height);
		
		g.setColor(_color[1]);
		g.fillRect(_rect[1].x,_rect[1].y,_rect[1].width,_rect[1].height);

		g.setColor(_color[2]);
		g.fillRect(_rect[2].x,_rect[2].y,_rect[2].width,_rect[2].height);

		g.setColor(_color[3]);
		g.fillRect(_rect[3].x,_rect[3].y,_rect[3].width,_rect[3].height);

		g.setColor(_color[4]);
		g.fillRect(_rect[4].x,_rect[4].y,_rect[4].width,_rect[4].height);

		g.setColor(_color[5]);
		g.fillRect(_rect[5].x,_rect[5].y,_rect[5].width,_rect[5].height);

		g.setColor(_color[6]);
		g.fillRect(_rect[6].x,_rect[6].y,_rect[6].width,_rect[6].height);

		g.setColor(_color[7]);
		g.fillRect(_rect[7].x,_rect[7].y,_rect[7].width,_rect[7].height);

		g.setColor(_color[8]);
		g.fillRect(_rect[8].x,_rect[8].y,_rect[8].width,_rect[8].height);

		g.setColor(_color[9]);
		g.fillRect(_rect[9].x,_rect[9].y,_rect[9].width,_rect[9].height);

		g.setColor(_color[10]);
		g.fillRect(_rect[10].x,_rect[10].y,_rect[10].width,_rect[10].height);

		g.setColor(_color[11]);
		g.fillRect(_rect[11].x,_rect[11].y,_rect[11].width,_rect[11].height);
		
		g.setColor(_color[12]);
		g.fillRect(_rect[12].x,_rect[12].y,_rect[12].width,_rect[12].height);
		
		g.setColor(Color.black);
		
		for(int i=0; i < 13 ; i++)  {
			g.drawRect(_rect[i].x,_rect[i].y,_rect[i].width,_rect[i].height);
		}	
		g.setColor(old);
	}
	
	public void update(Graphics g) {
		Color old = g.getColor();
		g.setColor(_color[12]);
		g.fillRect(_rect[12].x,_rect[12].y,_rect[12].width,_rect[12].height);
		g.setColor(Color.black);
		g.drawRect(_rect[12].x,_rect[12].y,_rect[12].width,_rect[12].height);
		g.setColor(old);
	}		

}