package ProtocolLayer.Example.CAD;


import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class ImgButton  /*extends Canvas implements MouseListener */ {
	
		Image[] _image = null;
		
		String _id = null;
		int _currentState = 0;  // 0 for default 1 for active 2 for clicked 3 for disabled
		boolean _disable = false;
//		CADApplet _parent;
		ButtonBar _parent;
		Rectangle _box;
		Rectangle _tipRect = new Rectangle(0,0,0,0);
		int _persistentMode = -1; // -1 is not persistent mode
						
		public ImgButton(String label,
										 Image[] img,
									   ButtonBar parent)  {
			_id = label;									   
			_image = new Image[4];
			
			_image[0] = img[0];
			_image[1] = img[1];
			_image[2] = img[2];
			_image[3] = img[3];

			_parent = parent;
		}
	
		public ImgButton(String label,
										 Image imgd,
										 Image imga,
										 Image imgc,
										 Image imgi,
									   ButtonBar parent)  {
			_id = label;									   
			_image = new Image[4];
			
			_image[0] = imgd;
			_image[1] = imga;
			_image[2] = imgc;
			if(imgi == null)  {
				_image[3] = imgd;
			}
			else  {
				_image[3] = imgi;
			}		

			_parent = parent;
		}
	
		public void setPersistentMode(int mode)  {
			_persistentMode = mode;
		}
		
		public void disable()  {
			_persistentMode = 3;
		}	
		
		public boolean isDisabled()  {
			if(_persistentMode == 3)  {
				return true;
			}
			return false;
		}
					
		public void setTipRectangle(int startx,int starty,int width,int height)  {
			_tipRect.x = startx;
			_tipRect.y = starty;
			_tipRect.width = width;
			_tipRect.height = height;
		}
		
		public Rectangle getTipRectangle()  {
			return _tipRect;
		}	
			

		public String getName()  {
			return _id;
		}
			
		public void setBounds(Rectangle r)  {
			_box = r;
		}	

		public void setParent(ButtonBar b) {
			_parent = b;
		}	

		public boolean contains(Point p)  {
			return _box.contains(p);
		}	

		public boolean contains(int x,int y)  {
			return _box.contains(x,y);
		}	

		public synchronized void setState(int s)  {
			_currentState = s;
		}

		public int getState()  {
			return _currentState;
		}
			
		public Rectangle getBounds() {
			return _box;
		}		
		
		public int getX()  {
			return _box.x;
		}
		
		public int getWidth()  {
			return _box.width;
		}
		
		public int getHeight()  {
			return _box.height;
		}
				
		public int getY()  {
			return _box.y;
		}		

		public Image getImage()  {
			if(_persistentMode == -1)  {
				return _image[_currentState];
			}
			else  {
				return _image[_persistentMode];
			}		
		}
			
}