package ProtocolLayer.Example.CAD;

import java.awt.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class MatrixPanel extends Panel  {
	TextField _originX;
	TextField _originY;
	TextField _originZ;

	TextField _orientationX;
	TextField _orientationY;
	TextField _orientationZ;
	
	public MatrixPanel()  {
		init();
	}
	
	protected void init()  {
		
		Label o = new Label("Origin:");
		_originX = new TextField("0.0",5);
		_originY = new TextField("0.0",5);
		_originZ = new TextField("0.0",5);
		add(o);
		add(_originX);
		add(_originY);
		add(_originZ);

		Label lo = new Label("Angle:");
		_orientationX = new TextField("0.0",5);
		_orientationY = new TextField("0.0",5);
		_orientationZ = new TextField("0.0",5);
		add(lo);
		add(_orientationX);
		add(_orientationY);
		add(_orientationZ);
	}
	
	public void setOrigin(Point3d origin)  {
		_originX.setText(Float.toString(origin._x));
		_originY.setText(Float.toString(origin._y));
		_originZ.setText(Float.toString(origin._z));
	}
	
	public void setOrientation(Point3d orientation)  {
		_orientationX.setText(Float.toString(orientation._x));
		_orientationY.setText(Float.toString(orientation._y));
		_orientationZ.setText(Float.toString(orientation._z));
	}
	
	public Point3d getOrigin()  {
		Point3d p = null;
		try  {
			String ox = _originX.getText();
			float oxf = Float.valueOf(ox).floatValue();
			String oy = _originY.getText();
			float oyf = Float.valueOf(oy).floatValue();
			String oz = _originZ.getText();
			float ozf = Float.valueOf(oz).floatValue();
			
			p = new Point3d();
			p._x = oxf; p._y = oyf; p._z = ozf;
		}  catch (Exception e)  {
			System.out.println(e.toString());
		}		
		
		return p;
	}	
		
	
	public Point3d getOrientation()  {
		Point3d p = null;
		try  {
			String ox = _orientationX.getText();
			float oxf = Float.valueOf(ox).floatValue();
			String oy = _orientationY.getText();
			float oyf = Float.valueOf(oy).floatValue();
			String oz = _orientationZ.getText();
			float ozf = Float.valueOf(oz).floatValue();
			
			p = new Point3d();
			p._x = oxf; p._y = oyf; p._z = ozf;
		}  catch (Exception e)  {
			System.out.println(e.toString());
		}		
		
		return p;
	
	}		


}