package ProtocolLayer.Example.IPRCApplet;

import java.awt.*;
import java.awt.event.*;
import KQMLLayer.*;

import RouterLayer.AgentClient.Example.RCApplet.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

/**
* Message compose panel
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class IPComposePanel extends Panel implements ActionListener {
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
	Color bkgColor = new Color(210,210,210);
	TextField _performative;
	TextField _receiver;
	TextField _language;
	TextField _ontology;
	TextArea _content;
	Button _send;
	Button _email;
	Button _cancel;
	
	IPRCFrame _agentFrame;
	
	public IPComposePanel(IPRCFrame parent)  {	
		setLayout(new BorderLayout());
		_agentFrame = parent;
		add("Center", composePanels());
	}
	
	
	protected Panel composePanels()  	{
		Panel wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);
		
		Panel performativePanel = newPackerPanel();
		Label performative = new Label("Performative:", Label.RIGHT);
		_performative = new TextField("tell",20);
		performativePanel.add("label;side=right;fill=both", _performative);
		performativePanel.add("label;side=right;fill=both;padx=5;anchor=e", performative);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", performativePanel);
		
		Panel receiverPanel = newPackerPanel();
		Label receiver = new Label("Receiver:", Label.RIGHT);
		_receiver = new TextField("",20);
		receiverPanel.add("label;side=right;fill=both", _receiver);        
		receiverPanel.add("label;side=right;padx=5;fill=both;anchor=e", receiver);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", receiverPanel);
		
		Panel languagePanel = newPackerPanel();
		Label language = new Label("Language:", Label.RIGHT);
		_language = new TextField("KQML",20);
		languagePanel.add("label;side=right;fill=both", _language);        
		languagePanel.add("label;side=right;fill=both;padx=5;anchor=e", language);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", languagePanel);
		
		Panel ontologyPanel = newPackerPanel();
		Label ontology = new Label("Ontology:", Label.RIGHT);
		_ontology = new TextField("",20);
		ontologyPanel.add("label;side=right;anchor=w;fill=both", _ontology);        
		ontologyPanel.add("label;side=right;fill=both;padx=5;anchor=e", ontology);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", ontologyPanel);
		
		
		Panel contentPanel = newPackerPanel();
		Label contentLabel = new Label("Content:");
		contentLabel.setFont(boldFont);
		_content = new TextArea(7,12);
		contentPanel.add("label1;side=top;expand=true;fill=both", contentLabel);    
		contentPanel.add("label;side=top;expand=true;fill=both", _content); 
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", contentPanel);
		
		Panel buttonPanel = newPackerPanel();
		_send = new Button("Send");
		_send.addActionListener(this);
		
		_email = new Button("Email");
		_email.addActionListener(this);
		
		_cancel = new Button("Cancel");
		_cancel.addActionListener(this);
		
		buttonPanel.add("label;side=right;expand=true;fill=both", _cancel);   
		buttonPanel.add("label;side=right;padx=5;expand=true;fill=both", _email); 
		buttonPanel.add("label;side=right;padx=5;expand=true;fill=both", _send); 
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", buttonPanel);
		
		enableButtons(false);
		
		return wholePanel;
	}

				
	public void actionPerformed(ActionEvent evt)  {
			String cmd = evt.getActionCommand();
			
			if("Send".equals(cmd))  {
				_agentFrame.sendMessage(getKQMLString());
			}			
			else
			if("Email".equals(cmd))  {
				_agentFrame.sendEmailMessage(getKQMLString());
			}	
			else if("Cancel".equals(cmd)) {
				_performative.setText("tell");
				_receiver.setText("");
				_language.setText("KQML");
				_ontology.setText("");
				_content.setText("");
			}	
	}		
																			
	public String	getKQMLString() 	{
		String sender = _agentFrame.getMyName();
				
		String kqml = "(";
		kqml = kqml + _performative.getText() + " :sender ";
		kqml = kqml + sender + " :receiver ";
		kqml = kqml + _receiver.getText() + " :language ";
		kqml = kqml + _language.getText();
		if(!_ontology.getText().equals(""))  {
			kqml = kqml + " :ontology " + _ontology.getText();
		}	
		kqml = kqml + " :content (";
		kqml = kqml + _content.getText() + "))";
		return kqml;
	}	
	
	public void setKQMLString(KQMLmessage kqml)   {
		String perf = kqml.getValue("performative");
		String receiver = kqml.getValue("receiver");
		String language = kqml.getValue("language");
		String ontology = kqml.getValue("ontology");
		String content = kqml.getValue("content");
		
		if(perf != null)  {
			_performative.setText(perf);
		}
		else  {
			_performative.setText("");
		}	
		
		if(receiver != null)  {
			_receiver.setText(receiver);
		}
		else  {
			_receiver.setText("");
		}	
		
		
		if(language != null)  {
			_language.setText(language);
		}
		else  {
			_language.setText("");
		}	
		
		
		if(ontology != null)  {
			_ontology.setText(ontology);
		}
		else  {
			_ontology.setText("");
		}	
		
		
		if(content != null)  {
			if(content.startsWith("("))  {
				_content.setText(content.substring(1,content.length() -1));
			}
			else  {
				_content.setText(content);
			}		
		}					
		else  {
			_content.setText("");
		}	

	}
	
	public void enableButtons(boolean tf)  {
		_send.setEnabled(tf);
		_email.setEnabled(tf);
	}
							
	public Insets insets()   	{
    	return new Insets(10, 10, 10, 10);
	}
  
 	private Panel newPackerPanel()	{
		Panel p = new Panel();
		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}	
}	
				