package ProtocolLayer.Example.IPRCApplet;

import Abstract.*;
import BaseLayer.*;
import KQMLLayer.*;
import RouterLayer.Router.*;
import RouterLayer.AgentClient.*;
import ProtocolLayer.*;
import RouterLayer.AgentClient.Example.RCApplet.*;

import java.net.*;
import java.io.*;
import java.util.*;
import features.*;
import webcad_01_0_1.*;

/**
* A RouterClient example. This example implements the Act(Object) and processMessage(String,String[]),
* those are declared as abstract in the RouterClientAction class. The Act(Object) method will pass
* the received message to the RCApplet object to display the message.
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class IPRCActionExample extends IPRouterClientAction  {
/*02/09/2005*/ //  ArmazenadorDeFeatures armazenadorDeFeatures=new ArmazenadorDeFeatures();//20041015 so para no ficar nulo. Depois tira
  DadosDoProjeto dadosDoProjeto = new DadosDoProjeto();

  FramePrincipal framePrincipal;
// since this example use GUI frame
	protected IPRCFrame _agentFrame;

	// set GUI
	public void setRCFrame(IPRCFrame agentFrame)  {
		_agentFrame = agentFrame;
		((IPRouterSecurityWithGUI)_security).setRCFrame(agentFrame);
	}

	public IPRCActionExample()  {
		super();
	}

	/**
	* Normally invoked by a stand-alone agent
	*/
	public IPRCActionExample(Address myaddress,
						   Address routeraddress,
						   Address registraraddress,
						   int durationTime)  {
		super(myaddress,routeraddress,registraraddress,durationTime);

		// override default security with RouterSecurityWithGUI
		_security = new IPRouterSecurityWithGUI(_addresses,null);

		// createServerThread, if it is not an applet
		if(myaddress.getPort() != -1)  {
			createServerThread(myaddress.getID(),Thread.NORM_PRIORITY);
		}
	}
//20041015
        /**
* Normally invoked by a stand-alone agent
*/
public IPRCActionExample(Address myaddress,
                                           Address routeraddress,
                                           Address registraraddress,
                                           int durationTime,/*features.ArmazenadorDeFeatures armazenadorDeFeatures*/FramePrincipal frame1)  {
        super(myaddress,routeraddress,registraraddress,durationTime);
//        this.armazenadorDeFeatures = armazenadorDeFeatures;
        this.framePrincipal = frame1;



        // override default security with RouterSecurityWithGUI
        _security = new IPRouterSecurityWithGUI(_addresses,null);

        // createServerThread, if it is not an applet
        if(myaddress.getPort() != -1)  {
                createServerThread(myaddress.getID(),Thread.NORM_PRIORITY);
        }
}

//20041015
	/**
	* Will be invoked by an aglet
	*/
	public IPRCActionExample(Address routeraddress,Address registraraddress,int durationTime)  {
		super(routeraddress,registraraddress,durationTime);
		// override default security with RouterSecurityWithGUI
		_security = new IPRouterSecurityWithGUI(_addresses,null);
	}

	/**
	* Override the register method of the RouterClientAction to support GUI
	* @param registrar The Router Registrar address
	* @param myaddress My address to be registered
	* @exception ConnectionException for any error occurs during processing this service
	*/
	public synchronized void register(Address registrar,Address myaddress)
	throws ConnectionException  {
		try  {
			_addresses.addAddress(myaddress);
			_addresses.addAddress(registrar);

			// This part has been changed to support GUI
			IPRegistrarSecurityWithGUI rsw =
				new IPRegistrarSecurityWithGUI((RouterSecurity)_security);
			rsw.setRCFrame(_agentFrame);

			RegistrarRecvThread rth = new RegistrarRecvThread(registrar,
																	Thread.NORM_PRIORITY,myaddress,null,null,rsw,getThreadGroup());
			rth.setEndWith(_endWith);
			rth.setDurationTime(10);
			rth.start();
		} catch (Exception e)  {
			throw new ConnectionException(e.toString());
		}
	}

	/**
	  * Override processMessage to show dialog box when performing IP related actions
	  * @param command String - SMTP or FTP
	  * @param obj SMTPCon or FTPCon depends on the command parameter
	  */
  public void processMessage(String command,Object obj)  {
  	if(command.equals("SMTPMessage"))  {
  		if(_agentFrame != null)  {
  			_agentFrame.notifyMessage((String)obj);
  		}
  	}
  	else
  	if(command.equals("FTPMessage"))  {
  		if(_agentFrame != null)  {
  			_agentFrame.notifyMessage((String)obj);
  		}
  	}
  	else
  	if(command.startsWith("SMTP"))  {
  		SMTPCon con = (SMTPCon)obj;
  		if(con == null)  {
  			displayMessage("Can not process message::Null SMTPCon passed");
  		}

  		String error = con.getErrorMessage();
  		if((error == null) || (error.equals("")))  {
  			String[] receivers = con.getReceiverAddresses();
  			String recs = "";
  			if(receivers == null)  {
  				displayMessage("SMTP :: No receivers");
  			}
  			else  {
  				for(int i=0; i < receivers.length; i++)  {
  					recs = recs + receivers[i] + " ";
  				}

  				displayMessage("SMTP to " + recs + " Success");
  			}
  		}
  		else  {
  			displayMessage("SMTPError " + error);
  		}
  	}
  	else
  	if(command.startsWith("FTP"))  {
  		FTPCon con = (FTPCon)obj;
  		if(con == null)  {
  			displayMessage("Can not process message::Null FTPCon passed");
  		}

  		String error = con.getErrorMessage();
  		if((error == null) || (error.equals("")))  {
  			 if(con.isGetMode())  {
  			  	displayMessage("FTP Get Success");
  			 }
  			 else  {
  			 	 displayMessage("FTP Put Success. Check out ComposePanel");
  			 	 _agentFrame.setFTPPutMessage(con);
  			 }
  		}
  		else  {
  			 displayMessage("FTPError " + error);
  		}
  	}
  	else
  	if(command.startsWith("Router"))  {
  		KQMLmessage kqml = (KQMLmessage)obj;
  		displayMessage("Router Error. Refer to Request Panel");
  	}
  }

	protected void displayMessage(String msg)  {
		if(_agentFrame != null)  {
			MessageBox b = new MessageBox(msg,_agentFrame);
                        b.setSize(b.WIDTH*2, b.HEIGHT*2);
                        b.repaint();
		}
		else  {
			System.out.println(msg);
		}
	}

 	/**
 	* Example to display the message to the _agentApplet.
 	*/
 	public boolean Act(Object o)  {
 		String stampmsg = (String)o;
 		try  {
	 		//KQMLmail wrap the KQMLmessage
 			KQMLmail mail = new KQMLmail(stampmsg,_mailQueue.size());

 			// add the mail to the _mailQueue.
 			_mailQueue.addElement(mail);
 			// agentApplet will update the list panel
			_agentFrame.processMessage(mail);

      processRouterMessage(mail.getKQMLmessage());

 		} catch (Exception e)  {
 			displayMessage("Act error :: Refer to Request Panel");
 			if(_agentFrame != null)  {
 				_agentFrame.notifyError(e.toString());
 			}
 			return false;
 		}

 		return true;
  }

	/**
	* Send delete-message message to the Router and update the GUI
	*/
  public void sendDeleteMessage()  {
  	super.sendDeleteMessage();
 		_agentFrame.updateListPanel();
  }

	/**
	* Applet Callback implementation
	*/
  public void FTPStore(String fileName,/*OutputStream out*/ObjectOutputStream out) throws ConnectionException  {
          try {
            System.out.println("Classe FTPPortThread: ");
            System.out.println("");
            this.dadosDoProjeto = framePrincipal.dadosDoProjeto;
            System.out.println("ARMAZENADOR DE FEATURES - IPRCActionExample - Linha 269");
            //framePrincipal.saveAction();
            out.writeObject(this.dadosDoProjeto);
            out.flush();out.close();
          }
          catch (IOException ex) {
          }
/*          PrintWriter output = new PrintWriter(new BufferedWriter(new
         OutputStreamWriter(out)));
          output.write(str);
  output.print(armazenadorDeFeatures);
  output.write("\n Testando a String");
        output.flush();
  	output.close();*/
  }

	/**
	* Applet Callback implementation
	*/
  public void FTPAppend(String fileName,/*OutputStream out*/ObjectOutputStream out) throws ConnectionException  {
    try {
      out.writeObject(dadosDoProjeto);
      out.flush();out.close();
    }
    catch (IOException ex) {
    }


  	/*String str = "Append test. Success";
		PrintWriter output = new PrintWriter(new BufferedWriter(new OutputStreamWriter(out)));
	 	output.write(str);
  	output.flush();
  	output.close();*/
  }

	/**
	* Applet Callback implementation
	*/
  public void FTPRetrieve(String fileName,/*InputStream in*/ObjectInputStream in) throws ConnectionException {
//    try  {
      System.out.println("In CADAgentFrame");
  //    DataInputStream input = new DataInputStream(in);
  //    ObjectInputStream input = new ObjectInputStream(in);
//      this.framePrincipal.getCanvas().readObjects(fileName,/*input*/in);
  //    System.out.println("TIPO CLASSE:"+ in.getClass());
    //  this.framePrincipal.repaint();
    //in.close();
  //   input.close();
//    }  catch (IOException e)  {
//      throw new ConnectionException("IOException while reading CAD objects from " + fileName);
//    }




   try {
      System.out.println("CLASSE IPRCActionExample");
      System.out.println("CLASSE do READ: " + in.getClass());
      System.out.println("CLASSE do readObject :" + in.readObject().getClass());

      Object obj = in.readObject();
      System.out.println("OBJECT - "+ obj.getClass());
      this.framePrincipal.dadosDoProjeto = (DadosDoProjeto) in.readObject();
     System.out.println("Inicio do PAINT");
      this.framePrincipal.repaint();
      in.close();
    }
    catch (ClassNotFoundException ex) {
    }
    catch (IOException ex) {
    }

  System.out.println("Retrieve success");


  /*byte[] buffer = new byte[0x1000];
  	int readlen;
   	BufferedInputStream input = new BufferedInputStream(in,0x1000);
  	String retrieved = null;

  	try  {
			while(true) {
				readlen = in.read(buffer,0,0x1000);
				if(readlen > 0)  {
					retrieved = new String(buffer,0,readlen);
				}

				// end condition.
				if(readlen < 0x1000)  {
					break;
				}

			}

			if(retrieved != null)   {
				displayMessage(retrieved);
			}

		}  catch (Exception e)  {
			System.out.println(e.toString());
		}*/

  //              System.out.println("BUFFER: "+input.getClass());
  }


}
