package ProtocolLayer.Example.IPRCApplet;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.applet.*;
import java.io.*;

import Abstract.*;
import RouterLayer.AgentClient.*;
import RouterLayer.util.*;
import KQMLLayer.*;
import ProtocolLayer.*;

import RouterLayer.AgentClient.Example.RCApplet.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

/**
* IPRouter client applet example
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class IPRCApplet extends Applet {

	public static void main(String args[])	{
  	if(args.length == 1)  {
  		try  {
				IPRCFrame frame = new IPRCFrame(args[0]);
        frame.setVisible(true);
 			
  		} catch (Exception e)  {
  			System.out.println(e.toString());
  		}
  	}
  	else  {
  		System.out.println("AddressFile path should be passed	by an argument");
  		System.exit(0);
  	}	
	
	
	}
	
	// invoked by applet
	public IPRCApplet()  {
	}
		
	public void init()  {	
    try  {
    	String routername = getParameter("RouterName");
    	String host = getParameter("RouterHost");
    	String port = getParameter("RouterPort");
    	String regname = getParameter("RegistrarName");
    	String regport = getParameter("RegistrarPort");
    	String description = getParameter("Description");
    	
	    if((routername == null) || (host == null) || (port == null))  {
				showStatus("Invalid Applet Parameters. Check the parameters");
				System.out.println("Invalid Applet Parameters. Check the parameters");
				
				destroy();
    	}		
	
			String ftpConId = getParameter("FTPConName");
			String ftpConRemotePath = getParameter("RemotePath");
			String ftpConUserName = getParameter("UserName");
			String ftpConHost = getParameter("FTPHost");
			String ftpConPort = getParameter("FTPPort");

			int ftpportno = 21;
			if(ftpConPort != null)  {
				ftpportno = getInt(ftpConPort);
			}
						
			FTPCon appletFTPCon = new FTPCon(ftpConId,ftpConRemotePath,ftpConHost,ftpportno,ftpConUserName,null,null,null,0);
	
    	Address routeraddress = new Address(routername,host,getInt(port),"MessageRouter",description);
    	Address registraraddress = new Address(regname,host,getInt(regport),"MessageRouter",description);
    	
    	
			IPRCFrame frame = new IPRCFrame(routeraddress,registraraddress,appletFTPCon);
      frame.setVisible(true);
    	
    } catch (Exception e) { showStatus(e.toString()); }	
				
  }
		
	protected int getInt(String str)	{
		return (Integer.valueOf(str)).intValue();
	}
		
}		