package ProtocolLayer.Example.IPRCApplet;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.applet.*;
import java.io.*;
import java.net.*;

import Abstract.*;
import RouterLayer.AgentClient.*;
import RouterLayer.util.*;
import KQMLLayer.*;
import ProtocolLayer.*;

import RouterLayer.AgentClient.Example.RCApplet.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

import webcad_01_0_1.*;
/**
* IPRouter client applet example
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class IPRCFrame extends Frame implements ActionListener,WindowListener,ItemListener {
	//GUI variables
        String fileName;
        FramePrincipal controlador;
	protected Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Dialog",Font.PLAIN,12),
				 bigBoldFont = new Font("Times",Font.BOLD,14);

	protected Color	bkgColor = new Color(210,210,210),
					scrlBarColor = new Color(225,225,225);

	protected Panel 	wholePanel, leftPanel, rightPanel, mailList, showArea, controlButtons,
					requestPanel, composePanel, reservePanel, registerPanel,ftpPanel;
	protected TabFolder tf;
	protected IPRequestPanel _reqp;
	protected IPComposePanel _comp;
	protected IPFTPPanel _ftpp;

	protected IPReservePanel _resp;
	protected IPRegisterPanel _regp;
	protected java.awt.List _mailList = new java.awt.List(10,true);
	protected TextArea _showArea = new TextArea("",10,32);
	protected Checkbox _automatic;
	protected int _isAutomatic = 0;

	protected Button _act,_delete,_quit,_show, getFile;

	protected Vector _mails;

	protected static final char deletebit = 'D';
	protected static final char reservebit = 'F';
	protected static final char readbit = ' ';

	protected int	_maxidletime = 1000;

	// STANDALONE APPLICATION SUPPORT:
	//		m_fStandAlone will be set to true if applet is run standalone
	//--------------------------------------------------------------------------
	public boolean m_fStandAlone = false;

	// My address
	protected Address _myAddress = null;

	// Router address
	protected Address _routerAddress = null;

	// Registrar address
	protected Address _registrarAddress = null;

	protected IPRCActionExample _agentAction = null;

	protected Vector _ftpCons = new Vector();

	// Given script file, parse addresses for me, router,registrar and FTP connections
	public IPRCFrame(String scriptFilePath)  {
		super("WebCADbyFeatures Collaborative Design IPLayer Router Client");
		setAddress(scriptFilePath);
		m_fStandAlone	= true;
		init();
	}

	/**
	 * For applet case
	 */
	public IPRCFrame(Address routerAddress,Address registrarAddress,FTPCon con)   {
		super("WebCADbyFeatures Collaborative Design IPLayer Router Client");
		_routerAddress = routerAddress;
		_registrarAddress = registrarAddress;
		if(con != null)  {
			_ftpCons.addElement(con);
		}

		init();
	}

	/**
	 * For applet case
	 */
	public IPRCFrame(Address routerAddress,Address registrarAddress,Vector cons, String fileName1, FramePrincipal controlador1)   {
		super("WebCADbyFeatures Collaborative Design IPLayer Router Client");
                this.controlador = controlador1;
                fileName = fileName1;
		_routerAddress = routerAddress;
		_registrarAddress = registrarAddress;
		if(cons != null)  {
			Enumeration e = cons.elements();
			while(e.hasMoreElements())  {
				_ftpCons.addElement(e.nextElement());
			}
		}

		init();
	}

	protected void setAddress(String scriptFilePath)   {
 		try  {
 			BufferedReader in = new BufferedReader(new FileReader(new File(scriptFilePath)));

			while(true)  {
				String line = in.readLine();
				if(line == null)  break;

				String next;

				if(line.startsWith("#"))  {
				}
				else
				if(line.startsWith("MyAddress"))  {
					next = in.readLine();
					_myAddress = new Address(next);
				}
				else
				if(line.startsWith("RouterAddress"))  {
					next = in.readLine();
					_routerAddress = new Address(next);
				}
				else
				if(line.startsWith("RouterRegistrarAddress"))  {
					next = in.readLine();
					_registrarAddress = new Address(next);
				}
				else
				if(line.startsWith("MaxIdleTime"))   {
					next = in.readLine();
					_maxidletime = getInt(next);
				}
				else
				// FTP Put connections
				if(line.startsWith("FTPCon"))  {
					addFTPConFromFile(in);
				}
			}
			in.close();
		}  catch (Exception e)  {
			System.out.println(e.toString());
		}
	}

	protected void addFTPConFromFile(BufferedReader in)  throws IOException  {
		String id = null;
		String remotePath = null;
		String host = null;
		String port = "21";
		String username = null;
		String password = null;
		String localPath = null;

		try  {
			while(true)  {
				String line = in.readLine();

				if(line == null)  {
					FTPCon con = new FTPCon(id,remotePath,host,getInt(port),username,password,localPath,null,0);
					_ftpCons.addElement(con);
					return;
				}
				else
				if(line.startsWith("Name"))  {
					id = in.readLine();
				}
				else
				if(line.startsWith("RemotePath"))  {
					remotePath = in.readLine();
				}
				else
				if(line.startsWith("Host"))  {
					host = in.readLine();
				}
				else
				if(line.startsWith("Port"))  {
					port = in.readLine();
				}
				else
				if(line.startsWith("UserName"))  {
					username = in.readLine();
				}
				else
				if(line.startsWith("Password"))  {
					password = in.readLine();
				}
				else
				if(line.startsWith("LocalDirectory"))  {
					localPath = in.readLine();
				}
				else
				if(line.equalsIgnoreCase("FTPCon"))  {
					FTPCon con = new FTPCon(id,remotePath,host,getInt(port),username,password,localPath,null,0);
					_ftpCons.addElement(con);
					id = null; remotePath = null; host = null; port = "21"; username = null; password = null; localPath = null;
				}
			}
		}	 catch (Exception e)  {
			throw new IOException(e.toString());
		}
	}

	public void init()   {
		try  {
			setSize(800,530);
			setFont(normFont);
			add("Center", JATPanels(fileName, controlador));
   		setVisible(true);

 		} catch (Exception e)  {
 			System.out.println(e.toString());
 		}
	}

	protected void createAgentAction_ORIG(String id,String password,String email)
		throws ConnectionException {
System.out.println(id+password+email);
		try  {
    	if(m_fStandAlone)  {
System.out.println("Stand alone");
          _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime);
		    // myaddress may be changed
	  	  _myAddress = _agentAction.getMyAddress();

			}
			else  {
				// from request panel
				// if it is from register panel, _myAddress is already set
				if((id !=null) && (password != null))  {
					String descrip = "(agent-info :password " + password;
					if((email != null) && (!email.equals("")))  {
						descrip = descrip + " :email " + email;
					}
					descrip = descrip + ")";
		    	_myAddress = new Address(id, "null", -1, "MessageRouter",descrip);
				}
                          _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime);
			}
System.out.println("AgentAction Created");
		  _mails = _agentAction.getMailQueue();
		  _agentAction.setRCFrame(this);
		  _agentAction.setPriority(Thread.NORM_PRIORITY);

		} catch (Exception e)  {
			throw new ConnectionException(e.toString());
		}
	}

	public String getMyName()  	{
		return _myAddress.getID();
	}

	public Address getMyAddress()  {
		return _myAddress;
	}

	public Address getRouterAddress()  {
		return _routerAddress;
	}

	public Address getRegistrarAddress() {
		return _registrarAddress;
	}

 public void processMessage(Object o)  	{
   KQMLmail mail = (KQMLmail)o;
   String id = mail.getString();
   _mailList.add(id);
   KQMLmessage kqml = mail.getKQMLmessage();
   String perf = kqml.getValue("performative");
   if((perf.equals("agent-address")) || (perf.equals("registered-agent")))  {
     _reqp.notifyMessage(kqml.getReadString());
   }

   if(!_delete.isEnabled())  {
	 	 enableButtons(true);
	 }


   if(_isAutomatic != 0)  {
   	messageAction(kqml);
   }
 }

  public void notifyError(String msg)   {
    _reqp.notifyMessage(msg);
  }

	public void alert(String msg)   {
  	MessageBox b = new MessageBox(msg,getFrame());
	}

  public void notifyMessage(String msg)   {
    _reqp.notifyMessage(msg);
  }


  /**
  * ActionPerformed implementation
  */
	public void actionPerformed(ActionEvent event) {
      String source = event.getActionCommand();

      if(source.equals("Delete"))  {
				deleteAction();
      }
      else
      if(source.equals("Quit"))  {
				quitAction();
      }
      else
      if(source.equals("Act"))  {
      	messageAction();
      }
      else
      if(source.equals("Show"))  {
      	showAction();
      }
      else  {
	      int no = _mailList.getSelectedIndex();
  	    if(no != -1) {
					KQMLmail mail = (KQMLmail)_mails.elementAt(no);
					mail.setReadBit(readbit);
					_mailList.replaceItem(mail.getString(),no);
					_showArea.setText(mail.getKQMLmessage().getReadString());
      	System.out.println(source);
       }
     }
  }

	protected void showAction()  {
		int no = _mailList.getSelectedIndex();
		if(no != -1)  {
			KQMLmail mail = (KQMLmail)_mails.elementAt(no);
			KQMLmessage kqml = mail.getKQMLmessage();
			_showArea.setText(kqml.getReadString());
		}
	}

	/* After selecting the message, click Act button will invoke this method.
	 * Three default execution will be performed.
	 * 1. If click on the request address, address will be cached
	 * 2. If click on the list-agent, agent list dialog will be displayed
	 * 3. If click on the 'tell' performative and content is '(store ftp://...)',
	 *    FTP get action will be performed.
	 */
	protected void messageAction()    {
		int no = _mailList.getSelectedIndex();
		if(no != -1)  {
			KQMLmail mail = (KQMLmail)_mails.elementAt(no);
			KQMLmessage kqml = mail.getKQMLmessage();
			messageAction(kqml);
		}
	}

	protected void messageAction(KQMLmessage kqml)  {
			String perf = kqml.getValue("performative");
			if(perf.equalsIgnoreCase("registered-agent"))  {
				AgentListFrame f = new AgentListFrame(kqml);
			}
			else
			if(perf.equalsIgnoreCase("agent-address"))  {
				_agentAction.cacheAddress(kqml);
			}
			else
			if(perf.equalsIgnoreCase("tell"))  {
				String content = kqml.getValue("content");
				Vector v = null;
				try  {
					v = new takeOffList(content);
				} catch (ParseException e)  {
					MessageBox b = new MessageBox("Parse error for Action",getFrame());
					return;
				}

				if(v.size() != 3)  {
					return;
				}

				String cperf = (String)v.elementAt(0);
				if(!cperf.equalsIgnoreCase("store"))  {
					return;
				}

				String sender = kqml.getValue("sender");

				Enumeration e = _ftpCons.elements();
				while(e.hasMoreElements())  {
					FTPCon con = (FTPCon)e.nextElement();
					String conId = con.getID();
					if(conId.equals(sender))  {
				  	_ftpp.setText(sender,content);
						_ftpp.getAction(this.fileName);
						return;
					}
				}

				_ftpp.setText(sender,content);
				MessageBox b = new MessageBox("FTPCon is not defined for the sender " + sender + "\r\nFill in the FTP panel and click GET button",getFrame());
			}

	}

  public void windowClosed(WindowEvent event) {

  }

  public void windowDeiconified(WindowEvent event) {
  }

  public void windowIconified(WindowEvent event) {
  }

  public void windowActivated(WindowEvent event) {
  }

  public void windowDeactivated(WindowEvent event) {
  }

  public void windowOpened(WindowEvent event) {
  }

  public void windowClosing(WindowEvent event) {
		quitAction();
	}

	public void itemStateChanged(ItemEvent e)  {
		_isAutomatic = e.getStateChange();
	}

	protected synchronized void deleteAction()  	{
    	int[] a = _mailList.getSelectedIndexes();
    	if(a.length < 1)  return;

    	if(a.length == 1)  {
    		KQMLmail tmp = (KQMLmail)_mails.elementAt(a[0]);
    		tmp.setReadBit(deletebit);
    		_mailList.replaceItem(tmp.getString(),a[0]);
    	//	_mailList.delItem(a[0]);
    		_agentAction.addToDeleteBuffer(a[0]);
    	}
    	else {
	 		QSort qsort = new QSort();
			// sort needs size - 1
			qsort.sort(a,0,a.length - 1);

  		for(int i= (a.length - 1); i >= 0; i--)  {
  				KQMLmail tmp = (KQMLmail)_mails.elementAt(a[i]);
	    		tmp.setReadBit(deletebit);
	    		_mailList.replaceItem(tmp.getString(),a[i]);
    			//_mailList.delItem(a[i]);
			}
    		_agentAction.addToDeleteBuffer(a);
    	}

    	if(_mailList.getItemCount() == 0)  {
    		enableButtons(false);
    	}
	}


	protected void quitAction()  	{
		disconnect();
   	dispose();
	}


	public void sendMessage(String msg)  	{
		try  {
			_agentAction.sendKQMLMessage(msg);
		} catch (ParseException p)  {  // ParseException, ConnectionException
			_reqp.notifyMessage(p.toString());
			MessageBox b = new MessageBox("Send message failed :: Parse Exception. See Request Panel for more information",this);
		}  catch (ConnectionException c)	{
			_reqp.notifyMessage(c.toString());
			int code = c.getCode();
			if(code == ConnectionException.OUTPUTCLOSE)  {
				MessageBox b = new MessageBox("Disconnected from Router. You need to reconnect to send a message",this);
				disconnect();
			}
			else
			if(code == ConnectionException.MSGLENGTH)  {
				MessageBox b = new MessageBox("Message size too big. Sending ignored",this);
			}
		}
  }


	public void reserveMessage(long time,Address address)   {
        String content = "(", routername;
    	int[] a = _mailList.getSelectedIndexes();

    	for(int i=0; i< a.length; i++)  {
    		KQMLmail mail = (KQMLmail)_mails.elementAt(a[i]);
    		int number = mail.getMessageNumber();
    		content = content + number + " ";
    		mail.setReadBit(reservebit);
    		_mailList.replaceItem(mail.getString(),a[i]);
		  }

	    routername = _agentAction.getRouterName();
	    content = content + ")";

	    try  {
	    	_agentAction.reserveMessage(time,content,address);
	    } catch (ConnectionException e)  {
	    	_reqp.notifyMessage(e.toString());
	    }
	}

	public void connect(String id, String password,String email)  {
		spew(id + password);
		try  {
			if(_agentAction == null)  {
				createAgentAction_ORIG(id,password,email);
			}

	  	_agentAction.connect();
	  	_agentAction.start();
		  _reqp.setMyAddress(_myAddress);
		  _regp.setMyAddress(_myAddress);
		  _resp.setMyAddress(_myAddress);

			enablePanelButtons(true);

	  } catch (ConnectionException e)  {
	  	// error. Delete _agentAction
			quitAgentAction();
	  	_reqp.notifyMessage(e.toString());
	  }
	}

	public void disconnect()  	{

		// clear address info for applet case
		if(!m_fStandAlone)  {
			_reqp.clearMyAddress();
			_regp.clearMyAddress();
			_resp.clearMyAddress();
		}

		enableButtons(false);
		enablePanelButtons(false);

		quitAgentAction();

		notifyMessage("Disconnected");
	}

	protected void quitAgentAction()  {
		if(_agentAction != null)  {
     	_agentAction.endAction();
     	_agentAction = null;
    }
    _mailList.removeAll();

	}

	public void listUsers()  	{
		try  {
			_agentAction.listUsers();
		} catch (ConnectionException e) {
			_reqp.notifyMessage(e.toString());
		}
	}

	public void register(String rport, String id, String host, String port, String type, String description)	{
		if((id == null) || (type == null) || (description == null))  {
			_reqp.notifyMessage("Wrong data for registration");
		}
		else  {
			_registrarAddress = new Address(_registrarAddress.getID(),_registrarAddress.getHost(),getInt(rport), "MessageRouter", "(RouterRegistrar)");
			_myAddress = new Address(id, host, getInt(port), type, description);
			try  {
				if(_agentAction == null)  {
					//my address already set
					createAgentAction_ORIG(null,null,null);
				}

				_agentAction.setMyAddress(_myAddress);
				_agentAction.register(_registrarAddress,_myAddress);
				//_reqp.setMyName(rid);
				_regp.setRegistrarAddress(_registrarAddress);
				_reqp.setMyAddress(_myAddress);
				_regp.setMyAddress(_myAddress);
				_resp.setMyAddress(_myAddress);

			} catch (ConnectionException e)  {
		  	// error. Delete _agentAction. Should not be omitted
				quitAgentAction();
				_reqp.notifyMessage(e.toString());
			}
		}
	}

	public void unregister(Address addr)  {
		try  {
			_agentAction.unregister(addr);
		} catch (ConnectionException e)  {
			_reqp.notifyMessage(e.toString());
		} finally  {

			// Router will automatically disconnect if I unregister
			disconnect();
		}
	}

	public void requestAddress(String name)  	{
		try  {
			_agentAction.requestAddress(name);
		} catch (ConnectionException e)  {
			_reqp.notifyMessage(e.toString());
		}
	}

	public void updateListPanel()  	{
		_mailList.removeAll();

		Enumeration	e = _mails.elements();
		while(e.hasMoreElements())  {
			KQMLmail tmp = (KQMLmail)e.nextElement();
			spew("ADDNO" + tmp.getString());
			_mailList.add(tmp.getString());
		}
  }

  public void getAction(FTPCon con)  {
  	if(con == null)  {
  		MessageBox b = new MessageBox("Null FTPCon passed. Aborted",this);
  		return;
  	}

  	con.setMode(con.getMode() | FTPCon.ISGETMODE);
		try  {
  		if(m_fStandAlone)  {
  			_agentAction.FTP(con);
  		}
  		else  {
  			_agentAction.createDataTransferConnection(con);
  		}
  	} catch (ConnectionException e)  {
  		MessageBox b = new MessageBox("FTP Error. See Request Panel for detail",this);
  		_reqp.notifyMessage(e.toString());
		}
  }

  public void putAction(FTPCon con)  {
  	if(con == null)  {
  		MessageBox b = new MessageBox("Null FTPCon passed. Aborted",this);
  		return;
  	}

		try  {
  		if(m_fStandAlone)  {
  			_agentAction.FTP(con);
  		}
  		else  {
  			_agentAction.createDataTransferConnection(con);
  		}
  	} catch (ConnectionException e)  {
  		MessageBox b = new MessageBox("FTP Error. See Request Panel for detail",this);
  		_reqp.notifyMessage(e.toString());
		}

  }

 	/**
 	 * FTPCon for the receiver should be specified. FTPCon name is the same as receiver
 	 * name. This method will be invoked from IPRCActionExample, processMessage() method,
 	 * after finishing FTP successfully.
 	 * @parem sender File sender
 	 */
 	public void setFTPPutMessage(FTPCon con)  {
		KQMLmessage kqml = new KQMLmessage();
		kqml.addFieldValuePair("performative","tell");
		kqml.addFieldValuePair("language","KQML");
		kqml.addFieldValuePair("sender",_myAddress.getID());
		kqml.addFieldValuePair("receiver",con.getID());
		String contentstr = "(store ftp://";
		contentstr = contentstr + con.getHost() + "/";
		contentstr = contentstr + con.getRemotePath() + " (";
		String[] files = con.getFiles();
		for(int i=0; i < files.length; i++)  {
			String filefullpath = files[i];
			int delloc = filefullpath.lastIndexOf(File.separatorChar);
			if(delloc != -1)  {
				String filename = filefullpath.substring(delloc + 1);
				contentstr = contentstr + filename + " ";
			}
			else  {
				contentstr = contentstr + filefullpath;
			}
		}
		contentstr = contentstr + "))";
		kqml.addFieldValuePair("content",contentstr);
		_comp.setKQMLString(kqml);
		_comp.requestFocus();
		if(_isAutomatic != 0)	{
				sendMessage(kqml.getSendString());
		}
 	}

	protected void spew(String args)	{
		System.out.println(args);
	}

	protected int getInt(String str)	{
		return (Integer.valueOf(str)).intValue();
	}

	public Frame getFrame()    {
		return this;
  }

  protected Panel newPackerPanel()	{
		Panel p = new Panel();
		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}

	public void sendEmailMessage(String msg)  {
		try  {
			if(m_fStandAlone)  {
				_agentAction.sendEmailMessage(msg);
			}
			else  {
				_agentAction.createEmailConnection(msg);
			}
  	} catch (ConnectionException e)  {
  		MessageBox b = new MessageBox("SMTP Error. See Request Panel for detail",this);
  		_reqp.notifyMessage(e.toString());
		}

	}

	protected Panel JATPanels(String fileName1, FramePrincipal controlador1) 	{

		_reqp = new IPRequestPanel(this);
		_comp = new IPComposePanel(this);
		_resp = new IPReservePanel(this);
		_regp = new IPRegisterPanel(this);
                /*20041007*/   //_ftpp = new IPFTPPanel(this ,_ftpCons);
                /*20041007*/   _ftpp = new IPFTPPanel(this,_ftpCons, fileName1, controlador1);


		wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);

		//Main Panel (left)
		leftPanel = newPackerPanel();

		//SubPanels - 2 of them, from top to bottom
		//First, the label
		Label l = new Label("Collaborative WebCADbyFeatures");
		l.setFont(ultraBoldFont);

		//Next, the Tab Folder - done in the following steps:
		//Set up the individual panels for the Tab Folder
		requestPanel = newPackerPanel();
		requestPanel.add("panel;expand=true;fill=both", _reqp);

		composePanel = newPackerPanel();
		composePanel.add("panel;expand=true;fill=both", _comp);

		reservePanel = newPackerPanel();
		reservePanel.add("panel;expand=true;fill=both", _resp);

		registerPanel = newPackerPanel();
		registerPanel.add("panel;expand=true;fill=both", _regp);

		ftpPanel = newPackerPanel();
		ftpPanel.add("panel;expand=true;fill=both", _ftpp);

		//and then instantiate the Tab Folder
		tf = new TabFolder("Request", requestPanel);
	  tf.addTab("Compose", composePanel);
	  tf.addTab("Register", registerPanel);
	  tf.addTab("FTP", ftpPanel);
		tf.addTab("Reserve", reservePanel);

	  leftPanel.add("label;side=top;padx=5;expand=true;fill=both", l);
	  leftPanel.add("TabFolder;side=top;pady=5", tf);

		////////////////////////
		//Main Panel (right)
		rightPanel = newPackerPanel();
		//SubPanels - 3 of them, from top to bottom
		mailList = newPackerPanel();
		showArea = newPackerPanel();
		controlButtons = newPackerPanel();

		_mailList.setBackground(Color.white);
		mailList.add("panel;expand=true;fill=both;padx=5;pady=5", _mailList);
		showArea.add("panel;expand=true;fill=both;padx=5", _showArea);
		_mailList.addActionListener(this);

		_automatic = new Checkbox("Auto",false);
		_automatic.addItemListener(this);

		_act = new Button("Act");
		_delete = new Button("Delete");
		_quit = new Button("Quit");
		_show = new Button("Show");

		controlButtons.add("panel;side=left;fill=x;pady=5;ipady=5", _automatic);
		_automatic.setFont(normFont);
		controlButtons.add("panel;side=left;fill=x;padx=5;pady=5;ipadx=5;ipady=5", _act);
		_act.setFont(bigFont);
		_act.addActionListener(this);

		controlButtons.add("panel;side=left;fill=x;padx=5;pady=5;ipadx=5;ipady=5", _show);
		_show.setFont(bigFont);
		_show.addActionListener(this);

		controlButtons.add("panel;side=left;fill=x;padx=5;pady=5;ipadx=5;ipady=5", _delete);
		_delete.setFont(bigFont);
		_delete.addActionListener(this);

		controlButtons.add("panel;side=left;fill=x;padx=5;ipadx=5;ipady=5", _quit);
		_quit.setFont(bigFont);
		_quit.addActionListener(this);

		// disable delete, act button
		enableButtons(false);

		rightPanel.add("panel;side=top;expand=true;fill=both", mailList);
		rightPanel.add("panel;side=top;expand=true;fill=both", showArea);
		rightPanel.add("panel;side=top;expand=true;fill=both", controlButtons);

		//Now add both left & right panels into the whole Panel
		wholePanel.add("leftPanel;side=left;padx=5;pady=5", leftPanel);
		wholePanel.add("leftPanel;side=left;expand=true;fill=both;padx=5;pady=5", rightPanel);

		return wholePanel;
	}


   public static void main(String args[])  {
   	if(args.length != 1)  {
   		System.out.println("Address script file missing\nUsage:java ProtocolLayer.Example.CAD.CADApplet [AddressFilePath]");
   		return;
   	}

   	IPRCFrame f  = new IPRCFrame(args[0]);
   }

	 protected void enableButtons(boolean tf)  {
	 		_delete.setEnabled(tf);
	 		_show.setEnabled(tf);
	 		_act.setEnabled(tf);
	 }

	 protected void enablePanelButtons(boolean tf)  {
			_ftpp.enableButtons(tf);
			_comp.enableButtons(tf);
			_reqp.enableButtons(tf);
			_resp.enableButtons(tf);
			_regp.enableButtons(tf);
	 }
}
