package ProtocolLayer.Example.IPRCApplet;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import RouterLayer.AgentClient.Example.RCApplet.extawt.*;
import Abstract.*;
import KQMLLayer.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout;
/**
* RCApplet example sub component
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class IPRegisterPanel extends Panel implements ActionListener {
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
	Color bkgColor = new Color(210,210,210);

	// registrar information
	TextField _rname;
	TextField _rhost;
	TextField _rport;
	TextField _regport;

	// my address information
	TextField _name;
	TextField _host;
	TextField _port;
	TextField _email;
	TextField _description;


	IPRCFrame _agentFrame;
	Address _myAddress;
	Address _serverAddress;
	Address _registrarAddress;

	Button _unregister;

	public IPRegisterPanel(IPRCFrame parent)  	{
		setLayout(new BorderLayout());
		_agentFrame = parent;
		_myAddress = parent.getMyAddress();
		_serverAddress = parent.getRouterAddress();
		_registrarAddress = parent.getRegistrarAddress();

		add("Center", GUIComponents());
	}

	public void setMyAddress(Address addr)  {
		_myAddress = addr;

		_name.setEditable(true);
		_name.setText(addr.getID());
		_name.setEditable(false);

		_host.setEditable(true);
		_host.setText(addr.getHost());
		_host.setEditable(false);

		_port.setEditable(true);
		_port.setText(Integer.toString(addr.getPort()));
		_port.setEditable(false);

		_email.setEditable(true);
		_email.setText(getEmail(addr));
		_email.setEditable(false);

		_description.setEditable(true);
		_description.setText(getPassword(addr));
		_description.setEditable(false);
	}

	public void clearMyAddress()   {
		_name.setEditable(true);
		_name.setText("");

		_email.setEditable(true);
		_email.setText("");

		_description.setEditable(true);
		_description.setText("");
	}

	public void setRegistrarAddress(Address addr)  {
		_registrarAddress = addr;
		_rname.setText(addr.getID());
		_rhost.setText(addr.getHost());
		_regport.setText(Integer.toString(addr.getPort()));
	}


	protected String getPassword(Address addr)  {
		String password = "";
		try  {
			String desc = addr.getDescription();
			KQMLmessage kqml = new KQMLmessage(desc);
			String tmp = kqml.getValue("password");
			if(tmp != null)  {
				password = tmp;
			}
		}  catch (ParseException p)  {}
		return password;
	}

	protected String getEmail(Address addr)  {
		String email = "";
		try  {
			String desc = addr.getDescription();
			KQMLmessage kqml = new KQMLmessage(desc);
			String tmp = kqml.getValue("email");
			if(tmp != null)  {
				email = tmp;
			}
		}  catch (ParseException p)  {}
		return email;
	}


	protected Panel GUIComponents()  {
		// Buttons
		Button btnRegister = new Button("Register");
		btnRegister.addActionListener(this);

		_unregister = new Button("UnRegister");
		_unregister.addActionListener(this);

		Panel wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);

		Panel rNamePanel = newPackerPanel();
		Label rname = new Label("Router Name:", Label.RIGHT);
		_rname = new TextField(_serverAddress.getID(),20);
		rNamePanel.add("label;side=right;fill=both", _rname);
		rNamePanel.add("label;side=right;padx=5;fill=both", rname);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", rNamePanel);

		Panel rHostPanel = newPackerPanel();
		Label rhost = new Label("Router Host",Label.RIGHT);
		_rhost = new TextField(_serverAddress.getHost(),20);
		if(_agentFrame.m_fStandAlone == false)  {
			_rhost.setEditable(false);
		}
		rHostPanel.add("label;side=right;fill=both", _rhost);
		rHostPanel.add("label;side=right;padx=5;fill=both", rhost);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", rHostPanel);

		Panel rPortPanel = newPackerPanel();
		Label rport = new Label("Router Port:",Label.RIGHT);
		_rport = new TextField(Integer.toString(_serverAddress.getPort()),20);
		rPortPanel.add("label;side=right;fill=both", _rport);
		rPortPanel.add("label;side=right;padx=5;fill=both", rport);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", rPortPanel);


		Panel regPortPanel = newPackerPanel();
		Label regport = new Label("Registrar Port:",Label.RIGHT);
		_regport = new TextField(Integer.toString(_registrarAddress.getPort()),20);
		regPortPanel.add("label;side=right;fill=both", _regport);
		regPortPanel.add("label;side=right;padx=5;fill=both", regport);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", regPortPanel);

		Label myAddress = new Label("My Address:");
		myAddress.setFont(boldFont);
		wholePanel.add("label;side=top;anchor=w", myAddress);

		Panel aNamePanel = newPackerPanel();
		Label name = new Label("Agent Name:",Label.RIGHT);
		String mname = "";
		if(_myAddress != null)  {
			mname = _myAddress.getID();
		}
		_name = new TextField(mname,20);
		aNamePanel.add("label;side=right;fill=both", _name);
		aNamePanel.add("label;side=right;padx=5;fill=both", name);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", aNamePanel);

		Panel aHostPanel = newPackerPanel();
		Label host = new Label("Host:",Label.RIGHT);
		String mhost = "";
		if(_myAddress != null)  {
			mhost = _myAddress.getHost();
		}
		_host = new TextField(mhost,20);
		if(_agentFrame.m_fStandAlone == false)  {
			_host.setText("null");
			_host.setEditable(false);
		}

		aHostPanel.add("label;side=right;fill=both", _host);
		aHostPanel.add("label;side=right;padx=5;fill=both", host);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", aHostPanel);

		Panel aPortPanel = newPackerPanel();
		Label port = new Label("Port:",Label.RIGHT);
		String mport = "";
		if(_myAddress != null)  {
			mport = Integer.toString(_myAddress.getPort());
		}
		_port = new TextField(mport,20);
		if(_agentFrame.m_fStandAlone == false)  {
			_port.setText("-1");
			_port.setEditable(false);
		}

		aPortPanel.add("label;side=right;fill=both", _port);
		aPortPanel.add("label;side=right;padx=5;fill=both", port);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", aPortPanel);

		Panel emailPanel = newPackerPanel();
		Label email = new Label("Email(Optional):",Label.RIGHT);
		String emailaddr = "";
		if(_myAddress != null)  {
			emailaddr = getEmail(_myAddress);
		}
		_email = new TextField(emailaddr,20);
		emailPanel.add("label;side=right;fill=both", _email);
		emailPanel.add("label;side=right;padx=5;fill=both", email);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", emailPanel);

		Panel passwdPanel = newPackerPanel();
		Label description = new Label("Password:",Label.RIGHT);
		String mpass = "";
		if(_myAddress != null)   {
			mpass = getPassword(_myAddress);
		}
		_description = new TextField(mpass,20);
		passwdPanel.add("label;side=right;fill=both", _description);
		passwdPanel.add("label;side=right;padx=5;fill=both", description);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", passwdPanel);

		Panel regBtnPanel = newPackerPanel();
		regBtnPanel.add("label;side=right;expand=true;fill=both", _unregister);
		regBtnPanel.add("label;side=right;padx=5;expand=true;fill=both", btnRegister);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", regBtnPanel);

		enableButtons(false);

		return wholePanel;
	}


  /**
  * ActionPerformed implementation
  */
	public void actionPerformed(ActionEvent event) {
      String source = event.getActionCommand();

      if(source.equals("Register"))  {
				String rport = _regport.getText();

				String id = _name.getText();
				String host = _host.getText();
				String port = _port.getText();
				String email = _email.getText();
				String description = "(agent-info :password " + _description.getText();
				if(!email.equals(""))  {
					description = description + " :email " + email;
				}
				description += ")";
				_agentFrame.register(rport,id,host,port,"MessageRouter",description);

      }
      else
      if(source.equals("UnRegister"))  {
				String id = _name.getText();
				String host = _host.getText();
				String port = _port.getText();
				String email = _email.getText();
				String description = "(agent-info :password " + _description.getText();
				if(!email.equals(""))  {
					description = description + " :email " + email;
				}
				description += ")";
				Address addr = new Address(id,host,(Integer.valueOf(port)).intValue(),"MessageRouter",description);
				_agentFrame.unregister(addr);
      }
  }

	public void enableButtons(boolean tf)  {
		_unregister.setEnabled(tf);
	}

	public Insets insets()   	{
    	return new Insets(10, 10, 10, 10);
 	}

 	private Panel newPackerPanel()	{
		Panel p = new Panel();

		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}
}

