package ProtocolLayer.Example.IPRCApplet;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import Abstract.*;
import KQMLLayer.*;
import ProtocolLayer.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

/**
* Sub component of RCApplet
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class IPRequestPanel extends Panel implements ActionListener {
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
	Color bkgColor = new Color(210,210,210);
	TextField _myname;
	TextField _password;
	TextField _agentname;
	TextField _email;
	TextArea _echoArea;	
	
	IPRCFrame _agentFrame;
	Address _myAddress;
	
	Button _list,_disconnect,_addr,_connect;

	public IPRequestPanel(IPRCFrame parent)  	{
		setLayout(new BorderLayout());
		_agentFrame = parent;
		_myAddress = parent.getMyAddress();
		add("Center", GUIComponents());
	}		
	
	// will be invoked if the address is changed	
	public void setMyAddress(Address addr)  {
		_myAddress = addr;
		
		_myname.setEditable(true);
		_myname.setText(addr.getID());
		_myname.setEditable(false);
		
		_password.setEditable(true);
		_password.setText(getPassword(addr));
		_password.setEditable(false);
		
		_email.setEditable(true);
		_email.setText(getEmail(addr));
		_email.setEditable(false);
		
	}
			
	public void clearMyAddress()  {
		_myname.setEditable(true);
		_myname.setText("");
		
		_password.setEditable(true);
		_password.setText("");
		
		_email.setEditable(true);
		_email.setText("");
		
	}
			
	protected String getPassword(Address addr)  {
		String password = "";
		try  {
			String desc = addr.getDescription();
			KQMLmessage kqml = new KQMLmessage(desc);
			String tmp = kqml.getValue("password");
			if(tmp != null)  {
				password = tmp;
			}
		}  catch (ParseException p)  {}		
		return password;
	}
	
	protected String getEmail(Address addr)  {
		String email = "";
		try  {
			String desc = addr.getDescription();
			KQMLmessage kqml = new KQMLmessage(desc);
			String tmp = kqml.getValue("email");
			if(tmp != null)  {
				email = tmp;
			}
		}  catch (ParseException p)  {}		
		return email;
	}
						
	private Panel GUIComponents()  
	{
		Panel wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);
		
		Panel namePanel = newPackerPanel();
		Label myname = new Label("My Name:", Label.RIGHT);
		String mname = "";
		if(_myAddress != null)  {
			mname = _myAddress.getID();
		}	
		_myname = new TextField(mname,8);
		namePanel.add("label;side=right;expand=true;fill=both", _myname);
		namePanel.add("label;side=right;padx=5;expand=true;fill=both", myname);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", namePanel);
		
		Panel passwdPanel = newPackerPanel();
		Label pass = new Label("Password:", Label.RIGHT);
		String mpass = "";
		if(_myAddress != null)  {
			mpass = getPassword(_myAddress);
		}	
		_password = new TextField(mpass,8);
		passwdPanel.add("label;side=right;expand=true;fill=both", _password);        
		passwdPanel.add("label;side=right;padx=5;expand=true;fill=both", pass);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", passwdPanel);
		
		Panel emailPanel = newPackerPanel();
		Label email = new Label("Email:", Label.RIGHT);
		String memail = "";
		if(_myAddress != null)  {
			memail = getEmail(_myAddress);
		}	
		_email = new TextField(memail,8);
		emailPanel.add("label;side=right;expand=true;fill=both", _email);        
		emailPanel.add("label;side=right;padx=5;expand=true;fill=both", email);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", emailPanel);
		
		
		Panel connectionPanel = newPackerPanel();
		_connect = new Button("Connect");
		_list = new Button("List Agents");
		_list.addActionListener(this);
		_connect.addActionListener(this);
		_disconnect = new Button("DisConnect");
		_disconnect.addActionListener(this);
		
		connectionPanel.add("label;side=right;expand=true;fill=both", _disconnect);     
 		connectionPanel.add("label;side=right;padx=5;expand=true;fill=both", _list);        
		connectionPanel.add("label;side=right;padx=5;expand=true;fill=both", _connect); 
		wholePanel.add("Panel;side=top;pady=5;expand=true;fill=both", connectionPanel);
		
		Panel agentNamePanel = newPackerPanel();
		Label aname = new Label("AgentName:");
		_agentname = new TextField("",8);
		_addr = new Button("Address");
		_addr.addActionListener(this);
		
		agentNamePanel.add("label;side=right", _addr);        
		agentNamePanel.add("label;side=right;padx=5;expand=true;fill=both", _agentname);    
		agentNamePanel.add("label;side=right", aname); 
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", agentNamePanel);
		
		
		_echoArea = new TextArea("",10,12);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", _echoArea);
	
		enableButtons(false);
		
		return wholePanel;
	}
				
	public void setMyName(String id) 	{
		_myname.setText(id);
	}				
				
	public void actionPerformed(ActionEvent evt)  {
			String cmd = evt.getActionCommand();
			
			if("Connect".equals(cmd))  {
				String name = _myname.getText();
				String pass = _password.getText();
				String email = _email.getText();
				if((name.equals("")) || (pass.equals("")))  {
					_echoArea.append("Agent name and Password should be specified\n");
				}
				else  {	
					_agentFrame.connect(name,pass,email);
				}
			}			
			else 
			if("DisConnect".equals(cmd)) {
			  _agentFrame.disconnect();
			}	
			else 
			if("List Agents".equals(cmd)) {
				_agentFrame.listUsers();
			}	
			else 
			if("Address".equals(cmd)) {
				String name = _agentname.getText();
				if(name.equals(""))  {
					_echoArea.append("Agent name should be specified\n");
				}
				else {
					_agentFrame.requestAddress(name);
				}
			}	
			
	}		
				
				
	public void notifyMessage(String msg)  	{
		_echoArea.append(msg + "\n");
	}
			
	public void enableButtons(boolean tf)  {
		_disconnect.setEnabled(tf);
		_list.setEnabled(tf);
		_addr.setEnabled(tf);
 		_connect.setEnabled(!tf); 
		
	}		
					
	public Insets insets()   	{
   	return new Insets(10, 10, 10, 10);
 	}
  	
  	  
  private Panel newPackerPanel()	{
		Panel p = new Panel();
		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}																		
}	
				