package ProtocolLayer.Example.IPRCApplet;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import Abstract.*;
import KQMLLayer.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

/**
* Sub component of JATLite example, RCApplet. This panel will take user input for
* message reservation
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class IPReservePanel extends Panel implements ActionListener {
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
	Color bkgColor = new Color(210,210,210);
	TextField _year;
	TextField _month;
	TextField _date;
	TextField _hour;
	TextField _minute;
		
	TextField _receiver;
	TextField _host;
	TextField _port;
	TextField _type;
	TextField _description;
	
	Button _ok;
		
	IPRCFrame _agentFrame;
	Address _myAddress;	
	
	public IPReservePanel(IPRCFrame parent)  	{
		setLayout(new BorderLayout());
		_agentFrame = parent;
		_myAddress = parent.getMyAddress();
		add("Center", GUIComponents());
		repaint();
	}	

	protected String getPassword(Address addr)  {
		String password = "";
		try  {
			String desc = addr.getDescription();
			KQMLmessage kqml = new KQMLmessage(desc);
			String tmp = kqml.getValue("password");
			if(tmp != null)  {
				password = tmp;
			}
		}  catch (ParseException p)  {}		
		return password;
	}
	
	public void setMyAddress(Address addr)  {
		_myAddress = addr;
		
		_receiver.setEditable(true);
		_receiver.setText(addr.getID());
		_receiver.setEditable(false);
		
		_host.setEditable(true);
		_host.setText(addr.getHost());
		_host.setEditable(false);
		
		_port.setEditable(true);
		_port.setText(Integer.toString(addr.getPort()));
		_port.setEditable(false);
		
		_type.setEditable(true);
		_type.setText(addr.getType());
		_type.setEditable(false);
		
		_description.setEditable(true);
		_description.setText(getPassword(addr));	
		_description.setEditable(false);
	}	
		
	public void clearMyAddress()   {
		_receiver.setEditable(true);
		_receiver.setText("");
		
		_type.setEditable(true);
		_type.setText("");
		
		_description.setEditable(true);
		_description.setText("");	
	}
	
	
	protected Panel GUIComponents() 
	{
		Panel wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);
				
		Panel eventDatePanel = newPackerPanel();
		_month = new TextField("");
		_year = new TextField("");
		Label month = new Label("Month:", Label.RIGHT);
		Label year = new Label("Year:", Label.RIGHT);
		eventDatePanel.add("label;side=right;fill=x;expand=true", _year);   
		eventDatePanel.add("label;side=right;padx=5", year);		
		eventDatePanel.add("label;side=right;fill=x;expand=true", _month);	
		eventDatePanel.add("label;side=right;padx=5", month); 	 
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", eventDatePanel);
		
		Panel eventTimePanel = newPackerPanel();
		_minute = new TextField("");
		_hour = new TextField("");
		_date = new TextField("");
		Label min = new Label("Min:", Label.RIGHT);
		Label hour = new Label("Hour:", Label.RIGHT);
		Label date = new Label("Date:", Label.RIGHT);
		eventTimePanel.add("label;side=right;expand=true;fill=both", _minute);
		eventTimePanel.add("label;side=right;padx=5", min);
		eventTimePanel.add("label;side=right;expand=true;fill=both", _hour);
		eventTimePanel.add("label;side=right;padx=5", hour);
		eventTimePanel.add("label;side=right;expand=true;fill=both", _date);
		eventTimePanel.add("label;side=right;padx=5", date);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", eventTimePanel);
		
		Panel infoPanel = newPackerPanel();
		Label l1 = new Label("If you want to specify the receiver address, you can");
		Label l2 = new Label("specify it here. The receiving location need not be");
		Label l3 = new Label("the same as the current location.");
		infoPanel.add("label;side=top;anchor=w", l1);
		infoPanel.add("label;side=top;anchor=w", l2);
		infoPanel.add("label;side=top;anchor=w", l3);
		wholePanel.add("Panel;side=top;pady=5;expand=true;fill=both", infoPanel);
		
		Panel receiverPanel = newPackerPanel();
		Label receiver = new Label("Receiver:",Label.RIGHT);
		String mname = "";
		if(_myAddress != null)  {
			mname = _myAddress.getID();
		}	
		_receiver = new TextField(mname,20);
		receiverPanel.add("label;side=right;fill=both", _receiver);
		receiverPanel.add("label;side=right;padx=5;fill=both", receiver);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", receiverPanel);
		
		Panel hostPanel = newPackerPanel();
		Label host = new Label("Host:",Label.RIGHT);
		String mhost = "";
		if(_myAddress != null)  {
			mhost = _myAddress.getHost();
		}	
		_host = new TextField(mhost,20);
		hostPanel.add("label;side=right;fill=both", _host);        
		hostPanel.add("label;side=right;padx=5;fill=both", host);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", hostPanel);
		
		Panel portPanel = newPackerPanel();
		Label port = new Label("Port:",Label.RIGHT);
		String mport = "";
		if(_myAddress != null)  {
			mport = Integer.toString(_myAddress.getPort());
		}	
		_port = new TextField(mport,20);
		portPanel.add("label;side=right;fill=both", _port);        
		portPanel.add("label;side=right;padx=5;fill=both", port);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", portPanel);
		
		Panel messageMethodPanel = newPackerPanel();
		Label type = new Label("Message-method:",Label.RIGHT);
		String mmessagemethod = "";
		if(_myAddress != null)  {
			mmessagemethod = _myAddress.getType();
		}	
		_type = new TextField(mmessagemethod,20);
		messageMethodPanel.add("label;side=right;fill=both", _type);        
		messageMethodPanel.add("label;side=right;padx=5;fill=both", type);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", messageMethodPanel);
		
		Panel descriptionPanel = newPackerPanel();
		Label description = new Label("Password:",Label.RIGHT);
		String mpass = "";
		if(_myAddress != null)  {
			mpass = getPassword(_myAddress);
		}	
		_description = new TextField(mpass,20);
		descriptionPanel.add("label;side=right;fill=both", _description);        
		descriptionPanel.add("label;side=right;padx=5;fill=both", description);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", descriptionPanel);
		
		Panel connectionPanel = newPackerPanel();
		Button time = new Button("Set Time");
		time.addActionListener(this);
		_ok = new Button("OK");
		_ok.addActionListener(this);
		
		Button cancel = new Button("Cancel");
		cancel.addActionListener(this);
		
		connectionPanel.add("label;side=right;expand=true;fill=both", cancel);        
		connectionPanel.add("label;side=right;padx=5;expand=true;fill=both", _ok); 
		connectionPanel.add("label;side=right;expand=true;fill=both", time); 
		wholePanel.add("Panel;side=top;pady=7;expand=true;fill=both", connectionPanel);
		
		enableButtons(false);
		
		return wholePanel;
	}
	
	
  /**
  * ActionPerformed implementation
  */
	public void actionPerformed(ActionEvent event) {
      String source = event.getActionCommand();

      if(source.equals("OK"))  {
				Address address = null;
				String host = _host.getText();
				if(!host.equals(""))  {
					String description = _description.getText();
					if(description.equals("")) description = null;
	
					address = new Address(_receiver.getText(),
										   host,
										   getTextFieldInt(_port),
										   _type.getText(),
										   description);
				}	
				Calendar time = new GregorianCalendar((Integer.valueOf(_year.getText())).intValue(),
														 				 (Integer.valueOf(_month.getText())).intValue() - 1,
														 				 (Integer.valueOf(_date.getText())).intValue(),
														 				 (Integer.valueOf(_hour.getText())).intValue(),
														 				 (Integer.valueOf(_minute.getText())).intValue());	
				_agentFrame.reserveMessage(time.getTime().getTime(),address);
	    }
      else
      if(source.equals("Cancel"))  {
 				_receiver.setText(_myAddress.getID());
				_host.setText(_myAddress.getHost());
				_port.setText(Integer.toString(_myAddress.getPort()));
				_type.setText(_myAddress.getType());
				_description.setText(_myAddress.getDescription());
				_year.setText("");
				_month.setText("");
				_date.setText("");
				_hour.setText("");
				_minute.setText("");
      }
      else
      if(source.equals("Set Time"))  {
				Calendar c = new GregorianCalendar();
				c.setTime(new Date());
				_year.setText(Integer.toString(c.get(Calendar.YEAR)));
				_month.setText(Integer.toString((int)c.get(Calendar.MONTH) + 1));
				_date.setText(Integer.toString(c.get(Calendar.DAY_OF_MONTH)));
				_hour.setText(Integer.toString(c.get(Calendar.HOUR_OF_DAY)));
				_minute.setText(Integer.toString(c.get(Calendar.MINUTE)));
			}       
      
  }  
	

	public void enableButtons(boolean tf)  {
		_ok.setEnabled(tf);
	}
						
	public Insets insets()   	{
    	return new Insets(10, 10, 10, 10);
 	}
	
	private int getIntString(String str)	{
		return (Integer.valueOf(str)).intValue();
	}
	
	private int getTextFieldInt(TextField tf)	{
		return (Integer.valueOf(tf.getText())).intValue();
	}	
	
	private Panel newPackerPanel()
	{
		Panel p = new Panel();
		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}																	
}	
				