package RouterLayer.AgentClient.Example.CalcServer;

import java.awt.*;
import java.util.*;

import RouterLayer.AgentClient.Example.RCApplet.extawt.*;
import Abstract.*;
import KQMLLayer.*;

/**
* Sub component of the RCAddressHelper class. 
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class MyPanel extends Panel {
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
	Color bkgColor = new Color(210,210,210);

	/**
	* My name text field
	*/	
	TextField _name;
	
	/**
	* My host internet address 
	*/
	TextField _host;
	
	/**
	* The port I am running. 
	*/
	TextField _port;
	
	/**
	* Message method
	*/
	TextField _type;
	
	/**
	* Description, may be advertise
	*/
	TextField _description;
	
	/**
	* KQML extensions, may be URL
	*/
	TextField _KQMLextensions;
	
	/**
	* My password
	*/
	TextField _password;
	
	/**
	* My email address
	*/
	TextField _email;
	
	/**
	* Default consructor
	*/
	public MyPanel()  
	{
		setLayout(new BorderLayout());
		add("Center", GUIComponents());
	}
	
	/**
	* Set my address
	* @param addr My address
	*/
	public void setAddress(Address addr)  {
	
		_name.setText(addr.getID());
		_host.setText(addr.getHost());
		_port.setText(Integer.toString(addr.getPort()));
		_type.setText(addr.getType());
		
		String description = addr.getDescription();
		if(description != null)  {
			try  {
				KQMLmessage kqml = new KQMLmessage(description);
				
				String kqmlext = kqml.getValue("KQML-extensions");
				String email = kqml.getValue("email");
				String password = kqml.getValue("password");
				String desc = kqml.getValue("description");
				
				if(kqmlext != null)  {
					_KQMLextensions.setText(kqmlext);
				}
				else  {
					_KQMLextensions.setText("");
				}
				
				if(email != null)  {
					_email.setText(email);
				}
				else  {
					_email.setText("");
				}

				if(password != null)  {
					_password.setText(password);
				}
				else  {
					_password.setText("");
				}

				if(desc != null)  {
					_description.setText(desc);
				}
				else  {
					_description.setText("");
				}
			} catch (Exception e)  {
				System.out.println(e.toString());
			}
		}			
				
	}						
		
	/**
	* Accessor to get my address
	* @return My address object
	*/		
	public Address getAddress()  {
		String name = _name.getText();
		String host = _host.getText();
		String port = _port.getText();
		String type = _type.getText();
		String password = _password.getText();
		String kqmlext = _KQMLextensions.getText();
		String email = _email.getText();
		String desc = _description.getText();
		
		String description = "(agent-info ";	
		if(!password.equals(""))  {
			description = description + " :password " + password;
		}
		if(!kqmlext.equals(""))  {
			description = description + " :KQML-extensions " + kqmlext;
		}		
		if(!email.equals(""))  {
			description = description + " :email " + email;
		}
		if(!desc.equals(""))  {
			description = description + " :description " + desc;
		}
		description = description + ")";
		
		return new Address(name,host,(Integer.valueOf(port)).intValue(),type,description);
	}	
		
	protected Panel GUIComponents()  {
		Panel wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);
		
		Panel aNamePanel = newPackerPanel();
		Label name = new Label("Agent Name:",Label.RIGHT);
		_name = new TextField("",20);
		aNamePanel.add("label;side=right;fill=both", _name);        
		aNamePanel.add("label;side=right;padx=5;fill=both", name);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", aNamePanel);
		
		Panel aHostPanel = newPackerPanel();
		Label host = new Label("Host:",Label.RIGHT);
		_host = new TextField("",20);
		aHostPanel.add("label;side=right;fill=both", _host);        
		aHostPanel.add("label;side=right;padx=5;fill=both", host);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", aHostPanel);
		
		Panel aPortPanel = newPackerPanel();
		Label port = new Label("Port:",Label.RIGHT);
		_port = new TextField("",20);
		aPortPanel.add("label;side=right;fill=both", _port);        
		aPortPanel.add("label;side=right;padx=5;fill=both", port);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", aPortPanel);
		
		Panel msgMethodPanel = newPackerPanel();
		Label type = new Label("Message-Method:",Label.RIGHT);
		_type = new TextField("",20);
		msgMethodPanel.add("label;side=right;fill=both", _type);        
		msgMethodPanel.add("label;side=right;padx=5;fill=both", type);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", msgMethodPanel);
		
		Panel passwdPanel = newPackerPanel();
		Label password = new Label("Password:",Label.RIGHT);
		_password = new TextField("",20);
		passwdPanel.add("label;side=right;fill=both", _password);        
		passwdPanel.add("label;side=right;padx=5;fill=both", password);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", passwdPanel);
		
		Panel kqmlPanel = newPackerPanel();
		Label kqml = new Label("KQML-extensions:",Label.RIGHT);
		_KQMLextensions = new TextField("",20);
		kqmlPanel.add("label;side=right;fill=both", _KQMLextensions);        
		kqmlPanel.add("label;side=right;padx=5;fill=both", kqml);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", kqmlPanel);

		Panel emailPanel = newPackerPanel();
		Label email = new Label("email:",Label.RIGHT);
		_email = new TextField("",20);
		emailPanel.add("label;side=right;fill=both", _email);        
		emailPanel.add("label;side=right;padx=5;fill=both", email);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", emailPanel);
		
		Panel descPanel = newPackerPanel();
		Label desc = new Label("Description:",Label.RIGHT);
		_description = new TextField("",20);
		descPanel.add("label;side=right;fill=both", _description);        
		descPanel.add("label;side=right;padx=5;fill=both", desc);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", descPanel);
		
		return wholePanel;
	}
				
 	
	public Insets insets()   
	{
    	return new Insets(10, 10, 10, 10);
  	}
  	
  	private Panel newPackerPanel()
	{
		Panel p = new Panel();
		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}																			
}	
				