package RouterLayer.AgentClient.Example.CalcServer;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.applet.*;
import java.io.*;

import Abstract.*;
import RouterLayer.AgentClient.*;
import RouterLayer.util.*;
import KQMLLayer.*;

import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

/**
* Router client address helper
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class RCAddressHelper extends Frame implements ActionListener {
	
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
				 
	private Color	bkgColor = new Color(210,210,210),
					scrlBarColor = new Color(225,225,225);
					
	private Panel 	wholePanel, upperPanel, lowerPanel, centerPanel,routerPanel, myPanel /*otherPanel*/;                                                  
	TabFolder tf;                                                                  
	RouterPanel _routerp;
	MyPanel _myp;
	
	TextField _filePath;
	
	// My address
	Address _myAddress;
	
	// Router address
	Address _routerAddress;
	
	// Registrar address
	Address _registrarAddress;

	// registeration is necessary?
	boolean _registerRequest = false;

	String _durationTime;
		
	String _RCActionClassName;
	
	RouterClientAction _action;
		
	public RCAddressHelper(String classname)  {
		super("RCAddressHelper");
		_RCActionClassName = classname;	
		// Must show Frame before we size it so insets() will return valid values
		setVisible(true);
		setVisible(false);
		setSize(getInsets().left + getInsets().right  + 360,
								  	 getInsets().top  + getInsets().bottom + 400);
	
		setLayout(new BorderLayout());
		setFont(normFont);
		setSize(360, 400);
		add("Center", AddressPanels());
  }

  private Panel newPackerPanel()	{
		Panel p = new Panel();
		p.setLayout(new PackerLayout());
		return p;
	}
	
	private Panel AddressPanels()
	{	
	
		Button open = new Button("Open");
		open.addActionListener(this);
		
		Button browse = new Button("Browse");
		browse.addActionListener(this);
		
		Button save = new Button("Save");
		save.addActionListener(this);
		
		Button start = new Button("Start");
		start.addActionListener(this);
		
		Button close = new Button("Quit");
		close.addActionListener(this);
		
	
		_routerp = new RouterPanel();
		_myp = new MyPanel();
	
		wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);
		
		upperPanel = newPackerPanel();
		Label filepath = new Label("File",Label.LEFT);
		_filePath = new TextField("",20);
		upperPanel.add("label;side=right;expand=true;padx=3;fill=both",browse);
		upperPanel.add("label;side=right;expand=true;padx=3;fill=both",open);
		upperPanel.add("label;side=right;expand=true;padx=3;fill=both",_filePath);
		upperPanel.add("label;side=right;expand=true;padx=3",filepath);


		centerPanel = newPackerPanel();		
		routerPanel = newPackerPanel();
		routerPanel.add("panel;expand=true;fill=both", _routerp);
	
		myPanel = newPackerPanel();
		myPanel.add("panel;expand=true;fill=both", _myp);
		
		tf = new TabFolder("Router", routerPanel);
	  tf.addTab("MyAddress", myPanel);
    centerPanel.add("TabFolder;side=top;pady=5", tf);
		
		lowerPanel = newPackerPanel();
		lowerPanel.add("label;side=right;expand=true;padx=10;fill=both", close);
		lowerPanel.add("label;side=right;expand=true;padx=10;fill=both", start);
		lowerPanel.add("label;side=right;expand=true;padx=10;fill=both", save);
		
		wholePanel.add("panel;side=top;padx=5;pady=10;fill=both", upperPanel);
		wholePanel.add("panel;side=top;padx=5;pady=5", centerPanel);
		wholePanel.add("panel;side=top;expand=false;fill=both;padx=5;pady=5", lowerPanel);
				
		return wholePanel;
	}


  /**
  * ActionPerformed implementation
  */
	public void actionPerformed(ActionEvent event) {
      String source = event.getActionCommand();

      if(source.equals("Open"))  {
				openAction();
      }
      else
      if(source.equals("Browse"))  {
		   	browseAction();
      }
      else
      if(source.equals("Save"))  {
		   	saveAction();
      }
      else
      if(source.equals("Start"))  {
		   	startAction();
      }
      else
      if(source.equals("Quit"))  {
		   	quitAction();
      }
  }  

	protected void openAction()  {
		String filepath = _filePath.getText();
		try  {
			RandomAccessFile in = new RandomAccessFile(filepath,"rw");
			
			while(true)  {
				String line = in.readLine();
				if(line == null)  break;
				
				String next;
				
				if(line.startsWith("MyAddress"))  {
					next = in.readLine();
					_myAddress = new Address(next);
					_myp.setAddress(_myAddress);
				}
				else
				if(line.startsWith("RouterAddress"))  {
					next = in.readLine();
					_routerAddress = new Address(next);
					_routerp.setRouterAddress(_routerAddress);
				}
				else
				if(line.startsWith("RouterRegistrarAddress"))  {
					next = in.readLine();
					_registrarAddress = new Address(next);
					_routerp.setRegistrarAddress(_registrarAddress);
				}
				else
				if(line.startsWith("RegisterRequest"))  {
					next = in.readLine();
					if(next.startsWith("y"))  {
						_registerRequest = true;
						_routerp.setRegisterRequest(true);
					}
					else  {
						_registerRequest = false;
						_routerp.setRegisterRequest(false);
					}		
				}
				else
				if(line.startsWith("MaxIdleTime"))  {
					next = in.readLine();
					_durationTime = next;
					_routerp.setDurationTime(next);
				}	
			}
			
			in.close();
			
			
			
			
		} catch (Exception e)  {
			System.out.println(e.toString());
		}		
	}
	
	protected void browseAction()  {
		FileDialog fd = new FileDialog(this,"Open Address File");
		fd.show();
		String dir = fd.getDirectory();
		String file = fd.getFile();
		String filepath = dir + file;
		_filePath.setText(filepath);
	}	
		
	protected void saveAction()  {
		_myAddress = _myp.getAddress();
		_routerAddress = _routerp.getRouterAddress();
		_registrarAddress = _routerp.getRegistrarAddress();
		_registerRequest = _routerp.getRegisterRequest();
		_durationTime = _routerp.getDurationTime();
		
		String filepath = _filePath.getText();
		try  {
			RandomAccessFile out = new RandomAccessFile(filepath,"rw");
			out.writeBytes("MyAddress\n");
			out.writeBytes(getAddressString(_myAddress) + "\n");
			out.writeBytes("RouterAddress\n");
			out.writeBytes(getAddressString(_routerAddress) + "\n");
			out.writeBytes("RouterRegistrarAddress\n");
			out.writeBytes(getAddressString(_registrarAddress) + "\n");
			out.writeBytes("RegisterRequest\n");
			if(_registerRequest == true)  {
				out.writeBytes("yes\n");
			}
			else  {
				out.writeBytes("no\n");
			}
			out.writeBytes("MaxIdleTime\n");
			out.writeBytes(_durationTime + "\n");
			
			out.close();
		} catch (Exception e) {
			System.out.println(e.toString());
		}		
	}			
		
			
	protected String getAddressString(Address addr)  {
		String retstr = addr.getID();
		retstr = retstr + "," + addr.getHost() + "," + Integer.toString(addr.getPort()) + ",";
		retstr = retstr + addr.getType() + "," + addr.getDescription();
		return retstr;
	}		
	
	protected void startAction()  {
		_myAddress = _myp.getAddress();
		_routerAddress = _routerp.getRouterAddress();
		_registrarAddress = _routerp.getRegistrarAddress();
		_registerRequest = _routerp.getRegisterRequest();
		_durationTime = _routerp.getDurationTime();
		
		if((_myAddress != null) && (_routerAddress != null))  {
			try  {
    		Class c = Class.forName(_RCActionClassName);
    		_action = (RouterClientAction)c.newInstance();
    		_action.setMyAddress(_myAddress);
    		_action.setRouterAddress(_routerAddress);
    		_action.setRegistrarAddress(_registrarAddress);
    		
    		if(!_durationTime.equals(""))  {
    			int idletime = (Integer.valueOf(_durationTime)).intValue();
					_action.setDurationTime(idletime);
				}	
				    		
    		if(_registerRequest == true)  {
	    		_action.register(_registrarAddress,_myAddress);
    		}

				if(_myAddress.getPort() != -1)  {    		
					// Since stand alone, create server thread using my address
					_action.createServerThread(_myAddress.getID(),Thread.NORM_PRIORITY);
				}
		
				// connect to the router by sending my address
				_action.connect(_myAddress);
    		_action.start();	
			} catch (Exception e)  {
  		 	System.out.println(e.toString());
			}
		}
		else {
			System.out.println("My address and Router address should be specified");
		}		
		
	}		
	
	protected void quitAction()  {
		if(_action != null)  {
			if(_action.isAlive())  {
				_action.endAction();
			}	
		}
		dispose();
	}

	private int getInt(String str)
	{
		return (Integer.valueOf(str)).intValue();
	}
	
}		