package RouterLayer.AgentClient.Example.CalcServer;

import java.awt.*;
import java.util.*;

import RouterLayer.AgentClient.Example.RCApplet.extawt.*;
import Abstract.*;
import KQMLLayer.*;

/**
* Sub component of the RCAddressHelper class. 
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class RouterPanel extends Panel  {
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
	Color bkgColor = new Color(210,210,210);

	/**
	* router name
	*/	
	TextField _rname;
	
	/**
	* router host inetaddress
	*/
	TextField _rhost;
	
	/**
	* router port
	*/
	TextField _rport;
		
	/**
	* registrar name
	*/	
	TextField _regname;
	
	/**
	* registrar host name. Normally the same as the router host name
	*/
	TextField _reghost;
	
	/**
	* registrar port
	*/
	TextField _regport;
	
	/**
	* Maximum idle time for the received connections
	*/
	TextField _durationTime;

	/**
	* Register request check box
	*/
	Checkbox _registerRequest;
	
	/**
	* Default constructor
	*/
	public RouterPanel()  
	{
		setLayout(new BorderLayout());
		add("Center", GUIComponents());
	}
	
	/**
	* Set router address
	* @param addr Router address
	*/
	public void setRouterAddress(Address addr)  {
		_rname.setText(addr.getID());
		_rhost.setText(addr.getHost());
		_rport.setText(Integer.toString(addr.getPort()));
		_regname.setText(addr.getID());
		_reghost.setText(addr.getHost());
	}	
		
	/**
	* Set registrar address
	* @param addr Registrar address
	*/	
	public void setRegistrarAddress(Address addr)  {
		_regname.setText(addr.getID());
		_reghost.setText(addr.getHost());
		_regport.setText(Integer.toString(addr.getPort()));
	}	

	/**
	* Set register request
	* @param tf if true, register will be requested
	*/
	public void setRegisterRequest(boolean tf)  {
		_registerRequest.setState(tf);
	}	
	
	/**
	* Set duration time
	* @param time Maximum idle time for the received thread, in minutes
	*/
	public void setDurationTime(String time)  {
		_durationTime.setText(time);
	}	
		
	/**
	* GUI component panel construction
	* @return GUI components panel
	*/	
	protected Panel GUIComponents()  {
		Panel wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);
		
		Panel rNamePanel = newPackerPanel();
		Label rname = new Label("Router Name:", Label.RIGHT);
		_rname = new TextField("",20);
		rNamePanel.add("label;side=right;fill=both", _rname);
		rNamePanel.add("label;side=right;padx=5;fill=both", rname);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", rNamePanel);
		
		Panel rHostPanel = newPackerPanel();
		Label rhost = new Label("Host",Label.RIGHT);
		_rhost = new TextField("",20);
		rHostPanel.add("label;side=right;fill=both", _rhost);        
		rHostPanel.add("label;side=right;padx=5;fill=both", rhost);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", rHostPanel);
		
		Panel rPortPanel = newPackerPanel();
		Label rport = new Label("Router Port:",Label.RIGHT);
		_rport = new TextField("",20);
		rPortPanel.add("label;side=right;fill=both", _rport);        
		rPortPanel.add("label;side=right;padx=5;fill=both", rport);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", rPortPanel);
		
		Panel regNamePanel = newPackerPanel();
		Label regname = new Label("Registrar Name:", Label.RIGHT);
		_regname = new TextField("",20);
		regNamePanel.add("label;side=right;fill=both", _regname);
		regNamePanel.add("label;side=right;padx=5;fill=both", regname);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", regNamePanel);
		
		Panel regHostPanel = newPackerPanel();
		Label reghost = new Label("Host",Label.RIGHT);
		_reghost = new TextField("",20);
		regHostPanel.add("label;side=right;fill=both", _reghost);        
		regHostPanel.add("label;side=right;padx=5;fill=both", reghost);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", regHostPanel);
		
		Panel regPortPanel = newPackerPanel();
		Label regport = new Label("Port:",Label.RIGHT);
		_regport = new TextField("",20);
		regPortPanel.add("label;side=right;fill=both", _regport);        
		regPortPanel.add("label;side=right;padx=5;fill=both", regport);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", regPortPanel);
		
		Panel idlePanel = newPackerPanel();
		Label idle = new Label("Max. Idle Time:",Label.RIGHT);
		_durationTime = new TextField("",20);
		idlePanel.add("label;side=right;fill=both", _durationTime);        
		idlePanel.add("label;side=right;padx=5;fill=both", idle);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", idlePanel);
		
		
		Panel rrPanel = new Panel();
		rrPanel.setLayout(new GridLayout(1,2));
		Label rr = new Label("Register Request:");
		_registerRequest = new Checkbox();
		rrPanel.add(rr);
		rrPanel.add(_registerRequest);        
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", rrPanel);
		
		return wholePanel;
	}
	
	/**
	* Get router address
	* @return Router address
	*/			
	public Address getRouterAddress()  {
		String rname = _rname.getText();
		String rhost = _rhost.getText();
		String rport = _rport.getText();
		
		Address addr = new Address(rname,rhost,(Integer.valueOf(rport)).intValue(),"MessageRouter","(MessageRouter)");
		return addr;
	}
	
	/**
	* Get registrar address
	* @return Registrar address
	*/
	public Address getRegistrarAddress()  {
		String rname = _regname.getText();
		String rhost = _reghost.getText();
		String rport = _regport.getText();
		
		Address addr = new Address(rname,rhost,(Integer.valueOf(rport)).intValue(),"MessageRouter","(MessageRouterRegistrar)");
		return addr;
	}
	
	/**
	* Get register request 
	* @return true if registraion is requested
	*/
	public boolean getRegisterRequest()  {
		return _registerRequest.getState();
	}	
	
	/**
	* Get maximum idle time
	* @return Maximum idle time
	*/
	public String getDurationTime()  {
		return _durationTime.getText();
	}
		
	public Insets insets()   
	{
    	return new Insets(10, 10, 10, 10);
  	}
  	
  	private Panel newPackerPanel()
	{
		Panel p = new Panel();
		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}																			
}	
				