package RouterLayer.AgentClient.Example.NBanner;

import Abstract.*;
import RouterLayer.*;
import RouterLayer.AgentClient.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class BannerAgent extends RouterClientAction  {

	BannerControlFrame _controlFrame = null;
		
	public BannerAgent(Address myAddress,
										 Address routerAddress,
										 Address registrarAddress)  {
		super(myAddress,routerAddress,registrarAddress,1000);
	}
	
	public void setBannerControlFrame(BannerControlFrame f)  {
		_controlFrame = f;
	}	
	
  public boolean Act(Object o)  {
    String stampmsg = (String)o;
   
    //KQMLmail wrap the KQMLmessage
    try  {
      KQMLmail mail = new KQMLmail(stampmsg,_mailQueue.size());
      _mailQueue.addElement(mail);
      _controlFrame.messageAction(mail.getKQMLmessage());
      addToDeleteBuffer(0);
      
    } catch (Exception e)  {
      System.out.println(e.toString());
    }	
    return true;
	}
	
  public void processMessage(String command,Object obj)  {}
}	