package RouterLayer.AgentClient.Example.NBanner;


import java.awt.*;
import RouterLayer.AgentClient.*;
import Abstract.*;
import KQMLLayer.*;
import java.util.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class BannerControlFrame extends Frame  {

  BannerAgent _agent;
  String _bannerName;
  NBColorPicker _colorPicker;
  java.awt.List _fontList;
  Address _myAddress;
  Address _routerAddress;
  Address _registrarAddress;

  TextArea _in;
  TextArea _out;
  Button _requestFont;

  NBannerApplet _parent;

  public BannerControlFrame(Address myAddress,
			    Address routerAddress,
			    Address registrarAddress,
			    String bannerID)   {

     super(myAddress.getID());
     _myAddress = myAddress;
     _routerAddress = routerAddress;
     _registrarAddress = registrarAddress;

     _bannerName = bannerID;

      _agent = new BannerAgent(_myAddress,_routerAddress,_registrarAddress);
      _agent.setBannerControlFrame(this);

     initGUI();
  }

  public void setApplet(NBannerApplet p)  {
  	_parent = p;
  }

	public void register()  throws ConnectionException {
    try  {
      _in.appendText("Register to router as " + _myAddress.getID() + "...\r\n");
      _agent.register();
      _in.appendText("Register success\r\n");
		}  catch (Exception e)  {
			_in.appendText("Register fail " + e.toString());
    	throw new ConnectionException(e.toString());

		}
	}

	public void unregister()  throws ConnectionException {
    try  {
      _in.appendText("Unregister from router..\r\n");
      _agent.unregister();
      _in.appendText("Unregister success\r\n");
		}  catch (Exception e)  {
			_in.appendText("Unregister fail " + e.toString());
    	throw new ConnectionException(e.toString());

		}
	}

	public void connect()  throws ConnectionException {
    try  {
      _in.appendText("Connecting ...\r\n");
      _agent.connect();
      _in.appendText("Connect success\r\n");
			_agent.start();
		}  catch (Exception e)  {
			_in.appendText("Connect fail " + e.toString());
    	throw new ConnectionException(e.toString());

		}

  }

	public void disconnect() throws ConnectionException  {
    try  {
      _in.appendText("Disconnecting ...\r\n");
      _agent.disconnect();
      _in.appendText("Disconnect success\r\n");
		}  catch (Exception e)  {
			_in.appendText("Disconnect fail " + e.toString());
    	throw new ConnectionException(e.toString());

		}
  }

  public void initGUI()   {
    Panel buttonPanel = new Panel();

    buttonPanel.add(new Button("   <<   "));
    buttonPanel.add(new Button("Play"));
    buttonPanel.add(new Button("   >>   "));
    buttonPanel.add(new Button("Pause"));

    add("North",buttonPanel);

    Panel optionPanel = new Panel();
    _colorPicker = new NBColorPicker();
    _fontList = new java.awt.List(7,false);
    _fontList.addItem("                  ");

    Panel obuttonPanel = new Panel();
    obuttonPanel.setLayout(new GridLayout(4,1));
    _requestFont = new Button("Request Font");
    obuttonPanel.add(_requestFont);
    obuttonPanel.add(new Button("Change Font"));
    obuttonPanel.add(new Button("Change Color"));
    obuttonPanel.add(new Button("Change Text"));

    optionPanel.add("West",_colorPicker);
    optionPanel.add("Center",_fontList);
    optionPanel.add("East",obuttonPanel);

    add("Center",optionPanel);

    Panel messagePanel = new Panel();
    messagePanel.setLayout(new GridLayout(2,1));
    _in = new TextArea(10,20);
    _in.setText("Incoming Message\r\n");
    messagePanel.add(_in);

    _out = new TextArea(10,20);
    messagePanel.add(_out);
    _out.setText("Outgoing message\r\n");
    add("South",messagePanel);

    resize(350,540);
//    show();
  }

  public void messageAction(KQMLmessage kqml)  {
    String perf = kqml.getValue("performative");
    if(perf.equals("reply"))  {
      try  {
	String content = kqml.getValue("content");
	Vector v = new takeOffList(content);
	if(v.size() != 0)  {
	  String cperf = (String)v.elementAt(0);
	  if(cperf.equals("font-list"))  {
	    _fontList.delItem(0);
	    for(int i=1; i < v.size(); i++)  {
	      _fontList.addItem((String)v.elementAt(i));
	    }
	    _requestFont.disable();
	  }

	}
      } catch (Exception e) {}
    }

    displayReceivedMessage(kqml);
  }

  public void displayReceivedMessage(KQMLmessage kqml)  {
    _in.appendText("============================================\r\n");

    _in.appendText(kqml.getReadString());
//    _parent.increaseReceivingMessageNumber("NControl");
  }

  public void displaySendMessage(KQMLmessage kqml)  {
    _out.appendText("============================================\r\n");

    _out.appendText(kqml.getReadString());
//    _parent.increaseSendingMessageNumber("NControl");
  }

  public void sendAskMessage(String content,String replyWith)  {
    String sendmsg = "(ask :sender ";
    sendmsg = sendmsg + _myAddress.getID() + " :receiver ";
    sendmsg = sendmsg + _bannerName + " :content " + content;
    if((replyWith != null) && (!replyWith.equals("")))  {
      sendmsg = sendmsg + " :reply-with " + replyWith;
    }

    sendmsg += ")";

    try  {
	    _agent.sendMessage(sendmsg);
      displaySendMessage(new KQMLmessage(sendmsg));
    } catch (Exception e) {}
  }

  public void sendTellMessage(String content)  {
    String sendmsg = "(tell :sender ";
    sendmsg = sendmsg + _myAddress.getID() + " :receiver ";
    sendmsg = sendmsg + _bannerName + " :content " + content;
    sendmsg += ")";

    try  {
    	KQMLmessage kqml = new KQMLmessage(sendmsg);
      displaySendMessage(kqml);
	    _agent.sendMessage(kqml);
    } catch (Exception e)  {
    	System.out.println(sendmsg);
    }
  }

  public boolean action(Event evt, Object arg)	{

    if (evt.target instanceof Button) {
      if(arg.equals("Request Font"))  {
	sendAskMessage("request-font","font");
      }
      else
	if(arg.equals("Change Font"))  {
	  int selNo = _fontList.getSelectedIndex();
	  if(selNo != -1)  {
	    String fontid = _fontList.getItem(selNo);
	    String content = "(change-font " + fontid + ")";
	    sendTellMessage(content);
	  }
	}
	else
	  if(arg.equals("Change Color"))  {
	    String bkcolor = _colorPicker.getBackgroundColor();
	    String textColor = _colorPicker.getTextColor();

	    String content = "(change-color " + bkcolor + " " + textColor + ")";
	    sendTellMessage(content);
	  }
	  else
	    if(arg.equals("Change Text"))  {
	      TextInputDialog dlg = new TextInputDialog(this);
	    }
	    else
	      if(arg.equals("   <<   "))    {
		sendTellMessage("increase-speed");
	      }
	      else
		if(arg.equals("Play"))  {
		  sendTellMessage("play");
				}
		else
		  if(arg.equals("   >>   "))  {
		    sendTellMessage("decrease-speed");
		  }
		  else
		    if(arg.equals("Pause"))  {
		      sendTellMessage("pause");
		    }
    }

    return true;
  }

  public boolean handleEvent(Event evt)   {

    if (evt.id == Event.WINDOW_DESTROY)   {
      stop();
    }

    return super.handleEvent(evt);
  }

  public void changeText(String text)   {
    String content = "(change-text   (" + text + "))";
    sendTellMessage(content);
  }

  public void stop()  {
    if(_agent != null)  {
      _agent.endAction();
    }

    if(_parent != null)  {
      _parent.notifyClose("NControl");
		}

    dispose();
  }

  public static void main(String args[])  {
    try  {
      BannerControlFrame f =
	new BannerControlFrame(
			       new Address("CADApplet",null,-1,"MessageMethod","(agent-info :password jhc)"),
			       new Address("Router","ev-95-86a.stanford.edu",4444,"MessageRouter",null),
			       new Address("RouterRegistrar","ev-95-86a.stanford.edu",4445,"MessageRouter",null),
			       "CADStandAlone");
      f.show();
    }  catch (Exception e)  {
      System.out.println(e.toString());
    }
  }

}
