package RouterLayer.AgentClient.Example.NBanner;

import java.awt.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class NBColorPicker extends Canvas  {
	
  Color[] _color;
  Rectangle[] _rect;
  Color _colorPicked;
  
  public NBColorPicker()  {
    
    _rect = new Rectangle[14];
    int size = 20;
    
    int startx = 0; int starty = 0;
    int k=0;
    for(int i=0; i < 4; i++)  {
      for(int j=0; j < 3; j++)  {
	_rect[k++] = new Rectangle(i*size,j*size,size,size);
      }
    }
    
    _rect[12] = new Rectangle(size/2,size*4 - 2,size,size); 
    _rect[13] = new Rectangle(size/2 + size* 2,size*4 - 2,size,size);
    
    _color = new Color[14];
    _color[0] = Color.black; 
    _color[1] = Color.darkGray; 
    _color[2] = Color.white; 
    _color[3] = Color.lightGray; 
    _color[4] = Color.cyan; 
    _color[5] = Color.green; 
    _color[6] = Color.magenta; 
    _color[7] = Color.orange; 
    _color[8] = Color.pink; 
    _color[9] = Color.red; 
    _color[10] = Color.yellow; 
    _color[11] = Color.blue; 
    _color[12] = Color.black; 
    _color[13] = Color.white; 
    
    _colorPicked = null;
    
    resize(2 + size*4 + 2, size * 5);
  }	
  
  public String getBackgroundColor()  {
    int r = _color[12].getRed();
    int g = _color[12].getGreen();
    int b = _color[12].getBlue();
    
    String retstr = "(" + Integer.toString(r) + " " + Integer.toString(g) + " " + Integer.toString(b) + ")";
    return retstr;
  }
  
  public String getTextColor()   {
    int r = _color[13].getRed();
    int g = _color[13].getGreen();
    int b = _color[13].getBlue();
    
    String retstr = "(" + Integer.toString(r) + " " + Integer.toString(g) + " " + Integer.toString(b) + ")";
    return retstr;
	}	
  
  
  public boolean mouseDown(Event e,int x,int y)  {
    if(_colorPicked != null)   {
      if(contained(_rect[12],x,y))  {
	_color[12] = _colorPicked;
      }
      else 
	if(contained(_rect[13],x,y))  {
	  _color[13] = _colorPicked;
	}		
      _colorPicked = null;
      repaint();	
    }
    else  {	
      for(int i=0; i < 12; i++)  {
	if(contained(_rect[i],x,y))  {
	  _colorPicked = _color[i];
	  break;
				}
      }		
    }
    
    return true;		
  }
 
  protected boolean contained(Rectangle rect,int x,int y) {
    if((x >= rect.x) && (x <= (rect.x + rect.width)) &&
       (y >= rect.y) && (y <= (rect.y + rect.height))) {
      return true;
    }

    return false;
  }
  
  public void paint(Graphics g)  {	
    Color old = g.getColor();
    for(int i=0; i < 14; i++)  {
      g.setColor(_color[i]);
      g.fillRect(_rect[i].x,_rect[i].y,_rect[i].width,_rect[i].height);
      g.setColor(Color.black);
      g.drawRect(_rect[i].x,_rect[i].y,_rect[i].width,_rect[i].height);
    }
    g.drawString("  Back     Text",0,75);
    g.setColor(old);
  }
  
  public void update(Graphics g) {
    Color old = g.getColor();
    for(int i=12; i < 14; i++)  {
      g.setColor(_color[i]);
      g.fillRect(_rect[i].x,_rect[i].y,_rect[i].width,_rect[i].height);
      g.setColor(Color.black);
      g.drawRect(_rect[i].x,_rect[i].y,_rect[i].width,_rect[i].height);
    }	
    g.setColor(old);
  }		
  
}