package RouterLayer.AgentClient.Example.NBanner;

import Abstract.*;
import BaseLayer.*;
import KQMLLayer.*;
import RouterLayer.Router.*;
import RouterLayer.AgentClient.*;

import java.net.*;
import java.lang.*;
import java.io.*;
import java.util.*;

/**
* A RouterClient example. This example implements the Act(Object) and processMessage(String,String[]),
* those are declared as abstract in the RouterClientAction class. The Act(Object) method will pass
* the received message to the RCApplet object to display the message. 
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class NBannerAction extends RouterClientAction {

	// since this example use GUI frame
	NBannerFrame _agentFrame;

	// set GUI	
	public void setAgentFrame(NBannerFrame f)  {
		_agentFrame = f;
	}

	/**
	* Default constructor
	*/
	public NBannerAction()  {
		super();
	}


	/**
	* Will be invoked by an aglet. 
	* @param routeraddress Router address
	* @param registraraddress Registrar address
	*/
	public NBannerAction(Address myaddress,Address routeraddress,Address registraraddress)  {
		// set maximum idle time to the connection as 20 minutes.
		super(myaddress,routeraddress,registraraddress,20);
	}
	
 	/**
 	* Example to display the message to the _agentApplet.
 	* @param o Received message string
 	*/
 	public boolean Act(Object o)  {
 		String stampmsg = (String)o;
 		try  {
	 		//KQMLmail wrap the KQMLmessage
 			KQMLmail mail = new KQMLmail(stampmsg,0);
 			
 			// add the mail to the _mailQueue.
 			_mailQueue.addElement(mail);
 			
 			// agentApplet will update the list panel
			_agentFrame.processMessage(mail);
			
			// 'delete-message' message should be sent after the message is received and performed.
			addToDeleteBuffer(0);
 		} catch (Exception e)  {
 			return false;
 		}

 		return true;
  }

	/**
	* This class does not use the processMessage
	* @param command Command string
	* @param obj Reference object
	*/
  public void processMessage(String command,Object obj)  {
  }
  
  /**
  * Send error message if the received message contains error.
  * Invoked by the Applet
  * @param receiver Receiver
  * @param content Message content
  */
	public void sendErrorMessage(String receiver,String content)  {  	
    String sendstr = "(error :sender ";
    sendstr = sendstr + _myAddress.getID() + " :receiver " + receiver;
    sendstr = sendstr + " :content (" + content + ") :language KQML)";
    try  {
    	sendMessage(sendstr);
    } catch (Exception e)  {
    	MessageBox b = new MessageBox(e.toString(),_agentFrame);
    }		
  }  

}