package RouterLayer.AgentClient.Example.NBanner;

import KQMLLayer.*;
import Abstract.*;
import RouterLayer.AgentClient.*;

import java.awt.*;
import java.util.*;
import java.applet.*;
import java.net.*;

/**
* This is a simple example of the JATLite applet. 
* First, you will need to implement RouterClientAction like BannerAction class, to notify
* a message(actually invoke the processMessage(KQMLmail) method of BannerApplet object) to
* the BannerApplet. Refer to BannerAction.java. The received message will be parsed and
* performed according to the message content.
* See the init() method. It will show that how the BannerAction object created.
* See the action(Event,Object) method. Several methods of the RouterClientAction will be
* invoked.
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class NBannerApplet extends Applet implements ButtonBarAppletOld {
  NBannerFrame _bannerFrame;
  BannerControlFrame _controlFrame; 

 	ButtonBarOld _bannerBar;	
 	ButtonBarOld _controlBar;	

	MediaTracker _tracker;
	Image[] _image;
	
	ImgButtonOld _bregister;
	ImgButtonOld _bconnect;
	ImgButtonOld _cregister;
	ImgButtonOld _cconnect;
	ImgButtonOld _btitle;
	ImgButtonOld _ctitle;
	
	/**
  * Note : Component isShowing() method is not working in Netscape
  */
	boolean _bannerIsShowing = false;
	boolean _controlIsShowing = false;	
	
	Address _bannerAddress,_controlAddress,_routerAddress,_registrarAddress;
	
  public NBannerApplet()  {
  }
  
  /**
   * Create a RouterClientAction object. You will pass the Router/Registrar address as the 
   * parameters and this method will make Address objects for them. Then, the addresses will
   * be passed to the constructor of BannerAction.
   */
  public void init() {
  
  	  
    // Address data for the router and registrar
    String routername = getParameter("ROUTERNAME");
    String host = getParameter("ROUTERHOST");
    String port = getParameter("ROUTERPORT");
    String registrarname = getParameter("REGISTRARNAME");
    String registrarport = getParameter("REGISTRARPORT");
    
    // create the addresses of router/registrar
    _routerAddress = new Address(routername,host,(Integer.valueOf(port)).intValue(),"MessageRouter","(Router)");
    _registrarAddress = new Address(registrarname,host,(Integer.valueOf(registrarport)).intValue(),"MessageRouter","(RouterRegistrar)");
    
    Date d = new Date();
    long myNumber = d.getTime();
    String bannerName = "NBanner" + myNumber;
    String controllerName = "Control" + myNumber;
    _bannerAddress = new Address(bannerName,"null",-1,"MessageRouter","(agent-info :password " + bannerName + ")");
    _controlAddress = new Address(controllerName,"null",-1,"MessageRouter","(agent-info :password " + controllerName + ")");
    
    createBannerFrame();
    createControlFrame();
    
    initGUI();
  }

	protected void createBannerFrame()    {
		if(_bannerFrame == null) {
    	_bannerFrame = new NBannerFrame(_bannerAddress,_routerAddress,_registrarAddress,_controlAddress.getID());
 	    _bannerFrame.setApplet(this);
		}
	}

	protected void createControlFrame()   {
		if(_controlFrame == null)  {
    	_controlFrame = new BannerControlFrame(_controlAddress,_routerAddress,_registrarAddress,_bannerAddress.getID());
     // set applet to be notified the received message from the BannerAction
   	 _controlFrame.setApplet(this);
   	} 
	}		
										
			
  public boolean handleEvent(Event evt)   {  
 
    if (evt.id == Event.WINDOW_DESTROY)  {
    	closeFrames();
    }
    
    return super.handleEvent(evt);
  }  
  
  protected void closeFrames()  {
	    if(_bannerFrame != null)  {
  	    try {
    	  	// disconnect router connection
      		_bannerFrame.stop();	
      	} catch (Exception e)  {
      	}		
	    }		
    
  	  if(_controlFrame != null)  {
    		try  {
    			// disconnect router connection
      		_controlFrame.stop();
      	} catch (Exception e)  {
      	}		
    	}		
	}
	  	
  public void start()  {
  }	
  
  protected void initGUI()  {
  	_tracker = new MediaTracker(this);
 	
  	_image = new Image[22];
  	
  	_bannerBar = new ButtonBarOld(this,430,50);
  	_controlBar = new ButtonBarOld(this,430,50);
  	
   	URL url = getDocumentBase();
  	
  	_image[0] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/btitled.gif");
  	_image[1] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/btitlec.gif");
  	_image[2] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/btitle.gif");
  	
  	_image[3] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/ctitled.gif");
  	_image[4] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/ctitlec.gif");
  	_image[5] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/ctitle.gif");
  	

  	_image[6] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/registerd.gif");	
  	_image[7] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/registera.gif");
  	_image[8] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/registerc.gif");
  	_image[9] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/registeri.gif");
  	
  	
  	_image[10] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/connectd.gif");	
  	_image[11] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/connecta.gif");
  	_image[12] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/connectc.gif");
  	_image[13] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/connecti.gif");
  	
  	
  	_image[14] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/unregisterd.gif");	
  	_image[15] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/unregistera.gif");
  	_image[16] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/unregisterc.gif");
  	_image[17] = _image[9];
  	
  	
  	_image[18] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/disconnectd.gif");	
  	_image[19] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/disconnecta.gif");
  	_image[20] = getImage(url,"RouterLayer/AgentClient/Example/NBanner/disconnectc.gif");
  	_image[21] = _image[13];  	
  	
  	for(int i=0; i < 22; i++)  {
  		_tracker.addImage(_image[i],0);
  	}
  		
   	try  {
   		showStatus("Button Image Loading...");
	  	_tracker.waitForID(0);			
	  	showStatus("Image loading done");
	  } catch (Exception e)  {
	  	System.out.println(e.toString());
	  }		
  		
  	_btitle = new ImgButtonOld("Start Banner",_image[0],_image[0],_image[1],_image[2],_bannerBar);
  	_bregister = new ImgButtonOld("Register-B  ",_image[6],_image[7],_image[8],_image[9],_bannerBar);
  	_bconnect = new ImgButtonOld("Connect-B  ",_image[10],_image[11],_image[12],_image[13],_bannerBar);
  	_bannerBar.addButton(_btitle);
	 	_bannerBar.addButton(_bregister);
	 	_bannerBar.addButton(_bconnect);
	 	// disable 
	 	_bannerBar.setPersistentButton("Register-B  ",3);
	 	_bannerBar.setPersistentButton("Connect-B  ",3);
	 	
  	_ctitle = new ImgButtonOld("Start Control",_image[3],_image[3],_image[4],_image[5],_controlBar);
  	_cregister = new ImgButtonOld("Register-C  ",_image[6],_image[7],_image[8],_image[9],_controlBar);
  	_cconnect = new ImgButtonOld("Connect-C  ",_image[10],_image[11],_image[12],_image[13],_controlBar);
  	_controlBar.addButton(_ctitle);
	 	_controlBar.addButton(_cregister);
	 	_controlBar.addButton(_cconnect);
	 	
	 	_controlBar.setPersistentButton("Register-C  ",3);
	 	_controlBar.setPersistentButton("Connect-C  ",3);
	 	
  	
  	add(_bannerBar);
  	add(_controlBar);
  	
  	setBackground(Color.white);

  }

	// frame closed. Disable buttons
	public void notifyClose(String id)  {
		if(id.equals("NControl"))  {
			_cregister.setImage(_image[9],_image[9],_image[9],_image[9]);
			_cregister.setName("Next Demo    ");
			_cconnect.setImage(_image[13],_image[13],_image[13],_image[13]);
			_cconnect.setName("Next Demo    ");
			
		}
		else
		if(id.equals("NBanner"))  {
			_bregister.setImage(_image[9],_image[9],_image[9],_image[9]);
			_bregister.setName("Next Demo    ");
			_bconnect.setImage(_image[13],_image[13],_image[13],_image[13]);
			_bconnect.setName("Next Demo    ");
		}		
	}		
		
 	public void processButtonPressed(String buttonName,int x,int y)  {}
	public void processButtonReleased(String buttonName,int x,int y)  {
  	if(buttonName.equals("Start Banner"))  {
  		_bannerFrame.show(true);
  		_bannerIsShowing = true;
  		_bannerBar.setPersistentButton("Start Banner",3);
  		_bannerBar.setPersistentButton("Register-B  ",-1);
  		_bannerBar.setState("Register-B  ",0);
  		_btitle.setName("Banner Started");
  	}
  	else
  	if(buttonName.equals("Start Control"))  {
  		_controlFrame.show(true);
  		_controlIsShowing = true;
  		createControlFrame();
  		_controlBar.setPersistentButton("Start Control",3);
  		_controlBar.setPersistentButton("Register-C  ",-1);
  		
  		
  		_controlBar.setState("Register-C  ",0);
  		_ctitle.setName("Controller Started");
  		
  	}
  	else 
		if(buttonName.equals("Register-B  "))  {
			
			if(!_bannerIsShowing) {
				
				MessageBox b = new MessageBox("Banner is not started",getFrame());
				return;
			}
			try  {
				// OK. Release Connect button
	  		_bannerBar.setPersistentButton("Connect-B  ",-1);
				_bannerBar.setState("Connect-B  ",0);
				
				_bannerFrame.register();
				MessageBox b = new MessageBox("Registered",_bannerFrame);
				_bregister.setImage(_image[14],_image[15],_image[16],_image[17]);
				_bregister.setName("Unregister-B");
				
			}  catch (Exception e)  {
				displayError("Router is not running");
			}			
		}
		else
		if(buttonName.equals("Connect-B  "))  {
			if(!_bannerIsShowing) {
				MessageBox b = new MessageBox("Banner is not started",getFrame());
				return;
			}
			
			try  {
				_bannerFrame.connect();
				MessageBox b = new MessageBox("Connected",_bannerFrame);
				
				_bconnect.setImage(_image[18],_image[19],_image[20],_image[21]);
				_bconnect.setName("Disconnect-B");
				
			}  catch (Exception e)  {
				displayError("Connection denied");
			}			
				
		}
		else
		if(buttonName.equals("Register-C  "))  {
			if(!_controlIsShowing) {
				MessageBox b = new MessageBox("Controller is not started",getFrame());
				return;
			}
			
			try  {
	  		_controlBar.setPersistentButton("Connect-C  ",-1);
	  		_controlBar.setState("Connect-C  ",0);
				
				_controlFrame.register();
				MessageBox b = new MessageBox("Registered",_controlFrame);
				
				_cregister.setImage(_image[14],_image[15],_image[16],_image[17]);
				_cregister.setName("Unregister-C");
				
			}  catch (Exception e)  {
				displayError("Router is not running");
			}			
		}
		else
		if(buttonName.equals("Connect-C  "))  {
			if(!_controlIsShowing) {
				MessageBox b = new MessageBox("Controller is not started",getFrame());
				return;
			}
			
			try  {
				_controlFrame.connect();
				MessageBox b = new MessageBox("Connected",_controlFrame);
				
				_cconnect.setImage(_image[18],_image[19],_image[20],_image[21]);
				_cconnect.setName("Disconnect-C");
				
			}  catch (Exception e)  {
				displayError("Connection denied");
			}			
		}
		else
		if(buttonName.equals("Unregister-B"))  {
			try  {
				_bannerFrame.unregister();
				MessageBox b = new MessageBox("Unregistered and Disconnected",_bannerFrame);
				notifyClose("NBanner");				
/*				
				_bregister.setImage(_image[2],_image[3],_image[4],_image[5]);
				_bregister.setName("Regiser-B  ");
*/				
			}  catch (Exception e)  {
				displayError(e.toString());
			}			
		}
		else
		if(buttonName.equals("Disconnect-B"))  {
			try  {
				_bannerFrame.disconnect();
				MessageBox b = new MessageBox("Disconnected",_bannerFrame);
				notifyClose("NBanner");				
				
			}  catch (Exception e)  {
				displayError(e.toString());
			}			
		}
		else
		if(buttonName.equals("Unregister-C"))  {
			try  {
				_controlFrame.unregister();
				MessageBox b = new MessageBox("Unregistered and Disconnected",_controlFrame);
				notifyClose("NControl");				
/*				
				_cregister.setImage(_image[2],_image[3],_image[4],_image[5]);
				_cregister.setName("Regiser-C  ");
*/				
				
			}  catch (Exception e)  {
			}			
		}
		else
		if(buttonName.equals("Disconnect-C"))  {
			try  {
				_controlFrame.disconnect();
				MessageBox b = new MessageBox("Disconnected",_controlFrame);
				notifyClose("NControl");				
				
			}  catch (Exception e)  {
			}			
		}
		else
		if(buttonName.equals("Next Demo    "))  {
			try  {
				closeFrames();
				getAppletContext().showDocument(new URL("http://java.stanford.edu/java_agent/jhc/JATLiteBetaRelease/RCApplet.html"),"_parent");
				
			} catch (Exception e) {}	
		}	
  }				
  
  public void displayError(String error)  {
		MessageBox b = new MessageBox("Sorry. Router Error " + error,_bannerFrame);
	}	

	/*
	 * What happens on the Unix Netscape3.0?  	
  public void increaseReceivingMessageNumber(String from)  {
  	if(from.equals("NControl"))  {
  		_controlBar.increaseReceivingMessageNumber();
  	}
  	else  {
  		_bannerBar.increaseReceivingMessageNumber();
  		
  	}			
  }
  
  public void increaseSendingMessageNumber(String from)  {
  	if(from.equals("NControl"))  {
  		_controlBar.increaseSendingMessageNumber();
  		
  	}
  	else  {
  		_bannerBar.increaseSendingMessageNumber();
  		
  	}			
  }
  */ 
	protected Frame getFrame()    {
    	Object frame = getParent();
       	while (!(frame instanceof Frame))
          	frame = ((Component) frame).getParent();
        return (Frame)frame;
  }
  
  /**
   */  
  public void stop()  {
  
  }	

}