package RouterLayer.AgentClient.Example.RCApplet;

import java.awt.*;
import java.util.*;
import java.applet.*;
import java.io.*;

import Abstract.*;
import RouterLayer.AgentClient.*;
import RouterLayer.util.*;
import KQMLLayer.*;
import ProtocolLayer.*;

import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

import webcad_01_0_1.*;

/**
* IPRouter client applet example
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class RCApplet extends Applet {

	RCFrame _left = null;
	RCFrame _right = null;
	Button _lbutton,_rbutton;

	// invoked by applet
	public RCApplet()  {
	}

	public void init()  {
		initGUI();

    try  {
    	String routername = getParameter("RouterName");
    	String host = getParameter("RouterHost");
    	String port = getParameter("RouterPort");
    	String regname = getParameter("RegistrarName");
    	String regport = getParameter("RegistrarPort");
    	String description = getParameter("Description");

	    if((routername == null) || (host == null) || (port == null))  {
				showStatus("Invalid Applet Parameters. Check the parameters");
				System.out.println("Invalid Applet Parameters. Check the parameters");

				destroy();
    	}

    	Address routeraddress = new Address(routername,host,Integer.valueOf(port).intValue(),"MessageRouter",description);
    	Address registraraddress = new Address(regname,host,Integer.valueOf(regport).intValue(),"MessageRouter",description);


			_left = new RCFrame(routeraddress,registraraddress,Thread.currentThread().getThreadGroup(), "", new FramePrincipal(""));
			_right = new RCFrame(routeraddress,registraraddress,Thread.currentThread().getThreadGroup(), "", new FramePrincipal(""));

    } catch (Exception e) { showStatus(e.toString()); }

  }

  //Just two buttons for launch first and second applets
  protected void initGUI()  {
		setBackground(Color.white);
  	_lbutton = new Button("Left");
  	_rbutton = new Button("Right");

  	setLayout(new GridLayout(1,2,30,5));
  	add(_lbutton);
  	add(_rbutton);
  }

  public boolean handleEvent(Event evt)   {

    if (evt.id == Event.WINDOW_DESTROY
				&& evt.target == this) {
      if(_left != null)  {
      	_left.disconnect();
      	_left.dispose();
      	_left = null;
      }

      if(_right != null)  {
      	_right.disconnect();
      	_left.dispose();
      	_right = null;
      }

    }

    return super.handleEvent(evt);
  }

  public boolean action(Event evt, Object arg)   {

    if(evt.target instanceof Button) {
    	if(arg.equals("Left"))  {
    		_left.show(true);
    		_lbutton.disable();
    		return true;
    	}
    	else
      if(arg.equals("Right")) {
      	_right.show(true);
      	_rbutton.disable();
      	return true;
			}

		}
		return super.action(evt, arg);
  }

}
