package RouterLayer.AgentClient.Example.RCApplet;

import java.awt.*;
import java.util.*;

import Abstract.*;
import KQMLLayer.*;
import ProtocolLayer.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

/**
* Sub component of RCApplet
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class RequestPanel extends Panel  {
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
	Color bkgColor = new Color(210,210,210);
	TextField _myname;
	TextField _password;
	TextField _agentname;
	TextArea _echoArea;	
	
	RCFrame _agentFrame;
	Address _myAddress;
	
	Button _list,_disconnect,_addr,_connect;

	public RequestPanel(RCFrame parent)  	{
		setLayout(new BorderLayout());
		_agentFrame = parent;
		_myAddress = parent.getMyAddress();
		add("Center", GUIComponents());
	}		
	
	// will be invoked if the address is changed	
	public void setMyAddress(Address addr)  {
		_myAddress = addr;
		
		_myname.setEditable(true);
		_myname.setText(addr.getID());
		_myname.setEditable(false);
		
		_password.setEditable(true);
		_password.setText(getPassword(addr));
		_password.setEditable(false);
		
		
	}
			
	public void clearMyAddress()  {
		_myname.setEditable(true);
		_myname.setText("");
		
		_password.setEditable(true);
		_password.setText("");
		
	
	}
			
	protected String getPassword(Address addr)  {
		String password = "";
		try  {
			String desc = addr.getDescription();
			KQMLmessage kqml = new KQMLmessage(desc);
			String tmp = kqml.getValue("password");
			if(tmp != null)  {
				password = tmp;
			}
		}  catch (ParseException p)  {}		
		return password;
	}
	
						
	private Panel GUIComponents()  
	{
		Panel wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);
		
		Panel namePanel = newPackerPanel();
		Label myname = new Label("My Name:", Label.RIGHT);
		String mname = "";
		if(_myAddress != null)  {
			mname = _myAddress.getID();
		}	
		_myname = new TextField(mname,8);
		namePanel.add("label;side=right;expand=true;fill=both", _myname);
		namePanel.add("label;side=right;padx=5;expand=true;fill=both", myname);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", namePanel);
		
		Panel passwdPanel = newPackerPanel();
		Label pass = new Label("Password:", Label.RIGHT);
		String mpass = "";
		if(_myAddress != null)  {
			mpass = getPassword(_myAddress);
		}	
		_password = new TextField(mpass,8);
		passwdPanel.add("label;side=right;expand=true;fill=both", _password);        
		passwdPanel.add("label;side=right;padx=5;expand=true;fill=both", pass);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both;padx=20", passwdPanel);
		
		
		Panel connectionPanel = newPackerPanel();
		_connect = new Button("Connect");
		_list = new Button("List Agents");
		_disconnect = new Button("DisConnect");
		
		connectionPanel.add("label;side=right;expand=true;fill=both", _disconnect);     
 		connectionPanel.add("label;side=right;padx=5;expand=true;fill=both", _list);        
		connectionPanel.add("label;side=right;padx=5;expand=true;fill=both", _connect); 
		wholePanel.add("Panel;side=top;pady=5;expand=true;fill=both", connectionPanel);
		
		Panel agentNamePanel = newPackerPanel();
		Label aname = new Label("AgentName:");
		_agentname = new TextField("",8);
		_addr = new Button("Address");
		
		agentNamePanel.add("label;side=right", _addr);        
		agentNamePanel.add("label;side=right;padx=5;expand=true;fill=both", _agentname);    
		agentNamePanel.add("label;side=right", aname); 
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", agentNamePanel);
		
		
		_echoArea = new TextArea("",10,12);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", _echoArea);
	
		enableButtons(false);
		
		return wholePanel;
	}
				
	public void setMyName(String id) 	{
		_myname.setText(id);
	}				
				
 public boolean action(Event evt, Object arg)  
  {
    if(evt.target instanceof Button)  {
      if("Connect".equals(arg))  {
	String name = _myname.getText();
	String pass = _password.getText();
	if((name.equals("")) || (pass.equals("")))  {
	  _echoArea.appendText("Agent name and Password should be specified\n");
	}
	else  {	
	  _agentFrame.connect(name,pass);
	}
	return true;	
      }	
      else if("DisConnect".equals(arg))  {
	_agentFrame.disconnect();
	return true;
      }			
      else if("List Agents".equals(arg)) {
	_agentFrame.listUsers();
	return true;
      }
      else if("Address".equals(arg))  {
	String name = _agentname.getText();
	if(name.equals(""))  {
	  _echoArea.appendText("Agent name should be specified\n");
	}
	else {
	  _agentFrame.requestAddress(name);
	}
	return true;	
      }			
    }
    return super.action(evt, arg);
  }				
				
				
	public void notifyMessage(String msg)  	{
		_echoArea.appendText(msg + "\n");
	}
			
	public void enableButtons(boolean tf)  {
		_disconnect.enable(tf);
		_list.enable(tf);
		_addr.enable(tf);
 		_connect.enable(!tf); 
		
	}		
					
	public Insets insets()   	{
   	return new Insets(10, 10, 10, 10);
 	}
  	
  	  
  private Panel newPackerPanel()	{
		Panel p = new Panel();
		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}																		
}	
				