package RouterLayer.AgentClient.Example.RCApplet;

import RouterLayer.Router.*;
import Abstract.*;

/**
* Example of extension of RouterSecurity. This security object has a GUI 
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class RouterSecurityWithGUI extends RouterSecurity  {
	RCFrame _frame;

	/**
	* Default constructor
	*/
	public RouterSecurityWithGUI()  {
		super();
	}
	
	/**
	* Constructor with AddressTable and password file path. If you do not want password
	* check, it can be null. The constructor does not set password check bit to be true
	* even if you pass the password file as not null.
	* @param addresses AddressTable
	* @param passfile Password file path
	*/
	public RouterSecurityWithGUI(AddressTable addresses,String passfile)  {
		super(addresses,passfile);
	}
	
	public void setRCFrame(RCFrame f)  {
		_frame = f;
	}
	
	public void SystemOut(String str)  {
		if(_frame != null)  {
			_frame.notifyMessage(str);
		}
		else  {
			System.out.println(str);
		}		
	}
}