package Setup;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*
*/

public class SetupMessageBox extends Dialog implements ActionListener  {

	static final int _sizeX = 200;
	protected Font boldFont = new Font("Dialog",Font.PLAIN,12);


	public SetupMessageBox(String str,Frame parent)  {
		super(parent,"JATLite Message",true);
		setGUI(str);
		setFont(boldFont);
	}

	protected void setGUI(String msg)  {
		Vector v = new Vector();
		FontMetrics f = getFontMetrics(getFont());

		StringTokenizer token = new StringTokenizer(msg," ");
		int nofToken = token.countTokens();

		String line = "";
		for(int i=0; i < nofToken; i++)  {
			String s = token.nextToken();
			int size = f.stringWidth(line + s);
			if(size > _sizeX)  {
				v.addElement(line);
				line = s;
			}
			else  {
				line = line + " " + s;
			}
  	}
  	v.addElement(line);

		int unitHeight = f.getHeight() + 3;
		int linenum = v.size();
		setLayout(new GridLayout(linenum + 1,1));
		for(int i=0; i < linenum; i++)  {
			Label l = new Label((String)v.elementAt(i),Label.CENTER);
			l.setFont(boldFont);
			add(l);
		}

		Button b = new Button("OK");
		b.addActionListener(this);
		add(b,"South");

		setSize(_sizeX + 30,unitHeight*(linenum + 1) + 30);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent evt)  {
		String source = evt.getActionCommand();
		if(source.equals("OK"))  {
			dispose();
		}
	}
}
