package webcad_01_0_1;

import java.awt.*;
import java.util.*;
import features.*;
import pontos.ControlPoint1Spline;
import java.awt.event.*;

import java.awt.Frame;

//import java.awt.geom.*;
//import java.awt.TexturePaint;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corr�a & Jones Yudi
 * @version 1.0
 */

//Classe p�blica: DesenhadorDeFeatures: extende Canvas
public class DesenhadorDeFeatures
    extends Canvas {
  FrameEixoCFaceStraight frameEixoCFaceStraight;
  FrameEixoCODStraight frameEixoCODStraight;
  int labels = 0;
  int desBlank=0;
  FrameModificaFeature frameModificaFeature;
  Vector str = new Vector(5,5);
  int x0,y0;
  int nPontosArcos = 10;
  Arcos arcos;
  Ponto2D P0a, P0b, P0;
  double FatorPorcento, Ky;

  Ponto2D from = new Ponto2D(); /* Ponto inicial da Pr�xima feature,
                              que leva o valor final da ultima feature */
  double FatorZoom = 1.0;

  FramePrincipal controlador; // Objeto controlador do tipo FramePrincipal
//////////////////////////////
  Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); //d = tamanho da tela
  // 100 x 100 resolution
  protected int _res = 50 * 2;
  protected int _unitPixel = 10;

  Color grid;

  // objeto armazenadorDeFeatures do tipo ArmazenadorDeFeatures
  ArmazenadorDeFeatures armazenadorDeFeatures;
  CurveControlsODContouredCSpline curveControlsODContouredCSpline;
  //

  Graphics g2;
  Graphics g2D;
//  Graphics2D g2D;
  double blank_L = 1000, blank_D = 1000;
  public Vector _feature; //objeto _feature do tipo Vector
  public Vector _referencias;// armazena as referencias
  int RD = 0;
  int Modelagem;

  double D;
  int R;
  int L;
  double D1;
  double D2; //Para nao perder precisao, pois int trunca
  int R1;
  int R2;
  int tipoInicio;
  int NumerodeCurvas;

  //InterpCanvasSpline interpCanvasSpline;
  CanvasInicio inicio;
  int i;
  Panel panel1 = new Panel();

  int precision = 10; //numero de retas para aproximacao
  int nd = (int)(this.d.width*0.5);
  double Lb ;
  DadosDoProjeto dadosDoProjeto;

  //
  public DesenhadorDeFeatures(ArmazenadorDeFeatures armazenadorDeFeatures1,
                              FramePrincipal controlador1, int Modelagem1) {
    armazenadorDeFeatures = armazenadorDeFeatures1; //Para o par�metro valer para todos os m�todos desta classe
    System.out.println("ARMAZENADOR DE FEATURES - DesenhadorDeFeatures - Linha 89");
    //////////////////////////////
    controlador = controlador1;
    //////////////////////////////
    this.dadosDoProjeto = controlador1.dadosDoProjeto;
    Lb = controlador.dadosDoProjeto.ComprimentoDoBlank;
    this.FatorZoom = this.FatorZoom*nd/Lb;

    _referencias = controlador.dadosDoProjeto.referencias;
    _feature = armazenadorDeFeatures.getThis();
    System.out.println("ARMAZENADOR DE FEATURES - DesenhadorDeFeatures - Linha 99");
    Modelagem = Modelagem1;

    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    Color fundo = new Color(175, 175, 175);
    this.setBackground(fundo);
    this.addMouseListener(new DesenhadorDeFeatures_controlador_mouseAdapter(this));
    panel1.add(this, null);
    x0=d.width / 10;
    y0=d.height / 3;





  }

  public void paint(Graphics g) {
    str.removeAllElements();
    //g.translate(d.width/10, d.height/3);
//    g2D = (Graphics2D) g;
    g2D = g;
    g2D.translate( x0, y0);
    Color old = g2D.getColor();
//    FatorZoom = controlador.panelDraw.zoom;
///Desenha o grid
    Grid(g2D);

    g2D.setColor(old);

// Aqui come�a o desenhador de features propriamente dito
//    from.x = 0; //Xinicial;

    from.z = 0; //Zinicial;

    g2D.setColor(Color.black);
    int size = _feature.size();
    double xMax = 800;
    double zMax = 800;

//////////Come�o do desenhador do Blank////////////////
    if(desBlank==0){
    DesenhadorBlank(controlador.dadosDoProjeto);
//////////Fim do desenhador do Blank//////////////////
    }
////COMECO DO PERCORRIMENTO DO VETOR _features
    for (i = 0; i < size; i++) {
      Feature tmp = (Feature) _feature.elementAt(i);
      from.x = tmp.D1;
      System.out.println("VETOR DE TOLERANCIAS: ");

      int indiceReferencia=0;
      Referencia referencia = new Referencia();



      if (tmp.Tipo == Feature.ODCONTOURED) {
        ODContoured tmp2 = (ODContoured) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        Vector points1 = tmp2.pontos;
        g2D.setColor(Color.blue);
        CalculaODContouredCSpline(points1);
        g2D.setColor(old);

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + (from.z)));
        int x2 = (int) (FatorZoom * (R2));
        g2D.setColor(Color.yellow);
        g2D.drawLine(z2, -x2, z2, 0);
        g2D.setColor(old);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }

        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        if (RD == 1) {
          int x1r = (int) (2 * 0 - x1);
          int x2r = (int) (2 * 0 - x2);
          g2D.setColor(Color.yellow);
          g2D.drawLine(z2, -x2r, z2, 0);
        }

        from.z = from.z + L;
        from.x = D2;
      }


      if (tmp.Tipo == Feature.IDCONTOURED) {
        IDContoured tmp2 = (IDContoured) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        Vector points1 = tmp2.pontos;
        g2D.setColor(Color.blue);
        CalculaIDContouredCSpline(points1);
        g2D.setColor(old);

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L - (from.z)));
        int x2 = (int) (FatorZoom * (R2));
        g2D.setColor(Color.yellow);
        g2D.drawLine(z2, -x2, z2, 0);
        g2D.setColor(old);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 - ((z1-z2)/2),-(x1 + ((x2-x1)/2)));
        }

        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 - ((z1-z2)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        if (RD == 1) {
          int x1r = (int) (2 * 0 - x1);
          int x2r = (int) (2 * 0 - x2);
          g2D.setColor(Color.yellow);
          g2D.drawLine(z2, -x2r, z2, 0);
        }

        from.z = from.z - L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.FACECONTOURED) {
        FaceContoured tmp2 = (FaceContoured) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        Vector points1 = tmp2.pontos;
        g2D.setColor(Color.blue);
        CalculaFaceContouredCSpline(points1);
        g2D.setColor(old);

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + (from.z)));
        int x2 = (int) (FatorZoom * (R2));
        g2D.setColor(Color.yellow);
        g2D.drawLine(z2, -x2, z2, 0);
        g2D.setColor(old);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }

        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        if (RD == 1) {
          int x1r = (int) (2 * 0 - x1);
          int x2r = (int) (2 * 0 - x2);
          g2D.setColor(Color.yellow);
          g2D.drawLine(z2, -x2r, z2, 0);
        }

        from.z = from.z + L;
        from.x = D2;
      }




      if (tmp.Tipo == Feature.ODSTRAIGHT) {
        ODStraight tmp2 = (ODStraight) _feature.elementAt(i);
        D = tmp2.D1;
        R = (int) (D / 2);

        L = (int) tmp2.L1;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R));
        int z2 = (int) (FatorZoom * (L + (from.z)));
        int x2 = (int) (FatorZoom * (R));
        g.setColor(Color.red);

        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
             }
      int rZ = z1 + ((z2-z1)/3);
      int rZ2 = rZ + ((z2-z1)/3);
      int rX = -(x1 + ((x2-x1)/2));

        for(int k = 0; k < this.dadosDoProjeto.referencias.size(); k++){
                referencia = ((Referencia)this.dadosDoProjeto.referencias.elementAt(k));
          indiceReferencia = referencia.featureReferencia;
          System.out.println(referencia.nomeReferencia);

        if(indiceReferencia == i+1){
          System.out.println("");
          g.setColor(Color.lightGray);
          int d = 15;//distancia em X para colocar a referencia
          g.fillRect(rZ-5, rX-d-13-15,15,15);
          g.setColor(Color.black);

          g.drawString(referencia.nomeReferencia, rZ, rX-d-15);
          g.drawLine(rZ+3 ,rX-6, rZ+3, rX-d-13);
          g.drawRect(rZ-5, rX - d -13-15, 15, 15);
          g.drawLine(rZ-3, rX, rZ+3, rX-6 );
          g.drawLine(rZ+6, rX, rZ+3, rX-6);
          g.drawLine(rZ-3, rX, rZ+6, rX);
        }


        }
        if(tmp2.temConcentricidade){
         int d = 15;
          g.setColor(Color.lightGray);
          g.fillRect(rZ2-5, rX-d-13-15,55,15);
          g.setColor(Color.blue);

          g.drawOval(rZ2-5+1, rX - d - 13+1-15, 14 , 14);
          g.drawOval(rZ2-5+4, rX - d - 13+4-15, 8 , 8);
        //g.drawString("O", rZ2, rX-d);
        g.setColor(Color.black);
        String concentricidade = String.valueOf(tmp2.toleranciaConcentricidade.concentricidade);
          g.drawString(concentricidade,rZ2+12, rX-d-15);
          g.drawString(tmp2.toleranciaConcentricidade.referencia1,rZ2+40, rX-d-15);
          g.drawLine(rZ2+3 ,rX, rZ2+3, rX-d-13);//"linha no centro"
          g.drawRect(rZ2-5, rX - d - 13-15, 55, 15);
          g.drawRect(rZ2-5, rX - d - 13-15, 40, 15);
          g.drawRect(rZ2-5, rX - d - 13-15, 15, 15);
          //g.drawLine(rZ2+3, rX, rZ2-3, rX-6 );
          //g.drawLine(rZ2+3, rX, rZ2+6, rX-6);
          //g.drawLine(rZ2-3, rX-6, rZ2+6, rX-6);
          g.setColor(Color.black);
        }

        Rosca rosca = tmp2.rosca;
        g2D.setColor(Color.blue);
        ODStraight(z1, -x2, z2, i, rosca);
        g2D.setColor(old);
        from.x = D;
        from.z = from.z + L;
      }

      if (tmp.Tipo == Feature.ODTAPERED) {
        ODTapered tmp2 = (ODTapered) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        Rosca rosca = tmp2.rosca;
        g2D.setColor(Color.blue);
        ODTapered(z1, -x1, z2, -x2, i, rosca);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.ODCONCAVE) {
        ODConcave tmp2 = (ODConcave) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        double Raio = tmp2.R;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        ODConcave(z1, -x1, z2, -x2, r, i);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.ODCONVEX) {
        ODConvex tmp2 = (ODConvex) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        double Raio = tmp2.R;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        g2D.setColor(Color.blue);
        ODConvex(z1, -x1, z2, -x2, r, i);
        g2D.setColor(old);
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.FACESTRAIGHT) {
        FaceStraight tmp2 = (FaceStraight) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int x2 = (int) (FatorZoom * (R2));
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1), z1 ,-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        FaceStraight(z1, -x1, -x2, i);
        g2D.setColor(old);

        from.x = D2;
      }

      if (tmp.Tipo == Feature.FACETAPERED) {
        FaceTapered tmp2 = (FaceTapered) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        Rosca rosca = new Rosca();
        ODTapered(z1, -x1, z2, -x2, i, rosca);
        g2D.setColor(old);

        from.z = from.z + L; // + Zinicial;
        from.x = D2; // + Xinicial;
      }

      if (tmp.Tipo == Feature.FACECONCAVE) {
        FaceConcave tmp2 = (FaceConcave) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        double Raio = tmp2.R;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        FaceConcave(z1, -x1, z2, -x2, r, i);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.FACECONVEX) {
        FaceConvex tmp2 = (FaceConvex) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        double Raio = tmp2.R;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        FaceConvex(z1, -x1, z2, -x2, r, i);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.IDSTRAIGHT) {
        IDStraight tmp2 = (IDStraight) _feature.elementAt(i);
        D = tmp2.D1;
        R = (int) (D / 2);

        L = (int) tmp2.L1;
        L = -L;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R));
        int z2 = (int) (FatorZoom * (L + (from.z)));
        int x2 = (int) (FatorZoom * (R));
        //g2D.drawLine(z1, x1, z2, x2);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }

        // Aqui comea o desenhador de representao de tolerancias no WebCAD.
        int rZ = z1 + ((z2-z1)/3);
        int rZ2 = rZ + ((z2-z1)/3);
        int rX = -(x1 + ((x2-x1)/2));

          for(int k = 0; k < this.dadosDoProjeto.referencias.size(); k++){
            System.out.println("DENTRO DO LAO FOR DE REFERENCIAS");
            referencia = ((Referencia)this.dadosDoProjeto.referencias.elementAt(k));
            indiceReferencia = referencia.featureReferencia;
            System.out.println(referencia.nomeReferencia);

          if(indiceReferencia == i+1){
             int d = 15;//distancia em X para colocar a referencia
            System.out.println("");
            g.setColor(Color.lightGray);
            g.fillRect(rZ-5, rX + d -2+15, 15, 15);
            g.setColor(Color.black);

            g.drawString(referencia.nomeReferencia, rZ, rX+d+13-3+15);
            g.drawLine(rZ+3 ,rX+6, rZ+3, rX+d+13-15+15);
            g.drawRect(rZ-5, rX + d -2+15, 15, 15);
            g.drawLine(rZ-3, rX, rZ+3, rX+6 );
            g.drawLine(rZ+6+1, rX, rZ+3, rX+6);
            g.drawLine(rZ-3, rX, rZ+6, rX);
          }
        }
        if(tmp2.temConcentricidade){

          int d = 15;//distancia em X para colocar a referencia
           g.setColor(Color.lightGray);
         g.fillRect(rZ2-5, /*rX-d-13*/rX+d+13, 55, 15);
          g.setColor(Color.blue);
          g.drawOval(rZ2-5+1, rX+d+13+1, 14 , 14);
          g.drawOval(rZ2-5+4, rX+d+13+4, 8 , 8);
          g.setColor(Color.black);

          String concentricidade = String.valueOf(tmp2.toleranciaConcentricidade.concentricidade);
          g.drawString(concentricidade,rZ2+12, /*rX-d*/rX+d+13-3+15);
          g.drawString(tmp2.toleranciaConcentricidade.referencia1,rZ2+40, /*rX-d*/rX+d+13-3+15);
          g.drawLine(rZ2+3 ,/*rX-6*/rX, rZ2+3, /*rX-d-13+15*/rX+d+13);//"linha no centro"
          g.drawRect(rZ2-5, /*rX-d-13*/rX+d+13, 55, 15);


         g.setColor(Color.black);
          g.drawRect(rZ2-5, /*rX-d-13*/rX+d+13, 40, 15);
          g.drawRect(rZ2-5, /*rX-d-13*/rX+d+13, 15, 15);
     //     g.drawLine(rZ2+3, rX, rZ2-3, /*rX-6*/ rX+6);
     //     g.drawLine(rZ2+3, rX, rZ2+6, /*rX-6*/rX+6);
     //       g.drawLine(rZ2-3, /*rX-6*/rX+6, rZ2+6, /*rX-6*/rX+6);
            g.setColor(Color.black);
          }






          Ponto2D ponto2D = new Ponto2D();
    ponto2D.z = z1 + ((z2-z1)/2)-2;
    ponto2D.x = -(x1 + ((x2-x1)/2));
    str.insertElementAt(ponto2D,i);
    g2D.setColor(Color.blue);
    Rosca rosca = new Rosca();
    if(tmp2.rosca!=null){
      rosca = tmp2.rosca;
    }

    IDStraight(z1, -x2, z2, i, rosca);

    g2D.setColor(old);
    from.x = D; // + Xinicial;
    from.z = from.z + L; // + Zinicial;
  }

      if (tmp.Tipo == Feature.IDTAPERED) {
        IDTapered tmp2 = (IDTapered) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        L = -L;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        IDTapered(z1, -x1, z2, -x2, i);
        g2D.setColor(old);

        from.z = from.z + L; // + Zinicial;
        from.x = D2; // + Xinicial;
      }

      if (tmp.Tipo == Feature.IDCONCAVE) {
        IDConcave tmp2 = (IDConcave) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        L = -L;
        double Raio = tmp2.R;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        IDConcave(z1, -x1, z2, -x2, r, i);
        g2D.setColor(old);

        from.z = from.z + L; // + Zinicial;
        from.x = D2; // + Xinicial;

      }

      if (tmp.Tipo == Feature.IDCONVEX) {
        IDConvex tmp2 = (IDConvex) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;

        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        L = -L;
        double Raio = tmp2.R;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
       ponto2D.z = z1 + ((z2-z1)/2)-2;
       ponto2D.x = -(x1 + ((x2-x1)/2));
       str.insertElementAt(ponto2D,i);
       g2D.setColor(Color.blue);
        IDConvex(z1, -x1, z2, -x2, r, i);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVESQUARE) {
        GrooveSquare tmp2 = (GrooveSquare) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        double P = tmp2.Profundidade;
        double Raio = tmp2.R;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int p = (int) (P * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);
        g2D.setColor(Color.blue);
        GrooveSquare(z1, -x1, z2, -x2, p, r, i);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVETAPER) {
        GrooveTaper tmp2 = (GrooveTaper) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        double L1 = (int) tmp2.L1;
        double L2 = (int) tmp2.Largura2;
        double P = tmp2.Profundidade;
        double Angulo = tmp2.Angulo;
        double Raio = tmp2.Raio;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L1 + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int p = (int) (P * FatorZoom);
        int a = (int) Angulo; //angulo
        int l1 = (int) (L1 * FatorZoom);
        int l2 = (int) (L2 * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
       ponto2D.z = z1 + ((z2-z1)/2)-2;
       ponto2D.x = -(x1 + ((x2-x1)/2));
       str.insertElementAt(ponto2D,i);
       g2D.setColor(Color.blue);
        GrooveTaper(z1, -x1, z2, -x2, p, l1, l2, i, a, r);
        g2D.setColor(old);

        from.z = from.z + L1;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVERADIAL) {
        GrooveRadial tmp2 = (GrooveRadial) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        double L = (int) tmp2.L1;
        double P = tmp2.Profundidade;
        double Raio = tmp2.Raio;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int p = (int) (P * FatorZoom);
        int l = (int) (L * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
      ponto2D.z = z1 + ((z2-z1)/2)-2;
      ponto2D.x = -(x1 + ((x2-x1)/2));
      str.insertElementAt(ponto2D,i);
      g2D.setColor(Color.blue);
        GrooveRadial(z1, -x1, z2, -x2, p, l, r, i);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVERELIEF) {
        GrooveRelief tmp2 = (GrooveRelief) _feature.elementAt(i);
        D1 = tmp2.D1;
        double P = tmp2.Profundidade;
        double DA = tmp2.DA;
        double FD = tmp2.FD;
        double L = tmp2.L1;
        double D2 = tmp2.D2;
        double Raio = tmp2.Raio;
        double FA = tmp2.FA;

        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int p = (int) (P * FatorZoom);
        int l = (int) (L * FatorZoom);
        int da = (int) (DA); //angulo
        int fd = (int) (FD * FatorZoom);
        int fa = (int) (FA); //angulo
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        GrooveRelief(z1, -x1, z2, -x2, r, p, l, da, fd, fa);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVE_I_SQUARE) {
        Groove_I_Square tmp2 = (Groove_I_Square) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.L1;
        L = -L;
        double P = tmp2.Profundidade;
        double Raio = tmp2.Raio;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int p = (int) (P * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);
        g2D.setColor(Color.blue);
        Groove_I_Square(z1, -x1, z2, -x2, p, r, i);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVE_I_RELIEF) {
        Groove_I_Relief tmp2 = (Groove_I_Relief) _feature.elementAt(i);
        D1 = tmp2.D1;
        double P = tmp2.Profundidade;
        double DA = tmp2.DA;
        double FD = tmp2.FD;
        double L = tmp2.L1;
        double D2 = tmp2.D2;
        double Raio = tmp2.Raio;
        double FA = tmp2.FA;

        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int p = (int) (P * FatorZoom);
        int l = (int) (L * FatorZoom);
        int da = (int) (DA); //angulo
        int fd = (int) (FD * FatorZoom);
        int fa = (int) (FA); //angulo
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        Groove_I_Relief(z1, -x1, z2, -x2, r, p, l, da, fd, fa);
        g2D.setColor(old);

        from.z = from.z - L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVE_I_RADIAL) {
        Groove_I_Radial tmp2 = (Groove_I_Radial) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        double L = (int) tmp2.L1;
        double P = tmp2.Profundidade;
        double Raio = tmp2.Raio;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (L + from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int p = (int) (P * FatorZoom);
        int l = (int) (L * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);
        g2D.setColor(Color.blue);
        Groove_I_Radial(z1, -x1, z2, -x2, p, l, r, i);
        g2D.setColor(old);

        from.z = from.z + L;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVE_I_TAPER) {
        Groove_I_Taper tmp2 = (Groove_I_Taper) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        double L1 = (int) tmp2.L1;
        double L2 = (int) tmp2.Largura2;
        double P = tmp2.Profundidade;
        double Angulo = tmp2.Angulo;
        double Raio = tmp2.Raio;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (from.z - L1));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int p = (int) (P * FatorZoom);
        int a = (int) Angulo; //angulo
        int l1 = (int) (L1 * FatorZoom);
        int l2 = (int) (L2 * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
       ponto2D.z = z1 + ((z2-z1)/2)-2;
       ponto2D.x = -(x1 + ((x2-x1)/2));
       str.insertElementAt(ponto2D,i);
       g2D.setColor(Color.blue);
        Groove_I_Taper(z1, -x1, z2, -x2, p, l1, l2, i, a, r);
        g2D.setColor(old);

        from.z = from.z - L1;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVE_FACE_SQUARE) {
        Groove_Face_Square tmp2 = (Groove_Face_Square) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        double L = (int) tmp2.L;
        double W = (int) tmp2.Largura;
        double Raio = tmp2.Raio;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int l = (int) (L * FatorZoom);
        int w = (int) (W * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);
        g2D.setColor(Color.blue);
        Groove_Face_Square(z1, -x1, z2, -x2, l, w, i, r);
        g2D.setColor(old);

        from.z = from.z;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVE_FACE_RADIAL) {
        Groove_Face_Radial tmp2 = (Groove_Face_Radial) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        L = (int) tmp2.Largura;
        double Raio = tmp2.Raio;

        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);

        g2D.setColor(Color.blue);
        Groove_Face_Radial(z1, -x1, z2, -x2, r, i);
        g2D.setColor(old);

        from.z = from.z;
        from.x = D2;
      }

      if (tmp.Tipo == Feature.GROOVE_FACE_TAPER) {
        Groove_Face_Taper tmp2 = (Groove_Face_Taper) _feature.elementAt(i);
        D1 = tmp2.D1;
        D2 = tmp2.D2;
        R1 = (int) (D1 / 2);
        R2 = (int) (D2 / 2);
        double L = (int) tmp2.L;
        double W1 = (int) tmp2.L1;
        double W2 = (int) tmp2.Largura2;
        double Raio = tmp2.Raio;
        int z1 = (int) (FatorZoom * (from.z));
        int x1 = (int) (FatorZoom * (R1));
        int z2 = (int) (FatorZoom * (from.z));
        int x2 = (int) (FatorZoom * (R2));
        int r = (int) (Raio * FatorZoom);
        int l = (int) (L * FatorZoom);
        int w1 = (int) (W1 * FatorZoom);
        int w2 = (int) (W2 * FatorZoom);
        if(labels==0){
          g.setColor(Color.red);
          g.drawString("F "+(i+1),z1 + ((z2-z1)/2),-(x1 + ((x2-x1)/2)));
        }
        Ponto2D ponto2D = new Ponto2D();
        ponto2D.z = z1 + ((z2-z1)/2)-2;
        ponto2D.x = -(x1 + ((x2-x1)/2));
        str.insertElementAt(ponto2D,i);
        g2D.setColor(Color.blue);
        Groove_Face_Taper(z1, -x1, z2, -x2, l, w1, w2, i, r);
        g2D.setColor(old);

        from.z = from.z;
        from.x = D2;
      }

      if (xMax < FatorZoom * from.x) xMax = FatorZoom * from.x + 50;
      zMax = FatorZoom * from.z + 50;

    }
////////FIM DO PERCORRIMENTO DO VETOR _features

    if (xMax < 800) xMax = 800;
    if (zMax < 800) zMax = 800;
//    this.setSize( (int) zMax, (int) xMax);
    this.setSize((d.width-controlador.panelSecundario.WIDTH),(d.height-controlador.panelDraw.HEIGHT));
    System.out.println("");

    g2D.setColor(old);
  } //fim do paint

  public void DesenhadorBlank(DadosDoProjeto dados) {
    switch(dados.TipoDoBlank){
      case 0:
    {
      double LBlank = controlador.dadosDoProjeto.ComprimentoDoBlank;
      //double rBlank = controlador.dadosDoProjeto.Diametro1DoBlank / 2.0;
      double RBlank = controlador.dadosDoProjeto.Diametro2DBlank / 2.0;
      int z1 = (int) (FatorZoom * (from.z));
      int x1 = (int) (FatorZoom * (RBlank));
      int z2 = (int) (FatorZoom * (LBlank + (from.z)));
      int x2 = (int) (FatorZoom * (RBlank));

      int d = z2 - z1;
      if (Modelagem == 1) {
        z1 = - z1;
        z2 = z1 - d;
      }
      g2D.drawLine(z1-5, -x2, z2-5, -x2);
      g2D.drawLine(z1-5, -x2, z1-5, 0);
      g2D.drawLine(z2-5, -x2, z2-5, 0); //face final

      if (RD == 1) {
        int x2r = (int) (2 * 0 - x2);
        g2D.drawLine(z1-5, -x2r, z2-5, -x2r);
        g2D.drawLine(z1-5, -x2r, z1-5, 0);
        g2D.drawLine(z2-5, -x2r, z2-5, 0);
      }
    }

    case 1:
    {
      double LBlank = controlador.dadosDoProjeto.ComprimentoDoBlank;
      double rBlank = controlador.dadosDoProjeto.Diametro1DoBlank / 2.0;
      double RBlank = controlador.dadosDoProjeto.Diametro2DBlank / 2.0;
      int z1 = (int) (FatorZoom * (from.z));
      int x1 = (int) (FatorZoom * (RBlank));
      int z2 = (int) (FatorZoom * (LBlank + (from.z)));
      int x2 = (int) (FatorZoom * (RBlank));

      int z3 = (int) (FatorZoom * (from.z));
      int x3 = (int) (FatorZoom * (rBlank));
      int z4 = (int) (FatorZoom * (LBlank + (from.z)));
      int x4 = (int) (FatorZoom * (rBlank));

      int D = z2 - z1;
      int d = z4 - z3;
      if (Modelagem == 1) {
        z1 = - z1;
        z2 = z1 - D;
        z3 = -z3;
        z4 = z3-d;
      }
      g2D.drawLine(z1-5, -x2, z2-5, -x2);
      g2D.drawLine(z1-5, -x2, z1-5, -x3);
      g2D.drawLine(z2-5, -x2, z2-5, -x4); //face final

      g2D.drawLine(z3-5, -x4, z4-5, -x4);

      if (RD == 1) {
        int x2r = (int) (2 * 0 - x2);
        int x3r = (int) (2 * 0 - x3);
        int x4r = (int) (2 * 0 - x4);
        g2D.drawLine(z1-5, -x2r, z2-5, -x2r);
        g2D.drawLine(z1-5, -x2r, z1-5, -x3r);
        g2D.drawLine(z2-5, -x2r, z2-5, -x4r);

        g2D.drawLine(z3-5, -x4r, z4-5, -x4r);
      }
    }

    case 3:
        {
          double LBlank = controlador.dadosDoProjeto.ComprimentoDoBlank;
          double rBlank = controlador.dadosDoProjeto.Diametro1DoBlank / 2.0;
          double RBlank = controlador.dadosDoProjeto.Diametro2DBlank / 2.0;
          int z1 = (int) (FatorZoom * (from.z));
          int x1 = (int) (FatorZoom * (RBlank));
          int z2 = (int) (FatorZoom * (LBlank + (from.z)));
          int x2 = (int) (FatorZoom * (RBlank));

          int z3 = (int) (FatorZoom * (from.z));
          int x3 = (int) (FatorZoom * (rBlank));
          int z4 = (int) (FatorZoom * (LBlank + (from.z)));
          int x4 = (int) (FatorZoom * (rBlank));

          int D = z2 - z1;
          int d = z4 - z3;
          if (Modelagem == 1) {
            z1 = - z1;
            z2 = z1 - D;
            z3 = -z3;
            z4 = z3-d;
          }
          g2D.drawLine(z1-5, -x2, z2-5, -x2);
          g2D.drawLine(z1-5, -x2, z1-5, -x3);
          g2D.drawLine(z2-5, -x2, z2-5, -x4); //face final

          g2D.drawLine(z3-5, -x4, z4-5, -x4);

          if (RD == 1) {
            int x2r = (int) (2 * 0 - x2);
            int x3r = (int) (2 * 0 - x3);
            int x4r = (int) (2 * 0 - x4);
            g2D.drawLine(z1-5, -x2r, z2-5, -x2r);
            g2D.drawLine(z1-5, -x2r, z1-5, -x3r);
            g2D.drawLine(z2-5, -x2r, z2-5, -x4r);

            g2D.drawLine(z3-5, -x4r, z4-5, -x4r);
          }
    }
  }
  Inicio();

}

public void CalculaODContouredCSpline(Vector points) {

    int np = points.size(); // numero de pontos
    float d[] = new float[np]; // Vetor com os Coeficientes de Newton
    float x[] = new float[np]; // Vetor com as coordenadas-x dos pontos
    float y;
    float t;
    float oldy = 0;
    float oldt = 0;

    if (np > 0) { //se np>0 , ou seja, se h� algum ponto no vetor de pontos.

      // no for, desenha os Pontos de Controle.
      for (int i = 0; i < np; i++) {
        ControlPoint1Spline p = (ControlPoint1Spline) points.elementAt(i); // p = i-�simo ponto de controle.
        x[i] = p.x; // i-�simo elemento do vetor com as coordenadas-x
        //recebe a coordenada x do �-�simo ponto de controle.

        d[i] = p.y; // i-�simo elemento do vetor de Coeficiente de Newton
        // recebe a coordenada y do i-�simo ponto de controle.

        g2D.setColor(Color.red);

      } // fim do for

      { //verifica qual tipo de curva (mode) est� selecionada.

        {

          if (np > 1) { // Caso tenhamos mais de dois pontos (com dois pontos, temos uma reta)
            float a[] = new float[np]; //vetor a, com tamanho np.
            float t1;
            float t2;
            float h[] = new float[np]; //vetor h, com tamanho np.

            for (int i = 1; i <= np - 1; i++) {
              h[i] = x[i] - x[i - 1];
            }

            if (np > 2) { //Caso tenhamos mais de tr�s pontos
              float sub[] = new float[np - 1]; //vetor sub, com tamanho np-1.
              float diag[] = new float[np - 1]; //vetor diag, com tamanho np-1.
              float sup[] = new float[np - 1]; //vetor sup, com tamanho np-1.

              for (int i = 1; i <= np - 2; i++) {
                diag[i] = (h[i] + h[i + 1]) / 3;
                sup[i] = h[i + 1] / 6;
                sub[i] = h[i] / 6;
                a[i] = (d[i + 1] - d[i]) / h[i + 1] - (d[i] - d[i - 1]) / h[i];
              }

              InterpCanvasODContouredCSpline.solveTridiag(sub, diag, sup, a, np - 2); //Resolve o sistema. Ver m�todo solveTridiag.
            }

            // notar que a[0]=a[np-1]=0
            // desenha
            oldt = x[0];
            oldy = d[0];

            g2D.drawLine( (int) oldt, (int) oldy, (int) oldt, (int) oldy);

            for (int w = 1; w <= np - 1; w++) { // Desenha as linhas entre cada ponto de controle,
              // de acordo com a "precis�o" especifcada.
              for (int j = 1; j <= precision; j++) {
                t1 = (h[w] * j) / precision;
                t2 = h[w] - t1;
                y = ( ( -a[w - 1] / 6 * (t2 + h[w]) * t1 + d[w - 1]) * t2 +
                     ( -a[w] / 6 * (t1 + h[w]) * t2 + d[w]) * t1) / h[w];
                t = x[w - 1] + t1;

                g2D.setColor(Color.blue);

                ODContouredCSpline( (int) (FatorZoom * oldt),
                                   (int) (FatorZoom * oldy),
                                   (int) (FatorZoom * t), (int) (FatorZoom * y),
                                   w, np);
                oldt = t;
                oldy = y;
              }
            }
          }
        }
      }
    }

    /////////
  } //fim do metodo CalculaODContouredCSpline


  public void CalculaIDContouredCSpline(Vector points) {

    int np = points.size(); // numero de pontos
    float d[] = new float[np]; // Vetor com os Coeficientes de Newton
    float x[] = new float[np]; // Vetor com as coordenadas-x dos pontos
    float y;
    float t;
    float oldy = 0;
    float oldt = 0;

    if (np > 0) { //se np>0 , ou seja, se h� algum ponto no vetor de pontos.

      // no for, desenha os Pontos de Controle.
      for (int i = 0; i < np; i++) {
        ControlPoint1Spline p = (ControlPoint1Spline) points.elementAt(i); // p = i-�simo ponto de controle.
        x[i] = p.x; // i-�simo elemento do vetor com as coordenadas-x
        //recebe a coordenada x do �-�simo ponto de controle.

        d[i] = p.y; // i-�simo elemento do vetor de Coeficiente de Newton
        // recebe a coordenada y do i-�simo ponto de controle.

        g2D.setColor(Color.red);

      } // fim do for

      { //verifica qual tipo de curva (mode) est� selecionada.

        {

          if (np > 1) { // Caso tenhamos mais de dois pontos (com dois pontos, temos uma reta)
            float a[] = new float[np]; //vetor a, com tamanho np.
            float t1;
            float t2;
            float h[] = new float[np]; //vetor h, com tamanho np.

            for (int i = 1; i <= np - 1; i++) {
              h[i] = x[i] - x[i - 1];
            }

            if (np > 2) { //Caso tenhamos mais de tr�s pontos
              float sub[] = new float[np - 1]; //vetor sub, com tamanho np-1.
              float diag[] = new float[np - 1]; //vetor diag, com tamanho np-1.
              float sup[] = new float[np - 1]; //vetor sup, com tamanho np-1.

              for (int i = 1; i <= np - 2; i++) {
                diag[i] = (h[i] + h[i + 1]) / 3;
                sup[i] = h[i + 1] / 6;
                sub[i] = h[i] / 6;
                a[i] = (d[i + 1] - d[i]) / h[i + 1] - (d[i] - d[i - 1]) / h[i];
              }

              InterpCanvasODContouredCSpline.solveTridiag(sub, diag, sup, a, np - 2); //Resolve o sistema. Ver m�todo solveTridiag.
            }

            // notar que a[0]=a[np-1]=0
            // desenha
            oldt = x[0];
            oldy = d[0];

            g2D.drawLine( (int) oldt, (int) oldy, (int) oldt, (int) oldy);

            for (int w = 1; w <= np - 1; w++) { // Desenha as linhas entre cada ponto de controle,
              // de acordo com a "precis�o" especifcada.
              for (int j = 1; j <= precision; j++) {
                t1 = (h[w] * j) / precision;
                t2 = h[w] - t1;
                y = ( ( -a[w - 1] / 6 * (t2 + h[w]) * t1 + d[w - 1]) * t2 +
                     ( -a[w] / 6 * (t1 + h[w]) * t2 + d[w]) * t1) / h[w];
                t = x[w - 1] + t1;

                g2D.setColor(Color.blue);

                IDContouredCSpline( (int) (FatorZoom * oldt),
                                   (int) (FatorZoom * oldy),
                                   (int) (FatorZoom * t), (int) (FatorZoom * y),
                                   w, np);
                oldt = t;
                oldy = y;
              }
            }
          }
        }
      }
    }

    /////////
  } //fim do metodo CalculaIDContouredCSpline


  public void CalculaFaceContouredCSpline(Vector points) {

    int np = points.size(); // numero de pontos
    float d[] = new float[np]; // Vetor com os Coeficientes de Newton
    float x[] = new float[np]; // Vetor com as coordenadas-x dos pontos
    float y;
    float t;
    float oldy = 0;
    float oldt = 0;

    if (np > 0) { //se np>0 , ou seja, se h� algum ponto no vetor de pontos.

      // no for, desenha os Pontos de Controle.
      for (int i = 0; i < np; i++) {
        ControlPoint1Spline p = (ControlPoint1Spline) points.elementAt(i); // p = i-�simo ponto de controle.
        x[i] = p.x; // i-�simo elemento do vetor com as coordenadas-x
        //recebe a coordenada x do �-�simo ponto de controle.

        d[i] = p.y; // i-�simo elemento do vetor de Coeficiente de Newton
        // recebe a coordenada y do i-�simo ponto de controle.

        g2D.setColor(Color.red);

      } // fim do for

      { //verifica qual tipo de curva (mode) est� selecionada.

        {

          if (np > 1) { // Caso tenhamos mais de dois pontos (com dois pontos, temos uma reta)
            float a[] = new float[np]; //vetor a, com tamanho np.
            float t1;
            float t2;
            float h[] = new float[np]; //vetor h, com tamanho np.

            for (int i = 1; i <= np - 1; i++) {
              h[i] = x[i] - x[i - 1];
            }

            if (np > 2) { //Caso tenhamos mais de tr�s pontos
              float sub[] = new float[np - 1]; //vetor sub, com tamanho np-1.
              float diag[] = new float[np - 1]; //vetor diag, com tamanho np-1.
              float sup[] = new float[np - 1]; //vetor sup, com tamanho np-1.

              for (int i = 1; i <= np - 2; i++) {
                diag[i] = (h[i] + h[i + 1]) / 3;
                sup[i] = h[i + 1] / 6;
                sub[i] = h[i] / 6;
                a[i] = (d[i + 1] - d[i]) / h[i + 1] - (d[i] - d[i - 1]) / h[i];
              }

              InterpCanvasODContouredCSpline.solveTridiag(sub, diag, sup, a, np - 2); //Resolve o sistema. Ver m�todo solveTridiag.
            }

            // notar que a[0]=a[np-1]=0
            // desenha
            oldt = x[0];
            oldy = d[0];

            g2D.drawLine( (int) oldt, (int) oldy, (int) oldt, (int) oldy);

            for (int w = 1; w <= np - 1; w++) { // Desenha as linhas entre cada ponto de controle,
              // de acordo com a "precis�o" especifcada.
              for (int j = 1; j <= precision; j++) {
                t1 = (h[w] * j) / precision;
                t2 = h[w] - t1;
                t = ( ( -a[w - 1] / 6 * (t2 + h[w]) * t1 + d[w - 1]) * t2 +
                     ( -a[w] / 6 * (t1 + h[w]) * t2 + d[w]) * t1) / h[w];
                y = x[w - 1] + t1;

                g2D.setColor(Color.blue);

                FaceContouredCSpline( (int) (FatorZoom * oldt),
                                   (int) (FatorZoom * oldy),
                                   (int) (FatorZoom * t), (int) (FatorZoom * y),
                                   w, np);
                oldt = t;
                oldy = y;
              }
            }
          }
        }
      }
    }

    /////////
  } //fim do metodo CalculaFaceContouredCSpline




  public void ODContouredCSpline(int z1, int x1, int z2, int x2, int w, int np) {
    int d = z2 - z1;
    if (Modelagem == 0) {
    }
    if (Modelagem == 1) {
      z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
    }
    //1_1_8
    //g2D.setStroke(new BasicStroke(3));

    g2D.drawLine(z1, x1, z2, x2);
    //1_1_8
    //g2D.setStroke(new BasicStroke(1));

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    // g2D.drawLine(z2 , x2, z2 , 0);
    g2D.setColor(oldColor);
    if (RD == 1) {
      //1_1_8
      //g2D.setStroke(new BasicStroke(3));

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);
      g2D.drawLine(z1, x1r, z2, x2r); //3*10 dar uma folga no desenho
      //1_1_8
      //g2D.setStroke(new BasicStroke(1));

      g2D.setColor(Color.yellow);
      // g2D.drawLine(z2 , x2r, z2 , 0);
    }
    Inicio();
    g2D.setColor(oldColor);
  }

  public void IDContouredCSpline(int z1, int x1, int z2, int x2, int w, int np) {
    int d = z2 - z1;
    if (Modelagem == 0) {
    }
    if (Modelagem == 1) {
      z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
    }
    //1_1_8
    //g2D.setStroke(new BasicStroke(3));

    g2D.drawLine(z1, x1, z2, x2);
    //1_1_8
    //g2D.setStroke(new BasicStroke(1));

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    // g2D.drawLine(z2 , x2, z2 , 0);
    g2D.setColor(oldColor);
    if (RD == 1) {
      //1_1_8
      //g2D.setStroke(new BasicStroke(3));

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);
      g2D.drawLine(z1, x1r, z2, x2r); //3*10 dar uma folga no desenho
      //1_1_8
      //g2D.setStroke(new BasicStroke(1));

      g2D.setColor(Color.yellow);
      // g2D.drawLine(z2 , x2r, z2 , 0);
    }
    Inicio();
    g2D.setColor(oldColor);
  }

  public void FaceContouredCSpline(int z1, int x1, int z2, int x2, int w, int np) {

    z1 = -z1;
    z2 = -z2;
    x1 = -x1;
    x2 = -x2;

    int d = z2 - z1;
    if (Modelagem == 0) {
    }
    if (Modelagem == 1) {
      z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
    }
    //1_1_8
    //g2D.setStroke(new BasicStroke(3));

    g2D.drawLine(z1, x1, z2, x2);
    //1_1_8
    //g2D.setStroke(new BasicStroke(1));

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    // g2D.drawLine(z2 , x2, z2 , 0);
    g2D.setColor(oldColor);
    if (RD == 1) {
      //1_1_8
      //g2D.setStroke(new BasicStroke(3));

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);
      g2D.drawLine(z1, x1r, z2, x2r); //3*10 dar uma folga no desenho
      //1_1_8
      //g2D.setStroke(new BasicStroke(1));

      g2D.setColor(Color.yellow);
      // g2D.drawLine(z2 , x2r, z2 , 0);
    }
    Inicio();
    g2D.setColor(oldColor);
  }


  public void ODStraight(int z1, int x2, int z2, int i, Rosca rosca) {
    int d = z2 - z1;
    if (Modelagem == 1) {
      z1 =  - z1;
          z2 = z1 - d;
    }
    g2D.drawLine(z1, x2, z2, x2);
    Color oldColor = g2D.getColor();
    String s = new String();
    s = "F " + i;

    Graphics a = g2D;
    a.setColor(Color.red);
    //a.drawString(s, z1 + ( (z2 - z1) / 2), x2 + 10);

    g2D.setColor(Color.yellow);
    g2D.drawLine(z2, x2, z2, 0);
    g2D.setColor(oldColor);

    double inicioRosca;
    double comprimentoRosca;
    double passoRosca;
    if(rosca!=null){
      inicioRosca = rosca.inicio*FatorZoom;
      comprimentoRosca = rosca.comprimento*FatorZoom;
      passoRosca = rosca.threads_inch;
      Color oldColor1 = g2D.getColor();
      g2D.setColor(Color.green);
      g2D.drawLine(z1+(int)inicioRosca, x2, z1+(int)inicioRosca, x2+5);
      g2D.drawLine(z1+(int)inicioRosca, x2+5, z1+(int)(inicioRosca+comprimentoRosca), x2+5);
      g2D.drawLine(z1+(int)(inicioRosca+comprimentoRosca), x2+5, z1+(int)(inicioRosca+comprimentoRosca), x2);
      g2D.setColor(oldColor1);
    }

    if (RD == 1) {
      int x2r = (int) (2 * 0 - x2);
      g2D.drawLine(z1, x2r, z2, x2r);
      g2D.setColor(Color.yellow);
      g2D.drawLine(z2, x2r, z2, 0);

      if(rosca!=null){
        inicioRosca = rosca.inicio*FatorZoom;
        comprimentoRosca = rosca.comprimento*FatorZoom;
        passoRosca = rosca.threads_inch;
        Color oldColor1 = g2D.getColor();
        g2D.setColor(Color.green);
        g2D.drawLine(z1+(int)inicioRosca, x2r, z1+(int)inicioRosca, x2r-5);
        g2D.drawLine(z1+(int)inicioRosca, x2r-5, z1+(int)(inicioRosca+comprimentoRosca), x2r-5);
        g2D.drawLine(z1+(int)(inicioRosca+comprimentoRosca), x2r-5, z1+(int)(inicioRosca+comprimentoRosca), x2r);
        g2D.setColor(oldColor1);
      }

    }



    Inicio();
    g2D.setColor(oldColor);
  }

  public void ODTapered(int z1, int x1, int z2, int x2, int i, Rosca rosca) {
    int d = z2 - z1;
    if (Modelagem == 0) {
    }
    if (Modelagem == 1) {
      z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
    }
    //1_1_8
    //g2D.setStroke(new BasicStroke(3));

    g2D.drawLine(z1, x1, z2, x2);
    //1_1_8
    //g2D.setStroke(new BasicStroke(1));

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    g2D.drawLine(z2, x2, z2, 0);
    g2D.setColor(oldColor);

    int inicioRosca;
    int comprimentoRosca;
   /* if(rosca!=null){
      inicioRosca = (int)(rosca.inicio*FatorZoom);
      comprimentoRosca = (int)(rosca.comprimento*FatorZoom);
      Color colorOld1 = g2D.getColor();
      g2D.setColor(Color.green);
      g2D.drawLine(z1+inicioRosca, x1, z1+inicioRosca, x1+5);
      g2D.drawLine(z1+inicioRosca, x1+5, z1+inicioRosca+comprimentoRosca, x2-5);
      g2D.drawLine(z1+inicioRosca+comprimentoRosca, x2-5, z1+inicioRosca+comprimentoRosca, x2);
      g2D.setColor(colorOld1);
    }*/

    if (RD == 1) {
      //1_1_8
      //g2D.setStroke(new BasicStroke(3));

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);
      g2D.drawLine(z1, x1r, z2, x2r); //3*10 dar uma folga no desenho
      //1_1_8
      //g2D.setStroke(new BasicStroke(1));

      g2D.setColor(Color.yellow);
      g2D.drawLine(z2, x2r, z2, 0);
    }
    Inicio();
    g2D.setColor(oldColor);
  }

  public Vector ODConcaveCalacPontos(Ponto2D P1, Ponto2D P2, double R) {
    double L = P2.x - P1.x;
    double zPosicao = P1.x;
    Vector PontosDoArco = new Vector(nPontosArcos);
    arcos = new Arcos(P1, P2, R);
    P0a = arcos.getCentro1();
    P0b = arcos.getCentro2();
    if (P0a.z > P0b.z) {
      P0 = P0a;
    }
    else {
      P0 = P0b;
    }
    FatorPorcento = L / nPontosArcos;
    for (int iCirc = 1; iCirc < nPontosArcos; iCirc++) {
      zPosicao = zPosicao + FatorPorcento;
      Ky = calculaKy(zPosicao, P0.x, P0.z, R);
      PontosDoArco.addElement(new Ponto2D(P0.z - Ky, zPosicao));
    }
    return PontosDoArco;
  }

  public Vector ODConvexCalacPontos(Ponto2D P1, Ponto2D P2, double R) {
    double L = P2.x - P1.x;
    double zPosicao = P1.x;
    Vector PontosDoArco = new Vector(nPontosArcos);
    arcos = new Arcos(P1, P2, R);
    P0a = arcos.getCentro1();
    P0b = arcos.getCentro2();
    if (P0a.z > P0b.z) {
      P0 = P0b;
    }
    else {
      P0 = P0a;
    }
    FatorPorcento = L / nPontosArcos;
    for (int iCirc = 1; iCirc < nPontosArcos; iCirc++) {
      zPosicao = zPosicao + FatorPorcento;
      Ky = calculaKy(zPosicao, P0.x, P0.z, R);
      PontosDoArco.addElement(new Ponto2D(P0.z + Ky, zPosicao));
//    scaleD = scaleD.concat(PArco.z + " " + PArco.z + ",\t");
//    spineL = spineL + zPosicao + " 0.0 0.0,\t";
    }
    return PontosDoArco;
  }

  public double calculaKy(double x, double x0, double y0, double r) {
    double Ky = Math.sqrt(r * r - (x - x0) * (x - x0));
    return Ky;
  }

  public void ODConvex(int z1, int x1, int z2, int x2, int r, int i) {
    int d = z2 - z1;
    System.out.println("x1 " + x1);
    System.out.println("z1 " + z1);
    System.out.println("x2 " + x2);
    System.out.println("z2 " + z2);
    System.out.println("r " + r);
    if (Modelagem == 0) {
    }
    if (Modelagem == 1) {
      // z1 = /*(zsize - 210) - z1*/;
      z2 = z1 - d;
    }

    Vector pontosDoContorno = ODConcaveCalacPontos(new Ponto2D(z1, x1),
        new Ponto2D(z2, x2), r);
    Ponto2D p0 = (Ponto2D) pontosDoContorno.elementAt(0);
    g2D.drawLine(z1, x1, (int) p0.z, (int) p0.x);
    for (int iCirc = 1; iCirc < nPontosArcos - 1; iCirc++) {
      Ponto2D p1 = (Ponto2D) pontosDoContorno.elementAt(iCirc - 1);
      Ponto2D p2 = (Ponto2D) pontosDoContorno.elementAt(iCirc);
      g2D.drawLine( (int) p1.z, (int) p1.x, (int) p2.z, (int) p2.x);
      System.out.println(p1.x);
    }
    Ponto2D pf = (Ponto2D) pontosDoContorno.lastElement();
    g2D.drawLine( (int) pf.z, (int) pf.x, z2, x2);

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    g2D.drawLine(z2, x2, z2, 0);
    g2D.setColor(oldColor);
    if (RD == 1) {

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);

      pontosDoContorno = ODConvexCalacPontos(new Ponto2D(z1, x1r),
                                             new Ponto2D(z2, x2r), r);
      p0 = (Ponto2D) pontosDoContorno.elementAt(0);
      g2D.drawLine(z1, x1r, (int) p0.z, (int) p0.x);
      for (int iCirc = 1; iCirc < nPontosArcos - 1; iCirc++) {
        Ponto2D p1 = (Ponto2D) pontosDoContorno.elementAt(iCirc - 1);
        Ponto2D p2 = (Ponto2D) pontosDoContorno.elementAt(iCirc);
        g2D.drawLine( (int) p1.z, (int) p1.x, (int) p2.z, (int) p2.x);
        System.out.println(p1.x);
      }
      pf = (Ponto2D) pontosDoContorno.lastElement();
      g2D.drawLine( (int) pf.z, (int) pf.x, z2, x2r);

      g2D.setColor(Color.yellow);
      g2D.drawLine(z2, x2r, z2, 0);
    }
    Inicio();
    g2D.setColor(oldColor);
  }

  public void ODConcave(int z1, int x1, int z2, int x2, int r, int i) {
    int d = z2 - z1;
    if (Modelagem == 0) {
    }
    if (Modelagem == 1) {
      //
      z2 = z1 - d;
    }

    Vector pontosDoContorno = ODConvexCalacPontos(new Ponto2D(z1, x1),
                                                  new Ponto2D(z2, x2), r);
    Ponto2D p0 = (Ponto2D) pontosDoContorno.elementAt(0);
    g2D.drawLine(z1, x1, (int) p0.z, (int) p0.x);
    for (int iCirc = 1; iCirc < nPontosArcos - 1; iCirc++) {
      Ponto2D p1 = (Ponto2D) pontosDoContorno.elementAt(iCirc - 1);
      Ponto2D p2 = (Ponto2D) pontosDoContorno.elementAt(iCirc);
      g2D.drawLine( (int) p1.z, (int) p1.x, (int) p2.z, (int) p2.x);
      System.out.println(p1.x);
    }
    Ponto2D pf = (Ponto2D) pontosDoContorno.lastElement();
    g2D.drawLine( (int) pf.z, (int) pf.x, z2, x2);

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    g2D.drawLine(z2, x2, z2, 0);
    g2D.setColor(oldColor);
    if (RD == 1) {

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);

      pontosDoContorno = ODConcaveCalacPontos(new Ponto2D(z1, x1r),
                                              new Ponto2D(z2, x2r), r);
      p0 = (Ponto2D) pontosDoContorno.elementAt(0);
      g2D.drawLine(z1, x1r, (int) p0.z, (int) p0.x);
      for (int iCirc = 1; iCirc < nPontosArcos - 1; iCirc++) {
        Ponto2D p1 = (Ponto2D) pontosDoContorno.elementAt(iCirc - 1);
        Ponto2D p2 = (Ponto2D) pontosDoContorno.elementAt(iCirc);
        g2D.drawLine( (int) p1.z, (int) p1.x, (int) p2.z, (int) p2.x);
        System.out.println(p1.x);
      }
      pf = (Ponto2D) pontosDoContorno.lastElement();
      g2D.drawLine( (int) pf.z, (int) pf.x, z2, x2r);

      g2D.setColor(Color.yellow);
      g2D.drawLine(z2, x2r, z2, 0);
    }
    Inicio();
    g2D.setColor(oldColor);
  }

  public void FaceStraight(int z1, int x1, int x2, int i) {
    g2D.drawLine(z1, x1, z1, x2); //3*10 dar uma folga no desenho
    if (x2 > x1) {
      g2D.setColor(Color.yellow);
      g2D.drawLine(z1, x2, z1, 0);
    }
    Color oldColor = g2D.getColor();
    if (RD == 1) {

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);

      g2D.setColor(Color.blue);
      g2D.drawLine(z1, x1r, z1, x2r); //3*10 dar uma folga no desenho
      if (x2 < x1) {
        g2D.setColor(Color.yellow);
        g2D.drawLine(z1, x1r, z1, 0);
      }
    }
    Inicio();
    g2D.setColor(oldColor);
  }

  public void FaceTapered(int z1, int x1, int z2, int x2, int i) {

    int d = z2 - z1;
    if (Modelagem == 0) {
    }
    if (Modelagem == 1) {
      z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
    }
    //1_1_8
    //g2D.setStroke(new BasicStroke(3));

    g2D.drawLine(z1, x1, z2, x2);

    //1_1_8
    //g2D.setStroke(new BasicStroke(1));

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    g2D.drawLine(z2, x2, z2, 0);
    g2D.setColor(oldColor);
    if (RD == 1) {
      //1_1_8
      //g2D.setStroke(new BasicStroke(3));

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);
      g2D.drawLine(z1, x1r, z2, x2r); //3*10 dar uma folga no desenho
      //1_1_8
      //g2D.setStroke(new BasicStroke(1));

      g2D.setColor(Color.yellow);
      g2D.drawLine(z2, x2r, z2, 0);
    }
    Inicio();
    g2D.setColor(oldColor);
  }

  public void FaceConcave(int z1, int x1, int z2, int x2, int r, int i) {
    ODConcave(z1-1, x1, z2, x2,(int) (r+ (r * 0.1)), i);
/*        int d = z2 - z1;
        Arc2D.Double circ;
        if (Modelagem == 0) {
        }
        if (Modelagem == 1) {
          z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
        }
        //1_1_8
        //g2D.setStroke(new BasicStroke(3));
        circ = (Arc2D.Double)new Arco(z1  - 0.2, x1, z2 , x2,
                                      r + (r * 0.1), Arco.CONCAVO);
        g2D.draw(circ);
//    g2D.drawLine((int)z1+(3*10),(int)x1,(int)z2+(3*10),(int)x2);

        //1_1_8
        //g2D.setStroke(new BasicStroke(1));
        // Math.
        Color oldColor = g2D.getColor();
        g2D.setColor(Color.yellow);
        g2D.drawLine(z2 , x2, z2 , 0);
        g2D.setColor(oldColor);
        if (RD == 1) {
          //1_1_8
          //g2D.setStroke(new BasicStroke(3));

          int x1r = (int) (2 * 0 - x1);
          int x2r = (int) (2 * 0 - x2);
          circ = (Arc2D.Double)new Arco(z1  - 0.1, x1r, z2 ,
     x2r, r + (r * 0.1), Arco.CONVEXO); //Invertido CONCAVO-CONVEXO pois eh espelhado
          g2D.draw(circ);
//    g2D.drawLine(z1+(3*10), x1r, z2+(3*10), x2r);//3*10 dar uma folga no desenho
          //1_1_8
          //g2D.setStroke(new BasicStroke(1));

          g2D.setColor(Color.yellow);
          g2D.drawLine(z2 , x2r, z2 , 0);
        }
        Inicio();
        g2D.setColor(oldColor);
*/
  }

  public void FaceConvex(int z1, int x1, int z2, int x2, int r, int i) {
    ODConvex(z1, x1, z2, x2, r, i);

    /*    int d = z2 - z1;
        Arc2D.Double circ;
        if (Modelagem == 0) {
        }
        if (Modelagem == 1) {
          z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
        }
        //1_1_8
        //g2D.setStroke(new BasicStroke(3));
        circ = (Arc2D.Double)new Arco(z1  - 0.2, x1, z2 , x2,
                                      r + (r * 0.1), Arco.CONVEXO);
        g2D.draw(circ);
//    g2D.drawLine((int)z1+(3*10),(int)x1,(int)z2+(3*10),(int)x2);

        //1_1_8
        //g2D.setStroke(new BasicStroke(1));
        // Math.
        Color oldColor = g2D.getColor();
        g2D.setColor(Color.yellow);
        g2D.drawLine(z2 , x2, z2 , 0);
        g2D.setColor(oldColor);
        if (RD == 1) {
          //1_1_8
          //g2D.setStroke(new BasicStroke(3));

          int x1r = (int) (2 * 0 - x1);
          int x2r = (int) (2 * 0 - x2);
          circ = (Arc2D.Double)new Arco(z1  - 0.1, x1r, z2 ,
     x2r, r + (r * 0.1), Arco.CONCAVO); //Invertido CONCAVO-CONVEXO pois eh espelhado
          g2D.draw(circ);
//    g2D.drawLine(z1+(3*10), x1r, z2+(3*10), x2r);//3*10 dar uma folga no desenho
          //1_1_8
          //g2D.setStroke(new BasicStroke(1));

          g2D.setColor(Color.yellow);
          g2D.drawLine(z2 , x2r, z2 , 0);
        }
        Inicio();
        g2D.setColor(oldColor);
     */
  }

  public void IDStraight(int z1, int x2, int z2, int i, Rosca rosca) {
    //   z1 = -z1;
    //   z2 = -z2;
    System.out.println(
        "z1: " + z1 + " z2: " + z2);
    int d = z2 - z1;
    if (Modelagem == 0) {

    }
    if (Modelagem == 1) {
      z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
    }
    //1_1_8
    //g2D.setStroke(new BasicStroke(3));

    g2D.drawLine(z1, x2, z2, x2); //3*10 dar uma folga no desenho
    //1_1_8
    //g2D.setStroke(new BasicStroke(1));

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    g2D.drawLine(z2, x2, z2, 0);
    g2D.setColor(oldColor);

    int inicioRosca;
    int comprimentoRosca;
    if(rosca!=null){
      inicioRosca = (int)(rosca.inicio*FatorZoom);
      comprimentoRosca = (int)(rosca.comprimento*FatorZoom);
      Color colorOld1 = g2D.getColor();
      g2D.setColor(Color.green);
      g2D.drawLine(z1-inicioRosca, x2, z1-inicioRosca, x2-5);
      g2D.drawLine(z1-inicioRosca, x2-5, z1-inicioRosca-comprimentoRosca, x2-5);
      g2D.drawLine(z1-inicioRosca-comprimentoRosca, x2-5, z1-inicioRosca-comprimentoRosca, x2);
      g2D.setColor(colorOld1);
    }

    if (RD == 1) {
      //1_1_8
      //g2D.setStroke(new BasicStroke(3));

      int x2r = (int) (2 * 0 - x2);
      g2D.drawLine(z1, x2r, z2, x2r); //3*10 dar uma folga no desenho
      //1_1_8
      //g2D.setStroke(new BasicStroke(1));

      g2D.setColor(Color.yellow);
      g2D.drawLine(z2, x2r, z2, 0);

      if(rosca!=null){
     inicioRosca = (int)(rosca.inicio*FatorZoom);
     comprimentoRosca = (int)(rosca.comprimento*FatorZoom);
     Color colorOld1 = g2D.getColor();
     g2D.setColor(Color.green);
     g2D.drawLine(z1-inicioRosca, x2, z1-inicioRosca, x2+5);
     g2D.drawLine(z1-inicioRosca, x2+5, z1-inicioRosca-comprimentoRosca, x2+5);
     g2D.drawLine(z1-inicioRosca-comprimentoRosca, x2+5, z1-inicioRosca-comprimentoRosca, x2);
     g2D.setColor(colorOld1);
   }




    }

    Inicio();
    g2D.setColor(oldColor);

  }

  public void IDTapered(int z1, int x1, int z2, int x2, int i) {

    int d = z2 - z1;
    if (Modelagem == 0) {
    }
    if (Modelagem == 1) {
      z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
    }
    //1_1_8
    //g2D.setStroke(new BasicStroke(3));

    g2D.drawLine(z1, x1, z2, x2);
    //1_1_8
    //g2D.setStroke(new BasicStroke(1));

    Color oldColor = g2D.getColor();
    g2D.setColor(Color.yellow);
    g2D.drawLine(z2, x2, z2, 0);
    g2D.setColor(oldColor);
    if (RD == 1) {
      //1_1_8
      //g2D.setStroke(new BasicStroke(3));

      int x1r = (int) (2 * 0 - x1);
      int x2r = (int) (2 * 0 - x2);
      g2D.drawLine(z1, x1r, z2, x2r); //3*10 dar uma folga no desenho
      //1_1_8
      //g2D.setStroke(new BasicStroke(1));

      g2D.setColor(Color.yellow);
      g2D.drawLine(z2, x2r, z2, 0);
    }
    Inicio();
    g2D.setColor(oldColor);

  }

  public void IDConcave(int z1, int x1, int z2, int x2, int r, int i) {
    ODConvex(z1, x1, z2, x2, r, i);
    /*    int d = z2 - z1;
        Arc2D.Double circ;
        if (Modelagem == 0) {
        }
        if (Modelagem == 1) {
          z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
        }
        //1_1_8
        //g2D.setStroke(new BasicStroke(3));
        circ = (Arc2D.Double)new Arco(z2 , x2, z1  - 0.2, x1,
                                      r + (r * 0.1), Arco.CONVEXO);
        g2D.draw(circ);
//    g2D.drawLine((int)z1+(3*10),(int)x1,(int)z2+(3*10),(int)x2);

        //1_1_8
        //g2D.setStroke(new BasicStroke(1));
        // Math.
        Color oldColor = g2D.getColor();
        g2D.setColor(Color.yellow);
        g2D.drawLine(z2 , x2, z2 , 0);
        g2D.setColor(oldColor);
        if (RD == 1) {
          //1_1_8
          //g2D.setStroke(new BasicStroke(3));

          int x1r = (int) (2 * 0 - x1);
          int x2r = (int) (2 * 0 - x2);
          circ = (Arc2D.Double)new Arco(z2 , x2r, z1  - 0.1,
     x1r, r + (r * 0.1), Arco.CONCAVO); //Invertido CONCAVO-CONVEXO pois eh espelhado
          g2D.draw(circ);
//    g2D.drawLine(z1+(3*10), x1r, z2+(3*10), x2r);//3*10 dar uma folga no desenho
          //1_1_8
          //g2D.setStroke(new BasicStroke(1));

          g2D.setColor(Color.yellow);
          g2D.drawLine(z2 , x2r, z2 , 0);
        }
        Inicio();
        g2D.setColor(oldColor);
     */
  }

  public void IDConvex(int z1, int x1, int z2, int x2, int r, int i) {
    ODConcave(z1, x1, z2, x2, r, i);
    /*
            int d = z2 - z1;
        Arc2D.Double circ;
        if (Modelagem == 0) {
        }
        if (Modelagem == 1) {
          z1 = //(zsize - 210) - z1;
          z2 = z1 - d;
        }
        //1_1_8
        //g2D.setStroke(new BasicStroke(3));
        circ = (Arc2D.Double)new Arco(z2 , x2, z1  - 0.2, x1,
                                      r + (r * 0.1), Arco.CONCAVO);
        g2D.draw(circ);
//    g2D.drawLine((int)z1+(3*10),(int)x1,(int)z2+(3*10),(int)x2);

        //1_1_8
        //g2D.setStroke(new BasicStroke(1));
        // Math.
        Color oldColor = g2D.getColor();
        g2D.setColor(Color.yellow);
        g2D.drawLine(z2 , x2, z2 , 0);
        g2D.setColor(oldColor);
        if (RD == 1) {
          //1_1_8
          //g2D.setStroke(new BasicStroke(3));

          int x1r = (int) (2 * 0 - x1);
          int x2r = (int) (2 * 0 - x2);
          circ = (Arc2D.Double)new Arco(z2 , x2r, z1  - 0.1,
     x1r, r + (r * 0.1), Arco.CONVEXO); //Invertido CONCAVO-CONVEXO pois eh espelhado
          g2D.draw(circ);
//    g2D.drawLine(z1+(3*10), x1r, z2+(3*10), x2r);//3*10 dar uma folga no desenho
          //1_1_8
          //g2D.setStroke(new BasicStroke(1));

          g2D.setColor(Color.yellow);
          g2D.drawLine(z2 , x2r, z2 , 0);
        }
        Inicio();
        g2D.setColor(oldColor);
     */

  }

  public void GrooveSquare(int z1, int x1, int z2, int x2, int p, int r, int i) {

    g2D.setColor(Color.blue);
    FaceStraight(z1, x1, x1 + p - r, i);
    g2D.setColor(Color.blue);

    ODConcave(z1, x1 + p - r, z1 + r, x1 + p, r, i);
    g2D.setColor(Color.blue);
    Rosca rosca = new Rosca();
    ODStraight(z1 + r, x1 + p, z2 - r, i, rosca);
    g2D.setColor(Color.blue);

    ODConcave(z2 - r, x1 + p, z2, x1 + p - r, r, i);
    g2D.setColor(Color.blue);

    FaceStraight(z2, x1 + p - r, x1, i);
    g2D.setColor(Color.blue);
  }

  public void GrooveTaper(int z1, int x1, int z2, int x2, int p, int l1, int l2,
                          int i, int a, int r) {

    int p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x, p5z, p5x, p6z, p6x;
    p1z = z1;
    p1x = x1;
    p3z = p1z + ( (l1 - l2) / 2);
    p3x = p1x + p;
    double theta = Math.atan( ( (l1 - l2) / 2) / r);
    p2z = (int) (p3z - r * Math.sin(theta));
    p2x = (int) ( (p3x - r) + r * Math.cos(theta));
    p4z = p3z + l2;
    p4x = p3x;
    p5z = p2z + (int) (l2 + 2 * r * Math.sin(theta));
    p5x = p2x;
    p6z = p1z + l1;
    p6x = p1x;

    g2D.setColor(Color.blue);
    Rosca rosca = new Rosca();
    this.ODTapered(p1z, p1x, p2z, p2x, i, rosca);
    this.ODConcave(p2z, p2x, p3z, p3x, r, i);

    this.ODStraight(p3z, p3x, p4z, i, rosca);
    this.ODConcave(p4z, p4x, p5z, p5x, r, i);
    this.ODTapered(p5z, p5x, p6z, p6x, i, rosca);

  }

  public void GrooveRadial(int z1, int x1, int z2, int x2, int p, int l, int r,
                           int i) {
    g2D.setColor(Color.blue);
    this.ODConcave(z1, x1, z2, x1, r, i);
    g2D.setColor(Color.blue);
  }

  public void GrooveHelical() {

  }

  public void GrooveRelief(int z1, int x1, int z2, int x2, int r, int p, int l,
                           int da, int fd, int fa) {

        int p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x;
        if ( (x1) > (x2)) { //funciona/normal
          p1z = z1;
          p1x = x1;
          p2z = (int) (p1z + p / (Math.tan(2*Math.PI*da/180.0)));
          p2x = p1x + p;
          p4z = z2;
          p4x = x2;
          p3z = p4z + fd;
          p3x = (int) (p4x + fd / (Math.tan(Math.PI*(fa)/180.0)));

          g2D.setColor(Color.blue);
          Rosca rosca = new Rosca();
          ODTapered(p1z, p1x, p2z, p2x, i, rosca);

          g2D.setColor(Color.blue);
          ODConcave(p2z, p2x, p3z, p3x, r, i);

          g2D.setColor(Color.blue);
          ODTapered(p3z, p3x, p4z, p4x, i, rosca);
          g2D.setColor(Color.blue);
        }

        if ( (x1) < (x2)) {
          p1z = z1;
          p1x = x1;
          p4z = z2;
          p4x = x2;
          p2z = p1z - fd;
          p2x = (int) (p1x + (fd / Math.sin(Math.PI*(fa)/180.0)));
          p3z = (int) (p4z - (p / (Math.tan(Math.PI*(da)/180.0))));
          p3x = p4x + p;

          g2D.setColor(Color.blue);
          Rosca rosca = new Rosca();
          ODTapered(p1z, p1x, p2z, p2x, i, rosca);

          g2D.setColor(Color.blue);
          ODConcave(p2z, p2x, p3z, p3x, r, i);

          g2D.setColor(Color.blue);
          ODTapered(p3z, p3x, p4z, p4x, i, rosca);
          g2D.setColor(Color.blue);
        }

  }

  public void Groove_I_Square(int z1, int x1, int z2, int x2, int p, int r,
                              int i) {

    int p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x, p5z, p5x, p6z, p6x;
    p1z = z1;
    p1x = x1;
    p2z = p1z;
    p2x = p1x - p + r;
    p3z = p2z - r;
    p3x = p2x - r;
    p4z = p3z - ( (z1 - z2) - (2 * r));
    p4x = p3x;
    p5z = p4z - r;
    p5x = p4x + r;
    p6z = p5z;
    p6x = p5x + (p - r);

    g2D.setColor(Color.blue);
    FaceStraight(p1z, p1x, p2x, i);
    g2D.setColor(Color.blue);

    IDConcave(p2z, p2x, p3z, p3x, r, i);
    g2D.setColor(Color.blue);
    Rosca rosca = new Rosca();
    IDStraight( -p3z, p3x, -p4z, i, rosca);
    g2D.setColor(Color.blue);

    IDConcave(p4z, p4x, p5z, p5x, r, i);
    g2D.setColor(Color.blue);

    FaceStraight(p5z, p5x, p6x, i);
    g2D.setColor(Color.blue);

  }

  public void Groove_I_Taper(int z1, int x1, int z2, int x2, int p, int l1,
                             int l2, int i, int a, int r) {
    double p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x, p5z, p5x, p6z, p6x, theta;

    p1z = z1;
    p1x = x1;
    p6z = z2;
    p6x = x2;
    p3z = p1z - ( (l1 - l2) / 2.0);
    p3x = p1x - p;
    p4z = p3z - l2;
    p4x = p3x;
    theta = Math.atan( (l1 - l2) / (2.0 * r));
    p2z = p3z + r * Math.sin(theta);
    p2x = p3x + r - r * Math.cos(theta);
    p5z = p4z - r * Math.sin(theta);
    p5x = p2x;

    g2D.setColor(Color.blue);
    this.IDTapered( (int) p1z, (int) p1x, (int) p2z, (int) p2x, i);
    this.IDConcave( (int) p2z, (int) p2x, (int) p3z, (int) p3x, r, i);
    Rosca rosca = new Rosca();
    this.IDStraight( - (int) p3z, (int) p3x, - (int) p4z, i, rosca);
    this.IDConcave( (int) p4z, (int) p4x, (int) p5z, (int) p5x, r, i);
    this.IDTapered( (int) p5z, (int) p5x, (int) p6z, (int) p6x, i);

  }

  public void Groove_I_Radial(int z1, int x1, int z2, int x2, int p, int l,
                              int r,
                              int i) {
    g2D.setColor(Color.blue);
    this.IDConcave(z1, x1, z2, x1, r, i);
    g2D.setColor(Color.blue);

  }

  public void Groove_I_Helical() {

  }

  public void Groove_I_Relief(int z1, int x1, int z2, int x2, int r, int p,
                              int l,
                              int da, int fd, int fa) {

        int p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x;

        if (x1 > x2) {
          p1z = z1;
          p1x = x1;
          p4z = p1z - l;
          p4x = x2;
          p2z = p1z + fd;
          p2x = (int) (p1x - (fd / (Math.tan(Math.PI*(fa)/180.0))));
          p3z = (int) (p4z + (p / (Math.tan(Math.PI*(da)/180.0))));
          p3x = p4x - p;

          g2D.setColor(Color.blue);
          this.IDTapered(p1z, p1x, p2z, p2x, i);
          this.IDConcave(p2z, p2x, p3z, p3x, r, i);
          this.IDTapered(p3z, p3x, p4z, p4x, i);

        }

        if (x1 < x2) {
          p1z = z1;
          p1x = x1;
          p4z = p1z - l;
          p4x = x2;
          p2z = (int) (p1z - (p / (Math.tan(Math.PI*(da)/180.0))));
          p2x = p1x - p;
          p3z = p4z - fd;
          p3x = (int) (p4x - (fd / (Math.tan(Math.PI*(fa)/180))));

          g2D.setColor(Color.blue);
          this.IDTapered(p1z, p1x, p2z, p2x, i);
          this.IDConcave(p2z, p2x, p3z, p3x, r, i);
          this.IDTapered(p3z, p3x, p4z, p4x, i);

        }

  }


  public void Groove_Face_Radial(int z1, int x1, int z2, int x2, int r, int i) {
    ODConcave(z1, x1, z2, x2, r, i);

    Inicio();
  }

  public void Groove_Face_Square(int z1, int x1, int z2, int x2, int l, int w,
                                 int i, int r) {

    double p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x, p5z, p5x, p6z, p6x;
    p1z = z1;
    p1x = x1;
    p6z = z2;
    p6x = x2;

    System.out.println("x1:" + x1 + " x2:" + x2);

    if (x1 > x2) {
      p2z = p1z + l - r;
      p2x = p1x;
      p3z = p2z + r;
      p3x = p2x - r;
      p4z = p3z;
      p4x = p3x - w + 2 * r;
      p5z = p4z - r;
      p5x = p4x - r;

      g2D.setColor(Color.blue);
      Rosca rosca = new Rosca();
      this.ODStraight( (int) p1z, (int) p2x, (int) p2z, (int) i, rosca);
      g2D.setColor(Color.blue);
      this.ODConcave( (int) p2z, (int) p2x, (int) p3z, (int) p3x, (int) r,
                     (int) i);
      g2D.setColor(Color.blue);
      this.FaceStraight( (int) p3z, (int) p3x, (int) p4x, (int) i);
      g2D.setColor(Color.blue);
      this.IDConcave( (int) p4z, (int) p4x, (int) p5z, (int) p5x, (int) r,
                     (int) i);
      g2D.setColor(Color.blue);
      this.IDStraight( - (int) p5z, (int) p6x, - (int) p6z, (int) i, rosca);
      g2D.setColor(Color.blue);
    }

    if (x1 < x2) {
      p2z = p1z - l + r;
      p2x = p1x;
      p3z = p2z - r;
      p3x = p2x + r;
      p4z = p3z;
      p4x = p3x + w - 2 * r;
      p5z = p4z + r;
      p5x = p4x + r;

      g2D.setColor(Color.blue);
      Rosca rosca = new Rosca();
      this.IDStraight( - (int) p1z, (int) p2x, - (int) p2z, (int) i, rosca);
      g2D.setColor(Color.blue);
      this.IDConcave( (int) p2z, (int) p2x, (int) p3z, (int) p3x, (int) r,
                     (int) i);
      g2D.setColor(Color.blue);
      this.FaceStraight( (int) p3z, (int) p3x, (int) p4x, (int) i);
      g2D.setColor(Color.blue);
      this.ODConcave( (int) p4z, (int) p4x, (int) p5z, (int) p5x, (int) r,
                     (int) i);
      g2D.setColor(Color.blue);

      this.ODStraight( (int) p5z, (int) p6x, (int) p6z, (int) i, rosca);
      g2D.setColor(Color.blue);

    }

  }

  public void Groove_Face_Taper(int z1, int x1, int z2,
                                int x2, int l, int w1, int w2, int i, int r) {

    double p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x, p5z, p5x, p6z, p6x, theta;

    p1z = z1;
    p1x = x1;
    p6z = z2;
    p6x = x2;
    theta = Math.atan( (w1 - w2) / (2.0 * r));

    if (x1 > x2) {
      p3z = p1z + l;
      p3x = p1x - ( (w1 - w2) / (2.0));
      p2z = p3z - r;
      p2x = p3x + r * Math.sin(theta);
      p4z = p3z;
      p4x = p3x - (w1 - w2);
      p5z = p2z;
      p5x = p4x - r * Math.sin(theta);

      g2D.setColor(Color.blue);
      Rosca rosca = new Rosca();
      this.ODTapered( (int) p1z, (int) p1x, (int) p2z, (int) p2x, (int) i, rosca);
      g2D.setColor(Color.blue);
      this.ODConcave( (int) p2z, (int) p2x, (int) p3z, (int) p3x, (int) r,
                     (int) i);
      g2D.setColor(Color.blue);
      this.FaceStraight( (int) p3z, (int) p3x, (int) p4x, (int) i);
      g2D.setColor(Color.blue);
      this.IDConcave( (int) p4z, (int) p4x, (int) p5z, (int) p5x, (int) r,
                     (int) i);
      g2D.setColor(Color.blue);
      this.IDTapered( (int) p5z, (int) p5x, (int) p6z, (int) p6x, (int) i);
      g2D.setColor(Color.blue);

    }
    if (x1 < x2) {
      p3z = p1z - l;
      p3x = p1x + ( (w1 - w2) / 2.0);
      p2z = p3z + r;
      p2x = p3x - r * Math.sin(theta);
      p4z = p3z;
      p4x = p3x + (w1 - w2);
      p5z = p2z;
      p5x = p4x + r * Math.sin(theta);

      g2D.setColor(Color.blue);
      this.IDTapered( (int) p1z, (int) p1x, (int) p2z, (int) p2x, (int) i);
      g2D.setColor(Color.blue);
      this.IDConcave( (int) p2z, (int) p2x, (int) p3z, (int) p3x, (int) r,
                     (int) i);
      g2D.setColor(Color.blue);
      this.FaceStraight( (int) p3z, (int) p3x, (int) p4x, (int) i);
      g2D.setColor(Color.blue);
      this.ODConcave( (int) p4z, (int) p4x, (int) p5z, (int) p5x, (int) r,
                     (int) i);
      g2D.setColor(Color.blue);
      Rosca rosca = new Rosca();
      this.ODTapered( (int) p5z, (int) p5x, (int) p6z, (int) p6x, (int) i, rosca);
      g2D.setColor(Color.blue);

    }

  }

  public void Grid(Graphics g2D) {
    g2D.setColor(Color.lightGray);

    if (RD == 1) {
      for (int k = 0; k < 10000; k = k + 3 * _unitPixel) {
        g2D.setColor(grid);
        g2D.drawLine(0, k, 10000, k);
      }

      for (int k = 0; k < 10000; k = k + 3 * _unitPixel) {
        g2D.setColor(grid);
        g2D.drawLine(k, 0, k, 10000);
      }
    }

    g2D.setColor(Color.lightGray);
    for (int k = 0; k > -10000; k = k - 3 * _unitPixel) {
      g2D.setColor(grid);
      g2D.drawLine(0, k, 10000, k);
    }

    for (int k = 0; k < 10000; k = k + 3 * _unitPixel) {
      g2D.setColor(grid);
      g2D.drawLine(k, 0, k, -10000);
    }

//Eixos
    g2D.setColor(Color.red);
    for (int k = 0; k < 10000; k = k + 25) {
      g2D.drawLine(k, 0, k + 10, 0);
      g2D.drawLine(k + 16, 0, k + 18, 0);
    }

    //Eixo X : g2D.drawLine(0,0,0,10000);

    Inicio();
  }

  public void Inicio() {

    if (Modelagem == 0) {

      inicio = new CanvasInicio(0, 0, 1, (int) FatorZoom,
                                Modelagem);
      inicio.setLocation(0, 0);
      inicio.paint(g2D);
      inicio.setVisible(true);

    }
    if (Modelagem == 1) {

      inicio = new CanvasInicio(0, 0, 1,
                                (int) FatorZoom, Modelagem);
      inicio.setLocation(0, 0);
      inicio.paint(g2D);
      inicio.setVisible(true);
    }

  }

  void controlador_mouseClicked(MouseEvent e) {

    if(controlador.IntExt!=2){

    for(int w=0; w<str.size();w++){

    //  System.out.println("Clicou no Canvas em: "+(e.getX()-2)+"   "+ (e.getY()-2));
    //  System.out.println(" Ponto de str : "+(((Ponto2D)str.elementAt(w)).z+x0)+"     "+(((Ponto2D)str.elementAt(w)).x+y0));

      if(e.getX()-2>((Ponto2D)str.elementAt(w)).z+x0-10&&
          e.getX()-2<((Ponto2D)str.elementAt(w)).z+x0+10&&
          e.getY()-2>((Ponto2D)str.elementAt(w)).x+y0-10&&
          e.getY()-2<((Ponto2D)str.elementAt(w)).x+y0+10){

         frameModificaFeature = new FrameModificaFeature(((Feature)_feature.elementAt(w)).Tipo, controlador, controlador.RD1, w);
         frameModificaFeature.setVisible(true);

       }

    }
    }

    if(controlador.IntExt==2){
      for(int w=0; w<str.size();w++){

   //    System.out.println("Clicou no Canvas em: "+(e.getX()-2)+"   "+ (e.getY()-2));
   //    System.out.println(" Ponto de str : "+(((Ponto2D)str.elementAt(w)).z+x0)+"     "+(((Ponto2D)str.elementAt(w)).x+y0));

       if(e.getX()-2>((Ponto2D)str.elementAt(w)).z+x0-10&&
           e.getX()-2<((Ponto2D)str.elementAt(w)).z+x0+10&&
           e.getY()-2>((Ponto2D)str.elementAt(w)).x+y0-10&&
           e.getY()-2<((Ponto2D)str.elementAt(w)).x+y0+10){

          //frameModificaFeature = new FrameModificaFeature(((Feature)_feature.elementAt(w)).Tipo, controlador, controlador.RD1, w);
          //frameModificaFeature.setVisible(true);
          Feature feature1 = (Feature)_feature.elementAt(w);

          switch(feature1.Tipo){
            case 1:
              if(((Feature)this._feature.elementAt(w+1)).Tipo==6 || (((Feature)this._feature.elementAt(w-1)).Tipo==6)){
                frameEixoCODStraight = new FrameEixoCODStraight(this.controlador,((Feature)_feature.elementAt(w)));
                frameEixoCODStraight.setEnabled(true);
                frameEixoCODStraight.setVisible(true);
              }

              break;
            case 6:
              frameEixoCFaceStraight = new FrameEixoCFaceStraight(this.controlador,((Feature)_feature.elementAt(w)));
              frameEixoCFaceStraight.setEnabled(true);
              frameEixoCFaceStraight.setVisible(true);
              break;
          }

        }

     }

    }

  }

}

class DesenhadorDeFeatures_controlador_mouseAdapter extends java.awt.event.MouseAdapter {
  DesenhadorDeFeatures adaptee;

  DesenhadorDeFeatures_controlador_mouseAdapter(DesenhadorDeFeatures adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.controlador_mouseClicked(e);
  }
}
