package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import featureseixoc.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogEixoCReamed extends Dialog {
  //public double passo;
  public double diametro;
  public double profundidade;
  DadosDoProjeto dadosDoProjeto;
  Reamed reamed;
  Feature feature;
  HolePattern holePattern;

  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Button buttonHelp = new Button();
  Button buttonCancel = new Button();
  Button buttonOK = new Button();
  Label label1 = new Label();
  TextField textFieldDiametro = new TextField();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Label label2 = new Label();
  Label label3 = new Label();
  TextField textFieldProfundidade = new TextField();
  Label label4 = new Label();

  public DialogEixoCReamed(Frame frame, String title, boolean modal, DadosDoProjeto dadosDoProjeto1, Feature feature1, HolePattern holePattern1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      this.dadosDoProjeto = dadosDoProjeto1;
      holePattern = holePattern1;
      feature = feature1;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }



  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonHelp.setLabel("Help");
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogEixoCReamed_buttonCancel_actionAdapter(this));
    buttonCancel.addActionListener(new DialogEixoCReamed_buttonCancel_actionAdapter(this));
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogEixoCReamed_buttonOK_actionAdapter(this));
    buttonOK.addActionListener(new DialogEixoCReamed_buttonOK_actionAdapter(this));
    buttonOK.addActionListener(new DialogEixoCReamed_buttonOK_actionAdapter(this));
    label1.setText("mm");
    textFieldDiametro.setColumns(4);
    textFieldDiametro.setText("1");
    panel2.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(2);
    label2.setText("Diameter");
    label3.setText("mm");
    textFieldProfundidade.setColumns(4);
    textFieldProfundidade.setText("5");
    label4.setText("Depth     ");
    panel1.add(panel2, BorderLayout.CENTER);
    panel1.add(panel3,  BorderLayout.SOUTH);
    panel3.add(buttonOK, null);
    panel3.add(buttonCancel, null);
    panel3.add(buttonHelp, null);
    panel2.add(panel4, null);
    panel4.add(label2, null);
    panel4.add(textFieldDiametro, null);
    panel4.add(label1, null);
    panel2.add(panel5, null);
    panel5.add(label4, null);
    panel5.add(textFieldProfundidade, null);
    panel5.add(label3, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    this.diametro = Double.valueOf(this.textFieldDiametro.getText()).doubleValue();
    this.profundidade = Double.valueOf(this.textFieldProfundidade.getText()).doubleValue();
    this.reamed = new Reamed();
    this.reamed.diametro = this.diametro;
    this.reamed.profundidade = this.profundidade;
    this.holePattern.reamed = this.reamed;
    this.dispose();
  }
}

class DialogEixoCReamed_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogEixoCReamed adaptee;

  DialogEixoCReamed_buttonCancel_actionAdapter(DialogEixoCReamed adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class DialogEixoCReamed_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogEixoCReamed adaptee;

  DialogEixoCReamed_buttonOK_actionAdapter(DialogEixoCReamed adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}


