package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import featureseixoc.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogEixoCThreads extends Dialog {
  public double passo;
  DadosDoProjeto dadosDoProjeto;
  Threads threads = new Threads();
  Feature feature;
  HolePattern holePattern;

  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Button buttonHelp = new Button();
  Button buttonCancel = new Button();
  Button buttonOK = new Button();
  Label label1 = new Label();
  TextField textFieldPasso = new TextField();

  public DialogEixoCThreads(Frame frame, String title, boolean modal, DadosDoProjeto dadosDoProjeto1, Feature feature1, HolePattern holePattern1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      this.dadosDoProjeto = dadosDoProjeto1;
      holePattern = holePattern1;
      feature = feature1;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }



  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonHelp.setLabel("Help");
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogEixoCThreads_buttonCancel_actionAdapter(this));
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogEixoCThreads_buttonOK_actionAdapter(this));
    label1.setText("mm / rot");
    textFieldPasso.setColumns(4);
    textFieldPasso.setText("1");
    panel1.add(panel2, BorderLayout.CENTER);
    panel1.add(panel3,  BorderLayout.SOUTH);
    panel3.add(buttonOK, null);
    panel3.add(buttonCancel, null);
    panel3.add(buttonHelp, null);
    panel2.add(label1, null);
    panel2.add(textFieldPasso, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    this.passo = Double.valueOf(this.textFieldPasso.getText()).doubleValue();
    this.threads.passo = this.passo;
    this.holePattern.threads = this.threads;
    FaceStraight face1 = (FaceStraight)feature;

    this.dispose();
  }
}

class DialogEixoCThreads_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogEixoCThreads adaptee;

  DialogEixoCThreads_buttonCancel_actionAdapter(DialogEixoCThreads adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class DialogEixoCThreads_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogEixoCThreads adaptee;

  DialogEixoCThreads_buttonOK_actionAdapter(DialogEixoCThreads adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
