package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogToleranciaProfile extends Dialog {
  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  FrameFeatures frameFeatures;
  Feature feature;
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
//  CheckboxGroup checkboxGroupChooseBlankType = new CheckboxGroup();
//  Checkbox checkboxCylindricalBar = new Checkbox("",checkboxGroupChooseBlankType,true);

  Checkbox checkboxProfileOfLine = new Checkbox("",checkboxGroup1, true);
  Checkbox checkboxProfileOfSurface = new Checkbox("",checkboxGroup1,false);
  GridLayout gridLayout2 = new GridLayout();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  Label label1 = new Label();
  TextField textFieldValor = new TextField();
  Label label2 = new Label();

  public DialogToleranciaProfile(FrameFeatures frame, String title, boolean modal, Feature feature1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures = frame;
      feature=feature1;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }


  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogToleranciaProfile_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    panel2.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    checkboxProfileOfLine.setLabel("Profile of Line");
    checkboxProfileOfSurface.setState(false);
    checkboxProfileOfSurface.setLabel("Profile of Surface");
    panel4.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(2);
    panel5.setLayout(gridLayout3);
    gridLayout3.setColumns(1);
    gridLayout3.setRows(3);
    label1.setText("Value:");
    textFieldValor.setColumns(4);
    textFieldValor.setText("");
    label2.setText("mm");
    panel1.add(panel2, BorderLayout.CENTER);
    panel1.add(panel3,  BorderLayout.SOUTH);
    panel3.add(buttonOK, null);
    panel3.add(buttonCancel, null);
    panel2.add(panel4, null);
    panel2.add(panel5, null);
    panel5.add(panel8, null);
    panel8.add(checkboxProfileOfLine, null);
    panel5.add(panel7, null);
    panel7.add(checkboxProfileOfSurface, null);
    panel5.add(panel6, null);
    panel6.add(label1, null);
    panel6.add(textFieldValor, null);
    panel6.add(label2, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    if(this.checkboxProfileOfLine.getState()){
      feature.toleranciaFormaContorno= new ToleranciaFormaContorno();
      feature.toleranciaFormaContorno.contorno=Double.valueOf(this.textFieldValor.getText()).doubleValue();
    }
    if(this.checkboxProfileOfSurface.getState()){
      feature.toleranciaFormaSuperficie= new ToleranciaFormaSuperficie();
      feature.toleranciaFormaSuperficie.superficie=Double.valueOf(this.textFieldValor.getText()).doubleValue();
    }
    this.dispose();
  }
}

class DialogToleranciaProfile_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaProfile adaptee;

  DialogToleranciaProfile_buttonOK_actionAdapter(DialogToleranciaProfile adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
