package webcad_01_0_1;


import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

public class Frame1
    extends Frame
    implements Runnable, ButtonBarApplet {

  URL url1;
  URL urlImagem;
  String _helpFileURL = null;

  static final int TOLEFT = 1;
  static final int TORIGHT = 2;
  static final int UP = 3;
  static final int DOWN = 4;
  static final int ZOOMIN = 5;
  static final int ZOOMOUT = 6;

  MediaTracker _tracker;
  Image[] _image;
  int _isMoving = 0;

  int _tipHeight, _tipWidth, _imageX, _imageY;
  Font _tipFont = new Font("Dialog", Font.PLAIN, 10);
  String _tip = null;

  Thread _fetcher;
  ButtonBar _upperBar;

  public Frame1() {
    //Necessario para abilitar os eventos basicos
enableEvents(AWTEvent.WINDOW_EVENT_MASK);

  }

  public Frame1(URL url1) {
    this.url1 = url1;
    //Necessario para abilitar os eventos basicos
enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    _fetcher = new Thread(this);
    _fetcher.start();
    init();
  }

  public void init() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void jbInit() {
    _tracker = new MediaTracker(this);
    setFont(_tipFont);
    _tipHeight = getFontMetrics(getFont()).getHeight() + 2;
    setLayout(new BorderLayout());
    _image = new Image[76];
    System.out.println(url1);
    for (int i = 0; i < 76; i += 4) {
      try {
        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + i + ".gif");
        _image[i] = Toolkit.getDefaultToolkit().getImage(urlImagem);
        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + (i + 1) + ".gif");
        _image[i +1] = Toolkit.getDefaultToolkit().getImage(urlImagem);
        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + (i + 2) + ".gif");
        _image[i +2] = Toolkit.getDefaultToolkit().getImage(urlImagem);
        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + (i + 3) + ".gif");
        _image[i +3] = Toolkit.getDefaultToolkit().getImage(urlImagem);
      }
      catch (MalformedURLException ex) {
      }

      _tracker.addImage(_image[i], 0);
      _tracker.addImage(_image[i + 1], 0);
      _tracker.addImage(_image[i + 2], 0);
      _tracker.addImage(_image[i + 3], 0);
    }
    try {
      _tracker.waitForID(0);
    }
    catch (Exception e) {
      System.out.println(e.toString());
    }
    _upperBar = new ButtonBar(this, 600, 44);
    _upperBar.addButton("Open", _image[0], _image[1], _image[2], _image[3]);
    _upperBar.addButton("Save", _image[4], _image[5], _image[6], _image[7]);
    _upperBar.addSpace();
    _upperBar.addButton("Connect", _image[8], _image[9], _image[10], _image[11]);
    _upperBar.addSpace();

    _upperBar.addButton("Box", _image[12], _image[13], _image[14], _image[15]);
    _upperBar.addButton("Cylinder", _image[16], _image[17], _image[18], _image[19]);
    _upperBar.addButton("Cone", _image[20], _image[21], _image[22], _image[23]);
    _upperBar.addButton("Sphere", _image[24], _image[25], _image[26], _image[27]);
    _upperBar.addButton("Extrusion", _image[28], _image[29], _image[30], _image[31]);
    _upperBar.addButton("Axys-sym", _image[32], _image[33], _image[34], _image[35]);
    _upperBar.addSpace();
    _upperBar.addButton("Help", _image[36], _image[37], _image[38], _image[39]);
    _upperBar.addSpace();
    _upperBar.addButton("To-Left", _image[40], _image[41], _image[42], _image[43]);
    _upperBar.addButton("Reset", _image[44], _image[45], _image[46], _image[47]);
    _upperBar.addButton("To-Right", _image[48], _image[49], _image[50], _image[51]);
    _upperBar.addButton("Up", _image[52], _image[53], _image[54], _image[55]);
    _upperBar.addButton("Down", _image[56], _image[57], _image[58], _image[59]);
    _upperBar.addButton("Zoom-Out", _image[60], _image[61], _image[62], _image[63]);
    _upperBar.addButton("Zoom-In", _image[64], _image[65], _image[66], _image[67]);
    _upperBar.addButton("Remove", _image[68], _image[69], _image[70], _image[71]);
    _upperBar.addButton("Select", _image[72], _image[73], _image[74], _image[75]);

    add(_upperBar, "North");
    this.setSize(650, 450);
  }

  public void processButtonReleased(String id, MouseEvent e) {
    _isMoving = 0;
    if (id.equals("Open")) {
      openAction();
    }
    else
    if (id.equals("Save")) {
      saveAction();
    }
    else
    if (id.equals("Box")) {
/////////////////////      ObjectFrame o = new ObjectFrame(_canvas, 1);
    }
    else
    if (id.equals("Cylinder")) {
/////////////////////      ObjectFrame o = new ObjectFrame(_canvas, 2);
    }
    else
    if (id.equals("Cone")) {
/////////////////////      ObjectFrame o = new ObjectFrame(_canvas, 3);
    }
    else
    if (id.equals("Sphere")) {
/////////////////////      ObjectFrame o = new ObjectFrame(_canvas, 4);
    }
    else
    if (id.equals("Extrusion")) {
/////////////////////      ExtrusionFrame f = new ExtrusionFrame(_canvas);
    }
    else
    if (id.equals("Axys-sym")) {
/////////////////////      AxisSymFrame f = new AxisSymFrame(_canvas);
    }
    else
    if (id.equals("Select")) {
      boolean selmode = true;
      if (selmode == true) {
        _upperBar.setPersistentButton("Select", -1);
      }
      else {
        _upperBar.setPersistentButton("Select", 2);
      }
    }
    else
    if (id.equals("Remove")) {
    }
    else
    if (id.equals("Reset")) {
    }
    else
    if (id.equals("Help")) {
      try {
        if (_helpFileURL != null) {
          //////getAppletContext().showDocument(new URL(_helpFileURL), "_blank");
        }
      }
      catch (Exception eeee) {}
    }
    else
    if (id.equals("Connect")) {
      try {
        _upperBar.setPersistentButton("Connect", 3);
      }
      catch (Exception ee) {
        System.out.println(ee.toString());
      }
    }
  }

  protected void openAction() {
    FileDialog fd = new FileDialog(this, "Open CAD File");
    fd.show();
    String dir = fd.getDirectory();
    String file = fd.getFile();
    String filepath = dir + file;
    try {
      DataInputStream in = new DataInputStream(new FileInputStream(filepath));
      in.close();
    }
    catch (Exception ee) {
//      MessageBox b = new MessageBox("Open file error <" + file + "> " +
//                                    ee.toString(), getFrame());
    }
  }

  protected void saveAction() {
    FileDialog fd = new FileDialog(this, "Save CAD File", FileDialog.SAVE);
    fd.show();
    String dir = fd.getDirectory();
    String file = fd.getFile();
    String filepath = dir + file;
    try {
      DataOutputStream out = new DataOutputStream(new FileOutputStream(filepath, false));
      out.close();
    }
    catch (Exception ee) {
//      MessageBox b = new MessageBox("Save file error <" + file + "> " +
//                                    ee.toString(), getFrame());
    }
  }

  public void processButtonPressed(String id, MouseEvent e) {
    if (id.equals("To-Left")) {
      _isMoving = TOLEFT;
    }
    else
    if (id.equals("Zoom-In")) {
      _isMoving = ZOOMIN;
    }
    else
    if (id.equals("Zoom-Out")) {
      _isMoving = ZOOMOUT;
    }
    else
    if (id.equals("To-Right")) {
      _isMoving = TORIGHT;
    }
    else
    if (id.equals("Up")) {
      _isMoving = UP;
    }
    else
    if (id.equals("Down")) {
      _isMoving = DOWN;
    }
  }

  public void run() {
    try {
      Thread.currentThread().setPriority(Thread.NORM_PRIORITY);
      while (true) {
        switch (_isMoving) {
          case TOLEFT:
            break;
          case TORIGHT:
            break;
          case UP:
            break;
          case DOWN:
            break;
          case ZOOMIN:
            break;
          case ZOOMOUT:
            break;
        }
        _fetcher.sleep(10);
      }
    }
    catch (Exception e) {
    }
  }

  public void releaseConnectButton() {
    _upperBar.setPersistentButton("Connect", -1);
  }

  public void start() {
    _fetcher = new Thread(this);
    _fetcher.start();
  }

  public void stop() {
    if ( (_fetcher != null) && (_fetcher.isAlive())) {
      _fetcher.stop();
      _fetcher = null;
    }
    dispose();
  }
  //Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }
//Aqui termina

}
