package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;
import java.net.*;
import java.io.*;
import java.applet.AppletContext;
import java.util.Vector;
import java.applet.Applet;
import java.util.Date;
import Abstract.*;
import ProtocolLayer.*;
import ProtocolLayer.Example.IPRCApplet.*;
import ProtocolLayer.Example.CAD.*;
import featureseixoc.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FrameEixoCODStraight
    extends Frame {
  Panel panel2 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
//  HolePattern holePattern = new HolePattern();
  KeyWay keyWay = new KeyWay();

  PanelBlanks panelFigura;
//  MenuPrincipal menu01 = new MenuPrincipal(listener);

  FramePrincipal controlador;

  Feature feature;


  ODStraight faceStraight;
  Panel panel1 = new Panel();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  Label label1 = new Label();
  TextField textFieldKeyWayAngulo = new TextField();
  Label label2 = new Label();
  Label label3 = new Label();
  TextField textFieldKeyWayComprimento = new TextField();
  Label label4 = new Label();
  Label label5 = new Label();
  TextField textFieldKeyWayProfundidade = new TextField();
  Label label6 = new Label();
  Label label7 = new Label();
  TextField textFieldKeyWayLargura = new TextField();
  Label label8 = new Label();
  BorderLayout borderLayout1 = new BorderLayout();



  public FrameEixoCODStraight(FramePrincipal controlador1, Feature feature1) {
    try {
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      this.controlador = controlador1;
      this.panelFigura = new PanelBlanks(this.controlador.Applet, "KeyWay");
      feature = feature1;
      System.out.println("FrameEixoC: "+feature.Tipo);
      System.out.println(this.controlador.toString());
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);


    this.setSize(new Dimension(340, 236));
    this.setTitle("   C-Axis  -  ODStraight");
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new FrameEixoCODStraight_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new FrameEixoCODStraight_buttonCancel_actionAdapter(this));
    buttonHelp.setLabel("Help");
    panel1.setLayout(borderLayout1);
    panel4.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(4);
    label1.setText(" ");
    textFieldKeyWayAngulo.setColumns(4);
    textFieldKeyWayAngulo.setText("0");
    label2.setText("Initial Angle");
    label3.setText("mm");
    label4.setAlignment(Label.RIGHT);
    label4.setText("          Z1      ");
    label5.setText("mm");
    textFieldKeyWayProfundidade.setColumns(4);
    textFieldKeyWayProfundidade.setText("5");
    label6.setText("          X1      ");
    label7.setText("mm");
    textFieldKeyWayLargura.setColumns(4);
    textFieldKeyWayLargura.setText("0");
    label8.setText("         D      ");
    textFieldKeyWayComprimento.setColumns(4);
    textFieldKeyWayComprimento.setText("10");
    this.add(panel2, BorderLayout.SOUTH);
    panel2.add(buttonOK, null);
    panel2.add(buttonCancel, null);
    panel2.add(buttonHelp, null);
    this.add(panel1,  BorderLayout.CENTER);
    panel1.add(panel3,  BorderLayout.CENTER);
    panel1.add(panel4,  BorderLayout.EAST);
    panel4.add(panel5, null);
    panel5.add(label2, null);
    panel5.add(textFieldKeyWayAngulo, null);
    panel5.add(label1, null);
    panel4.add(panel6, null);
    panel6.add(label4, null);
    panel6.add(textFieldKeyWayComprimento, null);
    panel6.add(label3, null);
    panel4.add(panel7, null);
    panel7.add(label6, null);
    panel7.add(textFieldKeyWayProfundidade, null);
    panel7.add(label5, null);
    panel4.add(panel8, null);
    panel8.add(label8, null);
    panel8.add(textFieldKeyWayLargura, null);
    panel8.add(label7, null);

    this.panel1.add(this.panelFigura);
    this.panelFigura.setSize(this.panel3.getBounds().width,this.panel3.getBounds().height);
    this.panelFigura.setVisible(true);

    this.repaint();

  }
  //Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }





  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }




  void buttonOK_actionPerformed(ActionEvent e) {
    this.keyWay.tipoMae = feature.Tipo;
    this.keyWay.tipo = 7;
    this.keyWay.indiceMae = feature.getOrdem();
    this.keyWay.anguloInicial = Double.valueOf(this.textFieldKeyWayAngulo.getText()).doubleValue();
    this.keyWay.d1 = Double.valueOf(this.textFieldKeyWayProfundidade.getText()).doubleValue();
    this.keyWay.L1 = Double.valueOf(this.textFieldKeyWayComprimento.getText()).doubleValue();
    this.keyWay.W1 = Double.valueOf(this.textFieldKeyWayLargura.getText()).doubleValue();
//    this.holePattern.tipoMae = feature.Tipo;
//    this.holePattern.indiceMae = feature.getOrdem();
//    this.controlador.dadosDoProjeto.armazenadorEixoC.armazenaEixoC.addElement(this.holePattern);

    if(this.controlador.dadosDoProjeto.armazenadorEixoC==null){
      this.controlador.dadosDoProjeto.armazenadorEixoC = new ArmazenadorEixoC();
    }

//    this.controlador.dadosDoProjeto.armazenadorEixoC.armazenaEixoC.add(this.holePattern);
    this.controlador.dadosDoProjeto.armazenadorEixoC.armazenaEixoC.addElement(this.keyWay);
    this.dispose();

  }


}

class FrameEixoCODStraight_buttonCancel_actionAdapter
    implements java.awt.event.ActionListener {
  FrameEixoCODStraight adaptee;

  FrameEixoCODStraight_buttonCancel_actionAdapter(FrameEixoCODStraight adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class FrameEixoCODStraight_checkboxFlatShape_itemAdapter implements java.awt.event.ItemListener {
  FrameEixoCODStraight adaptee;

  FrameEixoCODStraight_checkboxFlatShape_itemAdapter(FrameEixoCODStraight adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {

  }
}

class FrameEixoCODStraight_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  FrameEixoCODStraight adaptee;

  FrameEixoCODStraight_buttonOK_actionAdapter(FrameEixoCODStraight adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
