package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.applet.Applet;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FrameModelagem extends Frame {
  Applet Applet;
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  Label label1 = new Label();
  FramePrincipal framePrincipal;
  String username;
  URL urlApplet;
  DadosDoProjeto dadosDoProjeto;
  int Modelagem;
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  CheckboxGroup checkboxGroup2 = new CheckboxGroup();
  Label label2 = new Label();
  Checkbox checkboxExternal = new Checkbox("",checkboxGroup2, true);
  Checkbox checkboxInternal = new Checkbox("",checkboxGroup2, false);
  Checkbox checkboxLeft = new Checkbox("",checkboxGroup1, true);
  Checkbox checkboxRight = new Checkbox("",checkboxGroup1, false);
  Modelagem modelagem = new Modelagem();
  DadosIntermediarios dadosIntermediarios = new DadosIntermediarios();



  public FrameModelagem(DadosDoProjeto dadosDoProjeto1, URL urlApplet1, DadosIntermediarios dadosIntermediarios1) {
    try {
      this.dadosDoProjeto = dadosDoProjeto1;
      username = dadosDoProjeto.NomeDoUsuario;
      urlApplet = urlApplet1;
      dadosIntermediarios = dadosIntermediarios1;

      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
  public FrameModelagem(DadosDoProjeto dadosDoProjeto1, Applet Applet, DadosIntermediarios dadosIntermediarios1) {
    try {
      this.Applet = Applet;
      this.dadosDoProjeto = dadosDoProjeto1;
      username = dadosDoProjeto.NomeDoUsuario;
      urlApplet = Applet.getCodeBase();
      dadosIntermediarios = dadosIntermediarios1;

      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new FrameModelagem_buttonOK_actionAdapter(this));
    //Necessario para abilitar os eventos basicos
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setSize(d.width / 3, d.height / 4);
    this.setLocation( (d.width - this.getSize().width) / 2,
                     (d.height - this.getSize().height) / 2);
    this.setTitle("Modelling Option");
    buttonCancel.setActionCommand("Cancel");
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new
                                   FrameModelagem_buttonCancel_actionAdapter(this));
    buttonHelp.setLabel("Help");
    label1.setAlignment(Label.LEFT);
    label1.setText("Choose Starting Point Side:");
    panel2.setLayout(borderLayout1);
    checkboxLeft.setLabel("Left");
    checkboxLeft.setState(true);
    checkboxRight.setEnabled(false);
    checkboxRight.setLabel("Right");
    checkboxRight.addComponentListener(new FrameModelagem_checkboxRight_componentAdapter(this));
    label2.setText("Choose Starting Region: ");
    checkboxExternal.setLabel("Outside");
    checkboxExternal.setState(true);
    checkboxInternal.setEnabled(false);
    checkboxInternal.setLabel("Inside");
    panel2.add(panel4, BorderLayout.NORTH);
    panel4.add(label1, null);
    panel2.add(panel3, BorderLayout.SOUTH);
    this.add(panel1, BorderLayout.SOUTH);
    panel1.add(buttonOK, null);
    panel1.add(buttonCancel, null);
    panel1.add(buttonHelp, null);
    this.add(panel2, BorderLayout.CENTER);
    panel4.add(checkboxLeft, null);
    panel4.add(checkboxRight, null);
    panel3.add(label2, null);
    panel3.add(checkboxExternal, null);
    panel3.add(checkboxInternal, null);

  }

//Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    if(checkboxGroup1.getSelectedCheckbox()==checkboxLeft)
    {
      modelagem.Lado = 0;
    }
    if(checkboxGroup1.getSelectedCheckbox()==checkboxRight)
    {
      modelagem.Lado = 1;
    }
    if(checkboxGroup2.getSelectedCheckbox()==checkboxExternal)
    {
      modelagem.Regiao = 0;
    }
    if(checkboxGroup2.getSelectedCheckbox()==checkboxInternal)
    {
      modelagem.Regiao = 1;
    }
    System.out.println("DadosDoProjeto.comprimento do Blank = "+ dadosDoProjeto.ComprimentoDoBlank);
    framePrincipal = new FramePrincipal(dadosDoProjeto, Applet, modelagem);
    framePrincipal.panelFeatureType.LBlank = dadosDoProjeto.ComprimentoDoBlank;

    framePrincipal.setEnabled(true);
    framePrincipal.setVisible(true);
    this.dispose();
  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  void checkboxRight_componentHidden(ComponentEvent e) {

  }
//Aqui termina

}

class FrameModelagem_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  FrameModelagem adaptee;

  FrameModelagem_buttonOK_actionAdapter(FrameModelagem adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}

class FrameModelagem_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  FrameModelagem adaptee;

  FrameModelagem_buttonCancel_actionAdapter(FrameModelagem adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class FrameModelagem_checkboxRight_componentAdapter extends java.awt.event.ComponentAdapter {
  FrameModelagem adaptee;

  FrameModelagem_checkboxRight_componentAdapter(FrameModelagem adaptee) {
    this.adaptee = adaptee;
  }
  public void componentHidden(ComponentEvent e) {
    adaptee.checkboxRight_componentHidden(e);
  }
}
