package webcad_01_0_1;

import java.util.Vector;
import features.*;
import pontos.ControlPoint1Spline;
import java.awt.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Jones Yudi
 * @version 1.0
 */

class InterpCanvasFaceContouredCSpline
    extends Canvas {

  Ponto2D from = new Ponto2D(); /* Ponto inicial da Prxima feature,
                            que leva o valor final da ultima feature */
  double FatorZoom;
  FramePrincipal controlador; // Objeto controlador do tipo FramePrincipal
//////////////////////////////
  Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); //d = tamanho da tela
// 100 x 100 resolution
  protected int _res = 50 * 2;
  protected int _unitPixel = 9;

  Color grid;

// objeto armazenadorDeFeatures do tipo ArmazenadorDeFeatures
  ArmazenadorDeFeatures armazenadorDeFeatures;
  CurveControlsFaceContouredCSpline curveControlsFaceContouredCSpline;
//

  Graphics g2;

  double blank_L = 1000, blank_D = 1000;
  public Vector _feature; //objeto _feature do tipo Vector

  int tsize = _res * _unitPixel;

  int RD = 0;
  int Modelagem;

  double D;
  int R;
  int L;
  double D1;
  double D2; //Para nao perder precisao, pois int trunca
  int R1;
  int R2;
  int tipoInicio;
  int NumerodeCurvas;

//InterpCanvasSpline interpCanvasSpline;
  CanvasInicio inicio;
  int i;
  Panel panel1 = new Panel();

  // constantes que representam as opes de curva.
  public static final int NAT_SPL = 1;

  private int mode = NAT_SPL; // inicializa o modo default como POLY

  public static final int ADD = 0; // constante que representam as aes.
  public static final int MOVE = 1;
  public static final int DELETE = 2;
  private int action = ADD; // inicializa a ao default como ADD.
  Vector points = new Vector(16, 4); // vetor que armazena os pontos,
  //tamanho 16 e incremento de 4 em 4
  Vector points1 = new Vector(16, 4);

  // Se um ponto de controle est sendo movido, este  o ndice na lista do ponto
  // movido. Caso Contrrio, contm -1
  private int moving_point;

  private int precision = 10; //Preciso: nmero de retas entre cada ponto.

  ControlPoint1Spline pi, pf, pi0, pf0;
  DesenhadorDeFeatures desenhador;
  Panel panel2 = new Panel();

  public InterpCanvasFaceContouredCSpline(ControlPoint1Spline p1, ControlPoint1Spline p2,
                            DesenhadorDeFeatures desenhador1) {

    try {
   jbInit();
 }
 catch (Exception ex) {
   ex.printStackTrace();
 }

    this.desenhador = desenhador1;
    this.from = desenhador.from;

    this.FatorZoom = desenhador.FatorZoom;
    this.grid = desenhador.grid;
    this.i = desenhador.i;
    this.inicio = desenhador.inicio;
    g2 = desenhador.getGraphics();
    pi = p1;
    pf = p2;

    pi = new ControlPoint1Spline((int)(FatorZoom*(pi.x)), (int)(FatorZoom*(pi.y)));
    pf = new ControlPoint1Spline((int)(FatorZoom*(pf.x)), (int)(FatorZoom*(pf.y)));
    points.insertElementAt(this.pi, 0);
    points.insertElementAt(this.pf, 1);
    pi0 = new ControlPoint1Spline(p1.x, -p1.y);
    pf0 = new ControlPoint1Spline(p2.x, -p2.y);
    points1.insertElementAt(pi0, 0);
    points1.insertElementAt(pf0, 1);

  }

  public void setAction(int action) {
    // Muda o tipo de ao.
    switch (action) {
      case ADD:
      case MOVE:
      case DELETE:
        this.action = action;
        break;
      default:
        throw new IllegalArgumentException();
    }
  }

  public void setCurveType(int mode) {
    // Muda o tipo de curva a ser mostrada.
    switch (mode) {
      case NAT_SPL:
        this.mode = mode;
        break;
      default:
        throw new IllegalArgumentException();
    }
  }

  public void clearPoints() {
    pi = (ControlPoint1Spline) points.firstElement();
    pf = (ControlPoint1Spline) points.lastElement();
    points.removeAllElements(); //remove todos os pontos.
    points.insertElementAt(pi, 0);
    points.insertElementAt(pf, 1);

    pi = (ControlPoint1Spline) points1.firstElement();
    pf = (ControlPoint1Spline) points1.lastElement();
    points1.removeAllElements(); //remove todos os pontos.
    points1.insertElementAt(pi, 0);
    points1.insertElementAt(pf, 1);

  }

  private int findPoint(int a, int b) {
    // Percorre a lista de pontos de controle para verificar se algum ponto
    // contm as coordenadas (a,b). Verificar a classe ControlPoint, mtodo within.
    // Se o ponto  encontrado, retorna o ndice do ponto, seno, retorna -1.
    int max = points.size();

    for (int i = 1; i < max - 1; i++) {
      ControlPoint1Spline pnt = (ControlPoint1Spline) points.elementAt(i);
      if (pnt.within(a, b)) {
        return i;
      }
    }
    return -1;
  }

  public boolean handleEvent(Event e) {
    //desenhador.d.width/10,desenhador.d.height/3
    e.x = e.x - desenhador.d.width / 10;
    e.y = e.y - desenhador.d.height / 3;
    int a = -e.x;
    int b = -e.y;
    e.x = b;
    e.y = a;
    //System.out.println(e.x);
    switch (e.id) { //verifica qual o evento executado pelo usurio.

      case Event.MOUSE_DOWN: //Evento de pressionar um boto do mouse.
      // O tratamento do evento MOUSE_DOWN depende da ao selecionada.
      {
        switch (action) { //verifica qual ao est selecionada no momento.
          case ADD:
            // Adiciona um novo ponto de controle no local especificado.
            int np = points.size(); //np = nmero de elementos (nmero de pontos).
            ControlPoint1Spline pnt; //cria um ponto de controle (ControlPoint1).

            // insere o novo ponto no local correto, desejado pelo usurio
            int i;
            for (i = 0;
                 i <= np - 1 &&
                 ( (ControlPoint1Spline) points.elementAt(i)).x < e.x;
                 i++) {}
            pnt = new ControlPoint1Spline(e.x, -e.y);
            ControlPoint1Spline pnt0 = new ControlPoint1Spline((int)(1.0/FatorZoom*(e.x)), (int)(1.0/FatorZoom*(e.y)));
            if (np >= 2) {
              if (pnt.x < ( (ControlPoint1Spline) points.lastElement()).x) {
                if (pnt.x > ( (ControlPoint1Spline) points.firstElement()).x) {
                  if (i <= np - 1) {
                    points.insertElementAt(pnt, i);
                    points1.insertElementAt(pnt0, i);
                  }
                  else {
                    points.addElement(pnt);
                    points1.addElement(pnt0);
                  }
                }
              }
            }

            if (np < 2) {
              points.addElement(pnt);
              points1.addElement(pnt0);
            }
            repaint();
            break;

          case MOVE:
            // Retorna moving_point, que  o ndice do ponto na licalizao escolhida.
            // Se no houver nenhum ponto na localizao, retorna -1, ou seja,
            // no h nenhum ponto a ser movido.
            moving_point = findPoint(e.x, -e.y);
            break;

          case DELETE:
            // Deleta um ponto, se for clicado.
            int delete_pt = findPoint(e.x, -e.y);
            if (delete_pt >= 0) {
              points.removeElementAt(delete_pt);
              points1.removeElementAt(delete_pt);
              repaint();
            }
            break;

          default:
            throw new IllegalArgumentException();
        }
        return true;
      } // fim do Evento MOUSE_DOWN
      case Event.MOUSE_UP: { //Evento de soltar um boto do mouse
        // Esse evento s  tratado se estivermos movendo um ponto de controle
        // If so, drop the control point.
        if (moving_point >= 0) { //Se o ndice do ponto (moving_point) >= a zero, muda para -1.
          moving_point = -1;
          repaint();
        }
        return true;
      }
      case Event.MOUSE_DRAG: { //Evento de arrastar o mouse com um boto pressionado.
        // Esse evento s  tratado se estivermos movendo um ponto de controle.
        if (e.x > ( (ControlPoint1Spline) points.firstElement()).x) {
          if (e.x < ( (ControlPoint1Spline) points.lastElement()).x) {

            if (moving_point >= 0) {
              int np = points.size();
              // test if e.x is between x of points.elementAt(moving_point+1)
              //                         and  points.elementAt(moving_point-1)
              if ( (moving_point == np - 1 ||
                    e.x <=
                    ( (ControlPoint1Spline) points.elementAt(moving_point + 1)).
                    x) &&
                  (moving_point == 0 ||
                   e.x >=
                   ( (ControlPoint1Spline) points.elementAt(moving_point - 1)).
                   x)) {
                ControlPoint1Spline pnt = (ControlPoint1Spline) points.
                    elementAt(moving_point);
                ControlPoint1Spline pnt0 = (ControlPoint1Spline) points1.
                    elementAt(moving_point);
                pnt.x = e.x;
                pnt.y = -e.y;
                pnt0.x = (int)(1.0/FatorZoom*(e.x));
                pnt0.y = (int)(1.0/FatorZoom*(e.y));
              }
              else {
                // otherwise find correct slot (or just always do this?)
                points.removeElementAt(moving_point);
                points1.removeElementAt(moving_point);
                int i;
                for (i = 0;
                     i <= np - 2 &&
                     ( (ControlPoint1Spline) points.elementAt(i)).x < e.x;
                     i++) {}
                ControlPoint1Spline pnt2 = new ControlPoint1Spline(e.x, -e.y);
                ControlPoint1Spline pnt20 = new ControlPoint1Spline((int)(1.0/FatorZoom*(e.x)), (int)(1.0/FatorZoom*(e.y)));
                if (i <= np - 1) {
                  points.insertElementAt(pnt2, i);
                  points1.insertElementAt(pnt20, i);
                }
                else {
                  points.addElement(pnt2);
                  points1.addElement(pnt20);
                }
                moving_point = i;
              }
              repaint();
            }
          }
        }
        return true;
      }
      default:
        return false;
    }
  }

  public static void solveTridiag(float sub[], float diag[], float sup[],
                                  float b[],
                                  int n) { //Recebe 4 matrizes de floats.
    //Resolve o sistema linear utilizando Eliminao de Gauss sem pivoteamento.
    /*                  solve linear system with tridiagonal n by n matrix a
                        using Gaussian elimination *without* pivoting
                        where   a(i,i-1) = sub[i]  for 2<=i<=n
                                a(i,i)   = diag[i] for 1<=i<=n
                                a(i,i+1) = sup[i]  for 1<=i<=n-1
                        (the values sub[1], sup[n] are ignored)
     right hand side vector b[1:n] is overwritten with solution
                        NOTE: 1...n is used in all arrays, 0 is unused */
    int i;
    /*                  factorization and forward substitution */
    for (i = 2; i <= n; i++) {
      sub[i] = sub[i] / diag[i - 1];
      diag[i] = diag[i] - sub[i] * sup[i - 1];
      b[i] = b[i] - sub[i] * b[i - 1];
    }
    b[n] = b[n] / diag[n];
    for (i = n - 1; i >= 1; i--) {
      b[i] = (b[i] - sup[i] * b[i + 1]) / diag[i];
    }
  }

  public void paint(Graphics g2) {
    desenhador.paint(g2);

    int np = points.size(); // numero de pontos
    float d[] = new float[np]; // Vetor com os Coeficientes de Newton
    float x[] = new float[np]; // Vetor com as coordenadas-x dos pontos
    float y;
    float t;
    float oldy = 0;
    float oldt = 0;

    this.setBackground(desenhador.getBackground());

    if (np > 0) { //se np>0 , ou seja, se h algum ponto no vetor de pontos.

      // no for, desenha os Pontos de Controle.
      for (int i = 0; i < np; i++) {
        ControlPoint1Spline p = (ControlPoint1Spline) points.elementAt(i); // p = i-simo ponto de controle.
        x[i] = p.x; // i-simo elemento do vetor com as coordenadas-x
        //recebe a coordenada x do -simo ponto de controle.

        d[i] = p.y; // i-simo elemento do vetor de Coeficiente de Newton
        // recebe a coordenada y do i-simo ponto de controle.
        Color old = g2.getColor();
        g2.setColor(Color.red);
        g2.drawRect(p.y - p.PT_SIZE, -p.x - p.PT_SIZE, p.PT_SIZE * 2,
                    p.PT_SIZE * 2); // desenha um quadrado em volta do i-simo ponto de controle.
        // escreve na tela, dinamicamente, as coordenadas dos pontos de controle.
        g2.setColor(Color.blue);
        g2.drawString("(" + (p.x) + "," + (p.y) + ")", p.y - p.PT_SIZE,
                      -p.x - 2 * p.PT_SIZE);
        g2.setColor(old);
        // g.drawString(String.valueOf(i), p.x + p.PT_SIZE, p.y - p.PT_SIZE);
        // desenha um ndice no quadrado que est em volta do i-simo ponto de controle.

      } // fim do for

      switch (mode) { //verifica qual tipo de curva (mode) est selecionada.
        case (NAT_SPL): {
          if (np > 1) { // Caso tenhamos mais de dois pontos (com dois pontos, temos uma reta)
            float a[] = new float[np]; //vetor a, com tamanho np.
            float t1;
            float t2;
            float h[] = new float[np]; //vetor h, com tamanho np.

            for (int i = 1; i <= np - 1; i++) {
              h[i] = x[i] - x[i - 1];
            }

            if (np > 2) { //Caso tenhamos mais de trs pontos
              float sub[] = new float[np - 1]; //vetor sub, com tamanho np-1.
              float diag[] = new float[np - 1]; //vetor diag, com tamanho np-1.
              float sup[] = new float[np - 1]; //vetor sup, com tamanho np-1.

              for (int i = 1; i <= np - 2; i++) {
                diag[i] = (h[i] + h[i + 1]) / 3;
                sup[i] = h[i + 1] / 6;
                sub[i] = h[i] / 6;
                a[i] = (d[i + 1] - d[i]) / h[i + 1] - (d[i] - d[i - 1]) / h[i];
              }

              solveTridiag(sub, diag, sup, a, np - 2); //Resolve o sistema. Ver mtodo solveTridiag.
            }

            // notar que a[0]=a[np-1]=0
            // desenha
            oldt = x[0];
            oldy = d[0];
            Ponto2D temp = new Ponto2D();
            temp.z = oldt;
            temp.x = oldy;

            g2.drawLine( (int) oldt, (int) oldy, (int) oldt, (int) oldy);

            for (int i = 1; i <= np - 1; i++) { // Desenha as linhas entre cada ponto de controle,
              // de acordo com a "preciso" especifcada.
              for (int j = 1; j <= precision; j++) {
                t1 = (h[i] * j) / precision;
                t2 = h[i] - t1;
                t = ( ( -a[i - 1] / 6 * (t2 + h[i]) * t1 + d[i - 1]) * t2 +
                     ( -a[i] / 6 * (t1 + h[i]) * t2 + d[i]) * t1) / h[i];
                y = x[i - 1] + t1;
                g2.setColor(Color.red);
                g2.drawOval( (int) oldt - 2, (int) - oldy - 2, 4, 4);
                g2.setColor(Color.blue);
                Rosca rosca = new Rosca();
                desenhador.ODTapered( (int) oldt, - (int) oldy, (int) t,
                                     - (int) y, i, rosca);
                temp.z = t;
                temp.x = y;

                oldt = t;
                oldy = y;
              }
            }
          }
          break;
        }
      }
    }
  }

   void jbInit() throws Exception {
    panel2.add(this, null);

  } ///Fim do mtodo paint.
}
