package capp_01_0_1;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining <BR>
 * Contem asinformacoesnecessarias para qualificar as features de fixacao</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class InfoFeatureDeFixacao implements Comparable{
  /**
   * O ndice da possvel feature de fixacao no vetor de features original
   */
  int indiceDaFeature;
  /**
   * <p>A prioridade e um valor numerico de 0 a 1 quantificando todos os atributos da feature,<BR>
   * procurando assim ordenar o vetor de features para agilizar o processo de escolha futuros.</p>
   * <p>Inicialmente esta feature de fixacao tem prioridade maxima e sera penalizada</p>
   * @todo Escolher se prioridade basica e 1.0, 0.5 ou 0.0 ???
   */
  double prioridade;
  public InfoFeatureDeFixacao() {
  }

  public final int compareTo(Object outraInfoFeatureDeFixacao) {
    final int BEFORE = -1;
    final int EQUAL = 0;
    final int AFTER = 1;
    final InfoFeatureDeFixacao that = (InfoFeatureDeFixacao)
        outraInfoFeatureDeFixacao;

    if (this.prioridade == that.prioridade) {
      return EQUAL;
    }
    if (this.prioridade < that.prioridade) {
      return BEFORE;
    }
    return AFTER;
  }

}
