package capp_01_0_1;

import java.util.*;
import features.*;
import java.text.DecimalFormat;
import javax.swing.JOptionPane;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class MyMath {

    /**
     *
     * @param entrada Vector
     * @return Vector
     */
    public static Vector ordenaVectorDeFeatures(Vector entrada){
    Vector saida = new Vector();
    int size = entrada.size();
    Feature[] entradaArray=new Feature[size];
    //Cast para array
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) entrada.elementAt(i);
      entradaArray[i] = tmp;
    }
    Arrays.sort(entradaArray);

    //Cast para vector
    for (int i = 0; i < size; i++) {
      Feature tmp = entradaArray[i];
      saida.add(tmp);
    }
    return saida;
  }

  /**
   *
   * @param entrada Vector
   * @return Vector
   *
   * Inverte a ordem de features de um vetor
   */
  public static Vector inverteVector(Vector entrada){
    Vector saida = new Vector();

    double D1tmp=0.0;
    double D2tmp=0.0;
    int size = entrada.size();
    for(int i = size-1; i >= 0; i--){
      Feature tmp = (Feature)entrada.elementAt(i);
      D2tmp =tmp.D1;
      D1tmp =tmp.D2;
      tmp.D1=D1tmp;
      tmp.D2=D2tmp;
      saida.add(tmp);
    }

    return saida;
  }


 /**
  *
  * @param entrada Vector
  * @return Vector
  *
  * Inverte os diametros de um vetor de features de entrada, utilizada quando
  * e necessario inverter a ordem das features da peca
  */
 public static Vector inverteDiametros(Vector entrada) {
    Vector saida = new Vector();
    double D1tmp = 0.0;
    double D2tmp = 0.0;
    int size = entrada.size();
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) entrada.elementAt(i);

      D2tmp = tmp.D1;
      D1tmp = tmp.D2;

      tmp.D1 = D1tmp;
      tmp.D2 = D2tmp;
      saida.add(tmp);
    }

    return saida;
  }


  public static Vector colocaAOrdem(Vector entrada){
    int size = entrada.size();
    //alert("Tamanho do vetor de Features:\n" + size);
    for (int i = 0; i < size; i++) {
      Feature tmpFeature = (Feature) entrada.elementAt(i);
      tmpFeature.Ordem = i + 1;
    }
    return entrada;
  }



  //1903 e 2003
  /**
   *
   * @param num double
   * @return double
   *
   * Recebe um double e retorna a string referente a este que sera incluida no CodigoG
   */
  public String arredondaDouble(double num) {
    double round = 0;
    DecimalFormat zeroDigits = new DecimalFormat("0");
    DecimalFormat oneDigit = new DecimalFormat("0.0");
    DecimalFormat twoDigits = new DecimalFormat("0.00");
    DecimalFormat threeDigits = new DecimalFormat("0.000");

    num *= 1000; //multiplica o numero por mil para arredondar para o mais proximo mesmo
    //considerando os milesimos de milimetro

    round = Math.round(num); //arredonda para o valor mais proximo
    round /= 1000; //divide por mil para retornar ao formato original

    //Faz a formatacao do numero arredondado
    //2.000 -> retorna 2
    //1.600 -> retorna 1.6
    //1.570 -> retorna 1.57
    //1.457 -> retorna 1.457
    String tmp = zeroDigits.format(round);
    tmp = tmp.replace(',', '.');
    double roundTmp = Double.parseDouble(tmp);

    if (round - roundTmp == 0) { //retorna o double sem casas decimais
      //return roundTmp;
      //System.out.println(tmp);
      return tmp;
    }
    else {
      tmp = oneDigit.format(round);
      tmp = tmp.replace(',', '.');
      roundTmp = Double.parseDouble(tmp);
      if (round - roundTmp == 0) { //retorna o double com uma casa decimal
        //return roundTmp;
        //System.out.println(roundTmp);
        return tmp;
      }
      else {
        tmp = twoDigits.format(round);
        tmp = tmp.replace(',', '.');
        roundTmp = Double.parseDouble(tmp);
        if (round - roundTmp == 0) { //retona o double com duas casas decimais
          //return roundTmp;
          //System.out.println(roundTmp);
          return tmp;
        }
        else { //retona o double com tres casas decimais
          tmp = threeDigits.format(round);
          tmp = tmp.replace(',', '.');
          //roundTmp = Double.parseDouble(tmp);
          //return roundTmp;
          //System.out.println(roundTmp);
          return tmp;
        }
      }

    }
  }
  //1903 e 2003

  //3103 0504
  /**
   *
   * @param num double
   * @return String
   *
   * Recebe um numero em milimetros e retorna a string equivalente
   * a este valor em micrometros, no formato de uma string
   */
  public String arredondaDoubleMicro(double num){
    DecimalFormat zeroDigits = new DecimalFormat("0");
    String tmp = "";

    tmp = zeroDigits.format(Double.parseDouble(arredondaDouble(num*1000)));

    return tmp;
  }
  //3103 0504

  /**
   * CastDeArrayDeInfoFeaturesPorDiametro
   *
   * @param novo InfoFeaturesPorDiametro[]
   * @param velho InfoFeaturesPorDiametro[]
   */
  public static void CastDeArrayDeInfoFeaturesPorDiametro(
      InfoFeaturesPorDiametro[] novo, InfoFeaturesPorDiametro[] velho) {
      int size = novo.length;
      for(int i=0;i<size;i++){
        novo[i]=velho[i];
      }
  }

  /**
   * InicializaArrayDeInfoFeaturesPorDiametro
   *
   * @param fPD InfoFeaturesPorDiametro[]
   */
  public static void InicializaArrayDeInfoFeaturesPorDiametro(
      InfoFeaturesPorDiametro[] fPD) {
      int size = fPD.length;
      for(int i=0;i<size;i++){
        fPD[i]=new InfoFeaturesPorDiametro();
        fPD[i].features = new Vector();
      }
  }

  /**
   * InicializarArrayDeInfoSuperficieDelimitadora
   *
   * @param infoSuperficieDelimitadora InfoSuperficieDelimitadora[]
   */
  public static void InicializarArrayDeInfoSuperficieDelimitadora(
      InfoSuperficieDelimitadora[] infoSuperficieDelimitadora) {
      int size= infoSuperficieDelimitadora.length;
      for(int i=0;i<size;i++){
        infoSuperficieDelimitadora[i]=new InfoSuperficieDelimitadora();
      }

  }

  /**
   *
   * @param _feature Vector
   * @param onde String
   *
   * ==Para Testes==
   * Imprime o vetor de features com alguns dos seus dados, esta nesta classe para
   * poder ser chamada da untitled5 e da untitled3
   */
  public static void imprimeVetorDeFeatures(Vector _feature, String onde){
      int size = _feature.size();

      System.out.println("\n=====> Features - " + onde + "<=====");
      for(int i = 0; i < size; i++){
        Feature tmp = (Feature)_feature.elementAt(i);
        System.out.println("\tFeature numero: " + tmp.Ordem);
        switch(tmp.Tipo){
          case Feature.FACECONCAVE:
            System.out.println("\t\tFaceConcave");
            break;
          case Feature.FACECONVEX:
            System.out.println("\t\tFaceConvex");
            break;
          case Feature.FACESTRAIGHT:
            System.out.println("\t\tFaceStraight");
            break;
          case Feature.FACETAPERED:
            System.out.println("\t\tFaceTapared");
            break;
          case Feature.GROOVE_COMPLEXO:
            System.out.println("\t\tGrooveComplexo");
            break;
          case Feature.ODCONCAVE:
            System.out.println("\t\tODConcave");
            break;
          case Feature.ODCONVEX:
            System.out.println("\t\tODConvex");
            break;
          case Feature.ODSTRAIGHT:
            System.out.println("\t\tODStraight");
            break;
          case Feature.ODTAPERED:
            System.out.println("\t\tODTapered");
            break;
          default:
            System.out.println("\t\t" + tmp.Tipo);
            break;
        }
        System.out.println("\t\tL1: " + tmp.L1 + "\n\t\tD1: " + tmp.D1 + "\n\t\tD2: " + tmp.D2);
      }
      System.out.println("=====> Features - " + onde + "<=====");
  }

  /**
   *
   * @param _feature Vector
   *
   * ==Para Testes==
   * Imprime o comprimento da peca a partir dos dados do vetor de features
   */
  public static void imprimeTamanho(Vector _feature) {
    int size = _feature.size();
    int tamanho = 0;
    Feature tmp;
    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      tamanho += tmp.L1;
    }
    System.out.println(tamanho);
  }

  /**
   *
   * @param alerta String
   *
   * ==Para Testes==
   * Mostra uma mensagem de alerta com os dados da string que a funcao recebe
   */
  public static void alert(String alerta){
    JOptionPane.showMessageDialog(null, alerta, "Alerta", 2);
  }


  /*

  ==->Daqui para baixo estao funcoes que nao sao utilizadas<===

   */


  /**
   *
   * @param fu FeatureDeUsinagem
   * @return int
   * @todo  tem q ver as funcoes direito
   *
   * Retorna um inteiro que representa o ciclo fixo do torno
   */
  public int getCiclo(FeatureDeUsinagem fu){
    switch (fu.tipo){
      case FeatureDeUsinagem.FACE:
        return 72;
      case FeatureDeUsinagem.BLOCO:
        return 71;
      case FeatureDeUsinagem.RECARTILHADO:
        return 999;
      case FeatureDeUsinagem.ROSCA:
        return 76;
      case FeatureDeUsinagem.GROOVE:
        return 75;
      default:
        return 01;
    }
  }

  /*
  private static void CastDeArrayDeInfoFeaturesPorDiametro(InfoFeaturesPorDiametro[] in,InfoFeaturesPorDiametro[] out) {

  }
*/


}
