package capp_01_0_1;

import java.util.Vector;
import features.Feature;
import features.GrooveComplexo;

/**
 * <p>Title: CAPP</p>
 *
 * <p>Description: CAPP para o projeto Webmachining</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: GrACo</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Untitled1 {
  Vector _feature;
  MyMath calculus = new MyMath();

  public Untitled1(Vector _features) {
    this._feature = _features;
    this._feature = normalizadorDeFeatures(this._feature);
    imprimeNormalizacao(this._feature);
  }

  private Vector agrupaGrooves(Vector entrada) {
    int size = entrada.size();
    Vector saida = new Vector(size);
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) entrada.elementAt(i);
      if (tmp.Tipo == Feature.GROOVE_COMPLEXO) {
        Vector tmpJ = ( (GrooveComplexo) tmp).features;
        int sizeJ = tmpJ.size();
        for (int j = 0; j < sizeJ; j++) {
          saida.add(tmpJ.elementAt(j));
        }
      }
      else {
        saida.add(tmp);
      }
    }

    return MyMath.ordenaVectorDeFeatures(saida);
  }


  private Vector normalizadorDeFeatures(Vector _feature) {
    Vector _featuresNormalizadas;

    _featuresNormalizadas = normalizadorParcial(_feature, 0, false, 0);
    _featuresNormalizadas = calculus.colocaAOrdem(_featuresNormalizadas);
    calculus.imprimeVetorDeFeatures(_featuresNormalizadas, "Inicio");


    _featuresNormalizadas = calculus.inverteVector(_featuresNormalizadas);
    _featuresNormalizadas = calculus.colocaAOrdem(_featuresNormalizadas);
    calculus.imprimeVetorDeFeatures(_featuresNormalizadas, "Inverteu");


    _featuresNormalizadas = normalizadorParcial(_featuresNormalizadas, 0 , false, 0);
    _featuresNormalizadas = calculus.colocaAOrdem(_featuresNormalizadas);
    calculus.imprimeVetorDeFeatures(_featuresNormalizadas, "Normalizou denovo");


    _featuresNormalizadas = calculus.inverteVector(_featuresNormalizadas);
    _featuresNormalizadas = calculus.colocaAOrdem(_featuresNormalizadas);
    calculus.imprimeVetorDeFeatures(_featuresNormalizadas, "Desinverteu");


    return _featuresNormalizadas;
  }

  public Vector normalizadorParcial(Vector _feature, int ini, boolean groove, int controle) {
    Vector _featuresNormalizadas = new Vector();
    Feature tmp;
    boolean desceu = false;

    //guarda o valor do diametro atual -> importante para quando encontrar grooveComplexo
    double diametroInicialDoGroove = 0;
    if (groove) {
      diametroInicialDoGroove = ( (Feature) _feature.elementAt(ini)).D1;
    }

    int size = _feature.size();
    for (int i = ini; i < size; i++) {
      tmp = (Feature)_feature.elementAt(i);
      calculus.alert("FOR i: " + i);

      if (tmp.D2 > tmp.D1) { //subindo...
        if (groove) { //caso seja um groove
          if (tmp.D2 >= diametroInicialDoGroove) { //fechou o groove => retorna
            _featuresNormalizadas.add(tmp);
            calculus.alert("Fechou " + controle);
            break;
          }
          else { //ainda nao fechou o groove => adiciona ao vetor normalizado
            _featuresNormalizadas.add(tmp);
          }
        }
        else { //nao e groove => adiciona ao vetor normalizado
          _featuresNormalizadas.add(tmp);
        }
      }
      else if (tmp.D2 == tmp.D1) { //linha reta...
        _featuresNormalizadas.add(tmp);
      }
      else if (tmp.D2 < tmp.D1) { //descendo...GGRRROOOVVEEE!!!!
          if(groove && desceu == false){
            _featuresNormalizadas.add(tmp);
            desceu = true;
          }
          else{//vai criar um novo groove
            controle++;
            calculus.alert("Iniciando groove: " + controle);
            Vector vetorDoGroove = normalizadorParcial(_feature, i, true, controle);
            int sizeX = vetorDoGroove.size();
            String elem = "Features do vetorDeGroove\n";
            for(int x = 0; x < sizeX; x++){
              elem += ((Feature)vetorDoGroove.elementAt(x)).Tipo + "\n";
            }
            calculus.alert(elem);
            GrooveComplexo grooveNovo = new GrooveComplexo();

            //vetorDoGroove = agrupaGrooves(vetorDoGroove);
            //grooveNovo.setFeatures(vetorDoGroove);
            grooveNovo.D1 = ( (Feature) vetorDoGroove.firstElement()).D1;
            grooveNovo.D2 = ( (Feature) vetorDoGroove.lastElement()).D2;
            calculus.alert("Diametros\nD1: " + grooveNovo.D1 + " D2: " + grooveNovo.D2);

            int sizeGroove;
            int avanca = 0;
            if(grooveNovo.D2 < grooveNovo.D1){//nao conseguiu fechar um groove => adiciona as features no _featuresNormalizadas
              sizeGroove = vetorDoGroove.size();
              for(int l = 0; l < sizeGroove; l++){
                Feature tmpF = (Feature)vetorDoGroove.elementAt(l);
                _featuresNormalizadas.add(tmpF);

                if(tmpF.Tipo == Feature.GROOVE_COMPLEXO){
                  avanca += ((GrooveComplexo)tmpF).features.size();
                }

              }
              calculus.alert("Nao fechou: " + controle);

              avanca += sizeGroove;
            }
            else{
              vetorDoGroove = agrupaGrooves(vetorDoGroove);
              grooveNovo.setFeatures(vetorDoGroove);

              sizeGroove = vetorDoGroove.size();
              double tamanho = 0;
              for (int k = 0; k < sizeGroove; k++) {
                tamanho += ( (Feature) vetorDoGroove.elementAt(k)).L1;
              }
              grooveNovo.L1 = tamanho;

              _featuresNormalizadas.add(grooveNovo);
              avanca = sizeGroove;
            }
            //atualiza o i
            calculus.alert("Tamanho do groove\n" + sizeGroove);
            i += avanca - 1;

          }

        //Vector vetorDoGroove = normalizadorParcial(_feature, i);
        //GrooveComplexo groove = new GrooveComplexo();
        //groove.setFeatures(vetorDoGroove);
      }
    }

    return _featuresNormalizadas;
  }

  private void imprimeNormalizacao(Vector _featuresNormalizadas) {
    int size = _featuresNormalizadas.size();
    Feature tmp;

    for (int i = 0; i < size; i++) {
      tmp = (Feature) _featuresNormalizadas.elementAt(i);
      if (tmp.Tipo == Feature.GROOVE_COMPLEXO) {
        System.out.println("Inicio Groove_Complexo ------> Ordem[" + tmp.Ordem +
                           "]:\n\tTipo: " + tmp.Tipo + "----> GROOVE_COMPLEXO");
        GrooveComplexo grooveTmp = (GrooveComplexo) tmp;
        imprimeNormalizacao(grooveTmp.features);
        System.out.println("Fim GrooveComplexo ------> Ordem[" + tmp.Ordem +
                           "]");
      }
      else {
        System.out.println("Ordem[" + tmp.Ordem + "]:\n\tTipo: " + tmp.Tipo);
      }
    }
  }

}
