package capp_01_0_1;

import java.util.*;

import features.*;
import pontos.*;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

/**
 * @todo colocar o M36 e o M37 no inicio e no final do programa
 * colocar os dados dos workingsteps
 * encontrar uma maneira de naum inverter os vetore, criar um metodo novo que adicione um novo objeto sempre
 */
public class Untitled3 {
public  String codigoTxT;

  InfoDecomposicaoOrientadaAOperacao decomposicaoOrientadaAOperacao;
  Vector codigoG = new Vector();
  int numeroDaLinha = 0;

  Blank blankUtilizado;
  FerramentaUtilizada ferramentaUtilizada = null;
  Maquina maquinaUtilizada;
  boolean fluidoDeCorte = false; //0803

  MyMath calculus = new MyMath();
  Vector _feature;
  int numeroDaFU = 1;
  int numeroDoSetup = 1;

  public Untitled3(InfoDecomposicaoOrientadaAOperacao
                   decomposicaoOrientadaAOperacao, Vector _feature) {
    System.out.println("#####=====UNTITLED 3=====#####");
    this._feature = _feature;
    this.decomposicaoOrientadaAOperacao = decomposicaoOrientadaAOperacao;
    this.blankUtilizado = decomposicaoOrientadaAOperacao.blankUtilizado;
    init();
  }

  private void init() {
    maquinaUtilizada = decomposicaoOrientadaAOperacao.maquinaUtilizada;
    percorredorSetups(decomposicaoOrientadaAOperacao.setupN);

    System.out.println("\n");
     codigoTxT = getCodigoGTxT(codigoG);
    System.out.println(codigoTxT);
  }

  private String getLinhaDoCodigoG() {
    String linhaDoCodigoG = "N";
    numeroDaLinha += 10;
    linhaDoCodigoG += numeroDaLinha;

    return linhaDoCodigoG;
  }

  /**
   *
   * @param vetorSetupN Vector
   *
   * Esse metodo vai percorrer um vetor com N Setups pra chamar o metodo que
   * resolve cada um deles ou melhor que passa como parametro os workingsteps do SetupN.
   */
  private void percorredorSetups(Vector vetorSetupN) {
    int size = vetorSetupN.size();

    //Adiciona o bloco inicial do codico G
    blocoInicial();

    for (int i = 0; i < size; i++) {
      Vector WS = (Vector) vetorSetupN.elementAt(i);

      //0303
      codigoG.add(getLinhaDoCodigoG() + "(INICIO SETUP" + numeroDoSetup + ")");
      //0303

      workingstepsDoSetupN(WS);

      //0303
      codigoG.add(getLinhaDoCodigoG() + "(FIM SETUP" + numeroDoSetup + ")");
      numeroDoSetup++;
      numeroDaFU = 1;
      //0303

      if (size != 1 && i != size - 1) {
        blocoTrocaSetup();
      }
      if (i == size - 1) {
        blocoFinal();
      }
    }
  }

  /**
   * blocoInicail
   *
   * @todo Tem que colocar um nmero para o programa tambm tem que buscar no BD os
   * dados referentes a situacao do torno (ferrementas etc)
   */
  private void blocoInicial() {
    codigoG.add("O1000(PECA R1 - UFSC)");
    codigoG.add("N10G21G40G90G95");
    codigoG.add("N20M36");
    codigoG.add("N30M37");
    numeroDaLinha = (codigoG.size() - 1) * 10;
  }

  private void blocoTrocaSetup() {
    codigoG.add(getLinhaDoCodigoG() + "(TROCA DE SETUP)");
    codigoG.add(getLinhaDoCodigoG() + "M00");

    codigoG.add(getLinhaDoCodigoG() + "M36");
    codigoG.add(getLinhaDoCodigoG() + "M37");
    MyMath.inverteDiametros(_feature);
  }

  private void blocoFinal() {
    Ponto2D pontoDeTrocaDeFerramenta = decomposicaoOrientadaAOperacao.
        maquinaUtilizada.pontoDeTrocaDeFerramenta;
    codigoG.add(getLinhaDoCodigoG() + "G53G40M9M5"); //00
    codigoG.add(getLinhaDoCodigoG() + "G0X" +
                calculus.arredondaDouble(pontoDeTrocaDeFerramenta.x) + "Z" +
                calculus.arredondaDouble(pontoDeTrocaDeFerramenta.z) + "T00");

    codigoG.add(getLinhaDoCodigoG() + "M36");
    codigoG.add(getLinhaDoCodigoG() + "M37");
    codigoG.add(getLinhaDoCodigoG() + "M30" + "(FIM DA PECA)");
  }

  /**
   *
   * @param _workingsteps Vector Este metodo gera o bloco do codigoG de cada
   *   setup, verificando cada workingstep Ja esta testando a necessidade da troca
   *   de ferramenta
   */
  private void workingstepsDoSetupN(Vector _workingsteps) {
    Vector blocoCodigoG = null;
    Workingstep WS;
    int size = _workingsteps.size();

    for (int i = 0; i < size; i++) {
      WS = (Workingstep) _workingsteps.elementAt(i);
      //0803
      getDescricaoDoWorkingstep(WS);
      //0803

      /**
       * @todo tem que adicionar as ferramentas para os outros tipos de FU, alem da face
       */
      switch (WS.featureDoWorkingstep.tipo) {
        case FeatureDeUsinagem.FACE:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG75(WS);
          break;
        case FeatureDeUsinagem.BLOCO:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG7170_tipo1(WS);
          break;
        case FeatureDeUsinagem.GROOVE_COMPLEXO:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG7270(WS);
          break;
        case FeatureDeUsinagem.ROSCA:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG76(WS);
          break;
      }
      if (blocoCodigoG != null) {
        codigoG = insereNoVetor(codigoG, blocoCodigoG);
      }
      numeroDaLinha = (codigoG.size() - 1) * 10;
      blocoCodigoG = null;
    }
  }

  /**
   * getDescricaoDoWorkingstep
   *
   * @param WS Workingstep
   *
   * insere no codigoG a descricao do Workingstep, incluindo varios dados sobre este
   */
  private void getDescricaoDoWorkingstep(Workingstep WS) {
    String tmp = "";
    tmp = (getLinhaDoCodigoG() + "(WORKINGSTEP - ");

    switch (WS.featureDoWorkingstep.tipo) {
      case FeatureDeUsinagem.FACE:
        tmp += ("FEATURE DE USINAGEM Fu" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.BLOCO:
        tmp += ("FEATURE DE TORNEAMENTO Ft" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.GROOVE:
        tmp += ("FEATURE DE USINAGEM Fu" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.GROOVE_COMPLEXO:
        tmp += ("FEATURE DE TORNEAMENTO Ft" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.RECARTILHADO:
        tmp += ("FEATURE DE USINAGEM Fu" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.ROSCA:
        tmp += ("FEATURE DE USINAGEM Fu" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
    }
    numeroDaFU++;
  }

  /**
   * trocaDeFerramenta
   *
   * @param WS Workingstep
   *
   * Faz a troca de ferramenta sempre que for necessario
   */
  private void trocaDeFerramenta(Workingstep WS) {
    FerramentaUtilizada ferrUti = WS.operacaoDeUsinagem[0].ferramentaUtilizada[
        0];

    if ( (ferramentaUtilizada == null) ||
        (ferrUti.numDaMagazine != ferramentaUtilizada.numDaMagazine)) { //para esses casos a troca de ferramenta e necessaria
      ferramentaUtilizada = ferrUti;
      fluidoDeCorte = false; //muda a variavel de forma que sempre que houver uma troca de ferramenta seja adicionada
      //a linha M8 no codigo G

      codigoG.add(getLinhaDoCodigoG() + "G53");
      codigoG.add(getLinhaDoCodigoG() + "G0X" +
                  calculus.arredondaDouble(maquinaUtilizada.
                                           pontoDeTrocaDeFerramenta.x) + "Z" +
                  calculus.arredondaDouble(maquinaUtilizada.
                                           pontoDeTrocaDeFerramenta.z) + "T00");

      //Forcando o codigo a ter dois dgitos para o n na magazine e para o n de compensacao
      String tmp = "";
      tmp = getLinhaDoCodigoG() + "T";
      if (WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDaMagazine < 10)
        tmp += "0";
      tmp += WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDaMagazine;
      if (WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDeCompensacao < 10)
        tmp += "0";
      tmp += WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDeCompensacao +
          "(Tool " + WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].descricao +
          ")";
      codigoG.add(tmp);

      //1903
      if (numeroDoSetup == 1)
        codigoG.add(getLinhaDoCodigoG() + "G54");
      else
        codigoG.add(getLinhaDoCodigoG() + "G55");
      //1903

      codigoG.add(getLinhaDoCodigoG() + "G96S" +
                  (int) WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.Vc);
      codigoG.add(getLinhaDoCodigoG() + "G92S" + "4000");
      //@todo buscar pela operacao de usinagem se e M3 ou M4
      codigoG.add(getLinhaDoCodigoG() + "M4");

      //Adiciona M8 ou M9, dependendo do caso
      if (WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.fluidoDeCorte == true &&
          fluidoDeCorte == false) {
        codigoG.add(getLinhaDoCodigoG() + "M8"); //liga o fluido de corte
        fluidoDeCorte = true;
      }
      if (WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.fluidoDeCorte == false &&
          fluidoDeCorte == true) {
        codigoG.add(getLinhaDoCodigoG() + "M9"); //desliga o fluido de corte
        fluidoDeCorte = false;
      }
    }
  }

  /**
   * getCodigoG7170
   *
   * @param WS workingstep
   * @return Vector
   */
  private Vector getCodigoG7170_tipo1(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();
    double U = 1.0;
    double R = 2.0;
    int P;
    int Q;
    double sobreMetalU = 0.2;
    double sobreMetalW = 0.2;
    double F = 0.2;

    //0303
    _codigoIntermediario.add(getLinhaDoCodigoG() +
        "(Operacao - CICLO FIXO G71-TIPO1 DESBASTE E G70 ACABAMENTO)");
    //0303

    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.z));

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             calculus.arredondaDouble(WS.planoDeAproximacao.z));

    //Adiciona a primeira linha do ciclo fixo
    //adiciona um pedaco da segunda linha do ciclo fixo
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G71U" +
                             calculus.arredondaDouble(U) + "R" +
                             calculus.arredondaDouble(R));
    P = numeroDaLinha + 20;
    String tmp = getLinhaDoCodigoG() + "G71P" + P;

    //Coloca no _codigoIntermediario o plano de Aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(((FeatureDeUsinagem)WS.featureDoWorkingstep).origem.x));
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G42");
    /*Al q mia do vazio*/
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G1W-5");

    //Gera o bloco do ciclo fixo
    //Vector blocoFormaFinal = getPerfilCrescente(WS.featureDoWorkingstep._featuresDaFU);
    Vector blocoFormaFinal = getPerfil(WS); //1703

    //Coloca no _codigoIntermediario a string que representa a segunda linha do G71
    Q = numeroDaLinha;
    tmp += "Q" + Q + "U" + calculus.arredondaDouble(sobreMetalU) + "W" +
        calculus.arredondaDouble(sobreMetalW) + "F" +
        calculus.arredondaDouble(F);
    _codigoIntermediario.add(4, tmp); //Coloca em 2 pq (0) = G0 e (1) = 1 linha do G71 By Roman!!!

    //Coloca no _codigoIntermediario o perfil da forma que sera usinada
    _codigoIntermediario = insereNoVetor(_codigoIntermediario, blocoFormaFinal);

    //Insere  o ciclo de Acabamento
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G70P" + P + "Q" + Q);
    return _codigoIntermediario;
  }

//0303
  private Vector getCodigoG7170_tipo2(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();

    //0303
    _codigoIntermediario.add(getLinhaDoCodigoG() +
        "(Operacao - CICLO FIXO G71-TIPO2 DESBASTE E G70 ACABAMENTO)");
    //0303
    //@todo tem que criar uma funcao tipo getPerfilG71_tipo2 e tambem uma para pegar o perfil do spline (se necessario)


    return _codigoIntermediario;
  }

  private Vector getCodigoG7270(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();
    double W = 0.0; //profundidade de corte
    double R = 0.0; //valor de afastamento no eixo longitudinal para retorno ao "X" inicial
    int P = 0; //inicio do bloco do perfil
    int Q = 0; //fim do bloco do perfil
    double sobreMetalU = 0.0; //sobremetal no eixo X
    double sobreMetalW = 0.0; //sobremetal no eixo Z
    double F = 1; //avanco

    //0303
    _codigoIntermediario.add(getLinhaDoCodigoG() +
        "(Operacao - CICLO FIXO G72 GROOVE COMPLEXO E G70 ACABAMENTO)");
    //0303


    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.z));

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             calculus.arredondaDouble(WS.planoDeAproximacao.z));

    //Primeira linha do ciclo fixo
    //W = WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.Ap;
    W = 2;
    R = 0;
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G72W" +
                             calculus.arredondaDouble(W) + "R" +
                             calculus.arredondaDouble(R));
    //Pedaco da segunda linha do ciclo
    P = numeroDaLinha + 20;
    String tmp = getLinhaDoCodigoG() + "G72P" + P;


    //Para o G72, a primeira linha do perfil deve ter apenas um Z
    double comprimento = 0.0;
    int size = WS.featureDoWorkingstep._featuresDaFU.size();
    for (int i = 0; i < size; i++) {
      Feature fTmp = (Feature) WS.featureDoWorkingstep._featuresDaFU.elementAt(i);
      comprimento += fTmp.L1;
    }

    //Faz o deslocamento inicial em Z
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0Z" +
                             (calculus.arredondaDouble(WS.planoDeAproximacao.z -
        comprimento))); //0303

    _codigoIntermediario.add(getLinhaDoCodigoG() + "G41");

    //Tira o espaco entre a ferramenta e a peca (deltaAproximacao)
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G1X" +
                             calculus.
                             arredondaDouble( ( (Feature) ( (GrooveComplexo) WS.
        featureDoWorkingstep._featuresDaFU.elementAt(0)).features.firstElement()).
                                             D1));

    //Vector blocoFormaFinal = getPerfilGrooveComplexo(((GrooveComplexo)WS.featureDoWorkingstep._featuresDaFU.elementAt(0)).features);
    Vector blocoFormaFinal = getPerfil(WS);

    //Coloca no _codigoIntermediario a string que representa a segunda linha do G72
    Q = numeroDaLinha;
    tmp += "Q" + Q + "U" + calculus.arredondaDouble(sobreMetalU) + "W" +
        calculus.arredondaDouble(sobreMetalW) + "F" +
        calculus.arredondaDouble(F);
    _codigoIntermediario.add(4, tmp); //Coloca em 2 pq (0) = G0 e (1) = 1 linha do G72 bY Roman

    //Coloca no _codigoIntermediario o perfil da forma que sera usinada
    _codigoIntermediario = insereNoVetor(_codigoIntermediario, blocoFormaFinal);

    //Insere  o ciclo de Acabamento
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G70P" + P + "Q" + Q);

    return _codigoIntermediario;
  }

  /**
   *
   * @param WS workingstep
   * @return Vector
   */
  private Vector getCodigoG75(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();

    Ponto2D pontoDeAproximacao = new Ponto2D(WS.planoDeAproximacao.x,
                                             WS.planoDeAproximacao.z);
    double X = 0.0;
    double Z = 0.0;
    double P = 0;//milesimos de milimetro
    double Q = 0;//milesimos de milimetro
    double R = 0.0;
    double F = 0.0;

    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO FIXO G75 FACEAMENTO)");

    //Encontrando os valores
    FeatureDeUsinagem tmp = WS.featureDoWorkingstep;
    Feature featureTmp;
    X = 0.0;
    featureTmp = (Feature) tmp._featuresDaFU.lastElement();
    Z = (blankUtilizado.L1 + featureTmp.L1);
    P = (pontoDeAproximacao.x /*- Xinferior*/ / 2);
    Q = WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.Ap;
    R = 1.0;
    F = WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.F;


    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.z));

    //Arruma o plano de Aproximacao
    WS.planoDeAproximacao.z -= Q/1000;

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(pontoDeAproximacao.x) +
                             "Z" +
                             calculus.arredondaDouble(WS.planoDeAproximacao.z));

    //Adiciona a linha do ciclo fixo
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G75X" +
                             calculus.arredondaDouble(X) + "Z" +
                             calculus.arredondaDouble(Z) + "P" +
                             calculus.arredondaDoubleMicro(P) + "Q" +
                             calculus.arredondaDoubleMicro(Q) + "R" +
                             calculus.arredondaDouble(R) + "F" +
                             calculus.arredondaDouble(F));

    return _codigoIntermediario;
  }

  //0403 1903 2003 3003 3103
  /**
   *
   * @param WS Workingstep
   * @return Vector
   *
   * Gera o corigo do ciclo fixo G76, funciona apenas para rosca em ODStraight
   */
  private Vector getCodigoG76(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();
    int m = 0; //numero de repeticoes do ultimo passe
    int r = 10; //comprimento da saida angular da rosca
    int s = 0; //(r / passo)*10
    int a = 0; //angulo da ferramenta
    String valorDeP = ""; //valor que sera colocado em P na primeira linha do ciclo fixo
    double minimaProfundidade = 0; //(micrometros)
    double profundidadeDoUltimoPasse = 0;
    double X = 0; //diametro final
    double W = 0; //incremento em Z para a posicao final
    double R = 0; //conicidade
    double P = 0; //altura do filete
    double Q = 0; //profundidade do primeiro passe
    double F = 0; //passo da rosca

    ODStraight roscaTmp = (ODStraight) WS.featureDoWorkingstep._featuresDaFU.
        elementAt(0);
    F = roscaTmp.rosca.threads_inch; //coloca o valor do passo

    _codigoIntermediario.add(getLinhaDoCodigoG() +
        "(Operacao - CICLO FIXO G76 ROSCAMENTO AUTOMATICO)");

    //Muda a velocidade de rotacao e o sentido de rotacao
    double velocidade = 5000 / F;
    String sentido = "";
    if(roscaTmp.rosca.roscaDireita) sentido = "M3";
    else sentido = "M4";

    _codigoIntermediario.add(getLinhaDoCodigoG() + "G97S" +
                             calculus.arredondaDouble(velocidade));
    _codigoIntermediario.add(getLinhaDoCodigoG() + sentido);

    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.z));

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "X" +
                             calculus.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             calculus.arredondaDouble(WS.planoDeAproximacao.z));

    //Obtencao dos valores
    m = 0;
    s = (int) ( (r / F) * 10);
    a = 60;

    valorDeP = String.valueOf(m) + String.valueOf(s) + String.valueOf(a);
    //nao testei se isto ai em cima funciona -> concatenar doubles

    minimaProfundidade = 100;
    profundidadeDoUltimoPasse = 0.1;

    P = 0.65 * F;
    X = (WS.planoDeAproximacao.x - 5) - (P * F); //supondo que o plano de aproximacao
    // esteja com 5mm a mais que o diametro onde a rosca se inicia
    W = -roscaTmp.rosca.comprimento;

    double numeroDePasses = 0;
    Q = 0.5; //supondo um valor maior que 0.4 somente para entrar no While
    while (Q > 0.4) {
      ++numeroDePasses;
      Q = P / Math.sqrt(numeroDePasses);
    }

    _codigoIntermediario.add(getLinhaDoCodigoG() + "G76P" +
                             /*calculus.arredondaDouble(*/valorDeP
                             /*)*/ + "Q" +
                             calculus.arredondaDouble(minimaProfundidade) + "R" +
                             calculus.arredondaDouble(profundidadeDoUltimoPasse));
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G76X" +
                             calculus.arredondaDouble(X) + "W" +
                             calculus.arredondaDouble(W) + "P" +
                             calculus.arredondaDoubleMicro(P) + "Q" +
                             calculus.arredondaDoubleMicro(Q) + "F" +
                             calculus.arredondaDouble(F));

    //se tiver invertido o giro do eixo => desinverte
    if(sentido == "M3"){
      _codigoIntermediario.add(getLinhaDoCodigoG() + "M4");
    }

    return _codigoIntermediario;
  }

  //0403 1903 2003 3003 3103

  /**
   * getCodigoG79
   *
   * @param WS workingstep
   * @return Vector
   */
  private Vector getCodigoG79(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();
    double X = 0.0;
    double Z = 0.0;
    double R = 0.0;
    double F = 0.0;

    FeatureDeUsinagem fuTmp = WS.featureDoWorkingstep;
    Vector _featuresDaFu = fuTmp._featuresDaFU;
    Feature fTmp = (Feature) _featuresDaFu.elementAt(0);

    R = fTmp.L1;
    X = fTmp.D1;
    OperacaoDeUsinagem OU = WS.operacaoDeUsinagem[0];
    TecnologiaDeUsinagem tecDeUsi = OU.tecnologiaDeUsinagem;
    F = tecDeUsi.F;
    /**
     * Nesta etapa pegamos o comprimento do blankUtilizado e chegamos ate a face
     * adicionando o valor da ltima feature q fecha a poliforma.
     * Adiciona-se essa pois ela e negativa (-L1)
     * @todo Conferir se as coordenadas do 1 ponto sao passadas corretamente
     */
    Feature fFinal = (Feature) _featuresDaFu.elementAt(2);
    Z = blankUtilizado.L1 + fFinal.L1;

    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             calculus.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             calculus.arredondaDouble( (blankUtilizado.L1 +
        WS.planoDeSeguranca.z)));
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G79X" +
                             calculus.arredondaDouble(X) + "Z" +
                             calculus.arredondaDouble(Z) + "R" +
                             calculus.arredondaDouble(R) + "F" +
                             calculus.arredondaDouble(F));
    return _codigoIntermediario;
  }

  /**
   *
   * @param v Vector
   * @param blocoCodigoG Vector
   * @return Vector atualiza o vetor codigoG, inserindo no final dele o vetor
   *   blocoCodigoG
   */
  private Vector insereNoVetor(Vector v, Vector blocoCodigoG) {
    int sizeBloco = blocoCodigoG.size();
    for (int i = 0; i < sizeBloco; i++) {
      v.add(blocoCodigoG.elementAt(i));
    }
    return v;
  }

  /**
   * getCodigoGTxT
   *
   * @param codigoG Vector
   * @return String
   */
  private String getCodigoGTxT(Vector codigoG) {
    int size = codigoG.size();
    String resposta = "";
    for (int i = 0; i < size; i++) {
      resposta += (codigoG.elementAt(i)) + "\n";
    }
    return resposta;
  }

  private Vector getPerfil(Workingstep WS) {
    Vector perfil = new Vector();
    Vector _featuresDaFUTmp;

    String funcaoAtual = "";
    String funcaoTmp = null;
    double xAtual = 0.0;
    double xTmp = 0.0;
    double wTmp = 0.0;
    double fAtual = 0.0;
    double fTmp = 0.0;
    double R = 0.0;
    int size;
    Feature tmp;

    if (WS.featureDoWorkingstep.tipo == FeatureDeUsinagem.BLOCO) { //crescente
      _featuresDaFUTmp = WS.featureDoWorkingstep._featuresDaFU;
      size = _featuresDaFUTmp.size();
      for (int i = 0; i < size; i++) {
        tmp = (Feature) _featuresDaFUTmp.elementAt(i);
        String blocoTmp = getLinhaDoCodigoG();

        switch (tmp.Tipo) {
          case 0:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + calculus.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + calculus.arredondaDouble(wTmp));
            break;
          case Feature.FACESTRAIGHT:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + calculus.arredondaDouble(xAtual));
            }
            break;
          case Feature.FACETAPERED:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + calculus.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + wTmp);
            break;
          case Feature.ODSTRAIGHT:
            funcaoTmp = "G1";
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (wTmp != 0) blocoTmp += ("W" + calculus.arredondaDouble(wTmp));
            break;
          case Feature.ODTAPERED:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + calculus.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + calculus.arredondaDouble(wTmp));
            break;
          case Feature.ODCONCAVE:
            ODConcave odConcaveTmp = (ODConcave) tmp;
            xTmp = odConcaveTmp.D2;
            wTmp = -odConcaveTmp.L1;
            R = odConcaveTmp.R;

            if (isHorario(odConcaveTmp)) funcaoTmp = "G2";
            else funcaoTmp = "G3";

            if (funcaoAtual != funcaoTmp) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            xAtual = xTmp;
            blocoTmp += "X" + calculus.arredondaDouble(xTmp) + "W" +
                calculus.arredondaDouble(wTmp) + "R" +
                calculus.arredondaDouble(R);
            break;
          case Feature.ODCONVEX:
            ODConvex odConvexTmp = (ODConvex) tmp;
            xTmp = odConvexTmp.D2;
            wTmp = -odConvexTmp.L1;
            R = odConvexTmp.R;

            if (isHorario(odConvexTmp)) funcaoTmp = "G2";
            else funcaoTmp = "G3";

            if (funcaoAtual != funcaoTmp) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            xAtual = xTmp;
            blocoTmp += "X" + calculus.arredondaDouble(xTmp) + "W" +
                calculus.arredondaDouble(wTmp) + "R" +
                calculus.arredondaDouble(R);
            break;
        }
        perfil.add(blocoTmp);

      }
    }
    else if (WS.featureDoWorkingstep.tipo == FeatureDeUsinagem.GROOVE_COMPLEXO) { //decrescente
      _featuresDaFUTmp = ( (GrooveComplexo) WS.featureDoWorkingstep.
                          _featuresDaFU.elementAt(0)).features;
      size = _featuresDaFUTmp.size();
      for (int i = 0; i < size; i++) {
        String blocoTmp = getLinhaDoCodigoG();
        tmp = (Feature) _featuresDaFUTmp.elementAt(i);
        switch (tmp.Tipo) {
          case 0:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + calculus.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + calculus.arredondaDouble(wTmp));
            break;
          case Feature.FACESTRAIGHT:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + calculus.arredondaDouble(xAtual));
            }
            break;
          case Feature.FACETAPERED:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + calculus.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + calculus.arredondaDouble(wTmp));
            break;
          case Feature.ODSTRAIGHT:
            funcaoTmp = "G1";
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (wTmp != 0) blocoTmp += ("W" + calculus.arredondaDouble(wTmp));
            break;
          case Feature.ODTAPERED:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + calculus.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + calculus.arredondaDouble(wTmp));
            break;
          case Feature.ODCONCAVE:
            ODConcave odConcaveTmp = (ODConcave) tmp;
            xTmp = odConcaveTmp.D2;
            wTmp = odConcaveTmp.L1;
            R = odConcaveTmp.R;

            if (isHorario(odConcaveTmp)) funcaoTmp = "G2";
            else funcaoTmp = "G3";

            if (funcaoAtual != funcaoTmp) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            xAtual = xTmp;
            blocoTmp += "X" + calculus.arredondaDouble(xTmp) + "W" +
                calculus.arredondaDouble(wTmp) + "R" +
                calculus.arredondaDouble(R);
            break;
          case Feature.ODCONVEX:
            ODConvex odConvexTmp = (ODConvex) tmp;
            xTmp = odConvexTmp.D2;
            wTmp = odConvexTmp.L1;
            R = odConvexTmp.R;

            if (isHorario(odConvexTmp)) funcaoTmp = "G2";
            else funcaoTmp = "G3";

            if (funcaoAtual != funcaoTmp) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            xAtual = xTmp;
            blocoTmp += "X" + calculus.arredondaDouble(xTmp) + "W" +
                calculus.arredondaDouble(wTmp) + "R" +
                calculus.arredondaDouble(R);
            break;
        }
        perfil.add(blocoTmp);

      }
    }

    return perfil;
  }

  private Vector getPerfilSpline(Workingstep WS) {
    Vector perfil = new Vector();

    return perfil;
  }

  private boolean isHorario(Feature f) {
    int tipo = f.Tipo;
    if (tipo == Feature.ODCONCAVE) {
      if (f.D2 > f.D1)return true;
      else return false;
    }
    if (tipo == Feature.ODCONVEX) {
      if (f.D2 > f.D1)return false;
      else return true;
    }
    else return false; //so para nao dar erro de compilacao
  }
}
