package features;
import java.util.*;
/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra e Jones Yudi
 * @version 1.0
 */

public class  Feature
    implements java.io.Serializable , Comparable, Cloneable{
  public int Tipo;
  public static final int ODSTRAIGHT = 1;
  public static final int ODTAPERED = 2;
  public static final int ODCONCAVE = 3;
  public static final int ODCONVEX = 4;
  public static final int ODCONTOURED = 5;
  public static final int FACESTRAIGHT = 6;
  public static final int FACETAPERED = 7;
  public static final int FACECONCAVE = 8;
  public static final int FACECONVEX = 9;
  public static final int FACECONTOURED = 10;
  public static final int IDSTRAIGHT = 11;
  public static final int IDTAPERED = 12;
  public static final int IDCONCAVE = 13;
  public static final int IDCONVEX = 14;
  public static final int IDCONTOURED = 15;
  public static final int GROOVESQUARE = 16;
  public static final int GROOVETAPER = 17;
  public static final int GROOVERELIEF = 18;
  public static final int GROOVERADIAL = 19;
  public static final int GROOVEHELICAL = 20;
  public static final int GROOVE_I_SQUARE = 21;
  public static final int GROOVE_I_TAPER = 22;
  public static final int GROOVE_I_RELIEF = 23;
  public static final int GROOVE_I_RADIAL = 24;
  public static final int GROOVE_I_HELICAL = 25;
  public static final int FUROPADRAO = 26;
  public static final int FUROBELL = 27;
  public static final int GROOVE_FACE_SQUARE = 28;
  public static final int GROOVE_FACE_TAPER = 29;
  public static final int GROOVE_FACE_RADIAL = 30;
  public static final int GROOVE_COMPLEXO = 31;
  public static final int ODSPLINE_VIRTUAL = 32;
  public static final int IDSPLINE_VIRTUAL = 33;

  public long ID;        // Auto Num DB
  public long PecaID;
  public long ProjetoID; // Auto Num recebido do DB caracterizando o projeto
  public int Ordem;      // Auto Num no Applet, indicando qual  a posio da feature em ordem de criao
  public String Nome;    // Gerado automaticamente pelo Applet ou Servlet para facilitar a leitura humana

//Tolerncias e restries
  public long KnurlStraightID;
  public long KnurlDiamondID;
  public long RugosidadeID;
  public long CircularidadeID;
  public long ConcentricidadeID;
  public long CilindricidadeID;
  public long BatimentoCircularID;
  public long BatimentoPlanoID;
  public long BatimentoGlobalID;
  public long TDimensionalID;
  public long ThreadsID;

  public double L1;
  public double D1;
  public double D2;
  public double L1Mais,L1Menos;
  public double D1Mais,D1Menos;
  public double D2Mais,D2Menos;

  public boolean temTolerancia;

//Surface Straightness, Axis Straightness, Flatness, Circularity, Cylindricity, Line Profile, Surface Profile, Position,
//Concentricity, Angularity, Perpendicularity, Circular Runout, Total Runout
  public Vector circularidades; // o JONES VAI TIRAR ISSO DEPOIS
  public ToleranciaCilindricidade toleranciaCilindricidade;//j implementada
  public ToleranciaCircularidade toleranciaCircularidade;//j implementada
  public ToleranciaRetilineidadeSuperficie toleranciaRetilineidadeSuperficie;
  public ToleranciaRetilineidadeEixo toleranciaRetilineidadeEixo;//j implementada
  public ToleranciaPlanicidade toleranciaPlanicidade;//j implementada
  public ToleranciaFormaContorno toleranciaFormaContorno;//j implementada
  public ToleranciaFormaSuperficie toleranciaFormaSuperficie;//j implementada
  public ToleranciaPosicao toleranciaPosicao;
  public ToleranciaConcentricidade toleranciaConcentricidade;
  public ToleranciaInclinacao toleranciaInclinacao;
  public ToleranciaParalelismo toleranciaParalelismo;
  public ToleranciaPerpendicularidade toleranciaPerpendicularidade;
  public ToleranciaDesvioCircular toleranciaDesvioCircular;
  public ToleranciaDesvioTotal toleranciaDesvioTotal;

  public double Rugosidade;

  public boolean temCilindricidade = false;
  public boolean temCircularidade = false;
  public boolean temForma_Superficie = false;
  public boolean temConcentricidade = false;
  public boolean temBatimento_Axial = false;
  public boolean temBatimento_Radial = false;
  public boolean temInclinacao = false;
  public boolean temParalelismo = false;
  public boolean temPerpendicularidade = false;
  public boolean temRugosidade = false;

  public String referencia;



  public Feature() {
  }

  public final int compareTo(Object outra) {
  final int BEFORE = -1;
  final int EQUAL = 0;
  final int AFTER = 1;
  final Feature that = (Feature) outra;

  if (this.Ordem == that.Ordem) {
    return EQUAL;
  }
  if (this.Ordem < that.Ordem) {
    return BEFORE;
  }
  return AFTER;
}

  public void setBatimentoCircularID(long BatimentoCircularID) {
    this.BatimentoCircularID = BatimentoCircularID;
  }
  public long getConcentricidadeID() {
    return ConcentricidadeID;
  }
  public double getD1() {
    return D1;
  }
  public double getD2() {
    return D2;
  }
  public long getID() {
    return ID;
  }
  public long getKnurlDiamondID() {
    return KnurlDiamondID;
  }
  public long getKnurlStraightID() {
    return KnurlStraightID;
  }
  public double getL1() {
    return L1;
  }
  public String getNome() {
    return Nome;
  }
  public int getOrdem() {
    return Ordem;
  }
  public long getPecaID() {
    return PecaID;
  }
  public long getProjetoID() {
    return ProjetoID;
  }
  public long getRugosidadeID() {
    return RugosidadeID;
  }
  public long getTDimensionalID() {
    return TDimensionalID;
  }
  public long getThreadsID() {
    return ThreadsID;
  }
  public int getTipo() {
    return Tipo;
  }
  public void setTipo(int Tipo) {
    this.Tipo = Tipo;
  }
  public void setThreadsID(long ThreadsID) {
    this.ThreadsID = ThreadsID;
  }
  public void setTDimensionalID(long TDimensionalID) {
    this.TDimensionalID = TDimensionalID;
  }
  public void setRugosidadeID(long RugosidadeID) {
    this.RugosidadeID = RugosidadeID;
  }
  public void setProjetoID(long ProjetoID) {
    this.ProjetoID = ProjetoID;
  }
  public void setPecaID(long PecaID) {
    this.PecaID = PecaID;
  }
  public void setOrdem(int Ordem) {
    this.Ordem = Ordem;
  }
  public void setNome(String Nome) {
    this.Nome = Nome;
  }
  public void setL1(double L1) {
    this.L1 = L1;
  }
  public void setKnurlStraightID(long KnurlStraightID) {
    this.KnurlStraightID = KnurlStraightID;
  }
  public void setKnurlDiamondID(long KnurlDiamondID) {
    this.KnurlDiamondID = KnurlDiamondID;
  }
  public void setID(long ID) {
    this.ID = ID;
  }
  public void setD2(double D2) {
    this.D2 = D2;
  }
  public void setD1(double D1) {
    this.D1 = D1;
  }
  public void setConcentricidadeID(long ConcentricidadeID) {
    this.ConcentricidadeID = ConcentricidadeID;
  }
  public void setCircularidadeID(long CircularidadeID) {
    this.CircularidadeID = CircularidadeID;
  }
  public void setCilindricidadeID(long CilindricidadeID) {
    this.CilindricidadeID = CilindricidadeID;
  }
  public void setBatimentoPlanoID(long BatimentoPlanoID) {
    this.BatimentoPlanoID = BatimentoPlanoID;
  }
  public void setBatimentoGlobalID(long BatimentoGlobalID) {
    this.BatimentoGlobalID = BatimentoGlobalID;
  }
  public long getCircularidadeID() {
    return CircularidadeID;
  }
  public long getCilindricidadeID() {
    return CilindricidadeID;
  }
  public long getBatimentoPlanoID() {
    return BatimentoPlanoID;
  }
  public long getBatimentoGlobalID() {
    return BatimentoGlobalID;
  }
  public long getBatimentoCircularID() {
    return BatimentoCircularID;
  }

  public Object copy(){
    Feature copy = new Feature();

    copy.BatimentoCircularID = this.BatimentoCircularID;
    copy.BatimentoGlobalID = this.BatimentoGlobalID;
    copy.BatimentoPlanoID = this.BatimentoPlanoID;
    copy.CilindricidadeID = this.CilindricidadeID;
    copy.CircularidadeID = this.CircularidadeID;
    copy.ConcentricidadeID = this.ConcentricidadeID;
    copy.D1 = this.D1;
    copy.D1Mais = this.D1Mais;
    copy.D1Menos = this.D1Menos;
    copy.D2 = this.D2;
    copy.D2Mais = this.D2Mais;
    copy.KnurlDiamondID = this.KnurlDiamondID;
    copy.KnurlStraightID = this.KnurlStraightID;
    copy.L1 = this.L1;
    copy.L1Mais = this.L1Mais;
    copy.L1Menos = this.L1Menos;
    copy.Nome = this.Nome;
    copy.Ordem = this.Ordem;
    copy.PecaID = this.PecaID;
    copy.ProjetoID = this.ProjetoID;
    copy.referencia = this.referencia;
    copy.Rugosidade = this.Rugosidade;
    copy.RugosidadeID = this.RugosidadeID;
    copy.TDimensionalID = this.TDimensionalID;
    copy.temBatimento_Axial = this.temBatimento_Axial;
    copy.temBatimento_Radial = this.temBatimento_Radial;
    copy.temCilindricidade = this.temCilindricidade;
    copy.temCircularidade = this.temCircularidade;
    copy.temConcentricidade = this.temConcentricidade;
    copy.temForma_Superficie = this.temForma_Superficie;
    copy.temInclinacao = this.temInclinacao;
    copy.temParalelismo = this.temParalelismo;
    copy.temPerpendicularidade = this.temPerpendicularidade;
    copy.temRugosidade = this.temRugosidade;
    copy.temTolerancia = this.temTolerancia;
    copy.ThreadsID = this.ThreadsID;
    copy.Tipo = this.Tipo;


    if(this.toleranciaCilindricidade != null)
      copy.toleranciaCilindricidade = this.toleranciaCilindricidade.copy();
    if(this.toleranciaCircularidade != null)
      copy.toleranciaCircularidade = this.toleranciaCircularidade.copy();
    if(this.toleranciaConcentricidade != null)
      copy.toleranciaConcentricidade = this.toleranciaConcentricidade.copy();
    if(this.toleranciaDesvioCircular != null)
      copy.toleranciaDesvioCircular = this.toleranciaDesvioCircular.copy();
    if(this.toleranciaDesvioTotal != null)
      copy.toleranciaDesvioTotal = this.toleranciaDesvioTotal.copy();
    if(this.toleranciaFormaContorno != null)
      copy.toleranciaFormaContorno = this.toleranciaFormaContorno.copy();
    if(this.toleranciaFormaSuperficie != null)
      copy.toleranciaFormaSuperficie = this.toleranciaFormaSuperficie.copy();
    if(this.toleranciaInclinacao != null)
      copy.toleranciaInclinacao = this.toleranciaInclinacao.copy();
    if(this.toleranciaParalelismo != null)
      copy.toleranciaParalelismo = this.toleranciaParalelismo.copy();
    if(this.toleranciaPerpendicularidade != null)
      copy.toleranciaPerpendicularidade = this.toleranciaPerpendicularidade.copy();
    if(this.toleranciaPlanicidade != null)
      copy.toleranciaPlanicidade = this.toleranciaPlanicidade.copy();
    if(this.toleranciaPosicao != null)
      copy.toleranciaPosicao = this.toleranciaPosicao.copy();
    if(this.toleranciaRetilineidadeEixo != null)
      copy.toleranciaRetilineidadeEixo = this.toleranciaRetilineidadeEixo.copy();
    if(this.toleranciaRetilineidadeSuperficie != null)
      copy.toleranciaRetilineidadeSuperficie = this.toleranciaRetilineidadeSuperficie.copy();


    /**
     * essa parte pode dar problema, pois a copia vai fazer referencia ao original,
     * ela nao sera uma "copia"
     */
    if(this.circularidades != null)
      copy.circularidades = (Vector)this.circularidades.clone();

    return copy;
  }

}
