package features;

import java.util.Vector;

/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Correa & Roman Lorenzo & Jones Yudi
 * @version 1.0
 */

public class GrooveComplexo
    extends Feature
    implements java.io.Serializable {
  public Vector features = new Vector();

  public static boolean Externa = false;
  public static boolean TemRosca = false;
  public static boolean TemRecartilhado = false;

  public GrooveComplexo() {
    this.Tipo = Feature.GROOVE_COMPLEXO;
  }

  public GrooveComplexo(Feature tmp) {
    this.BatimentoCircularID = tmp.BatimentoCircularID;
    this.BatimentoGlobalID = tmp.BatimentoGlobalID;
    this.BatimentoPlanoID = tmp.BatimentoPlanoID;
    this.CilindricidadeID = tmp.CilindricidadeID;
    this.CircularidadeID = tmp.CircularidadeID;
    this.ConcentricidadeID = tmp.ConcentricidadeID;
    this.D1 = tmp.D1;
    this.D1Mais = tmp.D1Mais;
    this.D1Menos = tmp.D1Menos;
    this.D2 = tmp.D2;
    this.D2Mais = tmp.D2Mais;
    this.KnurlDiamondID = tmp.KnurlDiamondID;
    this.KnurlStraightID = tmp.KnurlStraightID;
    this.L1 = tmp.L1;
    this.L1Mais = tmp.L1Mais;
    this.L1Menos = tmp.L1Menos;
    this.Nome = tmp.Nome;
    this.Ordem = tmp.Ordem;
    this.PecaID = tmp.PecaID;
    this.ProjetoID = tmp.ProjetoID;
    this.referencia = tmp.referencia;
    this.Rugosidade = tmp.Rugosidade;
    this.RugosidadeID = tmp.RugosidadeID;
    this.TDimensionalID = tmp.TDimensionalID;
    this.temBatimento_Axial = tmp.temBatimento_Axial;
    this.temBatimento_Radial = tmp.temBatimento_Radial;
    this.temCilindricidade = tmp.temCilindricidade;
    this.temCircularidade = tmp.temCircularidade;
    this.temConcentricidade = tmp.temConcentricidade;
    this.temForma_Superficie = tmp.temForma_Superficie;
    this.temInclinacao = tmp.temInclinacao;
    this.temParalelismo = tmp.temParalelismo;
    this.temPerpendicularidade = tmp.temPerpendicularidade;
    this.temRugosidade = tmp.temRugosidade;
    this.temTolerancia = tmp.temTolerancia;
    this.ThreadsID = tmp.ThreadsID;
    this.Tipo = tmp.Tipo;


    this.toleranciaCilindricidade = tmp.toleranciaCilindricidade;
    this.toleranciaCircularidade = tmp.toleranciaCircularidade;
    this.toleranciaConcentricidade = tmp.toleranciaConcentricidade;
    this.toleranciaDesvioCircular = tmp.toleranciaDesvioCircular;
    this.toleranciaDesvioTotal = tmp.toleranciaDesvioTotal;
    this.toleranciaFormaContorno = tmp.toleranciaFormaContorno;
    this.toleranciaFormaSuperficie = tmp.toleranciaFormaSuperficie;
    this.toleranciaInclinacao = tmp.toleranciaInclinacao;
    this.toleranciaParalelismo = tmp.toleranciaParalelismo;
    this.toleranciaPerpendicularidade = tmp.toleranciaPerpendicularidade;
    this.toleranciaPlanicidade = tmp.toleranciaPlanicidade;
    this.toleranciaPosicao = tmp.toleranciaPosicao;
    this.toleranciaRetilineidadeEixo = tmp.toleranciaRetilineidadeEixo;
    this.toleranciaRetilineidadeSuperficie = tmp.
        toleranciaRetilineidadeSuperficie;
  }


  public void setLargura(double L1) {
    this.L1 = L1;
  }

  public void setFeatures(Vector features) {
    this.features = features;
  }

  public Vector getFeatures() {
    return this.features;
  }

  public Object copy() {
    GrooveComplexo copy = new GrooveComplexo((Feature)super.copy());

    int size = this.features.size();
    if (size > 0) {
      for (int i = 0; i < size; i++) {
        Feature tmp = (Feature) features.elementAt(i);
        switch (tmp.Tipo) {
          case 0:
            copy.features.add(tmp.copy());
            break;
          case Feature.FACECONCAVE:
            copy.features.add( ( (FaceConcave) tmp).copy());
            break;
          case Feature.FACECONTOURED:
            copy.features.add( ( (FaceContoured) tmp).copy());
            break;
          case Feature.FACECONVEX:
            copy.features.add( ( (FaceConvex) tmp).copy());
            break;
          case Feature.FACESTRAIGHT:
            copy.features.add( ( (FaceStraight) tmp).copy());
            break;
          case Feature.FACETAPERED:
            copy.features.add( ( (FaceTapered) tmp).copy());
            break;
          case Feature.FUROBELL:
            copy.features.add( ( (FuroBell) tmp).copy());
            break;
          case Feature.FUROPADRAO:
            copy.features.add( ( (FuroPadrao) tmp).copy());
            break;
          case Feature.GROOVE_COMPLEXO:
            copy.features.add( ( (GrooveComplexo) tmp).copy());
            break;
          case Feature.GROOVE_FACE_RADIAL:
            copy.features.add( ( (Groove_Face_Radial) tmp).copy());
            break;
          case Feature.GROOVE_FACE_SQUARE:
            copy.features.add( ( (Groove_Face_Square) tmp).copy());
            break;
          case Feature.GROOVE_FACE_TAPER:
            copy.features.add( ( (Groove_Face_Taper) tmp).copy());
            break;
          case Feature.GROOVE_I_HELICAL:
            copy.features.add( ( (Groove_I_Helical) tmp).copy());
            break;
          case Feature.GROOVE_I_RADIAL:
            copy.features.add( ( (Groove_I_Radial) tmp).copy());
            break;
          case Feature.GROOVE_I_RELIEF:
            copy.features.add( ( (Groove_I_Relief) tmp).copy());
            break;
          case Feature.GROOVE_I_SQUARE:
            copy.features.add( ( (Groove_Face_Radial) tmp).copy());
            break;
          case Feature.GROOVE_I_TAPER:
            copy.features.add( ( (Groove_I_Taper) tmp).copy());
            break;
          case Feature.GROOVEHELICAL:
            copy.features.add( ( (GrooveHelical) tmp).copy());
            break;
          case Feature.GROOVERADIAL:
            copy.features.add( ( (GrooveRadial) tmp).copy());
            break;
          case Feature.GROOVERELIEF:
            copy.features.add( ( (GrooveRelief) tmp).copy());
            break;
          case Feature.GROOVESQUARE:
            copy.features.add( ( (GrooveSquare) tmp).copy());
            break;
          case Feature.GROOVETAPER:
            copy.features.add( ( (GrooveTaper) tmp).copy());
            break;
          case Feature.IDCONCAVE:
            copy.features.add( ( (IDConcave) tmp).copy());
            break;
          case Feature.IDCONTOURED:
            copy.features.add( ( (IDContoured) tmp).copy());
            break;
          case Feature.IDCONVEX:
            copy.features.add( ( (IDConvex) tmp).copy());
            break;
          case Feature.IDSTRAIGHT:
            copy.features.add( ( (IDStraight) tmp).copy());
            break;
          case Feature.IDTAPERED:
            copy.features.add( ( (IDTapered) tmp).copy());
            break;
          case Feature.ODCONCAVE:
            copy.features.add( ( (ODConcave) tmp).copy());
            break;
          case Feature.ODCONTOURED:
            copy.features.add( ( (ODContoured) tmp).copy());
            break;
          case Feature.ODCONVEX:
            copy.features.add( ( (ODConvex) tmp).copy());
            break;
          case Feature.ODSTRAIGHT:
            copy.features.add( ( (ODStraight) tmp).copy());
            break;
          case Feature.ODTAPERED:
            copy.features.add( ( (ODTapered) tmp).copy());
            break;
          default:
            System.out.println("GrooveComplexo.copy nao reconece a feature " + tmp.Tipo);
            break;
        }
      }
    }

    return copy;
  }

}
