package features;

import java.util.Vector;

/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra
 * @version 1.0
 */

public class ODStraight extends Feature implements java.io.Serializable {
  public static boolean Externa = true;
  public double Rugosidade;
  public boolean TemRosca = false;
  public boolean TemRecartilhado = false;
  public boolean TemCircularidade = false;
  public boolean TemCilindricidade = false;
  public boolean TemRetilineidade = false;
  public boolean TemConcentricidade = false;
  public boolean BatPlano = false;
  public boolean BatCircular = false;
  public boolean BatGlobal = false;
  public Rosca rosca;
  public Recartilhado recartilhado;

  public ODStraight() {
  }
  public boolean isBatCircular() {
    return BatCircular;
  }
  public void setBatCircular(boolean BatCircular) {
    this.BatCircular = BatCircular;
  }
  public void setBatGlobal(boolean BatGlobal) {
    this.BatGlobal = BatGlobal;
  }
  public boolean isBatGlobal() {
    return BatGlobal;
  }
  public boolean isBatPlano() {
    return BatPlano;
  }
  public void setBatPlano(boolean BatPlano) {
    this.BatPlano = BatPlano;
  }
  public boolean isExterna() {
    return Externa;
  }
  public Recartilhado getRecartilhado() {
    return recartilhado;
  }
  public Rosca getRosca() {
    return rosca;
  }
  public double getRugosidade() {
    return Rugosidade;
  }
  public boolean isTemCilindricidade() {
    return TemCilindricidade;
  }
  public boolean isTemCircularidade() {
    return TemCircularidade;
  }
  public boolean isTemConcentricidade() {
    return TemConcentricidade;
  }
  public boolean isTemRecartilhado() {
    return TemRecartilhado;
  }
  public boolean isTemRetilineidade() {
    return TemRetilineidade;
  }
  public boolean isTemRosca() {
    return TemRosca;
  }
  public void setTemRosca(boolean TemRosca) {
    this.TemRosca = TemRosca;
  }
  public void setTemRetilineidade(boolean TemRetilineidade) {
    this.TemRetilineidade = TemRetilineidade;
  }
  public void setTemRecartilhado(boolean TemRecartilhado) {
    this.TemRecartilhado = TemRecartilhado;
  }
  public void setTemConcentricidade(boolean TemConcentricidade) {
    this.TemConcentricidade = TemConcentricidade;
  }
  public void setTemCircularidade(boolean TemCircularidade) {
    this.TemCircularidade = TemCircularidade;
  }
  public void setTemCilindricidade(boolean TemCilindricidade) {
    this.TemCilindricidade = TemCilindricidade;
  }
  public void setRugosidade(double Rugosidade) {
    this.Rugosidade = Rugosidade;
  }
  public void setRosca(Rosca rosca) {
    this.rosca = rosca;
  }
  public void setRecartilhado(Recartilhado recartilhado) {
    this.recartilhado = recartilhado;
  }
  public void setExterna(boolean Externa) {
    this.Externa = Externa;
  }

  public ODStraight(Feature tmp) {
    this.BatimentoCircularID = tmp.BatimentoCircularID;
    this.BatimentoGlobalID = tmp.BatimentoGlobalID;
    this.BatimentoPlanoID = tmp.BatimentoPlanoID;
    this.CilindricidadeID = tmp.CilindricidadeID;
    this.CircularidadeID = tmp.CircularidadeID;
    this.ConcentricidadeID = tmp.ConcentricidadeID;
    this.D1 = tmp.D1;
    this.D1Mais = tmp.D1Mais;
    this.D1Menos = tmp.D1Menos;
    this.D2 = tmp.D2;
    this.D2Mais = tmp.D2Mais;
    this.KnurlDiamondID = tmp.KnurlDiamondID;
    this.KnurlStraightID = tmp.KnurlStraightID;
    this.L1 = tmp.L1;
    this.L1Mais = tmp.L1Mais;
    this.L1Menos = tmp.L1Menos;
    this.Nome = tmp.Nome;
    this.Ordem = tmp.Ordem;
    this.PecaID = tmp.PecaID;
    this.ProjetoID = tmp.ProjetoID;
    this.referencia = tmp.referencia;
    this.Rugosidade = tmp.Rugosidade;
    this.RugosidadeID = tmp.RugosidadeID;
    this.TDimensionalID = tmp.TDimensionalID;
    this.temBatimento_Axial = tmp.temBatimento_Axial;
    this.temBatimento_Radial = tmp.temBatimento_Radial;
    this.temCilindricidade = tmp.temCilindricidade;
    this.temCircularidade = tmp.temCircularidade;
    this.temConcentricidade = tmp.temConcentricidade;
    this.temForma_Superficie = tmp.temForma_Superficie;
    this.temInclinacao = tmp.temInclinacao;
    this.temParalelismo = tmp.temParalelismo;
    this.temPerpendicularidade = tmp.temPerpendicularidade;
    this.temRugosidade = tmp.temRugosidade;
    this.temTolerancia = tmp.temTolerancia;
    this.ThreadsID = tmp.ThreadsID;
    this.Tipo = tmp.Tipo;


    this.toleranciaCilindricidade = tmp.toleranciaCilindricidade;
    this.toleranciaCircularidade = tmp.toleranciaCircularidade;
    this.toleranciaConcentricidade = tmp.toleranciaConcentricidade;
    this.toleranciaDesvioCircular = tmp.toleranciaDesvioCircular;
    this.toleranciaDesvioTotal = tmp.toleranciaDesvioTotal;
    this.toleranciaFormaContorno = tmp.toleranciaFormaContorno;
    this.toleranciaFormaSuperficie = tmp.toleranciaFormaSuperficie;
    this.toleranciaInclinacao = tmp.toleranciaInclinacao;
    this.toleranciaParalelismo = tmp.toleranciaParalelismo;
    this.toleranciaPerpendicularidade = tmp.toleranciaPerpendicularidade;
    this.toleranciaPlanicidade = tmp.toleranciaPlanicidade;
    this.toleranciaPosicao = tmp.toleranciaPosicao;
    this.toleranciaRetilineidadeEixo = tmp.toleranciaRetilineidadeEixo;
    this.toleranciaRetilineidadeSuperficie = tmp.
        toleranciaRetilineidadeSuperficie;

  }

  public Object copy() {
    ODStraight copy = new ODStraight((Feature)super.copy());

    copy.BatCircular = this.BatCircular;
    copy.BatGlobal = this.BatCircular;
    copy.BatPlano = this.BatPlano;
    copy.Externa = this.Externa;
    copy.TemCilindricidade = this.TemCilindricidade;
    copy.TemCircularidade = this.TemCircularidade;
    copy.TemConcentricidade = this.TemConcentricidade;
    copy.TemRetilineidade = this.TemRetilineidade;
    copy.TemRecartilhado = this.TemRecartilhado;
    copy.TemRosca = this.TemRosca;

    if (this.TemRecartilhado)
      copy.recartilhado = this.recartilhado.copy();
    if (this.TemRosca)
      copy.rosca = this.rosca.copy();


    return copy;
  }


}
