package util;

import java.util.Vector;
import features.*;
import featureseixoc.*;

public class CopiadorDeFeatures {
  public CopiadorDeFeatures() {
  }

  /**
   * Cria um clone do vetor de entrada
   *
   * @param _feature Vector
   * @return Vector
   */
  public static Vector getFeaturesCopiado(Vector _feature) {
    int size = _feature.size();
    Vector copy = null;

    if (size > 0) {
      copy = new Vector(size);
      for (int i = 0; i < size; i++) {
        Feature tmp = (Feature) _feature.elementAt(i);
        switch (tmp.Tipo) {
          case 0:
            copy.add( tmp.copy());
            break;
          case Feature.FACECONCAVE:
            copy.add( ( (FaceConcave) tmp).copy());
            break;
          case Feature.FACECONTOURED:
            copy.add( ( (FaceContoured) tmp).copy());
            break;
          case Feature.FACECONVEX:
            copy.add( ( (FaceConvex) tmp).copy());
            break;
          case Feature.FACESTRAIGHT:
            copy.add( ( (FaceStraight) tmp).copy());
            break;
          case Feature.FACETAPERED:
            copy.add( ( (FaceTapered) tmp).copy());
            break;
          case Feature.FUROBELL:
            copy.add( ( (FuroBell) tmp).copy());
            break;
          case Feature.FUROPADRAO:
            copy.add( ( (FuroPadrao) tmp).copy());
            break;
          case Feature.GROOVE_COMPLEXO:
            copy.add( ( (GrooveComplexo) tmp).copy());
            break;
          case Feature.GROOVE_FACE_RADIAL:
            copy.add( ( (Groove_Face_Radial) tmp).copy());
            break;
          case Feature.GROOVE_FACE_SQUARE:
            copy.add( ( (Groove_Face_Square) tmp).copy());
            break;
          case Feature.GROOVE_FACE_TAPER:
            copy.add( ( (Groove_Face_Taper) tmp).copy());
            break;
          case Feature.GROOVE_I_HELICAL:
            copy.add( ( (Groove_I_Helical) tmp).copy());
            break;
          case Feature.GROOVE_I_RADIAL:
            copy.add( ( (Groove_I_Radial) tmp).copy());
            break;
          case Feature.GROOVE_I_RELIEF:
            copy.add( ( (Groove_I_Relief) tmp).copy());
            break;
          case Feature.GROOVE_I_SQUARE:
            copy.add( ( (Groove_Face_Radial) tmp).copy());
            break;
          case Feature.GROOVE_I_TAPER:
            copy.add( ( (Groove_I_Taper) tmp).copy());
            break;
          case Feature.GROOVEHELICAL:
            copy.add( ( (GrooveHelical) tmp).copy());
            break;
          case Feature.GROOVERADIAL:
            copy.add( ( (GrooveRadial) tmp).copy());
            break;
          case Feature.GROOVERELIEF:
            copy.add( ( (GrooveRelief) tmp).copy());
            break;
          case Feature.GROOVESQUARE:
            copy.add( ( (GrooveSquare) tmp).copy());
            break;
          case Feature.GROOVETAPER:
            copy.add( ( (GrooveTaper) tmp).copy());
            break;
          case Feature.IDCONCAVE:
            copy.add( ( (IDConcave) tmp).copy());
            break;
          case Feature.IDCONTOURED:
            copy.add( ( (IDContoured) tmp).copy());
            break;
          case Feature.IDCONVEX:
            copy.add( ( (IDConvex) tmp).copy());
            break;
          case Feature.IDSTRAIGHT:
            copy.add( ( (IDStraight) tmp).copy());
            break;
          case Feature.IDTAPERED:
            copy.add( ( (IDTapered) tmp).copy());
            break;
          case Feature.ODCONCAVE:
            copy.add( ( (ODConcave) tmp).copy());
            break;
          case Feature.ODCONTOURED:
            copy.add( ( (ODContoured) tmp).copy());
            break;
          case Feature.ODCONVEX:
            copy.add( ( (ODConvex) tmp).copy());
            break;
          case Feature.ODSTRAIGHT:
            copy.add( ( (ODStraight) tmp).copy());
            break;
          case Feature.ODTAPERED:
            copy.add( ( (ODTapered) tmp).copy());
            break;
          case Feature.ODSPLINE_VIRTUAL:
            copy.add( ( (ODSplineVirtual) tmp).copy());
            break;
          case Feature.IDSPLINE_VIRTUAL:
            copy.add( ( (IDSplineVirtual) tmp).copy());
            break;
          default:
            MyMath.alert("CopiadorDeFeatures: Nao foi encontrada a feature\ndo tipo" + tmp.Tipo);
            break;
        }
      }
    }

    return copy;
  }


  public static Vector getFeaturesEixoCCopiado(Vector _featureEixoC){
    int size = _featureEixoC.size();
    Vector copy = null;

    if (size > 0) {
      copy = new Vector(size);
      for (int i = 0; i < size; i++) {
        featureEixoC tmp = (featureEixoC) _featureEixoC.elementAt(i);
        copy.add(tmp);
      }
    }

    return copy;
  }
}
