package util;

import java.util.Vector;
import features.*;
import pontos.Ponto2D;

public class InversorDeFeatures {
  public InversorDeFeatures() {
  }

  /**
   * Primeiro copiar o vetor _feature e depois inverte todas as suas features
   *
   * @param _feature Vector
   * @return Vector
   *
   */
  public static Vector getFeaturesInvertido(Vector _feature) {
    Vector _featureCopiado = CopiadorDeFeatures.getFeaturesCopiado(_feature);

    int size = _featureCopiado.size();
    Vector _featureInvertidoTmp = new Vector(size);
    for (int i = size - 1; i >= 0; i--) {
      _featureInvertidoTmp.add(_featureCopiado.elementAt(i));
    }

    double numTmp;
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) _featureInvertidoTmp.elementAt(i);
      switch (tmp.Tipo) {
        case 0:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        case Feature.FACECONCAVE:
          break;
        case Feature.FACECONTOURED:
          break;
        case Feature.FACECONVEX:
          break;
        case Feature.FACESTRAIGHT:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        case Feature.FACETAPERED:
          break;
        case Feature.FUROBELL:
          break;
        case Feature.FUROPADRAO:
          break;
        case Feature.GROOVE_COMPLEXO:
          GrooveComplexo gTmp = (GrooveComplexo)tmp;
          numTmp = gTmp.D1;
          gTmp.D1 = gTmp.D2;
          gTmp.D2 = numTmp;
          gTmp.features = getFeaturesInvertido(gTmp.features);
          break;
        case Feature.GROOVE_FACE_RADIAL:
          break;
        case Feature.GROOVE_FACE_SQUARE:
          break;
        case Feature.GROOVE_FACE_TAPER:
          break;
        case Feature.GROOVE_I_HELICAL:
          break;
        case Feature.GROOVE_I_RADIAL:
          break;
        case Feature.GROOVE_I_RELIEF:
          break;
        case Feature.GROOVE_I_SQUARE:
          break;
        case Feature.GROOVE_I_TAPER:
          break;
        case Feature.GROOVEHELICAL:
          break;
        case Feature.GROOVERADIAL:
          break;
        case Feature.GROOVERELIEF:
          break;
        case Feature.GROOVESQUARE:
          break;
        case Feature.GROOVETAPER:
          break;
        case Feature.IDCONCAVE:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        case Feature.IDCONTOURED:
          break;
        case Feature.IDCONVEX:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        case Feature.IDSTRAIGHT://nao precisa fazer nada
          break;
        case Feature.IDTAPERED:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        case Feature.ODCONCAVE:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        case Feature.ODCONTOURED:
          break;
        case Feature.ODCONVEX:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        case Feature.ODSTRAIGHT://nao precisa fazer nada
          break;
        case Feature.ODTAPERED:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        case Feature.ODSPLINE_VIRTUAL:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          ODSplineVirtual odsTmp = (ODSplineVirtual)tmp;
          numTmp = odsTmp.D1Original;
          odsTmp.D1Original = odsTmp.D2Original;
          odsTmp.D2Original = numTmp;
          int sizeS = odsTmp.pontos.size();
          Vector pontos2 = new Vector(sizeS);
          double incremento = 0.0;
          for(int j = sizeS-1; j >= 0; j--){
            Ponto2D pTmp = (Ponto2D)odsTmp.pontos.elementAt(j);
            System.out.println("Inversor -> Z: " + pTmp.z + " X: " + pTmp.x);
            double incTmp = pTmp.z;
            pTmp.z = incremento;
            incremento = incTmp;
            pontos2.add(pTmp);
          }
          odsTmp.pontos = pontos2;
          break;
        case Feature.IDSPLINE_VIRTUAL:
          numTmp = tmp.D1;
          tmp.D1 = tmp.D2;
          tmp.D2 = numTmp;
          break;
        default:
          MyMath.alert("InversorDeFeatures: Nao foi possivel inverter\na feature do tipo " + tmp.Tipo);
          break;
      }
    }

    for (int i = 0; i < size; i++) {
      ( (Feature) _featureInvertidoTmp.elementAt(i)).Ordem = (i + 1);
    }

    //_featureInvertidoTmp = _featureCopiado;
    return _featureInvertidoTmp;
  }

  public static Vector getFeaturesEixoCInvertido(Vector _featureEixoC){
    Vector _featureEixoCCopiado = CopiadorDeFeatures.getFeaturesEixoCCopiado(_featureEixoC);

    int size = _featureEixoCCopiado.size();
    Vector _featureEixoCInvertidoTmp = new Vector(size);
    for (int i = size - 1; i >= 0; i--) {
      _featureEixoCInvertidoTmp.add(_featureEixoCCopiado.elementAt(i));
    }


    return _featureEixoCInvertidoTmp;

  }


}
