package util;

import java.util.*;
import features.*;
import java.text.DecimalFormat;
import javax.swing.JOptionPane;
import webcapp_01_0_1.*;
import pontos.*;
import featureseixoc.*;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class MyMath {

  /**
   * Mostra uma mensagem de alerta.
   *
   * @param alerta String
   */
  public static void alert(String alerta) {
   /*22/09/2005 - Codigo comentado para perimtir a execucao do servlet.*/
   // JOptionPane.showMessageDialog(null, alerta, "Alerta", 2);
  }

  /**
   * Imprime o vetor de features e todos os dados utilizados destas.
   *
   * @param _feature Vector
   * @param tabulacao String
   */
  public static void imprimeVetorDeFeatures(Vector _feature, String tabulacao) {
    int size = _feature.size();

    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) _feature.elementAt(i);
      System.out.println(tabulacao + "\tFEATURE numero: " + tmp.Ordem);
      System.out.print(tabulacao + "\t\tTipo: ");
      switch (tmp.Tipo) {
        case 0:
          System.out.println("Nula");
          break;
        case Feature.FACECONCAVE:
          System.out.println("FaceConcave");
          break;
        case Feature.FACECONVEX:
          System.out.println("FaceConvex");
          break;
        case Feature.FACESTRAIGHT:
          System.out.println("FaceStraight");
          break;
        case Feature.FACETAPERED:
          System.out.println("FaceTapared");
          break;
        case Feature.GROOVE_COMPLEXO:
          System.out.println("GrooveComplexo");
          System.out.println(tabulacao + "\t\t\t Features presentes:");
          GrooveComplexo gTmp = (GrooveComplexo) tmp;
          imprimeVetorDeFeatures(gTmp.features, tabulacao + "\t\t\t");
          break;
        case Feature.ODCONCAVE:
          System.out.println("ODConcave");
          break;
        case Feature.ODCONVEX:
          System.out.println("ODConvex");
          break;
        case Feature.ODSTRAIGHT:
          System.out.println("ODStraight");
          ODStraight odTmp = (ODStraight)tmp;
          System.out.println(tabulacao + "\t\t\tTem Rosca: " + odTmp.TemRosca);
          break;
        case Feature.ODTAPERED:
          System.out.println("ODTapered");
          break;
        case Feature.ODCONTOURED:
          System.out.println("ODContoured");
          break;
        case Feature.IDCONCAVE:
          System.out.println("IDConcave");
          break;
        case Feature.IDCONTOURED:
          System.out.println("IDContoured");
          break;
        case Feature.IDCONVEX:
          System.out.println("IDConvex");
          break;
        case Feature.IDSTRAIGHT:
          System.out.println("IDStraight");
          break;
        case Feature.IDTAPERED:
          System.out.println("IDTapered");
          break;
        case Feature.ODSPLINE_VIRTUAL:
          System.out.println("OSplineVirtual");
          ODSplineVirtual odsTmp = (ODSplineVirtual) tmp;
          int sizeS = odsTmp.pontos.size();
          for (int j = 0; j < sizeS; j++) {
            Ponto2D pTmp = (Ponto2D) odsTmp.pontos.elementAt(j);
            System.out.println(tabulacao + "\t\t\tZ: " + pTmp.z + " X: " + pTmp.x);
          }
          break;
        case Feature.IDSPLINE_VIRTUAL:
          System.out.println("IDSplineVirtual");
          break;
        default:
          System.out.println("Nao colocado no codigo (arrumar): " +
                             tmp.Tipo);
          break;
      }
      System.out.println(tabulacao + "\t\tL1: " + tmp.L1 + "\n" + tabulacao +
                         "\t\tD1: " + tmp.D1 +
                         "\n" + tabulacao + "\t\tD2: " + tmp.D2);
    }

  }


  public static void imprimeEixoC(Vector _eixoC){
    if(_eixoC != null){
      int size = _eixoC.size();
      for(int i = 0; i < size; i++){
        featureEixoC tmp = (featureEixoC)_eixoC.elementAt(i);
        switch(tmp.tipo){
          case featureEixoC.HOLE_PATTERN:
            System.out.println("Hole Pattern");
            break;
          case featureEixoC.KEYWAY:
            System.out.println("KeyWay");
            break;
        }

      }
    }
    else
      System.out.println("Nao existem features de eixo C");

  }

  /**
   *
   * @param fuTmp FeatureDeUsinagem
   * @return boolean
   */
  public static boolean isExterno(FeatureDeUsinagem fuTmp){
    boolean tipo = false;

    int size = fuTmp._featuresDaFU.size();
    for(int i = 0; i < size; i++){
      Feature fTmp = (Feature)fuTmp._featuresDaFU.elementAt(i);
      if (fTmp.Tipo == Feature.IDCONCAVE ||
          fTmp.Tipo == Feature.IDCONVEX ||
          fTmp.Tipo == Feature.IDTAPERED ||
          fTmp.Tipo == Feature.IDSTRAIGHT ||
          fTmp.Tipo == Feature.IDCONTOURED ||
          fTmp.Tipo == Feature.GROOVE_I_HELICAL ||
          fTmp.Tipo == Feature.GROOVE_I_RADIAL ||
          fTmp.Tipo == Feature.GROOVE_I_RELIEF ||
          fTmp.Tipo == Feature.GROOVE_I_SQUARE ||
          fTmp.Tipo == Feature.GROOVE_I_TAPER ||
          fTmp.Tipo == Feature.IDSPLINE_VIRTUAL
          )
        tipo = false;
      if (fTmp.Tipo == Feature.ODCONCAVE ||
          fTmp.Tipo == Feature.ODCONVEX ||
          fTmp.Tipo == Feature.ODTAPERED ||
          fTmp.Tipo == Feature.ODSTRAIGHT ||
          fTmp.Tipo == Feature.ODCONTOURED ||
          fTmp.Tipo == Feature.GROOVEHELICAL ||
          fTmp.Tipo == Feature.GROOVERADIAL ||
          fTmp.Tipo == Feature.GROOVERELIEF ||
          fTmp.Tipo == Feature.GROOVESQUARE ||
          fTmp.Tipo == Feature.GROOVETAPER ||
          fTmp.Tipo == Feature.ODSPLINE_VIRTUAL
          )
        tipo = true;
      if(fTmp.Tipo == Feature.GROOVE_COMPLEXO){
        GrooveComplexo gTmp = (GrooveComplexo)fTmp;
        FeatureDeUsinagem fuTmp2 = new FeatureDeUsinagem();
        fuTmp2.setFeaturesDaFU(gTmp.features);

        if(isExterno(fuTmp2))
          tipo = true;
        else
          tipo = false;
      }
    }

    return tipo;
  }

  /**
   *
   * @param um Blank
   * @param dois Blank
   * @return boolean
   */
  public static boolean comparaDiametrosDeBlanks(Blank um, Blank dois){
    if(um.D1 == dois.D1){
      if(um.D2 == dois.D2){
        return true;
      }
    }
    return false;
  }


  /**
   * CalculaODContouredCSpline
   *
   * @param pontosDeControle Vector
   * @return Vector
   */
  public static Vector CalculaODContouredCSpline(Vector pontosDeControle, int nPontosArcos) {
    Vector PontosCalculados = new Vector();
    int Zinicial = 0;
    int np = pontosDeControle.size(); // numero de pontos
    float d[] = new float[np]; // Vetor com os Coeficientes de Newton
    float x[] = new float[np]; // Vetor com as coordenadas-x dos pontos
    float y;
    float t = Zinicial;
    float oldy = 0;
    float oldt = 0 + Zinicial;

    int npp = np * nPontosArcos; // npp = (nmero de pontos)*(Precisao) = Nmero de pontos utilizado para desenhar a curva.

    if (np > 0) { //se np>0 , ou seja, se ha algum ponto no vetor de pontos.

      // no for, desenha os Pontos de Controle.
      for (int i = 0; i < np; i++) {
        ControlPoint1Spline p = (ControlPoint1Spline) pontosDeControle.
            elementAt(i); // p = i-esimo ponto de controle.
        x[i] = p.x; // i-esimo elemento do vetor com as coordenadas-x
        //recebe a coordenada x do -esimo ponto de controle.
        d[i] = p.y; // i-esimo elemento do vetor de Coeficiente de Newton
        // recebe a coordenada y do i-esimo ponto de controle.
      } // fim do for
      if (np > 1) { // Caso tenhamos mais de dois pontos (com dois pontos, temos uma reta)
        float a[] = new float[np]; //vetor a, com tamanho np.
        float t1;
        float t2;
        float h[] = new float[np]; //vetor h, com tamanho np.
        for (int i = 1; i <= np - 1; i++) {
          h[i] = x[i] - x[i - 1];
        }

        if (np > 2) { //Caso tenhamos mais de trs pontos
          float sub[] = new float[np - 1]; //vetor sub, com tamanho np-1.
          float diag[] = new float[np - 1]; //vetor diag, com tamanho np-1.
          float sup[] = new float[np - 1]; //vetor sup, com tamanho np-1.

          for (int i = 1; i <= np - 2; i++) {
            diag[i] = (h[i] + h[i + 1]) / 3;
            sup[i] = h[i + 1] / 6;
            sub[i] = h[i] / 6;
            a[i] = (d[i + 1] - d[i]) / h[i + 1] - (d[i] - d[i - 1]) / h[i];
          }
          solveTridiag(sub, diag, sup, a, np - 2); //Resolve o sistema. Ver metodo solveTridiag.
        }

        // notar que a[0]=a[np-1]=0
        // desenha
        oldt = x[0] + Zinicial;
        oldy = d[0];
        for (int w = 1; w <= np - 1; w++) { // Desenha as linhas entre cada ponto de controle,
          // de acordo com a "precisao" especifcada.
          for (int j = 1; j <= nPontosArcos; j++) {
            t1 = (h[w] * j) / nPontosArcos;
            t2 = h[w] - t1;
            y = ( ( -a[w - 1] / 6 * (t2 + h[w]) * t1 + d[w - 1]) * t2 +
                 ( -a[w] / 6 * (t1 + h[w]) * t2 + d[w]) * t1) / h[w];
            t = x[w - 1] + t1;

            oldt = oldt + Zinicial;
            t = t + Zinicial;
            PontosCalculados.add(new Ponto2D( -oldy, oldt)); //Conferir a ordem
            oldt = t;
            oldy = y;
          }
        }
      }
    }

    return PontosCalculados;
    /////////
  } //fim do metodo CalculaODContouredCSpline


  public static void solveTridiag(float sub[], float diag[], float sup[],
                                  float b[],
                                  int n) { //Recebe 4 matrizes de floats.
    //Resolve o sistema linear utilizando Eliminacao de Gauss sem pivoteamento.
    /*                  solve linear system with tridiagonal n by n matrix a
                        using Gaussian elimination *without* pivoting
                        where   a(i,i-1) = sub[i]  for 2<=i<=n
                                a(i,i)   = diag[i] for 1<=i<=n
                                a(i,i+1) = sup[i]  for 1<=i<=n-1
                        (the values sub[1], sup[n] are ignored)
     right hand side vector b[1:n] is overwritten with solution
                        NOTE: 1...n is used in all arrays, 0 is unused */
    int i;
    /*                  factorization and forward substitution */
    for (i = 2; i <= n; i++) {
      sub[i] = sub[i] / diag[i - 1];
      diag[i] = diag[i] - sub[i] * sup[i - 1];
      b[i] = b[i] - sub[i] * b[i - 1];
    }
    b[n] = b[n] / diag[n];
    for (i = n - 1; i >= 1; i--) {
      b[i] = (b[i] - sup[i] * b[i + 1]) / diag[i];
    }
  }


  /**
   *
   * @param entrada Vector
   * @return Vector
   */
  public static Vector ordenaVectorDeFeatures(Vector entrada) {
    Vector saida = new Vector();
    int size = entrada.size();
    Feature[] entradaArray = new Feature[size];
    //Cast para array
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) entrada.elementAt(i);
      entradaArray[i] = tmp;
    }
    Arrays.sort(entradaArray);

    //Cast para vector
    for (int i = 0; i < size; i++) {
      Feature tmp = entradaArray[i];
      saida.add(tmp);
      System.out.println("" + tmp.Ordem);
    }
    return saida;
  }

  /**
   *
   * @param entrada Vector
   * @return Vector
   *
   * Inverte a ordem de features de um vetor
   */
  public static Vector inverteVector(Vector entrada) {
    Vector saida = new Vector();

    double D1tmp = 0.0;
    double D2tmp = 0.0;
    int size = entrada.size();
    for (int i = size - 1; i >= 0; i--) {
      Feature tmp = (Feature) entrada.elementAt(i);
      D2tmp = tmp.D1;
      D1tmp = tmp.D2;
      tmp.D1 = D1tmp;
      tmp.D2 = D2tmp;
      saida.add(tmp);
    }

    return saida;
  }

  /**
   *
   * @param entrada Vector
   * @return Vector
   *
   * Inverte os diametros de um vetor de features de entrada, utilizada quando
   * e necessario inverter a ordem das features da peca
   */
  public static Vector inverteDiametros(Vector entrada) {
    Vector saida = new Vector();
    double D1tmp = 0.0;
    double D2tmp = 0.0;
    int size = entrada.size();
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) entrada.elementAt(i);

      D2tmp = tmp.D1;
      D1tmp = tmp.D2;

      tmp.D1 = D1tmp;
      tmp.D2 = D2tmp;
      saida.add(tmp);
    }

    return saida;
  }

  public static Vector colocaAOrdem(Vector entrada) {
    int size = entrada.size();
    //alert("Tamanho do vetor de Features:\n" + size);
    for (int i = 0; i < size; i++) {
      Feature tmpFeature = (Feature) entrada.elementAt(i);
      tmpFeature.Ordem = i + 1;
    }
    return entrada;
  }

  //1903 e 2003
  /**
   *
   * @param num double
   * @return double
   *
   * Recebe um double e retorna a string referente a este que sera incluida no CodigoG
   */
  public static String arredondaDouble(double num) {
    double round = 0;
    DecimalFormat zeroDigits = new DecimalFormat("0");
    DecimalFormat oneDigit = new DecimalFormat("0.0");
    DecimalFormat twoDigits = new DecimalFormat("0.00");
    DecimalFormat threeDigits = new DecimalFormat("0.000");

    num *= 1000; //multiplica o numero por mil para arredondar para o mais proximo mesmo
    //considerando os milesimos de milimetro

    round = Math.round(num); //arredonda para o valor mais proximo
    round /= 1000; //divide por mil para retornar ao formato original

    //Faz a formatacao do numero arredondado
    //2.000 -> retorna 2
    //1.600 -> retorna 1.6
    //1.570 -> retorna 1.57
    //1.457 -> retorna 1.457
    String tmp = zeroDigits.format(round);
    tmp = tmp.replace(',', '.');
    double roundTmp = Double.parseDouble(tmp);

    if (round - roundTmp == 0) { //retorna o double sem casas decimais
      //return roundTmp;
      //System.out.println(tmp);
      return tmp;
    }
    else {
      tmp = oneDigit.format(round);
      tmp = tmp.replace(',', '.');
      roundTmp = Double.parseDouble(tmp);
      if (round - roundTmp == 0) { //retorna o double com uma casa decimal
        //return roundTmp;
        //System.out.println(roundTmp);
        return tmp;
      }
      else {
        tmp = twoDigits.format(round);
        tmp = tmp.replace(',', '.');
        roundTmp = Double.parseDouble(tmp);
        if (round - roundTmp == 0) { //retona o double com duas casas decimais
          //return roundTmp;
          //System.out.println(roundTmp);
          return tmp;
        }
        else { //retona o double com tres casas decimais
          tmp = threeDigits.format(round);
          tmp = tmp.replace(',', '.');
          //roundTmp = Double.parseDouble(tmp);
          //return roundTmp;
          //System.out.println(roundTmp);
          return tmp;
        }
      }

    }
  }

  //1903 e 2003

  //3103 0504
  /**
   *
   * @param num double
   * @return String
   *
   * Recebe um numero em milimetros e retorna a string equivalente
   * a este valor em micrometros, no formato de uma string
   */
  public static String arredondaDoubleMicro(double num) {
    DecimalFormat zeroDigits = new DecimalFormat("0");
    String tmp = "";

    tmp = zeroDigits.format(Double.parseDouble(arredondaDouble(num * 1000)));

    return tmp;
  }

  //3103 0504

  /**
   * CastDeArrayDeInfoFeaturesPorDiametro
   *
   * @param novo InfoFeaturesPorDiametro[]
   * @param velho InfoFeaturesPorDiametro[]
   */
  public static void CastDeArrayDeInfoFeaturesPorDiametro(
      InfoFeaturesPorDiametro[] novo, InfoFeaturesPorDiametro[] velho) {
    int size = novo.length;
    for (int i = 0; i < size; i++) {
      novo[i] = velho[i];
    }
  }

  /**
   * InicializaArrayDeInfoFeaturesPorDiametro
   *
   * @param fPD InfoFeaturesPorDiametro[]
   */
  public static void InicializaArrayDeInfoFeaturesPorDiametro(
      InfoFeaturesPorDiametro[] fPD) {
    int size = fPD.length;
    for (int i = 0; i < size; i++) {
      fPD[i] = new InfoFeaturesPorDiametro();
      fPD[i].features = new Vector();
    }
  }

  /**
   * InicializarArrayDeInfoSuperficieDelimitadora
   *
   * @param infoSuperficieDelimitadora InfoSuperficieDelimitadora[]
   */
  public static void InicializarArrayDeInfoSuperficieDelimitadora(
      InfoSuperficieDelimitadora[] infoSuperficieDelimitadora) {
    int size = infoSuperficieDelimitadora.length;
    for (int i = 0; i < size; i++) {
      infoSuperficieDelimitadora[i] = new InfoSuperficieDelimitadora();
    }

  }



  /**
   *
   * @param fu FeatureDeUsinagem
   * @return int
   * @todo  tem q ver as funcoes direito
   *
   * Retorna um inteiro que representa o ciclo fixo do torno
   */
  public int getCiclo(FeatureDeUsinagem fu) {
    switch (fu.tipo) {
      case FeatureDeUsinagem.FACE:
        return 72;
      case FeatureDeUsinagem.BLOCO_EXTERNO:
        return 71;
      case FeatureDeUsinagem.RECARTILHADO:
        return 999;
      case FeatureDeUsinagem.ROSCA_EXTERNA:
        return 76;
      case FeatureDeUsinagem.GROOVE_INTERNO:
        return 75;
      default:
        return 01;
    }
  }

}
