package webcapp_01_0_1;

import java.util.*;
import features.*;
import pontos.*;
import util.*;
import featureseixoc.*;

/**
 * <p>Title: CAPP</p>
 *
 * <p>Description: CAPP para o projeto Webmachining</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: GrACo</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class CodigoG {
  Blank blankUtilizado;
  InfoDecomposicaoOrientadaAOperacao infoDOO;
  Maquina maquinaUtilizada;


  Vector codigoG = new Vector();

  int numeroDaLinha = 0;
  int numeroDaFU = 1;
  int numeroDoSetup = 1;
  FerramentaUtilizada ferramentaUtilizada = null;
  boolean fluidoDeCorte = false;

  public CodigoG(InfoDecomposicaoOrientadaAOperacao infoDOO) {
    this.infoDOO = infoDOO;
    init();
  }

  public void init() {
    this.blankUtilizado = infoDOO.blankUtilizado;
    this.maquinaUtilizada = infoDOO.maquinaUtilizada;

    percorredorDeSetups(infoDOO.setupN);
  }

  private String getLinhaDoCodigoG() {
    String linhaDoCodigoG = "N";
    numeroDaLinha += 10;
    linhaDoCodigoG += numeroDaLinha;

    return linhaDoCodigoG;
  }

  public void percorredorDeSetups(Vector vetorSetupN) {
    int size = vetorSetupN.size();

    //Adiciona o bloco inicial do codico G
    blocoInicial();

    for (int i = 0; i < size; i++) {
      Vector wsDoSetupI = (Vector) vetorSetupN.elementAt(i);

      //0303
      codigoG.add(getLinhaDoCodigoG() + "(INICIO SETUP" + numeroDoSetup + ")");
      //0303

      workingstepsDoSetupN(wsDoSetupI);

      //0303
      codigoG.add(getLinhaDoCodigoG() + "(FIM SETUP" + numeroDoSetup + ")");
      numeroDoSetup++;
      numeroDaFU = 1;
      //0303

      if (size != 1 && i != size - 1) {
        blocoTrocaSetup();
      }
      if (i == size - 1) {
        blocoFinal();
      }
    }

  }

  private void blocoInicial() {
    codigoG.add("O1000");
    codigoG.add("N10G21G40G90G95");
    codigoG.add("N20M36");
    codigoG.add("N30M37");
    numeroDaLinha = (codigoG.size() - 1) * 10;
  }

  /**
   *
   * @param _workingsteps Vector Este metodo gera o bloco do codigoG de cada
   *   setup, verificando cada workingstep Ja esta testando a necessidade da troca
   *   de ferramenta
   */
  private void workingstepsDoSetupN(Vector _workingsteps) {
    Vector blocoCodigoG = null;
    Workingstep WS;
    int size = _workingsteps.size();

    for (int i = 0; i < size; i++) {
      WS = (Workingstep) _workingsteps.elementAt(i);
      //0803
      getDescricaoDoWorkingstep(WS);
      //0803

      /**
       * @todo tem que adicionar as ferramentas para os outros tipos de FU, alem da face
       */
      switch (WS.featureDoWorkingstep.tipo) {
        case FeatureDeUsinagem.FACE:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG75(WS);
          break;
        case FeatureDeUsinagem.FURO:
          trocaDeFerramentaAxial(WS);
          blocoCodigoG = getCodigoG74(WS);
          break;
        case FeatureDeUsinagem.FURO_ACIONADO:
          trocaDeFerramentaAxial(WS);
          blocoCodigoG = getCodigoG83(WS);
          break;
        case FeatureDeUsinagem.BLOCO_EXTERNO:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG7170_tipo1(WS);
          break;
        case FeatureDeUsinagem.BLOCO_INTERNO:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG7170_tipo1(WS);
          break;
        case FeatureDeUsinagem.GROOVECOMPLEXO_EXTERNO:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG7270(WS);
          break;
        case FeatureDeUsinagem.GROOVECOMPLEXO_INTERNO:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG7270(WS);
          break;
        case FeatureDeUsinagem.ROSCA_EXTERNA:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG76(WS);
          break;
        case FeatureDeUsinagem.ROSCA_INTERNA:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG76(WS);
          break;
        case FeatureDeUsinagem.SPLINE_EXTERNA:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoG7170_tipo2(WS);
          break;
        case FeatureDeUsinagem.PADRAO_DE_FURO:
          trocaDeFerramentaAxial(WS);
          blocoCodigoG = getCodigoG83(WS);
          break;
        case FeatureDeUsinagem.RASGO_DE_CHAVETA:
          trocaDeFerramenta(WS);
          blocoCodigoG = getCodigoManualRasgoDeChaveta(WS);
          break;
        default:
          MyMath.alert("Nao consegue criar codigoG para um tipo de workingstep");
          break;
      }
      if (blocoCodigoG != null) {
        codigoG = insereNoVetor(codigoG, blocoCodigoG);
      }
      numeroDaLinha = (codigoG.size() - 1) * 10;
      blocoCodigoG = null;
    }
  }

  /**
   * getDescricaoDoWorkingstep
   *
   * @param WS Workingstep
   *
   * insere no codigoG a descricao do Workingstep, incluindo varios dados sobre este
   */
  private void getDescricaoDoWorkingstep(Workingstep WS) {
    String tmp = "";
    tmp = (getLinhaDoCodigoG() + "(WORKINGSTEP - ");

    switch (WS.featureDoWorkingstep.tipo) {
      case FeatureDeUsinagem.FACE:
        tmp += ("FEATURE DE USINAGEM Fu" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.BLOCO_EXTERNO:
        tmp += ("FEATURE DE TORNEAMENTO Ft" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.GROOVE_EXTERNO:
        tmp += ("FEATURE DE USINAGEM Fu" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.GROOVECOMPLEXO_EXTERNO:
        tmp += ("FEATURE DE TORNEAMENTO Ft" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.RECARTILHADO:
        tmp += ("FEATURE DE USINAGEM Fu" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
      case FeatureDeUsinagem.ROSCA_EXTERNA:
        tmp += ("FEATURE DE USINAGEM Fu" + numeroDaFU + ")");
        codigoG.add(tmp);
        break;
    }
    numeroDaFU++;
  }

  /**
   * trocaDeFerramenta
   *
   * @param WS Workingstep
   *
   * Faz a troca de ferramenta sempre que for necessario
   */
  private void trocaDeFerramenta(Workingstep WS) {
    FerramentaUtilizada ferrUti = WS.operacaoDeUsinagem[0].ferramentaUtilizada[
        0];

    if (ferramentaUtilizada == null) {
      //FORCANDO A BARRA....
      ferramentaUtilizada = new FerramentaUtilizada();
      ferramentaUtilizada.numDaMagazine = 0;
    }
    if (ferrUti.numDaMagazine != ferramentaUtilizada.numDaMagazine) { //para esses casos a troca de ferramenta e necessaria
      ferramentaUtilizada = ferrUti;
      fluidoDeCorte = false; //muda a variavel de forma que sempre que houver uma troca de ferramenta seja adicionada
      //a linha M8 no codigo G

      codigoG.add(getLinhaDoCodigoG() + "G53");
      codigoG.add(getLinhaDoCodigoG() + "G0X" +
                  MyMath.arredondaDouble(maquinaUtilizada.
                                         pontoDeTrocaDeFerramenta.x) + "Z" +
                  MyMath.arredondaDouble(maquinaUtilizada.
                                         pontoDeTrocaDeFerramenta.z) + "T00");

      //Forcando o codigo a ter dois dgitos para o n na magazine e para o n de compensacao
      String tmp = "";
      tmp = getLinhaDoCodigoG() + "T";
      if (WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDaMagazine < 10)
        tmp += "0";
      tmp += WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDaMagazine;
      if (WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDeCompensacao <
          10)
        tmp += "0";
      tmp += WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDeCompensacao +
          "(Tool " +
          WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].descricao +
          ")";
      codigoG.add(tmp);

      //1903
      if (numeroDoSetup == 1)
        codigoG.add(getLinhaDoCodigoG() + "G54");
      else
        codigoG.add(getLinhaDoCodigoG() + "G55");
        //1903

      codigoG.add(getLinhaDoCodigoG() + "G96S" +
                  (int) WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.Vc);
      codigoG.add(getLinhaDoCodigoG() + "G92S" + "4000");
      //@todo buscar pela operacao de usinagem se e M3 ou M4
      codigoG.add(getLinhaDoCodigoG() + "M4");

      //Adiciona M8 ou M9, dependendo do caso
      if (WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.fluidoDeCorte == true &&
          fluidoDeCorte == false) {
        codigoG.add(getLinhaDoCodigoG() + "M8"); //liga o fluido de corte
        fluidoDeCorte = true;
      }
      if (WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.fluidoDeCorte == false &&
          fluidoDeCorte == true) {
        codigoG.add(getLinhaDoCodigoG() + "M9"); //desliga o fluido de corte
        fluidoDeCorte = false;
      }
    }
    else {
      codigoG.add(getLinhaDoCodigoG() + "G0X" +
                  MyMath.arredondaDouble(this.infoDOO.blankUtilizado.D2));
    }
  }


  private void trocaDeFerramentaAxial(Workingstep WS){
    FerramentaUtilizada ferrUti = WS.operacaoDeUsinagem[0].ferramentaUtilizada[
        0];

    if (ferramentaUtilizada == null) {
      //FORCANDO A BARRA....
      ferramentaUtilizada = new FerramentaUtilizada();
      ferramentaUtilizada.numDaMagazine = 00;
    }
    if (ferrUti.numDaMagazine != ferramentaUtilizada.numDaMagazine) { //para esses casos a troca de ferramenta e necessaria
      ferramentaUtilizada = ferrUti;
      fluidoDeCorte = false; //muda a variavel de forma que sempre que houver uma troca de ferramenta seja adicionada
      //a linha M8 no codigo G

      codigoG.add(getLinhaDoCodigoG() + "G53");
      codigoG.add(getLinhaDoCodigoG() + "G40");
      codigoG.add(getLinhaDoCodigoG() + "G0X" +
                  MyMath.arredondaDouble(maquinaUtilizada.
                                         pontoDeTrocaDeFerramenta.x) + "Z" +
                  MyMath.arredondaDouble(maquinaUtilizada.
                                         pontoDeTrocaDeFerramenta.z) + "T00");

      //Forcando o codigo a ter dois dgitos para o n na magazine e para o n de compensacao
      String tmp = "";
      tmp = getLinhaDoCodigoG() + "T";
      if (WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDaMagazine < 10)
        tmp += "0";
      tmp += WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDaMagazine;
      if (WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDeCompensacao <
          10)
        tmp += "0";
      tmp += WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].numDeCompensacao +
          "(Tool " +
          WS.operacaoDeUsinagem[0].ferramentaUtilizada[0].descricao +
          ")";
      codigoG.add(tmp);

      //1903
      if (numeroDoSetup == 1)
        codigoG.add(getLinhaDoCodigoG() + "G54");
      else
        codigoG.add(getLinhaDoCodigoG() + "G55");
        //1903

      codigoG.add(getLinhaDoCodigoG() + "G90");
      codigoG.add(getLinhaDoCodigoG() + "G97S800M15");

    }
    else {
      MyMath.alert("Utilizando a mesma ferramenta axial, fazer movimentacao!");
    }

  }


  private void blocoTrocaSetup() {
    Ponto2D pontoDeTrocaDeFerramenta = infoDOO.maquinaUtilizada.pontoDeTrocaDeFerramenta;
    codigoG.add(getLinhaDoCodigoG() + "(TROCA DE SETUP)");
    codigoG.add(getLinhaDoCodigoG() + "G53");
    codigoG.add(getLinhaDoCodigoG() + "G0X" + pontoDeTrocaDeFerramenta.x + "Z" +
                pontoDeTrocaDeFerramenta.z + "T00");
    codigoG.add(getLinhaDoCodigoG() + "M00");

    codigoG.add(getLinhaDoCodigoG() + "M36");
    codigoG.add(getLinhaDoCodigoG() + "M37");
  }

  private void blocoFinal() {
    Ponto2D pontoDeTrocaDeFerramenta = infoDOO.maquinaUtilizada.pontoDeTrocaDeFerramenta;
    codigoG.add(getLinhaDoCodigoG() + "G53G40M9M5"); //00
    codigoG.add(getLinhaDoCodigoG() + "G0X" +
                MyMath.arredondaDouble(pontoDeTrocaDeFerramenta.x) + "Z" +
                MyMath.arredondaDouble(pontoDeTrocaDeFerramenta.z) + "T00");

    codigoG.add(getLinhaDoCodigoG() + "M36");
    codigoG.add(getLinhaDoCodigoG() + "M37");
    codigoG.add(getLinhaDoCodigoG() + "M30" + "(FIM DA PECA)");
  }

  /**
   *
   * @param WS Workingstep
   * @return Vector
   */
  private Vector getCodigoG74(Workingstep WS){
    Vector _codigoIntermediario = new Vector();

    double R = 0.0;//retorno incrmental para a quebra de cavaco
    double Z = 0.0;//posicao final (absoluto)
    double Q = 0.0;//valor incremento no ciclo de furacao (milesimos de milimetro)
    double F = 0.0;//avanco de trabalho

    double deltaDeAproximacao = 5.0;

    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO FIXO G74 FURACAO)");

    //Vai para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "X" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.x) + "Z" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.z));

    //Vai para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "X" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z));

    R = 2.0;
    Q = 15000.0;
    F = 0.15;

    Feature fTmp = (Feature) WS.featureDoWorkingstep._featuresDaFU.
        firstElement();
    Z = WS.planoDeAproximacao.z - deltaDeAproximacao - fTmp.L1;
    /**
     * @todo verificar se o furo e passante, se for deve-se diminuir Z para
     * que o furo realmente passe pela peca.
     */

    _codigoIntermediario.add(getLinhaDoCodigoG() + "G74R" +
                             MyMath.arredondaDouble(R));
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G74Z" +
                             MyMath.arredondaDouble(Z) + "Q" +
                             MyMath.arredondaDouble(Q) + "F" +
                             MyMath.arredondaDouble(F));

    return _codigoIntermediario;
  }


  /**
   *
   * @param WS workingstep
   * @return Vector
   */
  private Vector getCodigoG75(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();

    Ponto2D pontoDeAproximacao = new Ponto2D(WS.planoDeAproximacao.x,
                                             WS.planoDeAproximacao.z);
    double X = 0.0;
    double Z = 0.0;
    double P = 0; //milesimos de milimetro
    double Q = 0; //milesimos de milimetro
    double R = 0.0;
    double F = 0.0;

    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO FIXO G75 FACEAMENTO)");

    //Encontrando os valores
    FeatureDeUsinagem tmp = WS.featureDoWorkingstep;
    Feature featureTmp;
    if(tmp.origem.x != 0)
      X = tmp.origem.x - 5.0;
    else
      X = 0.0;
    featureTmp = (Feature) tmp._featuresDaFU.lastElement();
    Z = (blankUtilizado.L1 + featureTmp.L1);
   // 29/07/2005 - P = profundidade de corte
    P = (pontoDeAproximacao.x /*- Xinferior*/ / 2);
   // P=400;
    Q = WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.Ap;
    R = 1.0;
    F = WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.F;

    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.z));

    //Arruma o plano de Aproximacao
    WS.planoDeAproximacao.z -= Q / 1000;

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(pontoDeAproximacao.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z));

    //Adiciona a linha do ciclo fixo
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G75X" +
                             MyMath.arredondaDouble(X) + "Z" +
                             MyMath.arredondaDouble(Z) + "P" +
                             MyMath.arredondaDoubleMicro(P) + "Q" +
                             MyMath.arredondaDoubleMicro(Q) + "R" +
                             MyMath.arredondaDouble(R) + "F" +
                             MyMath.arredondaDouble(F));

    return _codigoIntermediario;
  }

  /**
   * getCodigoG7170
   *
   * @param WS workingstep
   * @return Vector
   */
  private Vector getCodigoG7170_tipo1(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();
    double U = 1.0;
    double R = 2.0;
    int P;
    int Q;
    double sobreMetalU = 0.2;
    double sobreMetalW = 0.2;
    double F = 0.2;
    int produto = 1;
    boolean externo = true;


    if(!MyMath.isExterno(WS.featureDoWorkingstep)){
      externo = false;
      produto = -1;
    }


    //0303
    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO FIXO G71-TIPO1 DESBASTE E G70 ACABAMENTO)");
    //0303

    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.z));

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z));

    //Adiciona a primeira linha do ciclo fixo
    //adiciona um pedaco da segunda linha do ciclo fixo
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G71U" +
                             MyMath.arredondaDouble(U) + "R" +
                             MyMath.arredondaDouble(R));
    P = numeroDaLinha + 20;
    String tmp = getLinhaDoCodigoG() + "G71P" + P;

    //Coloca no _codigoIntermediario o plano de Aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble( ( (FeatureDeUsinagem) WS.
        featureDoWorkingstep).origem.x));

    if(externo)
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G42");
    else
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G41");

    /*Al q mia do vazio*/
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G1W-5");

    //Gera o bloco do ciclo fixo
    //Vector blocoFormaFinal = getPerfilCrescente(WS.featureDoWorkingstep._featuresDaFU);
    //Vector blocoFormaFinal = getPerfil(WS); //1703
    Vector blocoFormaFinal = gerarPerfil(WS,"normal");


    //Coloca no _codigoIntermediario a string que representa a segunda linha do G71
    Q = numeroDaLinha;
    tmp += "Q" + Q + "U" + MyMath.arredondaDouble(produto*sobreMetalU) + "W" +
        MyMath.arredondaDouble(sobreMetalW) + "F" +
        MyMath.arredondaDouble(F);
    _codigoIntermediario.add(4, tmp); //Coloca em 2 pq (0) = G0 e (1) = 1 linha do G71 By Roman!!!

    //Coloca no _codigoIntermediario o perfil da forma que sera usinada
    _codigoIntermediario = insereNoVetor(_codigoIntermediario, blocoFormaFinal);

    //Insere  o ciclo de Acabamento
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G70P" + P + "Q" + Q);
    return _codigoIntermediario;
  }

  /**
   * getCodigoG7170
   *
   * @param WS workingstep
   * @return Vector
   */
  private Vector getCodigoG7170_tipo2(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();
    //29/07/2005 U=sobremetal para acabamento
    // double U = 1.0;
    double U = 0.6;
    double R = 2.0;
    int P;
    int Q;
    double sobreMetalU = 0.2;
    double sobreMetalW = 0.2;
    double F = 0.2;
    int produto = 1;
    boolean externo = true;


    if(!MyMath.isExterno(WS.featureDoWorkingstep)){
      externo = false;
      produto = -1;
    }


    //0303
    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO FIXO G71-TIPO2 DESBASTE E G70 ACABAMENTO)");
    //0303

    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.z));

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z));

    //Adiciona a primeira linha do ciclo fixo
    //adiciona um pedaco da segunda linha do ciclo fixo
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G71U" +
                             MyMath.arredondaDouble(U) + "R" +
                             MyMath.arredondaDouble(R));
    P = numeroDaLinha + 20;
    String tmp = getLinhaDoCodigoG() + "G71P" + P;

    //Coloca no _codigoIntermediario o plano de Aproximacao
    String sTmp = getLinhaDoCodigoG() + "G0X" +
        MyMath.arredondaDouble( ( (FeatureDeUsinagem) WS.
                                 featureDoWorkingstep).origem.x);
   sTmp += "Z" + (MyMath.arredondaDouble(WS.planoDeAproximacao.z));
   _codigoIntermediario.add(sTmp);

    if(externo)
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G42");
    else
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G41");

    /*Al q mia do vazio*/
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G1W-5");

    //Gera o bloco do ciclo fixo
    //Vector blocoFormaFinal = getPerfilCrescente(WS.featureDoWorkingstep._featuresDaFU);
    //Vector blocoFormaFinal = getPerfil(WS); //1703
    Vector blocoFormaFinal = gerarPerfil(WS,"normal");


    //Coloca no _codigoIntermediario a string que representa a segunda linha do G71
    Q = numeroDaLinha;
    tmp += "Q" + Q + "U" + MyMath.arredondaDouble(produto*sobreMetalU) + "W" +
        MyMath.arredondaDouble(sobreMetalW) + "F" +
        MyMath.arredondaDouble(F);
    _codigoIntermediario.add(4, tmp); //Coloca em 2 pq (0) = G0 e (1) = 1 linha do G71 By Roman!!!

    //Coloca no _codigoIntermediario o perfil da forma que sera usinada
    _codigoIntermediario = insereNoVetor(_codigoIntermediario, blocoFormaFinal);

    //Insere  o ciclo de Acabamento
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G70P" + P + "Q" + Q);
    return _codigoIntermediario;
  }



  private Vector getCodigoG7270(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();
    double W = 0.0; //profundidade de corte
    double R = 0.0; //valor de afastamento no eixo longitudinal para retorno ao "X" inicial
    int P = 0; //inicio do bloco do perfil
    int Q = 0; //fim do bloco do perfil
    double sobreMetalU = 0.0; //sobremetal no eixo X
    double sobreMetalW = 0.0; //sobremetal no eixo Z
   //29/07/2005
    //double F = 1; //avanco
     double F = 0.2; //avanco
    int produto = 1;
    boolean externo = true;

    if(!MyMath.isExterno(WS.featureDoWorkingstep)){
      produto = -1;
      externo = false;
    }


    //0303
    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO FIXO G72 GROOVE COMPLEXO E G70 ACABAMENTO)");
    //0303


    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.z));

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z));

    //Primeira linha do ciclo fixo
    //W = WS.operacaoDeUsinagem[0].tecnologiaDeUsinagem.Ap;
  //29/07/2005
  // W = 2;
   W = 0.6;
    R = 0;
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G72W" +
                             MyMath.arredondaDouble(W) + "R" +
                             MyMath.arredondaDouble(R));
    //Pedaco da segunda linha do ciclo
    P = numeroDaLinha + 20;
    String tmp = getLinhaDoCodigoG() + "G72P" + P;

    //Para o G72, a primeira linha do perfil deve ter apenas um Z
    double comprimento = 0.0;
    int size = WS.featureDoWorkingstep._featuresDaFU.size();
    for (int i = 0; i < size; i++) {
      Feature fTmp = (Feature) WS.featureDoWorkingstep._featuresDaFU.elementAt(
          i);
      comprimento += fTmp.L1;
    }

    //Faz o deslocamento inicial em Z
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0Z" +
                             (MyMath.arredondaDouble(WS.planoDeAproximacao.z -
        comprimento))); //0303


    if(externo)
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G41");
    else
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G42");


    //Tira o espaco entre a ferramenta e a peca (deltaAproximacao)
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G1X" +
                             MyMath.
                             arredondaDouble( ( (Feature) ( (GrooveComplexo) WS.
        featureDoWorkingstep._featuresDaFU.elementAt(0)).features.firstElement()).
                                             D1));

    //Vector blocoFormaFinal = getPerfilGrooveComplexo(((GrooveComplexo)WS.featureDoWorkingstep._featuresDaFU.elementAt(0)).features);
//    Vector blocoFormaFinal = getPerfil(WS);
    Vector blocoFormaFinal = gerarPerfil(WS, "invertido");


    //Coloca no _codigoIntermediario a string que representa a segunda linha do G72
    Q = numeroDaLinha;
    tmp += "Q" + Q + "U" + MyMath.arredondaDouble(produto*sobreMetalU) + "W" +
        MyMath.arredondaDouble(sobreMetalW) + "F" +
        MyMath.arredondaDouble(F);
    _codigoIntermediario.add(4, tmp); //Coloca em 2 pq (0) = G0 e (1) = 1 linha do G72 bY Roman

    //Coloca no _codigoIntermediario o perfil da forma que sera usinada
    _codigoIntermediario = insereNoVetor(_codigoIntermediario, blocoFormaFinal);

    //Insere  o ciclo de Acabamento
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G70P" + P + "Q" + Q);

    return _codigoIntermediario;
  }

  /**
   *
   * @param WS Workingstep
   * @return Vector
   *
   * Gera o corigo do ciclo fixo G76, funciona apenas para rosca em ODStraight
   */
  private Vector getCodigoG76(Workingstep WS) {
    Vector _codigoIntermediario = new Vector();
    int m = 0; //numero de repeticoes do ultimo passe
    int r = 0; //comprimento da saida angular da rosca
    int s = 0; //(r / passo)*10
    int a = 0; //angulo da ferramenta
    String valorDeP = ""; //valor que sera colocado em P na primeira linha do ciclo fixo
    double minimaProfundidade = 0; //(micrometros)
    double profundidadeDoUltimoPasse = 0;
    double X = 0; //diametro final
    double W = 0; //incremento em Z para a posicao final
    double R = 0; //conicidade
    double P = 0; //altura do filete
    double Q = 0; //profundidade do primeiro passe
    double F = 0; //passo da rosca

    ODStraight roscaTmp = (ODStraight) WS.featureDoWorkingstep._featuresDaFU.
        elementAt(0);
    F = roscaTmp.rosca.threads_inch; //coloca o valor do passo

    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO FIXO G76 ROSCAMENTO AUTOMATICO)");

    //Muda a velocidade de rotacao e o sentido de rotacao
    double velocidade = 5000 / F;

    String sentido = "";
    if (roscaTmp.rosca.roscaDireita) sentido = "M4";
    else sentido = "M4";
    int velocidade1 = (int)velocidade;
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G97S" +
                             MyMath.arredondaDouble(velocidade1));
    _codigoIntermediario.add(getLinhaDoCodigoG() + sentido);

    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.z));

    //Ir para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "X" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z));

    //Obtencao dos valores
    m = 1;
    s = (int) ( (r / F) * 10);
    a = 60;

    valorDeP = "010060";//"O"+String.valueOf(m) + String.valueOf(s) + String.valueOf(a);
    /**
     * @todo colocar um if para quando m < 10 AQUI EM CIMA!!!
     */

    //nao testei se isto ai em cima funciona -> concatenar doubles

    minimaProfundidade = 0;
    profundidadeDoUltimoPasse = 0;

    P = 0.65 * F;
    X = (WS.planoDeAproximacao.x - 5) - (P * 2); //supondo que o plano de aproximacao
    // esteja com 5mm a mais que o diametro onde a rosca se inicia
    W = -roscaTmp.rosca.comprimento;

    double numeroDePasses = 0;
    Q = 0.5; //supondo um valor maior que 0.4 somente para entrar no While
    while (Q > 0.325) {
      ++numeroDePasses;
      Q = P / Math.sqrt(numeroDePasses);
    }

    _codigoIntermediario.add(getLinhaDoCodigoG() + "G76P" +
                             /*calculus.arredondaDouble(*/
                             valorDeP
                             /*)*/+ "Q" +
                             MyMath.arredondaDouble(minimaProfundidade) + "R" +
                             MyMath.arredondaDouble(profundidadeDoUltimoPasse));
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G76X" +
                             MyMath.arredondaDouble(X) + "W" +
                             MyMath.arredondaDouble(W) + "P" +
                             MyMath.arredondaDoubleMicro(P) + "Q" +
                             MyMath.arredondaDoubleMicro(Q) + "F" +
                             MyMath.arredondaDouble(F));

    //se tiver invertido o giro do eixo => desinverte
    if (sentido == "M3") {
      _codigoIntermediario.add(getLinhaDoCodigoG() + "M4");
    }

    return _codigoIntermediario;
  }

  /**
   * Ciclo fixo de furo com ferramenta acionada.
   *
   * @param WS Workingstep
   * @return Vector
   */
  private Vector getCodigoG83(Workingstep WS){
    Vector _codigoIntermediario = new Vector();
    double Z = 0.0;//posicao final do furo(absoluto)
    double Q = 0.0;//valor do incremento (incremental/milesimal)
    double P = 0.0;//tempo de permanencia ao final de fada incremento (milesimos de segundo)
    double F = 0.0;//Avanco
    double R = 0.0;//Plano de referencia para inicio de furacao

    /**
     * @todo Passar o valor do delta de aproximacao junto com a infoDOO
     */
    double deltaAproximacao = 5.0;

    double zAdicional = 5.0;

    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO FIXO G83 FURO COM FERRAMENTA ACIONADA)");

    _codigoIntermediario.add(getLinhaDoCodigoG() + "G97S800M15");
    _codigoIntermediario.add(getLinhaDoCodigoG() + "M19");


    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.z));

    if(WS.featureDoWorkingstep.tipo == FeatureDeUsinagem.PADRAO_DE_FURO){
      HolePattern hpTmp = (HolePattern)WS.featureDoWorkingstep._featuresDaFU.firstElement();
      //Rotaciona para o angulo zero se necessario
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G28C0");
      //Ir para o plano de aproximacao
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                               MyMath.arredondaDouble(WS.planoDeAproximacao.x) +
                               "Z" +
                               MyMath.arredondaDouble(WS.planoDeAproximacao.z) +
                               "C" + MyMath.arredondaDouble(hpTmp.anguloInicial));

      //Calculando Z
      Z = WS.planoDeAproximacao.z - deltaAproximacao - hpTmp.profundidade;
    }
    else{
      //Ir para o plano de aproximacao
      _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                               MyMath.arredondaDouble(WS.planoDeAproximacao.x) +
                               "Z" +
                               MyMath.arredondaDouble(WS.planoDeAproximacao.z));

      //Verificando se o furo e passante ou nao
      double comprimentoPeca = this.infoDOO.blankUtilizado.L1;
      Feature tmp = (Feature) WS.featureDoWorkingstep._featuresDaFU.
          firstElement();
      double comprimentoFuro = tmp.L1;

      //Calculando Z
      if (comprimentoFuro >= comprimentoPeca) { //furo passante
        Z = WS.planoDeAproximacao.z - deltaAproximacao - comprimentoPeca -
            zAdicional;
      }
      else { //apenas um furo
        Z = WS.planoDeAproximacao.z - deltaAproximacao - tmp.L1;
      }
    }
    String sTmp = getLinhaDoCodigoG() + "G83";

    sTmp += "Z" + MyMath.arredondaDouble(Z);

    //Calculando Q
    Q = 8000;
    sTmp += "Q" + MyMath.arredondaDouble(Q);

    //Calculando P
    P = 1500;
    sTmp += "P" + MyMath.arredondaDouble(P);

    //Calculando F
    F = 0.12;
    sTmp += "F" + MyMath.arredondaDouble(F);

    //Calculando R
    //Nao e necessario coloca-lo no codigo

    //Adiciona o novo trecho ao codigoG
    _codigoIntermediario.add(sTmp);

    if(WS.featureDoWorkingstep.tipo == FeatureDeUsinagem.PADRAO_DE_FURO){
      HolePattern hpTmp = (HolePattern)WS.featureDoWorkingstep._featuresDaFU.firstElement();
      int quantidade = hpTmp.numeroDeFuros;
      double deslocamento = 360 / quantidade;
      for (int i = 1; i < quantidade; i++) {
        _codigoIntermediario.add(getLinhaDoCodigoG() + "C" +
                                 MyMath.arredondaDouble(hpTmp.anguloInicial + i * deslocamento));
      }
    }

    _codigoIntermediario.add(getLinhaDoCodigoG() + "G80");

    return _codigoIntermediario;
  }


  private Vector getCodigoManualRasgoDeChaveta(Workingstep WS){
    Vector _codigoIntermediario = new Vector();

    double F = 0.0;

    double deltaDeAproximacao = 5.0;

    KeyWay kwTmp = (KeyWay)WS.featureDoWorkingstep._featuresDaFU.firstElement();

    _codigoIntermediario.add(getLinhaDoCodigoG() +
                             "(Operacao - CICLO MANUAL RASGO DE CHAVETA)");

    _codigoIntermediario.add(getLinhaDoCodigoG() + "G97S800M15");



    _codigoIntermediario.add(getLinhaDoCodigoG() + "M19");

    //Ir para o plano de seguranca
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeSeguranca.z));

    //Rotaciona para o angulo zero
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G28C0");

    //Posiciona no angulo desejado
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0X" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.x) +
                             "Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z) +
                             "C" + MyMath.arredondaDouble(kwTmp.anguloInicial)
                             );
    F = 0.16;

    //Movimenta a ferramenta ate o comprimento desejado
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G01Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z -
                                                    deltaDeAproximacao -
                                                    kwTmp.L1) +
                             "F" + MyMath.arredondaDouble(F));

    //Retorna para o plano de aproximacao
    _codigoIntermediario.add(getLinhaDoCodigoG() + "G0Z" +
                             MyMath.arredondaDouble(WS.planoDeAproximacao.z));

    _codigoIntermediario.add(getLinhaDoCodigoG() + "M17");

    return _codigoIntermediario;
  }

  /**
   *
   * @param v Vector
   * @param blocoCodigoG Vector
   * @return Vector atualiza o vetor codigoG, inserindo no final dele o vetor
   *   blocoCodigoG
   */
  private Vector insereNoVetor(Vector v, Vector blocoCodigoG) {
    int sizeBloco = blocoCodigoG.size();
    for (int i = 0; i < sizeBloco; i++) {
      v.add(blocoCodigoG.elementAt(i));
    }
    return v;
  }

  private Vector getPerfil(Workingstep WS) {
    Vector perfil = new Vector();
    Vector _featuresDaFUTmp;

    String funcaoAtual = "";
    String funcaoTmp = null;
    double xAtual = 0.0;
    double xTmp = 0.0;
    double wTmp = 0.0;
    double fAtual = 0.0;
    double fTmp = 0.0;
    double R = 0.0;
    int size;
    Feature tmp;

    if (WS.featureDoWorkingstep.tipo == FeatureDeUsinagem.BLOCO_EXTERNO) { //crescente
      _featuresDaFUTmp = WS.featureDoWorkingstep._featuresDaFU;
      size = _featuresDaFUTmp.size();
      for (int i = 0; i < size; i++) {
        tmp = (Feature) _featuresDaFUTmp.elementAt(i);
        String blocoTmp = getLinhaDoCodigoG();

        switch (tmp.Tipo) {
          case 0:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(wTmp));
            break;
          case Feature.FACESTRAIGHT:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
            }
            break;
          case Feature.FACETAPERED:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + wTmp);
            break;
          case Feature.ODSTRAIGHT:
            funcaoTmp = "G1";
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(wTmp));
            break;
          case Feature.ODTAPERED:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = -tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(wTmp));
            break;
          case Feature.ODCONCAVE:
            ODConcave odConcaveTmp = (ODConcave) tmp;
            xTmp = odConcaveTmp.D2;
            wTmp = -odConcaveTmp.L1;
            R = odConcaveTmp.R;

            if (isHorario(odConcaveTmp)) funcaoTmp = "G2";
            else funcaoTmp = "G3";

            if (funcaoAtual != funcaoTmp) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            xAtual = xTmp;
            blocoTmp += "X" + MyMath.arredondaDouble(xTmp) + "W" +
                MyMath.arredondaDouble(wTmp) + "R" +
                MyMath.arredondaDouble(R);
            break;
          case Feature.ODCONVEX:
            ODConvex odConvexTmp = (ODConvex) tmp;
            xTmp = odConvexTmp.D2;
            wTmp = -odConvexTmp.L1;
            R = odConvexTmp.R;

            if (isHorario(odConvexTmp)) funcaoTmp = "G2";
            else funcaoTmp = "G3";

            if (funcaoAtual != funcaoTmp) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            xAtual = xTmp;
            blocoTmp += "X" + MyMath.arredondaDouble(xTmp) + "W" +
                MyMath.arredondaDouble(wTmp) + "R" +
                MyMath.arredondaDouble(R);
            break;
        }
        perfil.add(blocoTmp);

      }
    }
    else if (WS.featureDoWorkingstep.tipo == FeatureDeUsinagem.GROOVECOMPLEXO_EXTERNO) { //decrescente
      _featuresDaFUTmp = ( (GrooveComplexo) WS.featureDoWorkingstep.
                          _featuresDaFU.elementAt(0)).features;
      size = _featuresDaFUTmp.size();
      for (int i = 0; i < size; i++) {
        String blocoTmp = getLinhaDoCodigoG();
        tmp = (Feature) _featuresDaFUTmp.elementAt(i);
        switch (tmp.Tipo) {
          case 0:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(wTmp));
            break;
          case Feature.FACESTRAIGHT:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
            }
            break;
          case Feature.FACETAPERED:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(wTmp));
            break;
          case Feature.ODSTRAIGHT:
            funcaoTmp = "G1";
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(wTmp));
            break;
          case Feature.ODTAPERED:
            funcaoTmp = "G1";
            xTmp = tmp.D2;
            wTmp = tmp.L1;
            if (!funcaoTmp.equals(funcaoAtual)) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            if (xTmp != xAtual) {
              xAtual = xTmp;
              blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
            }
            if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(wTmp));
            break;
          case Feature.ODCONCAVE:
            ODConcave odConcaveTmp = (ODConcave) tmp;
            xTmp = odConcaveTmp.D2;
            wTmp = odConcaveTmp.L1;
            R = odConcaveTmp.R;

            if (isHorario(odConcaveTmp)) funcaoTmp = "G2";
            else funcaoTmp = "G3";

            if (funcaoAtual != funcaoTmp) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            xAtual = xTmp;
            blocoTmp += "X" + MyMath.arredondaDouble(xTmp) + "W" +
                MyMath.arredondaDouble(wTmp) + "R" +
                MyMath.arredondaDouble(R);
            break;
          case Feature.ODCONVEX:
            ODConvex odConvexTmp = (ODConvex) tmp;
            xTmp = odConvexTmp.D2;
            wTmp = odConvexTmp.L1;
            R = odConvexTmp.R;

            if (isHorario(odConvexTmp)) funcaoTmp = "G2";
            else funcaoTmp = "G3";

            if (funcaoAtual != funcaoTmp) {
              funcaoAtual = funcaoTmp;
              blocoTmp += funcaoAtual;
            }
            xAtual = xTmp;
            blocoTmp += "X" + MyMath.arredondaDouble(xTmp) + "W" +
                MyMath.arredondaDouble(wTmp) + "R" +
                MyMath.arredondaDouble(R);
            break;
        }
        perfil.add(blocoTmp);

      }
    }

    return perfil;
  }


  private Vector gerarPerfil(Workingstep WS, String modo){
    Vector perfil = new Vector();
    Vector _featuresDaFUTmp;

    String funcaoAtual = "";
    String funcaoTmp = null;
    double xAtual = 0.0;
    double xTmp = 0.0;
    double wTmp = 0.0;
    double fAtual = 0.0;
    double fTmp = 0.0;
    double R = 0.0;
    int size;
    Feature tmp;
    int produto = 1;

    FeatureDeUsinagem fuTmp = WS.featureDoWorkingstep;
    if(fuTmp.tipo == FeatureDeUsinagem.GROOVECOMPLEXO_EXTERNO || fuTmp.tipo == FeatureDeUsinagem.GROOVECOMPLEXO_INTERNO){
      _featuresDaFUTmp = ((GrooveComplexo)WS.featureDoWorkingstep._featuresDaFU.firstElement()).features;
    }
    else if(fuTmp.tipo == FeatureDeUsinagem.SPLINE_EXTERNA){
      Vector pontos = ((ODSplineVirtual)WS.featureDoWorkingstep._featuresDaFU.firstElement()).pontos;

      _featuresDaFUTmp = new Vector();
      Ponto2D inicioTmp = (Ponto2D)pontos.elementAt(0);
      for(int i = 1; i < pontos.size(); i++){
        Ponto2D fimTmp = (Ponto2D)pontos.elementAt(i);
        ODTapered oTmp = new ODTapered();

        oTmp.D1 = inicioTmp.x;
        oTmp.D2 = fimTmp.x;
        oTmp.L1 = fimTmp.z;

        _featuresDaFUTmp.add(oTmp);
        inicioTmp = fimTmp;
      }
    }
    else if(fuTmp.tipo == FeatureDeUsinagem.SPLINE_INTERNA){
      Vector pontos = ( (IDSplineVirtual) WS.featureDoWorkingstep._featuresDaFU.
                       firstElement()).pontos;

      _featuresDaFUTmp = new Vector();
      Ponto2D inicioTmp = (Ponto2D) pontos.elementAt(0);
      for (int i = 1; i < pontos.size(); i++) {
        Ponto2D fimTmp = (Ponto2D) pontos.elementAt(i);
        ODTapered oTmp = new ODTapered();

        oTmp.D1 = inicioTmp.x;
        oTmp.D2 = fimTmp.x;
        oTmp.L1 = fimTmp.z;

        _featuresDaFUTmp.add(oTmp);
        inicioTmp = fimTmp;
      }
    }
    else{
      _featuresDaFUTmp = WS.featureDoWorkingstep._featuresDaFU;
    }

    if(modo == "invertido"){
      _featuresDaFUTmp = InversorDeFeatures.getFeaturesInvertido(
          _featuresDaFUTmp);
      produto = -1;
    }

    size = _featuresDaFUTmp.size();
    for(int i = 0; i < size; i++){
      tmp = (Feature) _featuresDaFUTmp.elementAt(i);
      String blocoTmp = getLinhaDoCodigoG();

      switch (tmp.Tipo) {
        case 0:
          funcaoTmp = "G1";
          xTmp = tmp.D2;
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (xTmp != xAtual) {
            xAtual = xTmp;
            blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
          }
          if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(produto*wTmp));
          break;
        case Feature.FACESTRAIGHT:
          funcaoTmp = "G1";
          xTmp = tmp.D2;
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (xTmp != xAtual) {
            xAtual = xTmp;
            blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
          }
          break;
        case Feature.FACETAPERED:
          funcaoTmp = "G1";
          xTmp = tmp.D2;
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (xTmp != xAtual) {
            xAtual = xTmp;
            blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
          }
          if (wTmp != 0) blocoTmp += ("W" + produto*wTmp);
          break;
        case Feature.ODSTRAIGHT:
          funcaoTmp = "G1";
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(produto*wTmp));
          break;
        case Feature.ODTAPERED:
          funcaoTmp = "G1";
          xTmp = tmp.D2;
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (xTmp != xAtual) {
            xAtual = xTmp;
            blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
          }
          if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(produto*wTmp));
          break;
        case Feature.ODCONCAVE:
          ODConcave odConcaveTmp = (ODConcave) tmp;
          xTmp = odConcaveTmp.D2;
          wTmp = -odConcaveTmp.L1;
          R = odConcaveTmp.R;

          if (isHorario(odConcaveTmp)) funcaoTmp = "G2";
          else funcaoTmp = "G3";

          if (funcaoAtual != funcaoTmp) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          xAtual = xTmp;
          blocoTmp += "X" + MyMath.arredondaDouble(xTmp) + "W" +
              MyMath.arredondaDouble(produto*wTmp) + "R" +
              MyMath.arredondaDouble(R);
          break;
        case Feature.ODCONVEX:
          ODConvex odConvexTmp = (ODConvex) tmp;
          xTmp = odConvexTmp.D2;
          wTmp = -odConvexTmp.L1;
          R = odConvexTmp.R;

          if (isHorario(odConvexTmp)) funcaoTmp = "G2";
          else funcaoTmp = "G3";

          if (funcaoAtual != funcaoTmp) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          xAtual = xTmp;
          blocoTmp += "X" + MyMath.arredondaDouble(xTmp) + "W" +
              MyMath.arredondaDouble(produto*wTmp) + "R" +
              MyMath.arredondaDouble(R);
          break;
        case Feature.IDCONCAVE:
          break;
        case Feature.IDCONVEX:
          break;
        case Feature.IDSTRAIGHT:
          funcaoTmp = "G1";
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(produto*wTmp));
          break;
        case Feature.IDTAPERED:
          funcaoTmp = "G1";
          xTmp = tmp.D2;
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (xTmp != xAtual) {
            xAtual = xTmp;
            blocoTmp += ("X" + MyMath.arredondaDouble(xAtual));
          }
          if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(produto*wTmp));
          break;
        case Feature.ODSPLINE_VIRTUAL:
          funcaoTmp = "G1";
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(produto*wTmp));
          break;
        case Feature.IDSPLINE_VIRTUAL:
          funcaoTmp = "G1";
          wTmp = -tmp.L1;
          if (!funcaoTmp.equals(funcaoAtual)) {
            funcaoAtual = funcaoTmp;
            blocoTmp += funcaoAtual;
          }
          if (wTmp != 0) blocoTmp += ("W" + MyMath.arredondaDouble(produto*wTmp));
          break;
      }
      perfil.add(blocoTmp);
    }

    //System.out.println(getCodigoGTxT(perfil));

    return perfil;
  }


  private boolean isHorario(Feature f) {
    int tipo = f.Tipo;
    if (tipo == Feature.ODCONCAVE) {
      if (f.D2 > f.D1)return true;
      else return false;
    }
    if (tipo == Feature.ODCONVEX) {
      if (f.D2 > f.D1)return false;
      else return true;
    }
    else return false; //so para nao dar erro de compilacao
  }

  public String getCodigoGTxT(Vector codigoG) {
    int size = codigoG.size();
    String resposta = "";
    for (int i = 0; i < size; i++) {
      resposta += (codigoG.elementAt(i)) + "\n";
    }
    return resposta;
  }

}


