package webcapp_01_0_1;

import java.util.Vector;
import features.*;
import pontos.Ponto2D;
import util.*;
import featureseixoc.*;

/**
 *
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author not attributable
 * @version 1.0
 */
public class DecomposicaoOrientadaAOperacao {
  public InfoFeature infoFeature;
  public InfoDecomposicaoOrientadaAGeometria infoDOG;

  public InfoDecomposicaoOrientadaAOperacao infoDOO;
  public Vector workingsteps;

  public Maquina maquinaUtilizada;

  public DecomposicaoOrientadaAOperacao(InfoFeature infoFeature, InfoDecomposicaoOrientadaAGeometria infoDOG) {
    this.infoDOG = infoDOG;
    this.infoFeature = infoFeature;

    System.out.println("===>Iniciando Decomposicao Orientada A Operacao<===");

    //Encontra maquina utilizada
    this.maquinaUtilizada = getMaquinaUtilizada();

    //Encontra os workingsteps
    this.workingsteps = getWorkingsteps();
    corrigePlanos();//corrige os planos

    //Cria a info decomposicao orientada a operacao.
    this.infoDOO = getInfoDecomposicaoOrientadaAOperacao();

    //Imprime
    imprime();

    System.out.println("===>Finalizando Decomposicao Orientada A Operacao<===");
  }

  /**
   * Cria o vetor de vetores de workingsteps.
   *
   * @return Vector
   */
  public Vector getWorkingsteps(){
    Vector workingstepsTmp = new Vector();

    int sizeI = this.infoDOG.fuDoSetupN.size();
    for(int i = 0; i < sizeI; i++){
      Vector wsSetup = new Vector();
      Vector featuresDeUsinagemTmp = (Vector)this.infoDOG.fuDoSetupN.elementAt(i);

      int sizeJ = featuresDeUsinagemTmp.size();
      for(int  j = 0; j < sizeJ; j++){
        FeatureDeUsinagem fuTmp = (FeatureDeUsinagem)featuresDeUsinagemTmp.elementAt(j);

        Workingstep wsTmp = new Workingstep(fuTmp);
        wsTmp.operacaoDeUsinagem = getOperacaoDeUsinagem(fuTmp);
        setarPlanos(wsTmp);

        wsSetup.add(wsTmp);//adiciona ao vetor do setup atual
      }
      workingstepsTmp.add(wsSetup);//adiciona ao vetor de todos os setups
    }

    return workingstepsTmp;
  }

  /**
   * Funcao para encontrar qual maquina sera utilizada.
   * No caso ela deve somente retornar uma maquina com os dados do
   * torno que esta sendo utilizado.
   *
   * @return Maquina
   */
  public Maquina getMaquinaUtilizada(){
    return new Maquina();
  }

  /**
   * Encontra todas as operacoes de usinagem possiveis para resolver
   * o workingstep em questao.
   *
   * @param featureDeUsinagem FeatureDeUsinagem
   * @return OperacaoDeUsinagem[]
   */
  public OperacaoDeUsinagem[] getOperacaoDeUsinagem(FeatureDeUsinagem
      featureDeUsinagem) {
    OperacaoDeUsinagem[] operacaoDeUsinagem;
    Vector operacaoDeUsinagemTmp = new Vector();

    OperacaoDeUsinagem operacaoDeU;
    switch (featureDeUsinagem.tipo) {
      case FeatureDeUsinagem.FACE:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.FACEAMENTO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.FURO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.FURO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.tipo);

        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.FURO_ACIONADO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.FURO_ACIONADO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.tipo);

        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.BLOCO_EXTERNO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.TORNEAMENTO_EXTERNO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.BLOCO_INTERNO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.TORNEAMENTO_INTERNO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.ROSCA_EXTERNA:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.ROSCAMENTO_EXTERNO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.ROSCA_INTERNA:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.ROSCAMENTO_INTERNO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.RECARTILHADO:
        operacaoDeUsinagemTmp.add(new OperacaoDeUsinagem(OperacaoDeUsinagem.
            RECARTILHADO));
        break;
      case FeatureDeUsinagem.GROOVE_EXTERNO:
        operacaoDeUsinagemTmp.add(new OperacaoDeUsinagem(OperacaoDeUsinagem.
            SANGRAMENTO_EXTERNO));
        operacaoDeUsinagemTmp.add(new OperacaoDeUsinagem(OperacaoDeUsinagem.
            TORNEAMENTOZIGZAG_EXTERNO));
        break;
      case FeatureDeUsinagem.GROOVE_INTERNO:
        operacaoDeUsinagemTmp.add(new OperacaoDeUsinagem(OperacaoDeUsinagem.
            SANGRAMENTO_INTERNO));
        operacaoDeUsinagemTmp.add(new OperacaoDeUsinagem(OperacaoDeUsinagem.
            TORNEAMENTOZIGZAG_INTERNO));
        break;
      case FeatureDeUsinagem.GROOVECOMPLEXO_EXTERNO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.SANGRAMENTO_EXTERNO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.GROOVECOMPLEXO_INTERNO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.SANGRAMENTO_INTERNO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.SPLINE_EXTERNA:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.
                                             SPLINE_EXTERNA);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.SPLINE_INTERNA:
        break;
      case FeatureDeUsinagem.PADRAO_DE_FURO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.FURO_ACIONADO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.RASGO_DE_CHAVETA:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.RASGO_DE_CHAVETA);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      default:
        MyMath.alert("Tentado criar operacao de usinagem nao reconhecida.");
        break;
    }

    //Transforma o vetor em array
    int size = operacaoDeUsinagemTmp.size();
    operacaoDeUsinagem = new OperacaoDeUsinagem[size];
    for (int i = 0; i < size; i++) {
      operacaoDeUsinagem[i] = (OperacaoDeUsinagem) operacaoDeUsinagemTmp.
          elementAt(i);
    }

    return operacaoDeUsinagem;
  }

  /**
   * Encontra a tecnologia de usinagem.
   * Atualmente ela retorna valores quaisqueres. Ainda tem que implementar
   * a funcao para que ela encontre as tecnologias de usinagem baseados
   * no workingstep e principalmente na operacao de usinagem.
   *
   * @return TecnologiaDeUsinagem
   */
  public TecnologiaDeUsinagem getTecnologiaDeUsinagem() {
    TecnologiaDeUsinagem tecnologiaDeUsinagem = new TecnologiaDeUsinagem();

    tecnologiaDeUsinagem.Ap = 2;
    tecnologiaDeUsinagem.Vc = 300;
    tecnologiaDeUsinagem.F = 0.2;
    tecnologiaDeUsinagem.numeroDePasses = 3;

    return tecnologiaDeUsinagem;
  }

  /**
   * Encontra a ferramenta que sera utilizada, baseando-se no tipo de operacao
   * de usinagem utilizada.
   *
   * @param tipo int
   * @return FerramentaUtilizada[]
   */
  public FerramentaUtilizada[] getFerramentaUtilizada(int tipo) {
    FerramentaUtilizada[] ferramentaUtilizada;
    FerramentaUtilizada tmp;
    Vector ferramentaUtilizadaTmp = new Vector();

    /*
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 5;
        tmp.numDeCompensacao = 5;
        tmp.descricao = "DESBASTE GERAL";
        ferramentaUtilizadaTmp.add(tmp);
     */

    switch (tipo) {
      case OperacaoDeUsinagem.FACEAMENTO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 7;
        tmp.numDeCompensacao = 7;
        tmp.descricao = "DESBASTE GERAL EXTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.FURO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 4;
        tmp.numDeCompensacao = 4;
        tmp.descricao = "FURACAO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.FURO_ACIONADO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 2;
        tmp.numDeCompensacao = 2;
        tmp.descricao = "FURACAO ACIONADA";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.TORNEAMENTO_EXTERNO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 7;
        tmp.numDeCompensacao = 7;
        tmp.descricao = "DESBASTE GERAL EXTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.TORNEAMENTO_INTERNO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 9;
        tmp.numDeCompensacao = 9;
        tmp.descricao = "DESBASTE GERAL INTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.SANGRAMENTO_EXTERNO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 3;
        tmp.numDeCompensacao = 3;
        tmp.descricao = "SANGRAMENTO EXTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.SANGRAMENTO_INTERNO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 9;
        tmp.numDeCompensacao = 9;
        tmp.descricao = "SANGRAMENTO INTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.ROSCAMENTO_EXTERNO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 1;
        tmp.numDeCompensacao = 1;
        tmp.descricao = "ROSCAMENTO EXTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.ROSCAMENTO_INTERNO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 6;
        tmp.numDeCompensacao = 6;
        tmp.descricao = "ROSCAMENTO INTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.SPLINE_EXTERNA:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 11;
        tmp.numDeCompensacao = 11;
        tmp.descricao = "SPLINE INTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.RASGO_DE_CHAVETA:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 10;
        tmp.numDeCompensacao = 10;
        tmp.descricao = "FRESAMENTO EXTERNO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      default:
        MyMath.alert("Tentou encontrar uma ferramenta para\num tipo de operacao de usinagem\nque ainda naum e tratado");
        break;
    }

    //Transforma o vetor em array
    int size = ferramentaUtilizadaTmp.size();
    ferramentaUtilizada = new FerramentaUtilizada[size];
    for (int i = 0; i < size; i++) {
      ferramentaUtilizada[i] = (FerramentaUtilizada) ferramentaUtilizadaTmp.
          elementAt(i);
    }

    return ferramentaUtilizada;
  }

  /**
   * Seta os planos de aproximacao e de seguranca do workingstep de entrada.
   *
   * @param WS Workingstep
   */
  public void setarPlanos(Workingstep WS) {
    double deltaAproximacao = 5, deltaSeguranca = 10;
    Ponto2D planoTmp = new Ponto2D(0, 0);
    Ponto2D planoDeSeguranca = new Ponto2D(0, 0);
    Ponto2D planoDeAproximacao = new Ponto2D(0, 0);
    FeatureDeUsinagem fu;
    Feature tmp;
    String tipo;

    fu = WS.featureDoWorkingstep;
    switch (fu.tipo) {
      case FeatureDeUsinagem.FACE:
        tipo = "Faceamento";
        tmp = (Feature) fu._featuresDaFU.lastElement();

        planoTmp.z = tmp.L1;
        planoTmp.x = tmp.D2;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z;
        planoDeAproximacao.x = planoTmp.x + deltaAproximacao;
        break;
      case FeatureDeUsinagem.FURO:
        tipo = "Furo";

        planoTmp.z = 0.0;
        planoTmp.x = 0.0;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x;

        planoDeAproximacao.z = planoTmp.z - deltaAproximacao;
        planoDeAproximacao.x = planoTmp.x;
        break;
      case FeatureDeUsinagem.BLOCO_EXTERNO:
        tipo = "Torneamento Externo";
        tmp = (Feature) fu._featuresDaFU.lastElement();

        planoTmp.z = fu.origem.z;
        planoTmp.x = tmp.D2;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z - deltaAproximacao;
        planoDeAproximacao.x = planoTmp.x;
        break;
      case FeatureDeUsinagem.BLOCO_INTERNO:
        tipo = "Torneamento Interno";
        tmp = (Feature) fu._featuresDaFU.lastElement();

        planoTmp.z = fu.origem.z;
        planoTmp.x = tmp.D2;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x - deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z - deltaAproximacao;
        planoDeAproximacao.x = planoTmp.x;
        break;
      case FeatureDeUsinagem.GROOVECOMPLEXO_EXTERNO:
        tipo = "Groove Complexo Externo";

        planoTmp.z = fu.origem.z;
        planoTmp.x = fu.origem.x;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z;
        planoDeAproximacao.x = planoTmp.x + deltaAproximacao;
        break;
      case FeatureDeUsinagem.GROOVECOMPLEXO_INTERNO:
        tipo = "Groove Complexo Interno";

        planoTmp.z = fu.origem.z;
        planoTmp.x = fu.origem.x;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x - deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z;
        planoDeAproximacao.x = planoTmp.x - deltaAproximacao;
        break;
      case FeatureDeUsinagem.ROSCA_EXTERNA:
        tipo = "Rosca Externa";
        tmp = (Feature) fu._featuresDaFU.firstElement();

        Rosca rosca = ( (ODStraight) tmp).rosca;

        planoTmp.z = fu.origem.z + rosca.inicio;
        planoTmp.x = fu.origem.x;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z;
        planoDeAproximacao.x = planoTmp.x + deltaAproximacao;
        break;
      case FeatureDeUsinagem.ROSCA_INTERNA:
        tipo = "Rosca Interna";
        tmp = (Feature) fu._featuresDaFU.firstElement();

        Rosca rosca2 = ( (ODStraight) tmp).rosca;

        planoTmp.z = fu.origem.z + rosca2.inicio;
        planoTmp.x = fu.origem.x;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x - deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z;
        planoDeAproximacao.x = planoTmp.x - deltaAproximacao;
        break;
      case FeatureDeUsinagem.SPLINE_EXTERNA:
        tipo = "Spline Externa";

        tmp = (Feature) fu._featuresDaFU.lastElement();

        planoTmp.z = fu.origem.z;
        planoTmp.x = tmp.D2;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z - deltaAproximacao;
        planoDeAproximacao.x = planoTmp.x;

        break;
      case FeatureDeUsinagem.SPLINE_INTERNA:
        tipo = "Spline Interna";

        tmp = (Feature) fu._featuresDaFU.lastElement();

        planoTmp.z = fu.origem.z;
        planoTmp.x = tmp.D2;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x - deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z - deltaAproximacao;
        planoDeAproximacao.x = planoTmp.x;

        break;
      case FeatureDeUsinagem.PADRAO_DE_FURO:
        tipo = "Padrao de Furo";

        //HolePattern cTmp = (HolePattern)fu._featuresDaFU.firstElement();

        planoTmp.z = fu.origem.z;
        planoTmp.x = fu.origem.x;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z - deltaAproximacao;
        planoDeAproximacao.x = planoTmp.x;

        break;
      case FeatureDeUsinagem.RASGO_DE_CHAVETA:
        tipo = "Rasgo de Chaveta";

        planoTmp.z = fu.origem.z;
        planoTmp.x = fu.origem.x;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z - deltaAproximacao;
        planoDeAproximacao.x = planoTmp.x;

        break;
      default:
        MyMath.alert("Tentando encontrar planos em\num Feature de Usinagem que\nainda nao e tratada.\n(setarPlanos)");
        tipo = "Else";
        break;
    }
    WS.planoDeSeguranca = planoDeSeguranca;
    WS.planoDeAproximacao = planoDeAproximacao;
  }


  /**
   * Faz a transladacao dos pontos para que os workingsteps fiquem na posicao
   * correta para serem usinadas.
   */
  public void corrigePlanos() {
    int sizeI = this.workingsteps.size();
    for (int i = 0; i < sizeI; i++) {
      Vector wsDoSetupI = (Vector)this.workingsteps.elementAt(i);

      int sizeJ = wsDoSetupI.size();
      if (i == 0) { //muda os planos do primeiro setup
        Workingstep tmp;
        for (int j = 0; j < sizeJ; j++) {
          tmp = (Workingstep) wsDoSetupI.elementAt(j);
          tmp.planoDeAproximacao.z *= -1;
          tmp.planoDeAproximacao.z += (this.infoDOG.blankUtilizado.L1 - 2);
          tmp.planoDeSeguranca.z *= -1;
          tmp.planoDeSeguranca.z += (this.infoDOG.blankUtilizado.L1 - 2);
        }
      }
      else { //muda os planos do segundo setup
        Workingstep tmp;
        for (int j = 0; j < sizeJ; j++) {
          tmp = (Workingstep) wsDoSetupI.elementAt(j);
          tmp.planoDeAproximacao.z *= -1;
          tmp.planoDeAproximacao.z += (this.infoDOG.blankUtilizado.L1 - 2);
          tmp.planoDeSeguranca.z *= -1;
          tmp.planoDeSeguranca.z += (this.infoDOG.blankUtilizado.L1 - 2);
        }
      }
    }
  }

  /**
   * Cria e retorna a info decomposicao orientada a operacao.
   *
   * @return InfoDecomposicaoOrientadaAOperacao
   */
  public InfoDecomposicaoOrientadaAOperacao
      getInfoDecomposicaoOrientadaAOperacao() {
    if (this.infoDOO == null) {
      this.infoDOO = new
          InfoDecomposicaoOrientadaAOperacao();

      this.infoDOO.blankUtilizado = this.infoDOG.blankUtilizado;
      this.infoDOO.maquinaUtilizada = this.maquinaUtilizada;
      this.infoDOO.setupN = this.workingsteps;
    }

    return this.infoDOO;
  }

  public void imprime() {
    Vector tmp;

    System.out.println("\n##############################################");
    System.out.println("DECOMPOSICAO ORIENTADA A OPERACAO:\n");
    System.out.println("---> Ainda tem que imprimir os dados da operacao <--");

    int sizeI = this.workingsteps.size();
    for (int i = 0; i < sizeI; i++) {
      System.out.println("\n\tSETUP numero: " + (i + 1));
      tmp = (Vector)this.workingsteps.elementAt(i);
      int sizeJ = tmp.size();
      for (int j = 0; j < sizeJ; j++) {
        System.out.println("\t\tWORKINGSTEP numero: " + (j + 1));
        Workingstep wsTmp = (Workingstep) tmp.elementAt(j);
        System.out.println("\t\t\tFeatureDeUsinagem Tipo: " +
                           wsTmp.featureDoWorkingstep.tipo);
        System.out.println("\t\t\tPlanoDeSeguranca: Z= " +
                           wsTmp.planoDeSeguranca.z + " X= " +
                           wsTmp.planoDeSeguranca.x);
        System.out.println("\t\t\tPlanoDeAproximacao: Z= " +
                           wsTmp.planoDeAproximacao.z + " X= " +
                           wsTmp.planoDeAproximacao.x);

        System.out.println("\t\t\tOperacoes de Usinagem:");
        int sizeK = wsTmp.operacaoDeUsinagem.length;
        for(int k = 0; k < sizeK; k++){
          OperacaoDeUsinagem opTmp = wsTmp.operacaoDeUsinagem[k];
          System.out.print("\t\t\t\tTipo: ");
          switch(opTmp.tipo){
            case OperacaoDeUsinagem.FACEAMENTO:
              System.out.println("Faceamento");
              break;
            case OperacaoDeUsinagem.PERFILAMENTO:
              System.out.println("Perfilamento");
              break;
            case OperacaoDeUsinagem.RECARTILHADO:
              System.out.println("Recartilhado");
              break;
            case OperacaoDeUsinagem.ROSCAMENTO_EXTERNO:
              System.out.println("Roscamento Externo");
              break;
            case OperacaoDeUsinagem.ROSCAMENTO_INTERNO:
              System.out.println("Roscamento Interno");
              break;
            case OperacaoDeUsinagem.SANGRAMENTO_EXTERNO:
              System.out.println("Sangramento Externo");
              break;
            case OperacaoDeUsinagem.SANGRAMENTO_INTERNO:
              System.out.println("Sangramento Interno");
              break;
            case OperacaoDeUsinagem.TORNEAMENTO_EXTERNO:
              System.out.println("Torneamento Externo");
              break;
            case OperacaoDeUsinagem.TORNEAMENTO_INTERNO:
              System.out.println("Torneamento Interno");
              break;
            case OperacaoDeUsinagem.TORNEAMENTOZIGZAG_EXTERNO:
              System.out.println("Torneamento ZigZag Externo");
              break;
            case OperacaoDeUsinagem.TORNEAMENTOZIGZAG_INTERNO:
              System.out.println("Torneamento ZigZag Interno");
              break;
            default:
              System.out.println("Ainda nao foi tratado");
              break;
          }

          TecnologiaDeUsinagem tcTmp = opTmp.tecnologiaDeUsinagem;
          System.out.println("\t\t\t\tTecnologia De Usinagem:");
          System.out.println("\t\t\t\t\tNumero de passes: " + tcTmp.numeroDePasses);
          System.out.println("\t\t\t\t\tFluido de corte: " + tcTmp.fluidoDeCorte);
          System.out.println("\t\t\t\t\tAp: " + tcTmp.Ap);
          System.out.println("\t\t\t\t\tF: " + tcTmp.F);
          System.out.println("\t\t\t\t\tVc: " + tcTmp.Vc);

          int sizeL = opTmp.ferramentaUtilizada.length;
          System.out.println("\t\t\t\tFerramentas Possiveis:");
          for(int l = 0; l < sizeL; l++){
            FerramentaUtilizada fTmp = opTmp.ferramentaUtilizada[l];
            System.out.println("\t\t\t\t\tDescricao: " + fTmp.descricao);
            System.out.println("\t\t\t\t\tNumero da Magazine: " + fTmp.numDaMagazine);
            System.out.println("\t\t\t\t\tNumero de Compensacao: " + fTmp.numDeCompensacao);
          }
        }
      }
    }

    System.out.println("##############################################");
  }


}
