package webcapp_01_0_1;

import features.*;
import java.util.Vector;
import java.util.Arrays;
import util.*;

/**
 *
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author not attributable
 * @version 1.0
 */
public class DecomposicaoOrientadaASetup {
  public InfoFeature infoFeature;
  public InfoDecomposicaoOrientadaASetup infoDOS;

  public InfoFeatureDeFixacao[] featuresDeFixacao;
  public InfoFeatureDeFixacao featureDeFixacaoUtilizada;

  public InfoSuperficieDelimitadora[] superficieDelimitadoraExterna = null;
  public InfoSuperficieDelimitadora superficieDelimitadoraExternaUtilizada;

  public InfoSuperficieDelimitadora[] superficieDelimitadoraInterna = null;
  public InfoSuperficieDelimitadora superficieDelimitadoraInternaUtilizada;


  /**
   *
   * @param infoFeature InfoFeature
   */
  public DecomposicaoOrientadaASetup(InfoFeature infoFeature) {
    this.infoFeature = infoFeature;

    System.out.println("===>Iniciando Decomposicao Orientada A Setup<===");

    //Feature de fixacao
    this.featuresDeFixacao = getPossiveisFeaturesDeFixacao();
    this.featureDeFixacaoUtilizada = getFeatureDeFixacaoUtilizada(featuresDeFixacao);

    //Superficie delimitadora externa
    this.superficieDelimitadoraExterna = getPossiveisSuperficiesDelimitadorasExternas();
    this.superficieDelimitadoraExternaUtilizada = getInfoSDExternaUtilizada(superficieDelimitadoraExterna);

    //Superfice delimitadora interna
    this.superficieDelimitadoraInterna = getPossiveisSuperficiesDelimitadorasInternas();
    this.superficieDelimitadoraInternaUtilizada = getInfoSDInternaUtilizada(superficieDelimitadoraInterna);

    //Info decomposicao orientada a setup
    this.infoDOS = getInfoDecomposicaoOrientadaASetup();

    //Imprime dados
    imprime();

    System.out.println("===>Finalizando Decomposicao Orientada A Operacao<===");
  }

  /**
   * Encontra todas as features que podem vir a se tornar a featureDeFixacao utilizada
   */
  public InfoFeatureDeFixacao[] getPossiveisFeaturesDeFixacao() {
    int size = this.infoFeature._feature.size();
    InfoFeatureDeFixacao[] tmpFeaturesDeFixacao = new InfoFeatureDeFixacao[size];
    Feature tmp;
    System.out.print("Candidatas a features de fixacao:");
    int j = 0;
    for (int i = 0; i < size; i++) {
      tmp = (Feature) infoFeature._feature.elementAt(i);
      switch (tmp.Tipo) {
        case Feature.ODSTRAIGHT:
          ODStraight tmp2 = (ODStraight) tmp;
          if (tmp2.L1 >= 5) { //5 mm      System.out.println("Eixo");
            //Tem ainda que se considerar se a medida for dada em polegadas

            //Desconsiderar as superficies com rosca ou recartilhado
            if (! ( (tmp2.TemRosca) || (tmp2.TemRecartilhado))) {
              InfoFeatureDeFixacao infoFeatureTmp = new InfoFeatureDeFixacao();
              /**
               * @todo Colocar todas as informacoes inportantes para dentro do vetor
               */
              infoFeatureTmp.indiceDaFeature = tmp.Ordem;
              infoFeatureTmp.feature = tmp;
              //infoFeature.prioridade =  (double)(size- (tmp.Ordem* tmp.D1));
              infoFeatureTmp.prioridade = (double) tmp.Ordem;
              tmpFeaturesDeFixacao[j] = (infoFeatureTmp);
              j++;
            }
          }
          break;
        case Feature.IDSTRAIGHT:
          IDStraight tmp3 = (IDStraight)tmp;
          if(tmp3.L1 >= 5){
            if(!tmp3.TemRosca){
              InfoFeatureDeFixacao infoFeature2 = new InfoFeatureDeFixacao();
              infoFeature2.indiceDaFeature = tmp.Ordem;
              tmpFeaturesDeFixacao[j] = infoFeature2;
              j++;
            }
          }
      }
    }
    /**
     * @todo Calcular a prioridade
     */
    //Parte final
    /**
     * Fazendo um cast e reordenando. Nao pode reordenar direto pois terao
     * campos nulos no Array.
     */
    featuresDeFixacao = new InfoFeatureDeFixacao[j];
    for (int i = 0; i < j; i++) {
      featuresDeFixacao[i] = tmpFeaturesDeFixacao[i];
    }
    Arrays.sort(featuresDeFixacao);
    //  featuresDeFixacao = tmpFeaturesDeFixacao;

    System.out.println("(Candidatas Reordenadas)");
    for (int i = 0; i < j; i++) {
      System.out.print("\tf" + featuresDeFixacao[i].indiceDaFeature);
    }
    System.out.println();
    System.out.println("Total de candidatas a features de fixacao = " + j);
    System.out.println("***********************************************");

    return featuresDeFixacao;
  }


  /**
   * Encontra a feature de fixacao utilizada
   *
   * @param featuresDeFixacao InfoFeatureDeFixacao[]
   * @return InfoFeatureDeFixacao
   */
  public InfoFeatureDeFixacao getFeatureDeFixacaoUtilizada(InfoFeatureDeFixacao[] featuresDeFixacao){
    InfoFeatureDeFixacao infoFeatureDeFixacaoTmp;

    /**
     * @todo Fazer um metodo para encontrar a feature de fixacao utilizada levando
     * em conta todos os dados necessarios
     */
    infoFeatureDeFixacaoTmp = featuresDeFixacao[featuresDeFixacao.length - 1];

    return infoFeatureDeFixacaoTmp;
  }


  /**
   * Encontra todas as possiveis superficiesDelimitadoras externas
   */
  public InfoSuperficieDelimitadora[] getPossiveisSuperficiesDelimitadorasExternas(){
    InfoSuperficieDelimitadora[] superficieDelimitadoraExternaTmp = null;

    Vector externo = this.infoFeature.getFeaturesExternas();

    System.out.println("===>Vetor Externo<===");
    MyMath.imprimeVetorDeFeatures(externo,"");
    System.out.println("===>Vetor Externo<===");

    System.out.println("===>Candidatas a Linha Delimitadora EXTERNA<===");
    superficieDelimitadoraExternaTmp = (new EncontrandoSuperficiesDelimitadoras2(externo)).superficieDelimitadora;
    System.out.println("===>Candidatas a Linha Delimitadora EXTERNA<===");

    return superficieDelimitadoraExternaTmp;
  }

  /**
   * Encontra a melhor superficie delimitadora externa
   *
   * @return InfoSuperficieDelimitadora
   */
  public InfoSuperficieDelimitadora getInfoSDExternaUtilizada(InfoSuperficieDelimitadora[] superficieDelimitadoraExterna){
    if(this.superficieDelimitadoraExterna != null){
      return this.superficieDelimitadoraExterna[this.
          superficieDelimitadoraExterna.length - 1];
    }
    return null;
  }



  /**
   * Encontra todas as possiveis superficiesDelimitadoras internas
   */
  public InfoSuperficieDelimitadora[] getPossiveisSuperficiesDelimitadorasInternas(){
    Vector interno = null;
    InfoSuperficieDelimitadora[] superficieDelimitadoraInternaTmp = null;

    if(this.infoFeature.temInterior){
      interno = this.infoFeature.getFeaturesInternas();

      System.out.println("===>Vetor Interno<===");
      MyMath.imprimeVetorDeFeatures(interno, "");
      System.out.println("===>Vetor Interno<===");

      /**
       * Faz um espelho do vetor de features internas para que ele possa ser tratado
       * da mesma maneira que um vetor de features externas
       */

      double maxDiametroInterno = EspelhoDeFeatures.encontrarMaiorDiametroInterno(interno);
      interno = EspelhoDeFeatures.espelharVerticalmenteVetor(interno, maxDiametroInterno);

      /**
       * E necessario reordenar o vetor interno para que seja possivel chamar a
       * classe "EncontrandoSuperficiesDelimitadoras2"
       */

      int size = interno.size();
      for(int i = 0; i < size; i++){
        Feature tmp = (Feature)interno.elementAt(i);
        tmp.Ordem = i + 1;
      }

      System.out.println("===>Candidatas a Linha Delimitadora INTERNA<===");
      superficieDelimitadoraInternaTmp = (new EncontrandoSuperficiesDelimitadoras2(interno)).superficieDelimitadora;
      System.out.println("===>Candidatas a Linha Delimitadora INTERNA<===");

      /**
       * Refaz o espelho do vetor interno para que suas features voltem a
       * ser como eram antes.
       */

      interno = EspelhoDeFeatures.espelharVerticalmenteVetor(interno, maxDiametroInterno);

      /**
       * Recoloca a ordem original nas features do vetor interno
       */

      for (int i = 0; i < size; i++) {
        Feature tmp = (Feature) interno.elementAt(i);
        tmp.Ordem = this.infoFeature.indiceFeaturesInternas + tmp.Ordem;
      }

      /**
       * Finalizando -> muda o indice das features das candidatas a superficie
       * delimitadora da parte interna, isto para que este indice seja referente
       * ao vetor _feature.
       */

      size = superficieDelimitadoraInternaTmp.length;
      for (int i = 0; i < size; i++) {
        superficieDelimitadoraInternaTmp[i].indiceDaFeature =
            superficieDelimitadoraInternaTmp[i].indiceDaFeature +
            this.infoFeature.indiceFeaturesInternas;
      }

      /**
       * Imprime o resultado final
       */

      System.out.println("===>Candidatas a Linha Delimitadora INTERNA - FINAL<===");
      for(int i = 0; i < size; i++){
        System.out.print("LD[" +
                         superficieDelimitadoraInternaTmp[i].indiceDaFeature +
                         "], prioridade=" +
                         superficieDelimitadoraInternaTmp[i].prioridade + "\t");
      }
      System.out.println("===>Candidatas a Linha Delimitadora INTERNA - FINAL<===");

    }

    return superficieDelimitadoraInternaTmp;
  }


  /**
   * Encontra a melhor superficie delimitadora interna
   *
   * @return InfoSuperficieDelimitadora
   */
  public InfoSuperficieDelimitadora getInfoSDInternaUtilizada(InfoSuperficieDelimitadora[] superficieDelimitadoraInterna){
    if(this.superficieDelimitadoraInterna != null){
      return this.superficieDelimitadoraInterna[this.
          superficieDelimitadoraInterna.length - 1];
    }
    return null;
  }




  /**
   * Cria e retorna a info decomposicao orientada a setup
   *
   * @return InfoDecomposicaoOrientadaASetup
   */
  public InfoDecomposicaoOrientadaASetup
      getInfoDecomposicaoOrientadaASetup() {
    if (infoDOS == null) {
      infoDOS = new InfoDecomposicaoOrientadaASetup(this.
          featureDeFixacaoUtilizada,
          this.superficieDelimitadoraExternaUtilizada,
          this.superficieDelimitadoraInternaUtilizada);
    }

    return infoDOS;
  }

  /**
   * Imprime os dados da infoDecomposicaoOrientadaASetup
   */
  public void imprime() {
    System.out.println("\n##############################################");
    System.out.println("DECOMPOSICAO ORIENTADA A SETUP:\n");

    System.out.println("\tFeatures de Fixacao possiveis:");
    int size = this.featuresDeFixacao.length;
    for (int i = 0; i < size; i++) {
      System.out.println("\t\tFeauture numero: " +
                         this.featuresDeFixacao[i].indiceDaFeature);
    }

    System.out.println("\n\tSuperficies Delimitadoras Externas");
    if (this.superficieDelimitadoraExterna != null) {
      size = this.superficieDelimitadoraExterna.length;
      System.out.println("\t\tSuperficies Delimitadoras Externas Possiveis:");
      for (int i = 0; i < size; i++) {
        System.out.println("\t\t\tFeature numero: " +
                           this.superficieDelimitadoraExterna[i].
                           indiceDaFeature);
      }

      System.out.println("\t\tSuperficie Delimitadora Externa Utilizada: " +
                         this.superficieDelimitadoraExternaUtilizada.
                         indiceDaFeature);
    }
    else
      System.out.println(
          "\t\tNao foram encontradas Superficies Delimitadoras Externas");

    System.out.println("\n\tSuperficies Delimitadoras Internas");
    if (this.superficieDelimitadoraInterna != null) {
      size = this.superficieDelimitadoraInterna.length;
      System.out.println("\t\tSuperficies Delimitadoras Internas Possiveis:");
      for (int i = 0; i < size; i++) {
        System.out.println("\t\t\tFeature numero: " +
                           this.superficieDelimitadoraInterna[i].
                           indiceDaFeature);
      }

      System.out.println("\t\tSuperficie Delimitadora Interna Utilizada: " +
                         this.superficieDelimitadoraInternaUtilizada.
                         indiceDaFeature);
    }
    else
      System.out.println(
          "\t\tNao foram encontradas Superficies Delimitadoras Interna");

    System.out.println("\n##############################################");
  }


}
