package webcapp_01_0_1;

import java.util.*;
import util.*;

import features.*;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class EncontrandoSuperficiesDelimitadoras {
  Vector _feature;
  InfoSuperficieDelimitadora[] superficieDelimitadora;
  public EncontrandoSuperficiesDelimitadoras(Vector _feature) {
    this._feature = _feature;
    InfoFeaturesPorDiametro[] featuresPorD = getFeaturesPorDiametro(_feature);
    String out = saidaGraficaDeFeaturesPorDiametro(featuresPorD);
    System.out.println(out);
    superficieDelimitadora = getPossiveisSuperficiesDelimitadoras(featuresPorD);
    /** @todo Implementar getPossiveisSuperficiesDelimitadoras*/
    setPrioridadeDaSuperficieDelimitadora(superficieDelimitadora);
    /** @todo Implementar setPrioridadeDaSuperficieDelimitadora*/
    Arrays.sort(superficieDelimitadora);//Para ordenar o array appos setar as prioridades
  }

  /**
   * setPrioridadeDaSuperficieDelimitadora
   * Dado Um Array de superfcies delimitadoras de uma forma refinada, tem-se<BR>
   * que qualificar cada uma destas, atraves de suas prioridades.
   * <P>As formas de qualificar sao:<BR>
   *  - Quantidade de features ascendentes (para uso de ciclos fixos)<BR>
   *  - Quantidade de referencias no mesmo setup
   * <\P>
   * @param superficieDelimitadora InfoSuperficieDelimitadora[]
   */


  private void setPrioridadeDaSuperficieDelimitadora(InfoSuperficieDelimitadora[]
      superficieDelimitadora) {
    double totalDaSoma = 0.0;
    int somaFAscendentes = 0;
    int somaFGroove = 0;
    int fReferencias = 0;
    double comprimentoParcial=0.0;
    double comprimentoTotal=0.0;
    double somaComprimento=0.0;
    final double PESOCOMPRIMENTO=1000000.0;
    Feature tmpF;
    int size = superficieDelimitadora.length;
    int somaDe=0;
    for(int i=0;i<size;i++){
      tmpF=(Feature)_feature.elementAt(i);
      comprimentoTotal+=tmpF.L1;//Calcula o comprimento total que e um parmetro de calculo da prioridade
    }

    for(int i=0;i<size;i++){
      InfoSuperficieDelimitadora iSD= superficieDelimitadora[i];
//      Feature fSD=(Feature)_feature.elementAt(iSD.indiceDaFeature-1);
      Feature fSD=iSD.feature;
      int somaAte=iSD.indiceDaFeature;
      for (int accIndice=somaDe;accIndice<somaAte;accIndice++){
        tmpF=(Feature)_feature.elementAt(accIndice);
        tmpF=(Feature)_feature.elementAt(accIndice);
        comprimentoParcial+=tmpF.L1;//Calcula o comprimento parcial que e um parmetro de calculo da prioridade
        if (tmpF.Tipo!=Feature.GROOVESQUARE){
          if (tmpF.D2 >= tmpF.D1) {
            somaFAscendentes++; //Aumenta mais uma ascendente
          }
        }
        else{
          somaFGroove++;
        }
        /**
         * @todo Relaizar a soma com os pesos
         */
        double fatorL=comprimentoParcial/comprimentoTotal;
        if(fatorL<0.5){
           somaComprimento = fatorL*2*PESOCOMPRIMENTO;//fatorL/0.5*PESOCOMPRIMENTO
        }
        else{
          if(fatorL>0.5){
            somaComprimento = (1-fatorL)*2*PESOCOMPRIMENTO;//(1-fatorL)/0.5*PESOCOMPRIMENTO
          }
          else{//fatorL==0,5 melhor caso. completamente balanceado!
            somaComprimento = PESOCOMPRIMENTO;
          }
        }
        /**
         * @todo Possivel falha
         */
        totalDaSoma = somaFAscendentes-somaFGroove;//+somaComprimento;
//        totalDaSoma = /*somaFAscendentes-somaFGroove+*/somaComprimento;
        if (iSD.prioridade<totalDaSoma){
          iSD.prioridade=totalDaSoma;
        }
//        System.out.println("Superficie["+iSD.indiceDaFeature+"]= fAscendentes"+somaFAscendentes);
      }
      /**/
      for (int accIndice=somaDe;accIndice<somaAte;accIndice++){
        tmpF=(Feature)_feature.elementAt(accIndice);
        System.out.println("Superficie["+tmpF.Ordem+"]");

      }
/**/


      somaDe=somaAte;
    }
  }

  /**
   * getPossiveisSuperficiesDelimitadoras
   *
   * @param featuresPorD InfoFeaturesPorDiametro[]
   * @return InfoSuperficieDelimitadora[]
   */
  private InfoSuperficieDelimitadora[] getPossiveisSuperficiesDelimitadoras(
      InfoFeaturesPorDiametro[] featuresPorD) {
    int AccSD = 0;
    final double FOLGA_DMAX = 1.1;
    InfoSuperficieDelimitadora[] possiveisSD = new InfoSuperficieDelimitadora[
        _feature.size()]; //Pior caso. Todas sao superfcies delimitadoras.

    MyMath.InicializarArrayDeInfoSuperficieDelimitadora(possiveisSD);
    int size = featuresPorD.length;
    double dMax = featuresPorD[size - 1].d; //O maior esta na ltima posicao, que e o tamanho do Array (size) menos 1 (comeca no zero).
    int nivel = size - 2; //1 nvel antes do ultimo
    while (dMax <= FOLGA_DMAX * featuresPorD[nivel].d) {
      //Niveis com folga       System.out.println("D["+nivel+"] = "+FOLGA_DMAX*featuresPorD[nivel].d);
      nivel--;
    }
    nivel++; //Para determinar o ltimo que atende a especificacao FOLGA_DMAX
    // Passando todas as features do nvel mais alto para o Array de SD (LD)
    Vector fDoNivel0 = featuresPorD[size - 1].features;
    int fSize = fDoNivel0.size();
    for (int i = 0; i < fSize; i++) {
      possiveisSD[i].indiceDaFeature = ( (Feature) (fDoNivel0.elementAt(i))).
          Ordem;
      possiveisSD[i].feature = ( (Feature) (fDoNivel0.elementAt(i)));
    }
    AccSD = fSize; //Neste moneto o nmero de SDs e o mesmo q o de feature no nvel mais alto.
    /* Apresentacao das LD do nvel 0
         fSize = _feature.size();
         for (int i = 0; i < fSize; i++) {
      System.out.print("LD[" + possiveisSD[i].indiceDaFeature + "]\t");
         }
         System.out.println();
     */
    if (nivel != (size - 1)) { //Se o ltimo nvel nao for o nico
      /**
       * @todo testar envolta das features possveis e ver se tem um Groove.
       */

      for (int j = size - 2; j > nivel - 1; j--) { //Desce os nveis ate atingir o ltimo potencialmente alto
        Vector fDoNivel = featuresPorD[j].features;
        /*int*/
        fSize = fDoNivel.size();
        for (int k = 0; k < fSize; k++) {
          int ordemDaFeature = ( (Feature) (fDoNivel.elementAt(k))).Ordem;
          /**
           * @todo Quando implementar Feature.isGroove , trocar ***.Tipo==Feature.Groo**** por este.
           * (ordemDaFeature - 1) e por que o indice da feature e osua ordem-1
           */
          System.out.println("OrdemDaFeautre:::" + ordemDaFeature);
          if (ordemDaFeature == _feature.size()) { //Para evitar fugir dos limites do Array
            if ( ( (Feature) _feature.elementAt( (ordemDaFeature - 1) - 1)).
                Tipo ==
                Feature.GROOVESQUARE) {
              possiveisSD[AccSD].indiceDaFeature = ( (Feature) (fDoNivel.
                  elementAt(k))).Ordem;
              possiveisSD[AccSD].feature = ( (Feature) (fDoNivel.elementAt(k)));

              AccSD++; //coloca -se ACC depois

              if ( ( (Feature) _feature.elementAt( (ordemDaFeature - 1))).Tipo ==
                  Feature.ODSTRAIGHT) {
                possiveisSD[AccSD].indiceDaFeature = ( (Feature) (fDoNivel.
                    elementAt(k - 1))).Ordem;
                possiveisSD[AccSD].feature = ( (Feature) (fDoNivel0.elementAt(k-1)));

                AccSD++;
              }
            }
          }
          else {
            if ( (ordemDaFeature - 1) == 0) { //Para evitar fugir dos limites do Array
              if ( ( (Feature) _feature.elementAt( /*(ordemDaFeature - 1) + */1)).
                  Tipo ==
                  Feature.GROOVESQUARE) {
                possiveisSD[AccSD].indiceDaFeature = ( (Feature) (fDoNivel.
                    elementAt(k))).Ordem;
                possiveisSD[AccSD].feature = ( (Feature) (fDoNivel0.elementAt(k)));

                AccSD++; //coloca -se ACC depois
                if ( ( (Feature) _feature.elementAt( (ordemDaFeature - 1))).
                    Tipo ==
                    Feature.ODSTRAIGHT) {
                  possiveisSD[AccSD].indiceDaFeature = ( (Feature) (fDoNivel.
                      elementAt(k + 1))).Ordem;
                  possiveisSD[AccSD].feature = ( (Feature) (fDoNivel0.elementAt(k+1)));

                  AccSD++;
                }
              }
            }
            else {
              System.out.println("ordemDaFeature=" + ordemDaFeature);
              if ( ( ( (Feature) _feature.elementAt( (ordemDaFeature - 1) - 1)).
                    Tipo ==
                    Feature.GROOVESQUARE) ||
                  ( ( (Feature) _feature.elementAt( (ordemDaFeature - 1) + 1)).
                   Tipo ==
                   Feature.GROOVESQUARE)) {
                //Circundado por Groove
                /**
                 * @todo Corrigir. Circundado por Groove....
                 * Resolver para o caso de ser uma ODStraight, onde D1=D2, o que leva a mais uma LD....
                 */
                System.out.println("FFFF:::" +_feature.elementAt(ordemDaFeature));
                possiveisSD[AccSD].indiceDaFeature = ordemDaFeature;
                possiveisSD[AccSD].feature = (Feature)_feature.elementAt(ordemDaFeature-1);
                    /*( (Feature) (fDoNivel.elementAt(k))).Ordem;*/
                /*( (Feature) (fDoNivel.elementAt(k))).Ordem;*/
                AccSD++;
                if ( ( ( (Feature) _feature.elementAt( (ordemDaFeature - 1) - 1)).
                      Tipo ==
                      Feature.GROOVESQUARE) &&
                    ( (Feature) _feature.elementAt( (ordemDaFeature - 1))).
                    Tipo ==
                    Feature.ODSTRAIGHT) {
                 int Ordo = ( (Feature) _feature.elementAt( (ordemDaFeature - 1) - 1)).Ordem;
                 possiveisSD[AccSD].indiceDaFeature = ( Ordo);
                 possiveisSD[AccSD].feature = ( (Feature) _feature.elementAt( (ordemDaFeature - 1) - 1));
                  AccSD++;
                }
                if ( ( ( (Feature) _feature.elementAt( (ordemDaFeature - 1) + 1)).
                      Tipo ==
                      Feature.GROOVESQUARE) &&
                    ( (Feature) _feature.elementAt( (ordemDaFeature - 1))).
                    Tipo ==
                    Feature.ODSTRAIGHT) {
                 int Ordo = ( (Feature) _feature.elementAt( (ordemDaFeature - 1) + 1)).Ordem;
                 possiveisSD[AccSD].indiceDaFeature = ( Ordo);
                 possiveisSD[AccSD].feature = ( (Feature) _feature.elementAt( (ordemDaFeature - 1) + 1));
                  AccSD++;
                }

              }
            }
          }
        }
        System.out.println("Algo estranho ocorre na terra dos homens...." + j);
      }
    }
    else {
      System.out.println("Algo estranho ocorre na terra dos elfos....");
    }
    InfoSuperficieDelimitadora[] sD = new InfoSuperficieDelimitadora[AccSD];
    for(int i=0;i<AccSD;i++){
      sD[i]=possiveisSD[i];
    }
    return sD;
  }

  /**
   * saidaGraficaDeFeaturesPorDiametro
   *
   * @param featuresPorD InfoFeaturesPorDiametro[]
   * @return String
   */
  private String saidaGraficaDeFeaturesPorDiametro(InfoFeaturesPorDiametro[]
      featuresPorD) {
    String out = "";
    int size = featuresPorD.length;
    for (int i = 0; i < size; i++) {
      out = out.concat(featuresPorD[i].d + "\t|");
      Vector f = featuresPorD[i].features;
      int sizeF = f.size();
      for (int j = 0; j < sizeF; j++) {
        out = out.concat("  f" + ( (Feature) (f.elementAt(j))).Ordem + "  |");
      }
      out = out.concat("\n");
    }

    return out;
  }

  /**
   * getFeaturesPorDiametro
   *
   * @param _feature Vector
   * @return InfoFeaturesPorDiametro[]
   */
  private InfoFeaturesPorDiametro[] getFeaturesPorDiametro(Vector _feature) {
    int size = _feature.size();
    InfoFeaturesPorDiametro[] fPD = new InfoFeaturesPorDiametro[size]; //O pior caso e quando todas as features diametros diferentes.
    MyMath.InicializaArrayDeInfoFeaturesPorDiametro(fPD);

    final boolean ALOCADO = true;
    final boolean DESALOCADO = false;
    boolean armazenado = DESALOCADO;
    int i = 0;
    int ultimoNivel = 0;
    for (int a = 0; a < size; a++) {
      Feature ftrTmp = (Feature) (_feature.elementAt(a));
      while ( (armazenado == DESALOCADO) && (i < ultimoNivel)) { //Enquanto nao alocado e nao atingiu o ltimo nvel
        if (fPD[i].d == ftrTmp.D2) {
          fPD[i].features.add(ftrTmp);
          armazenado = ALOCADO;
        }
        else {
          i++;
        }
      }
      if (armazenado == DESALOCADO) {
        ultimoNivel++; //Criou-se um novo nvel
        fPD[i].d = ftrTmp.D2;
        fPD[i].features.add(ftrTmp);
        //armazenado = ALOCADO; /*/Nao se pode setar como alocado, senao nao entra no laco acima
      }
      else { //Prepara para o proximo elemento
        i = 0;
        armazenado = DESALOCADO;
      }
    }
    InfoFeaturesPorDiametro[] featuresPorD = new InfoFeaturesPorDiametro[
        ultimoNivel];
    MyMath.CastDeArrayDeInfoFeaturesPorDiametro(featuresPorD, fPD);
    Arrays.sort(featuresPorD); //Ordenando

    return featuresPorD;

  }

}
