package webcapp_01_0_1;

import java.util.Vector;
import features.*;
import util.*;

/**
 *
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author not attributable
 * @version 1.0
 */
public class InfoFeature {
  public Vector _featureOriginal;
  public Vector _feature;
  public Vector _featureInvertido;

  public Vector _featureEixoCOriginal;
  public Vector _featureEixoC;
  public Vector _featureEixoCInvertido;

  public int indiceFeaturesInternas;

  public boolean temInterior = false;

  public InfoFeature(){
  }

  public InfoFeature(Vector _featureOriginal, Vector _featureEixoCOriginal){
    setFeatureOriginal(_featureOriginal, _featureEixoCOriginal);

    //Imprime
    imprime();
  }

  /**
   * Seta o _featureOriginal e cria os outros dois vetores presentes na classe
   * _feature e _featureInvertido.
   *
   * @param _featureOriginal Vector
   */
  public void setFeatureOriginal(Vector _featureOriginal, Vector _featureEixoCOriginal){
    this._featureOriginal = _featureOriginal;
    this._feature = NormalizadorDeFeatures.getFeaturesNormalizadas(this._featureOriginal);
    this._featureInvertido = InversorDeFeatures.getFeaturesInvertido(this._feature);

    this._featureEixoC = _featureEixoCOriginal;
    MyMath.imprimeEixoC(_featureEixoCOriginal);
    //this._featureEixoCInvertido = InversorDeFeatures.getFeaturesEixoCInvertido(this._featureEixoC);

    setIndiceFeaturesInternas(this._feature);
  }

  /**
   * Encontra a primeira feature interna, se ela existir.
   *
   * @param _feature Vector
   */
  public void setIndiceFeaturesInternas(Vector _feature){
    int size = _feature.size();
    for(int i = 0; i < size; i++){
      Feature fTmp = (Feature) _feature.elementAt(i);
      if (fTmp.Tipo == Feature.IDSTRAIGHT || fTmp.Tipo == Feature.IDTAPERED ||
          fTmp.Tipo == Feature.IDCONVEX || fTmp.Tipo == Feature.IDCONCAVE ||
          fTmp.Tipo == Feature.IDCONTOURED){
       this.temInterior = true;
       this.indiceFeaturesInternas = i;
       System.out.println("Indice Features Internas = " + i);
       break;
      }
    }
  }


  /**
   * Retorna um vetor contendo somente as features externas
   *
   * @return Vector
   */
  public Vector getFeaturesExternas(){
    Vector externas = new Vector();
    int fim;

    if(this.temInterior)
      fim = this.indiceFeaturesInternas;
    else
      fim = this._feature.size();


    for(int i = 0; i < fim; i++){
      externas.add(this._feature.elementAt(i));
    }


    return externas;
  }


  /**
   * Retorna um vetor contendo somente as features internas.
   *
   * @return Vector
   */
  public Vector getFeaturesInternas(){
    Vector internas;

    if(this.temInterior){
      internas = new Vector();

      for(int i = this.indiceFeaturesInternas; i < this._feature.size(); i++){
        internas.add(this._feature.elementAt(i));
      }

      return internas;
    }

    return null;
  }

  /**
   * Imprime
   */
  public void imprime(){
    System.out.println("#####################################################");
    System.out.println("INFO FEATURE");

    System.out.println("===>Features Originais<===");
    MyMath.imprimeVetorDeFeatures(this._featureOriginal, "");
    System.out.println("===>Features Originais<===");

    System.out.println("===>Features Normalizadas<===");
    MyMath.imprimeVetorDeFeatures(this._feature, "");
    System.out.println("===>Features Normalizadas<===");

    System.out.println("===>Features Normalizadas Invertidas<===");
    MyMath.imprimeVetorDeFeatures(this._featureInvertido, "");
    System.out.println("===>Features Normalizadas Invertidas<===");

    System.out.println("Tem Interior: " + this.temInterior);
    if(this.temInterior)
      System.out.println("Indice Primeira Feature Interna: " + this.indiceFeaturesInternas);

    System.out.println("#####################################################");
  }


}
