package webcapp_01_0_1;

import java.util.*;
import features.*;
import java.text.DecimalFormat;
import javax.swing.JOptionPane;
import pontos.Ponto2D;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class MyMath_movido_para_pacote_util {

  /**
   * Utilizada para encontrar o maior diametro de um vetor de features internas.
   * Este dado e utilizado para espelhar o vetor interno.
   *
   * @param featuresInternas Vector
   * @return double
   */
  public static double encontrarMaiorDiametroInterno(Vector featuresInternas){
    double maxDiametroInterior = 0.0;

    for (int i = 0; i < featuresInternas.size(); i++) { //encontra o maior diametro para poder inverter
      Feature fTmp = (Feature) featuresInternas.elementAt(i);
      if (fTmp.D1 > maxDiametroInterior)
        maxDiametroInterior = fTmp.D1;
      if (fTmp.D2 > maxDiametroInterior)
        maxDiametroInterior = fTmp.D2;
    }

    return maxDiametroInterior;
  }

  /**
   * Funcao para transformar o vetor de features internas em um vetor semelhate a
   * um vetor de features externas.
   *
   *
   * @param normal Vector
   * @param maxDiametro int
   * @return Vector
   */
  public static Vector espelharVerticalmenteVetor(Vector normal, double maxDiametro){
    Vector espelhado = normal;

    for (int i = 0; i < espelhado.size(); i++) { //espelho
      Feature fTmp = (Feature) espelhado.elementAt(i);
      fTmp.D1 = maxDiametro - fTmp.D1;
      fTmp.D2 = maxDiametro - fTmp.D2;
    }

    return espelhado;
  }

  public static Blank espelharBlank(Blank blankUtilizado, double maxDiametro){
    Blank espelhado = new Blank();

    espelhado.D1 = maxDiametro - blankUtilizado.D1;
    espelhado.D2 = maxDiametro - blankUtilizado.D2;
    espelhado.L1 = blankUtilizado.L1;

    return espelhado;
  }


  /**
     *
     * @param entrada Vector
     * @return Vector
     */
    public static Vector ordenaVectorDeFeatures(Vector entrada){
    Vector saida = new Vector();
    int size = entrada.size();
    Feature[] entradaArray=new Feature[size];
    //Cast para array
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) entrada.elementAt(i);
      entradaArray[i] = tmp;
    }
    Arrays.sort(entradaArray);

    //Cast para vector
    for (int i = 0; i < size; i++) {
      Feature tmp = entradaArray[i];
      saida.add(tmp);
      System.out.println("" + tmp.Ordem);
    }
    return saida;
  }

  /**
   *
   * @param entrada Vector
   * @return Vector
   *
   * Inverte a ordem de features de um vetor
   */
  public static Vector inverteVector(Vector entrada){
    Vector saida = new Vector();

    double D1tmp=0.0;
    double D2tmp=0.0;
    int size = entrada.size();
    for(int i = size-1; i >= 0; i--){
      Feature tmp = (Feature)entrada.elementAt(i);
      D2tmp =tmp.D1;
      D1tmp =tmp.D2;
      tmp.D1=D1tmp;
      tmp.D2=D2tmp;
      saida.add(tmp);
    }

    return saida;
  }


 /**
  *
  * @param entrada Vector
  * @return Vector
  *
  * Inverte os diametros de um vetor de features de entrada, utilizada quando
  * e necessario inverter a ordem das features da peca
  */
 public static Vector inverteDiametros(Vector entrada) {
    Vector saida = new Vector();
    double D1tmp = 0.0;
    double D2tmp = 0.0;
    int size = entrada.size();
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) entrada.elementAt(i);

      D2tmp = tmp.D1;
      D1tmp = tmp.D2;

      tmp.D1 = D1tmp;
      tmp.D2 = D2tmp;
      saida.add(tmp);
    }

    return saida;
  }


  public static Vector colocaAOrdem(Vector entrada){
    int size = entrada.size();
    //alert("Tamanho do vetor de Features:\n" + size);
    for (int i = 0; i < size; i++) {
      Feature tmpFeature = (Feature) entrada.elementAt(i);
      tmpFeature.Ordem = i + 1;
    }
    return entrada;
  }



  //1903 e 2003
  /**
   *
   * @param num double
   * @return double
   *
   * Recebe um double e retorna a string referente a este que sera incluida no CodigoG
   */
  public String arredondaDouble(double num) {
    double round = 0;
    DecimalFormat zeroDigits = new DecimalFormat("0");
    DecimalFormat oneDigit = new DecimalFormat("0.0");
    DecimalFormat twoDigits = new DecimalFormat("0.00");
    DecimalFormat threeDigits = new DecimalFormat("0.000");

    num *= 1000; //multiplica o numero por mil para arredondar para o mais proximo mesmo
    //considerando os milesimos de milimetro

    round = Math.round(num); //arredonda para o valor mais proximo
    round /= 1000; //divide por mil para retornar ao formato original

    //Faz a formatacao do numero arredondado
    //2.000 -> retorna 2
    //1.600 -> retorna 1.6
    //1.570 -> retorna 1.57
    //1.457 -> retorna 1.457
    String tmp = zeroDigits.format(round);
    tmp = tmp.replace(',', '.');
    double roundTmp = Double.parseDouble(tmp);

    if (round - roundTmp == 0) { //retorna o double sem casas decimais
      //return roundTmp;
      //System.out.println(tmp);
      return tmp;
    }
    else {
      tmp = oneDigit.format(round);
      tmp = tmp.replace(',', '.');
      roundTmp = Double.parseDouble(tmp);
      if (round - roundTmp == 0) { //retorna o double com uma casa decimal
        //return roundTmp;
        //System.out.println(roundTmp);
        return tmp;
      }
      else {
        tmp = twoDigits.format(round);
        tmp = tmp.replace(',', '.');
        roundTmp = Double.parseDouble(tmp);
        if (round - roundTmp == 0) { //retona o double com duas casas decimais
          //return roundTmp;
          //System.out.println(roundTmp);
          return tmp;
        }
        else { //retona o double com tres casas decimais
          tmp = threeDigits.format(round);
          tmp = tmp.replace(',', '.');
          //roundTmp = Double.parseDouble(tmp);
          //return roundTmp;
          //System.out.println(roundTmp);
          return tmp;
        }
      }

    }
  }
  //1903 e 2003

  //3103 0504
  /**
   *
   * @param num double
   * @return String
   *
   * Recebe um numero em milimetros e retorna a string equivalente
   * a este valor em micrometros, no formato de uma string
   */
  public String arredondaDoubleMicro(double num){
    DecimalFormat zeroDigits = new DecimalFormat("0");
    String tmp = "";

    tmp = zeroDigits.format(Double.parseDouble(arredondaDouble(num*1000)));

    return tmp;
  }
  //3103 0504

  /**
   * CastDeArrayDeInfoFeaturesPorDiametro
   *
   * @param novo InfoFeaturesPorDiametro[]
   * @param velho InfoFeaturesPorDiametro[]
   */
  public static void CastDeArrayDeInfoFeaturesPorDiametro(
      InfoFeaturesPorDiametro[] novo, InfoFeaturesPorDiametro[] velho) {
      int size = novo.length;
      for(int i=0;i<size;i++){
        novo[i]=velho[i];
      }
  }

  /**
   * InicializaArrayDeInfoFeaturesPorDiametro
   *
   * @param fPD InfoFeaturesPorDiametro[]
   */
  public static void InicializaArrayDeInfoFeaturesPorDiametro(
      InfoFeaturesPorDiametro[] fPD) {
      int size = fPD.length;
      for(int i=0;i<size;i++){
        fPD[i]=new InfoFeaturesPorDiametro();
        fPD[i].features = new Vector();
      }
  }

  /**
   * InicializarArrayDeInfoSuperficieDelimitadora
   *
   * @param infoSuperficieDelimitadora InfoSuperficieDelimitadora[]
   */
  public static void InicializarArrayDeInfoSuperficieDelimitadora(
      InfoSuperficieDelimitadora[] infoSuperficieDelimitadora) {
      int size= infoSuperficieDelimitadora.length;
      for(int i=0;i<size;i++){
        infoSuperficieDelimitadora[i]=new InfoSuperficieDelimitadora();
      }

  }

  /**
   *
   * @param _feature Vector
   * @param onde String
   *
   * ==Para Testes==
   * Imprime o vetor de features com alguns dos seus dados, esta nesta classe para
   * poder ser chamada da untitled5 e da untitled3
   */
  public static void imprimeVetorDeFeatures(Vector _feature, String tabulacao) {
    int size = _feature.size();

    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) _feature.elementAt(i);
      System.out.println(tabulacao + "\tFEATURE numero: " + tmp.Ordem);
      System.out.print(tabulacao + "\t\tTipo: ");
      switch (tmp.Tipo) {
        case Feature.FACECONCAVE:
          System.out.println("FaceConcave");
          break;
        case Feature.FACECONVEX:
          System.out.println("FaceConvex");
          break;
        case Feature.FACESTRAIGHT:
          System.out.println("FaceStraight");
          break;
        case Feature.FACETAPERED:
          System.out.println("FaceTapared");
          break;
        case Feature.GROOVE_COMPLEXO:
          System.out.println("GrooveComplexo");
          System.out.println(tabulacao + "\t\t\t Features presentes:");
          GrooveComplexo gTmp = (GrooveComplexo)tmp;
          imprimeVetorDeFeatures(gTmp.features, tabulacao + "\t\t\t");
          break;
        case Feature.ODCONCAVE:
          System.out.println("ODConcave");
          break;
        case Feature.ODCONVEX:
          System.out.println("ODConvex");
          break;
        case Feature.ODSTRAIGHT:
          System.out.println("ODStraight");
          break;
        case Feature.ODTAPERED:
          System.out.println("ODTapered");
          break;
        case Feature.ODCONTOURED:
          System.out.println("ODContoured");
          break;
        case Feature.IDCONCAVE:
          System.out.println("IDConcave");
          break;
        case Feature.IDCONTOURED:
          System.out.println("IDContoured");
          break;
        case Feature.IDCONVEX:
          System.out.println("IDConvex");
          break;
        case Feature.IDSTRAIGHT:
          System.out.println("IDStraight");
          break;
        case Feature.IDTAPERED:
          System.out.println("IDTapered");
          break;
        default:
          System.out.println("Nao colocado no codigo (arrumar): " +
                             tmp.Tipo);
          break;
      }
      System.out.println(tabulacao + "\t\tL1: " + tmp.L1 + "\n" + tabulacao + "\t\tD1: " + tmp.D1 +
                         "\n" + tabulacao + "\t\tD2: " + tmp.D2);
    }
  }


    /**
   *
   * @param _feature Vector
   *
   * ==Para Testes==
   * Imprime o comprimento da peca a partir dos dados do vetor de features
   */
  public static void imprimeTamanho(Vector _feature) {
    int size = _feature.size();
    int tamanho = 0;
    Feature tmp;
    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      tamanho += tmp.L1;
    }
    System.out.println(tamanho);
  }



  /**
   *
   * @param alerta String
   *
   * ==Para Testes==
   * Mostra uma mensagem de alerta com os dados da string que a funcao recebe
   */
  public static void alert(String alerta){
   /*22/09/2005 - Codigo comentado para perimtir a execucao do servlet.*/
    //JOptionPane.showMessageDialog(null, alerta, "Alerta", 2);
  }


  public static Feature copiaFeature(Feature tmp){
    Feature featureInvertida = new Feature();

    //Dados da features
    featureInvertida.ID = tmp.ID;
    featureInvertida.PecaID = tmp.PecaID;
    featureInvertida.ProjetoID = tmp.ProjetoID;
    featureInvertida.Ordem = tmp.Ordem;
    featureInvertida.Nome = tmp.Nome;

  //tolerancias e restries
    featureInvertida.KnurlStraightID = tmp.KnurlStraightID;
    featureInvertida.KnurlDiamondID = tmp.KnurlDiamondID;
    featureInvertida.RugosidadeID = tmp.RugosidadeID;
    featureInvertida.CircularidadeID = tmp.CircularidadeID;
    featureInvertida.ConcentricidadeID = tmp.ConcentricidadeID;
    featureInvertida.CilindricidadeID = tmp.CilindricidadeID;
    featureInvertida.BatimentoCircularID = tmp.BatimentoCircularID;
    featureInvertida.BatimentoPlanoID = tmp.BatimentoPlanoID;
    featureInvertida.BatimentoGlobalID = tmp.BatimentoGlobalID;
    featureInvertida.TDimensionalID = tmp.TDimensionalID;
    featureInvertida.ThreadsID = tmp.ThreadsID;

  //tamnhos...
    featureInvertida.L1 = tmp.L1;
    featureInvertida.D1 = tmp.D1;
    featureInvertida.D2 = tmp.D2;
    featureInvertida.L1Mais = tmp.L1Mais;
    featureInvertida.L1Menos = tmp.L1Menos;
    featureInvertida.D1Mais = tmp.D1Mais;
    featureInvertida.D1Menos = tmp.D1Menos;
    featureInvertida.D2Mais = tmp.D2Mais;
    featureInvertida.D2Menos = tmp.D2Menos;

    featureInvertida.temTolerancia = tmp.temTolerancia;

  //public Vector circularidades;??????????????????????????
  if(tmp.toleranciaCilindricidade != null){
    featureInvertida.toleranciaCilindricidade = new ToleranciaCilindricidade();
    featureInvertida.toleranciaCilindricidade.cilindricidade = tmp.toleranciaCilindricidade.cilindricidade;
  }
  if(tmp.toleranciaCircularidade != null){
    featureInvertida.toleranciaCircularidade = new ToleranciaCircularidade();
    featureInvertida.toleranciaCircularidade.circularidade = tmp.toleranciaCircularidade.circularidade;
    featureInvertida.toleranciaCircularidade.posicao = tmp.toleranciaCircularidade.posicao;
  }
  if(tmp.toleranciaConcentricidade != null){
    featureInvertida.toleranciaConcentricidade = new ToleranciaConcentricidade();
    featureInvertida.toleranciaConcentricidade.concentricidade = tmp.toleranciaConcentricidade.concentricidade;
    featureInvertida.toleranciaConcentricidade.referencia1 = tmp.toleranciaConcentricidade.referencia1;
    featureInvertida.toleranciaConcentricidade.referencia2 = tmp.toleranciaConcentricidade.referencia2;
    featureInvertida.toleranciaConcentricidade.referencia3 = tmp.toleranciaConcentricidade.referencia3;
  }
  if(tmp.toleranciaDesvioCircular != null){
    featureInvertida.toleranciaDesvioCircular = new ToleranciaDesvioCircular();
    featureInvertida.toleranciaDesvioCircular.desvioCircular = tmp.toleranciaDesvioCircular.desvioCircular;
    featureInvertida.toleranciaDesvioCircular.referencia1 = tmp.toleranciaDesvioCircular.referencia1;
    featureInvertida.toleranciaDesvioCircular.referencia2 = tmp.toleranciaDesvioCircular.referencia2;
    featureInvertida.toleranciaDesvioCircular.referencia3 = tmp.toleranciaDesvioCircular.referencia3;
  }
  if(tmp.toleranciaDesvioTotal != null){
    featureInvertida.toleranciaDesvioTotal = new ToleranciaDesvioTotal();
    featureInvertida.toleranciaDesvioTotal.desvioTotal = tmp.toleranciaDesvioTotal.desvioTotal;
    featureInvertida.toleranciaDesvioTotal.referencia1 = tmp.toleranciaDesvioTotal.referencia1;
    featureInvertida.toleranciaDesvioTotal.referencia2 = tmp.toleranciaDesvioTotal.referencia2;
    featureInvertida.toleranciaDesvioTotal.referencia3 = tmp.toleranciaDesvioTotal.referencia3;
  }
  if(tmp.toleranciaFormaContorno != null){
    featureInvertida.toleranciaFormaContorno = new ToleranciaFormaContorno();
    featureInvertida.toleranciaFormaContorno.contorno = tmp.toleranciaFormaContorno.contorno;
  }
  if(tmp.toleranciaFormaSuperficie != null){
    featureInvertida.toleranciaFormaSuperficie = new ToleranciaFormaSuperficie();
    featureInvertida.toleranciaFormaSuperficie.superficie = tmp.toleranciaFormaSuperficie.superficie;
  }
  if(tmp.toleranciaInclinacao != null){
    featureInvertida.toleranciaInclinacao = new ToleranciaInclinacao();
    featureInvertida.toleranciaInclinacao.feature_referencia = tmp.toleranciaInclinacao.feature_referencia;
    featureInvertida.toleranciaInclinacao.inclinacao = tmp.toleranciaInclinacao.inclinacao;
    featureInvertida.toleranciaInclinacao.referencia = tmp.toleranciaInclinacao.referencia;
  }
  if(tmp.toleranciaParalelismo != null){
    featureInvertida.toleranciaParalelismo = new ToleranciaParalelismo();
    featureInvertida.toleranciaParalelismo.paralelismo = tmp.toleranciaParalelismo.paralelismo;
  }
  /*
    public ToleranciaCilindricidade toleranciaCilindricidade;
    public ToleranciaCircularidade toleranciaCircularidade;
    public ToleranciaRetilineidadeSuperficie toleranciaRetilineidadeSuperficie;
    public ToleranciaRetilineidadeEixo toleranciaRetilineidadeEixo;
    public ToleranciaPlanicidade toleranciaPlanicidade;
    public ToleranciaFormaContorno toleranciaFormaContorno;
    public ToleranciaFormaSuperficie toleranciaFormaSuperficie;
    public ToleranciaPosicao toleranciaPosicao;
    public ToleranciaConcentricidade toleranciaConcentricidade;
    public ToleranciaInclinacao toleranciaInclinacao;
    public ToleranciaParalelismo toleranciaParalelismo;
    public ToleranciaPerpendicularidade toleranciaPerpendicularidade;
    public ToleranciaDesvioCircular toleranciaDesvioCircular;
    public ToleranciaDesvioTotal toleranciaDesvioTotal;*/

    featureInvertida.Rugosidade = tmp.Rugosidade;

    featureInvertida.temCilindricidade = tmp.temCilindricidade;
    featureInvertida.temCircularidade = tmp.temCircularidade;
    featureInvertida.temForma_Superficie = tmp.temForma_Superficie;
    featureInvertida.temConcentricidade = tmp.temConcentricidade;
    featureInvertida.temBatimento_Axial = tmp.temBatimento_Axial;
    featureInvertida.temBatimento_Radial = tmp.temBatimento_Radial;
    featureInvertida.temInclinacao = tmp.temInclinacao;
    featureInvertida.temParalelismo = tmp.temParalelismo;
    featureInvertida.temPerpendicularidade = tmp.temPerpendicularidade;
    featureInvertida.temRugosidade = tmp.temRugosidade;

    featureInvertida.referencia = tmp.referencia;





    return featureInvertida;
  }


  /*

  ==->Daqui para baixo estao funcoes que nao sao utilizadas<===

   */


  /**
   *
   * @param fu FeatureDeUsinagem
   * @return int
   * @todo  tem q ver as funcoes direito
   *
   * Retorna um inteiro que representa o ciclo fixo do torno
   */
  public int getCiclo(FeatureDeUsinagem fu){
    switch (fu.tipo){
      case FeatureDeUsinagem.FACE:
        return 72;
      case FeatureDeUsinagem.BLOCO_EXTERNO:
        return 71;
      case FeatureDeUsinagem.RECARTILHADO:
        return 999;
      case FeatureDeUsinagem.ROSCA_EXTERNA:
        return 76;
      case FeatureDeUsinagem.GROOVE_EXTERNO:
        return 75;
      default:
        return 01;
    }
  }

  /*
  private static void CastDeArrayDeInfoFeaturesPorDiametro(InfoFeaturesPorDiametro[] in,InfoFeaturesPorDiametro[] out) {

  }
*/


}
