package webcapp_01_0_1;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JToolBar;
import java.awt.*;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import features.ArmazenadorDeFeatures;
import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.util.Vector;
import javax.swing.tree.DefaultMutableTreeNode;

import util.*;
import featureseixoc.ArmazenadorEixoC;
import webcad_01_0_1.*;

/**
 * <p>Title: CAPP</p>
 *
 * <p>Description: CAPP para o projeto Webmachining</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: GrACo</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class WebCAPPFrame extends JFrame{
  //Frame Principal------------------------------------------------------------
  JPanel jContentPane = null;
  JPanel statusBar = null;
  JDesktopPane desktopPane = null;
  JScrollPane scrollPane = null;
  JInternalFrame projectInternalFrame = null;
  JInternalFrame dosInternalFrame = null;
  JInternalFrame dogInternalFrame = null;
  JInternalFrame dooInternalFrame = null;
  JInternalFrame andOrInternalFrame = null;
  JInternalFrame ncCodeInternalFrame = null;

  JMenuBar menuBar = new JMenuBar();
  JMenu principalMenu = new JMenu();
  JMenuItem openMenuItem = new JMenuItem();
  JMenuItem exitMenuItem = new JMenuItem();
  JMenu editMenu = new JMenu();
  JMenu viewMenu = new JMenu();
  JMenu aboutMenu = new JMenu();
  JMenuItem helpMenuItem = new JMenuItem();
  JToolBar toolBar = null;
  JButton printButton = new JButton();
  JButton openButton = new JButton();
  JButton andOrButton = new JButton();
  JButton ncCodeButton = new JButton();
  JButton projectButton = new JButton();
  //Frame Principal------------------------------------------------------------

  //ProjectInternalFrame-------------------------------------------------------
  BorderLayout borderLayout1 = new BorderLayout();
  JToolBar projectToolBar = new JToolBar();
  JButton dosButton = new JButton();
  JButton diameterButton = new JButton();
  JButton rayButton = new JButton();
  JButton dooButton = new JButton();
  JButton dogButton = new JButton();
  Component separator1 = Box.createHorizontalStrut(8);
  JButton fuButton = new JButton();
  Component separator2 = Box.createHorizontalStrut(8);
  JLabel zoomLabel = new JLabel();
  JTextField zoomField = new JTextField();
  JButton zoomButton = new JButton();
  JScrollPane scrollPaneProject = new JScrollPane();
  DesenhadorDeFeatures desenhadorDeFeatures;
  //ProjectInternalFrame-------------------------------------------------------

  //DosInternalFrame-----------------------------------------------------------
  JTree dosTree = null;
  //DosInternalFrame-----------------------------------------------------------

  //DogInternalFrame-----------------------------------------------------------
  JTree dogTree = null;
  //DogInternalFrame-----------------------------------------------------------

  //DooInternalFrame-----------------------------------------------------------
  JTree dooTree = null;
  //DooInternalFrame-----------------------------------------------------------

  //AndOrInternalFrame---------------------------------------------------------
  //AndOrInternalFrame---------------------------------------------------------

  //NCCodeInternalFrame--------------------------------------------------------
  //NCCodeInternalFrame--------------------------------------------------------

  //Logica---------------------------------------------------------------------
  private WebCAPP _webCAPP;
  private webcad_01_0_1.DadosDoProjeto dadosDoProjeto = null;
  private ArmazenadorDeFeatures armazenadorDeFeatures = null;
  private ArmazenadorEixoC armazenadorEixoC = null;
  private Vector _feature = null;
  private Vector _featureEixoC = null;
  //Logica---------------------------------------------------------------------



  public WebCAPPFrame() {
    try {
      jbInit();
      //this.pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setJMenuBar(menuBar);
    this.setResizable(true);
    this.setTitle("WebCAPP");
    this.setSize(500,500);
    principalMenu.setText("Principal");
    openMenuItem.setText("Open");
    exitMenuItem.setText("Exit");
    editMenu.setText("Edit");
    viewMenu.setText("View");
    aboutMenu.setText("About");
    helpMenuItem.setText("Help");

    menuBar.add(principalMenu);
    menuBar.add(editMenu);
    menuBar.add(viewMenu);
    menuBar.add(aboutMenu);
    principalMenu.add(openMenuItem);
    principalMenu.add(exitMenuItem);
    aboutMenu.add(helpMenuItem);
    this.setContentPane(getJContentPane());
  }

  private JPanel getJContentPane(){
    if (jContentPane == null) {
      jContentPane = new javax.swing.JPanel();
      jContentPane.setLayout(new java.awt.BorderLayout());
      jContentPane.add(getToolBar(), java.awt.BorderLayout.NORTH);
      jContentPane.add(getStatusBar(), java.awt.BorderLayout.SOUTH);
      jContentPane.add(getScrollPane(), java.awt.BorderLayout.CENTER);
    }
    return jContentPane;
  }

  private JToolBar getToolBar(){
    if(toolBar == null){
      toolBar = new JToolBar();

      printButton.setText("Print");
      printButton.addActionListener(new WebCAPPFrame_printButton_actionAdapter(this));
      openButton.setText("Open");
      openButton.addActionListener(new WebCAPPFrame_openButton_actionAdapter(this));
      andOrButton.setText("And-Or");
      andOrButton.setEnabled(false);
      andOrButton.addActionListener(new WebCAPPFrame_andOrButton_actionAdapter(this));
      ncCodeButton.setText("NC Code");
      ncCodeButton.setEnabled(false);
      ncCodeButton.addActionListener(new WebCAPPFrame_ncCodeButton_actionAdapter(this));
      projectButton.setText("Project");
      projectButton.setEnabled(false);
      projectButton.addActionListener(new WebCAPPFrame_projectButton_actionAdapter(this));

      toolBar.add(openButton);
      toolBar.add(printButton);
      toolBar.add(projectButton);
      toolBar.add(ncCodeButton);
      toolBar.add(andOrButton);

      toolBar.setBorder(BorderFactory.createLineBorder(Color.black));
    }
    return toolBar;
  }

  private JPanel getStatusBar(){
    if(statusBar == null){
      statusBar = new JPanel();
      statusBar.setBorder(BorderFactory.createLoweredBevelBorder());
    }

    return statusBar;
  }

  private JScrollPane getScrollPane(){
    if (scrollPane == null) {
            scrollPane = new JScrollPane();
            scrollPane.setBackground(java.awt.Color.white);
            scrollPane.setViewportView(getJDesktopPane());
    }
    return scrollPane;
  }

  private JDesktopPane getJDesktopPane() {
    if (desktopPane == null) {
      desktopPane = new JDesktopPane();
      desktopPane.setBackground(Color.gray);
      desktopPane.setPreferredSize(new Dimension(400, 500));
    }
    return desktopPane;
  }

  public void initProjectInternalFrame(){
    if(projectInternalFrame == null){
      projectInternalFrame = new JInternalFrame();
      projectInternalFrame.setTitle("ProcessosPainel");
      projectInternalFrame.setIconifiable(true);
      projectInternalFrame.setResizable(true);
      projectInternalFrame.setClosable(true);
      projectInternalFrame.setMaximizable(false);
      projectInternalFrame.setBounds(10, 8, 500, 350);
      projectInternalFrame.setVisible(true);
      projectInternalFrame.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
      projectInternalFrame.getContentPane().setLayout(borderLayout1);

      separator2 = Box.createHorizontalStrut(8);
      separator1 = Box.createHorizontalStrut(8);
      dosButton.setBorder(BorderFactory.createEtchedBorder());
      dosButton.setText("DOS");
      dosButton.addActionListener(new
                                  WebCAPPFrame_dosButton_actionAdapter(this));
      diameterButton.setBorder(BorderFactory.createEtchedBorder());
      diameterButton.setText("Diameter");
      rayButton.setBorder(BorderFactory.createEtchedBorder());
      rayButton.setText("Ray");
      dooButton.setBorder(BorderFactory.createEtchedBorder());
      dooButton.setText("DOO");
      dooButton.addActionListener(new
                                  WebCAPPFrame_dooButton_actionAdapter(this));
      dogButton.setBorder(BorderFactory.createEtchedBorder());
      dogButton.setText("DOG");
      dogButton.addActionListener(new
                                  WebCAPPFrame_dogButton_actionAdapter(this));
      fuButton.setBorder(BorderFactory.createEtchedBorder());
      fuButton.setText("Show Fu\'s");
      zoomLabel.setText("Zoom Factor:");
      zoomField.setText("100");
      zoomButton.setBorder(BorderFactory.createEtchedBorder());
      zoomButton.setText("Zoom");
      scrollPaneProject.setBackground(Color.white);
      scrollPaneProject.setAutoscrolls(true);

      projectToolBar.add(rayButton);
      projectToolBar.add(diameterButton);
      projectToolBar.add(fuButton);
      projectToolBar.add(separator1);
      projectToolBar.add(dosButton);
      projectToolBar.add(dogButton);
      projectToolBar.add(dooButton);
      projectToolBar.add(separator2);
      projectToolBar.add(zoomLabel);
      projectToolBar.add(zoomField);
      projectToolBar.add(zoomButton);
      projectInternalFrame.getContentPane().add(projectToolBar, java.awt.BorderLayout.SOUTH);
      projectInternalFrame.getContentPane().add(scrollPaneProject, java.awt.BorderLayout.CENTER);
      desktopPane.add(projectInternalFrame);

      projectButton.setEnabled(true);
      ncCodeButton.setEnabled(true);
      andOrButton.setEnabled(true);

      desenhadorDeFeatures = new DesenhadorDeFeatures(_webCAPP.infoFeature._featureOriginal,
          _webCAPP.decomposicaoOrientadaASetup.superficieDelimitadoraExterna);
      desenhadorDeFeatures.repaint();
      scrollPaneProject.add(desenhadorDeFeatures);
      scrollPaneProject.setSize(desenhadorDeFeatures.getSize());
      scrollPaneProject.setViewportView(desenhadorDeFeatures);


      desenhadorDeFeatures.repaint();

    }
  }

  public void initAndOrInternalFrame(){

  }

  public void initNCCodeInternalFrame(){

  }

  public void initDOSInternalFrame(){
    if(dosInternalFrame == null){
      dosInternalFrame = new JInternalFrame();
      dosInternalFrame.setTitle("DOS");
      dosInternalFrame.setIconifiable(true);
      dosInternalFrame.setResizable(false);
      dosInternalFrame.setClosable(true);
      dosInternalFrame.setMaximizable(false);
      dosInternalFrame.setBounds(10, 8, 500, 350);

      dosInternalFrame.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
      dosInternalFrame.getContentPane().setLayout(borderLayout1);

     // dosPanel = new JPanel();
     dosTree = createDosTree();

   //   dosPanel.add(dosTree);
      dosInternalFrame.getContentPane().add(dosTree, java.awt.BorderLayout.CENTER);
//      dosInternalFrame.setSize(dosTree.);
      desktopPane.add(dosInternalFrame);
      dosInternalFrame.setVisible(true);
    }
  }

  public void initDOGInternalFrame() {
    if (dogInternalFrame == null) {
      dogInternalFrame = new JInternalFrame();
      dogInternalFrame.setTitle("DOG");
      dogInternalFrame.setIconifiable(true);
      dogInternalFrame.setResizable(false);
      dogInternalFrame.setClosable(true);
      dogInternalFrame.setMaximizable(false);
      dogInternalFrame.setBounds(10, 8, 500, 350);

      dogInternalFrame.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
      dogInternalFrame.getContentPane().setLayout(borderLayout1);

      // dosPanel = new JPanel();
      dogTree = createDogTree();

      //   dosPanel.add(dosTree);
      dogInternalFrame.getContentPane().add(dogTree,
                                            java.awt.BorderLayout.CENTER);
  //      dosInternalFrame.setSize(dosTree.);
      desktopPane.add(dogInternalFrame);
      dogInternalFrame.setVisible(true);
    }
  }

  public void initDOOInternalFrame() {

  }

  public JTree createDosTree(){
    /*if(dosTree == null){
      DefaultMutableTreeNode root = new DefaultMutableTreeNode("Decomposicao Orientada A Setup");

      int size = _webCapp2._setup.size();
      for(int i = 0; i < size; i++){
        Setup setupTmp = (Setup)_webCapp2._setup.elementAt(i);
        DefaultMutableTreeNode infoSetupN = new DefaultMutableTreeNode("Setup " + (i+1));

        DefaultMutableTreeNode infoFeatureDeFixacao = new DefaultMutableTreeNode("Feature de Fixacao: " + setupTmp.indiceFeatureDeFixacao);
        infoSetupN.add(infoFeatureDeFixacao);
        if(setupTmp.temExteriror){
          DefaultMutableTreeNode exterior = new DefaultMutableTreeNode("Regiao Externa");

          String tmp = "Vector: ";
          if(setupTmp.vetorExterno) tmp += "_feature";
          else tmp += "_featureInvertido";

          DefaultMutableTreeNode vector = new DefaultMutableTreeNode(tmp);
          DefaultMutableTreeNode inicio = new DefaultMutableTreeNode("Inicio: " + setupTmp.inicioExterno);
          DefaultMutableTreeNode fim = new DefaultMutableTreeNode("Fim: " + setupTmp.fimExterno);

          exterior.add(vector);
          exterior.add(inicio);
          exterior.add(fim);

          infoSetupN.add(exterior);
        }
        if(setupTmp.temInterior){
          DefaultMutableTreeNode interior = new DefaultMutableTreeNode("Regiao Externa");

          String tmp = "Vector: ";
          if(setupTmp.vetorInterno) tmp += "_feature";
          else tmp += "_featureInvertido";

          DefaultMutableTreeNode vector = new DefaultMutableTreeNode(tmp);
          DefaultMutableTreeNode inicio = new DefaultMutableTreeNode("Inicio: " + setupTmp.inicioInterno);
          DefaultMutableTreeNode fim = new DefaultMutableTreeNode("Fim: " + setupTmp.fimInterno);

          interior.add(vector);
          interior.add(inicio);
          interior.add(fim);

          infoSetupN.add(interior);
        }
        root.add(infoSetupN);
      }
      dosTree = new JTree(root);
    }
*/
    return dosTree;
  }

  public JTree createDogTree(){
    if(dogTree == null){
      Vector nodes = new Vector();
      InfoDecomposicaoOrientadaAGeometria infoDOG = _webCAPP.
          decomposicaoOrientadaAGeometria.
          getInfoDecomposicaoOrientadaAGeometria();

      int sizeI = infoDOG.fuDoSetupN.size();
      for(int i = 0; i < sizeI; i++){
        Vector fuDoSetupI = (Vector)infoDOG.fuDoSetupN.elementAt(i);
        DefaultMutableTreeNode setup = new DefaultMutableTreeNode("Setup " + (i+1));

        int sizeJ = fuDoSetupI.size();
        for(int j = 0; j < sizeJ; j++){
          FeatureDeUsinagem fuTmp = (FeatureDeUsinagem)fuDoSetupI.elementAt(j);
          DefaultMutableTreeNode fu = new DefaultMutableTreeNode("Feature de Usinagem " + (j+1));
          fu.add(new DefaultMutableTreeNode("Tipo: " + fuTmp.getTipo()));
          DefaultMutableTreeNode origem = new DefaultMutableTreeNode("Origem");
          origem.add(new DefaultMutableTreeNode("X = " + fuTmp.getOrigem().x));
          origem.add(new DefaultMutableTreeNode("Z = " + fuTmp.getOrigem().z));
          fu.add(origem);

          //DefaultMutableTreeNode features = createFeaturesNode();
          //fu.add(features);
          setup.add(fu);
        }
        nodes.add(setup);
      }
      dogTree = new JTree(nodes);
    }
    return dogTree;
  }

  public void createDooTree() {
    if(dooTree == null){


    }
  }


  public void clearAllInternalFrames(){
    /**
     * @todo se der certo tem q limpar todos os frames internos
     */
  }

  protected boolean openAction() {
    if(_feature != null){//limpar toda a memoria utilizada no momento
      _feature.clear();
    }
    _feature = new Vector();
    FileDialog fd = new FileDialog(this, "Open CAD File");
    fd.show();
    String dir = fd.getDirectory();
    String file = fd.getFile();
    String filepath = dir + file;
    try {
      ObjectInputStream in = new ObjectInputStream(new FileInputStream(filepath));
      //armazenadorDeFeatures = (ArmazenadorDeFeatures) in.readObject();
      this.dadosDoProjeto = (webcad_01_0_1.DadosDoProjeto)in.readObject();
      this.armazenadorDeFeatures = this.dadosDoProjeto.armazenadorDeFeatures;
      if(this.dadosDoProjeto.armazenadorEixoC != null){
        this.armazenadorEixoC = this.dadosDoProjeto.armazenadorEixoC;
        this._featureEixoC = this.armazenadorEixoC.armazenaEixoC;
      }
      this._feature = this.armazenadorDeFeatures.getThis();


      in.close();
      return true;
    }
    catch (Exception ee) {
      ee.printStackTrace();
      return false;
    }
  }

  public void openButton_actionPerformed(ActionEvent e) {
    System.out.println("openButton / openMenuItem");
    if(openAction()){
      boolean abreFeature = true;
      int sizeFeature = _feature.size();
      String erro = "";
// Filtro
/*
      for (int i = 0; i < sizeFeature; i++) {
        Feature tmp = (Feature) _feature.elementAt(i);
        switch (tmp.Tipo) {
          case Feature.FACESTRAIGHT:
            break;
          case Feature.FACECONCAVE:
            break;
          case Feature.FACECONVEX:
            break;
          case Feature.FACETAPERED:
            break;
          case Feature.ODCONCAVE:
            break;
          case Feature.ODCONVEX:
            break;
          case Feature.FACECONTOURED:
            erro += "\nFACECONTOURED";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.FUROBELL:
            erro += "\nFUROBELL";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.FUROPADRAO:
            erro += "\nFUROPADRAO";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVE_FACE_RADIAL:
            erro += "\nGROOVE_FACE_RADIAL";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVE_FACE_SQUARE:
            erro += "\nGROOVE_FACE_SQUARE";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVE_FACE_TAPER:
            erro += "\nGROOVE_FACE_TAPER";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVE_I_HELICAL:
            erro += "\nGROOVE_I_HELICAL";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVE_I_RADIAL:
            erro += "\nGROOVE_I_RADIAL";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVE_I_RELIEF:
            erro += "\nGROOVE_I_RELIEF";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVE_I_SQUARE:
            erro += "\nGROOVE_I_SQUARE";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVE_I_TAPER:
            erro += "\nGROOVE_I_TAPER";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVEHELICAL:
            erro += "\nGROOVEHELICAL";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVERADIAL:
            erro += "\nGROOVERADIAL";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVERELIEF:
            erro += "\nGROOVERELIEF";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVESQUARE:
            erro += "\nGROOVESQUARE";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.GROOVETAPER:
            erro += "\nGROOVETAPER";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.IDCONCAVE:
            erro += "\nIDCONCAVE";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.IDCONTOURED:
            erro += "\nIDCONTOURED";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.IDCONVEX:
            erro += "\nIDCONVEX";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.IDSTRAIGHT:
            erro += "\nIDSTRAIGHT";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.IDTAPERED:
            erro += "\nIDTAPERED";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
            break;
          case Feature.ODCONTOURED:

            //erro += "\nODCONTOURED";
            //       erro += " -> (" + tmp.Ordem + ")";
            //       abreFeature = false;
            break;
          case Feature.ODSTRAIGHT:
            ODStraight tmp2 = (ODStraight) tmp;
            if (tmp2.TemRecartilhado) {
              erro += "\nODSTRAIGHT com Recartilhado";
              erro += " -> (" + tmp.Ordem + ")";
              abreFeature = false;
            }
            if (tmp2.TemRosca || tmp2.rosca != null) {
              MyMath.alert("Esta peca tem rosca num ODStraight");
            }
            break;
          case Feature.ODTAPERED:
            ODTapered tmp3 = (ODTapered) tmp;
            if (tmp3.TemRecartilhado) {
              erro += "\nODTAPERED com Recartilhado";
              erro += " -> (" + tmp.Ordem + ")";
              abreFeature = false;
            }
            if (tmp3.TemRosca) {
              erro += "\nODTAPARED com Rosca";
              erro += " -> (" + tmp.Ordem + ")";
              abreFeature = false;
            }
            break;
          default:
            erro += "\nFeature nao encontrada";
            erro += " -> (" + tmp.Ordem + ") -> Tipo=" + tmp.Tipo;
            abreFeature = false;
            break;
        }
      }
*/
      if (abreFeature == false) {
        MyMath.alert(
            "O arquivo contem features que nao \n podem ser processadas:\n" +
            "Tamanho da peca " + sizeFeature + " features\n" + erro);
      }
      else {
        clearAllInternalFrames();
        this._webCAPP = new WebCAPP(this._feature, this._featureEixoC);
        initProjectInternalFrame();
      }
    }
    else{
      JOptionPane.showMessageDialog(null, "Error while opening the file", "Error", 0);
    }
    //desktopPane.add(new ProjectInternalFrame(this));
    //projectInternalFrame.setVisible(true);
    //criar o internalFrame do projeto
  }

  public void printButton_actionPerformed(ActionEvent e) {
    System.out.println("printButton");
  }


  public void projectButton_actionPerformed(ActionEvent e){
    System.out.println("projectButton");
    if(projectInternalFrame != null){
      if(projectInternalFrame.isVisible()) projectInternalFrame.setVisible(false);
      else projectInternalFrame.setVisible(true);
    }
  }

  public void andOrButton_actionPerformed(ActionEvent e){
    System.out.println("andOrButton");
    if(andOrInternalFrame != null){
      if(andOrInternalFrame.isVisible()) andOrInternalFrame.setVisible(false);
      else andOrInternalFrame.setVisible(true);
    }
    else{
      initAndOrInternalFrame();
    }
  }

  public void ncCodeButton_actionPerformed(ActionEvent e){
    System.out.println("ncCodeButton");
    if(ncCodeInternalFrame != null){
      if(ncCodeInternalFrame.isVisible()) ncCodeInternalFrame.setVisible(false);
      else ncCodeInternalFrame.setVisible(true);
    }
    else{
      initNCCodeInternalFrame();
    }
  }

  public void dosButton_actionPerformed(ActionEvent e) {
    System.out.println("dosButton");
    if(dosInternalFrame == null){
      initDOSInternalFrame();
    }
    if (dosInternalFrame.isVisible()) dosInternalFrame.setVisible(false);
    else dosInternalFrame.setVisible(true);
  }

  public void dogButton_actionPerformed(ActionEvent e) {
    System.out.println("dogButton");
    if(dogInternalFrame == null){
      initDOGInternalFrame();
    }
    if (dogInternalFrame.isVisible()) dogInternalFrame.setVisible(false);
    else dogInternalFrame.setVisible(true);
  }

  public void dooButton_actionPerformed(ActionEvent e) {
    System.out.println("dooButton");
    if (dooInternalFrame == null) {
      initDOOInternalFrame();
    }
    if (dooInternalFrame.isVisible()) dooInternalFrame.setVisible(false);
    else dooInternalFrame.setVisible(true);
  }

}

class WebCAPPFrame_openButton_actionAdapter
    implements ActionListener {
  private WebCAPPFrame adaptee;
  WebCAPPFrame_openButton_actionAdapter(WebCAPPFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.openButton_actionPerformed(e);
  }
}

class WebCAPPFrame_printButton_actionAdapter
    implements ActionListener {
  private WebCAPPFrame adaptee;
  WebCAPPFrame_printButton_actionAdapter(WebCAPPFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.printButton_actionPerformed(e);
  }
}

class WebCAPPFrame_projectButton_actionAdapter
    implements ActionListener {
  private WebCAPPFrame adaptee;
  WebCAPPFrame_projectButton_actionAdapter(WebCAPPFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.projectButton_actionPerformed(e);
  }
}

class WebCAPPFrame_andOrButton_actionAdapter
    implements ActionListener {
  private WebCAPPFrame adaptee;
  WebCAPPFrame_andOrButton_actionAdapter(WebCAPPFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.andOrButton_actionPerformed(e);
  }
}

class WebCAPPFrame_ncCodeButton_actionAdapter
    implements ActionListener {
  private WebCAPPFrame adaptee;
  WebCAPPFrame_ncCodeButton_actionAdapter(WebCAPPFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.ncCodeButton_actionPerformed(e);
  }
}

class WebCAPPFrame_dosButton_actionAdapter
    implements ActionListener {
  private WebCAPPFrame adaptee;
  WebCAPPFrame_dosButton_actionAdapter(WebCAPPFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.dosButton_actionPerformed(e);
  }
}

class WebCAPPFrame_dogButton_actionAdapter
    implements ActionListener {
  private WebCAPPFrame adaptee;
  WebCAPPFrame_dogButton_actionAdapter(WebCAPPFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.dogButton_actionPerformed(e);
  }
}

class WebCAPPFrame_dooButton_actionAdapter
    implements ActionListener {
  private WebCAPPFrame adaptee;
  WebCAPPFrame_dooButton_actionAdapter(WebCAPPFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.dooButton_actionPerformed(e);
  }
}
