package webcapp_01_0_1;

import java.beans.XMLEncoder;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.*;
import java.beans.XMLDecoder;
import java.util.Vector;
import pontos.Ponto2D;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class XMLcomunicator {
  public XMLcomunicator() {
  }

  /**
   * XML2Java
   *
   * @return objeto Object
   * @param local String
   */
  public Object XML2Java(String local) {
    Object objeto;
    XMLDecoder d = null;
    try {
      d = new XMLDecoder(
          new BufferedInputStream(
          new FileInputStream(local)));
    }
    catch (FileNotFoundException ex) {
    }
    objeto =  d.readObject();
    return objeto;
  }

  /**
   * Java2XML
   *
   * @param objeto Object
   * @param local String
   */
  public void Java2XML(Object objeto, String local) {
    XMLEncoder e = null;
    try {
      e = new XMLEncoder(
          new BufferedOutputStream(
          new FileOutputStream(local)));
    }
    catch (FileNotFoundException ex) {
    }
    e.writeObject(objeto);
    e.close();
  }
  /**
   *
   * @param infoDOO InfoDecomposicaoOrientadaAOperacao
   * @return String
   */
  static final String XMLDecomposicaoOrientadaAOperacao(
   InfoDecomposicaoOrientadaAOperacao infoDOO,String codigoTxT) {
String out = "";
 Vector setupN = infoDOO.setupN;

 out+="<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
 out+="<?xml-stylesheet type='text/xsl' href='tst_template003.xsl'?>\n";

 out+="<setupN property=\"Vector\">\n";
 int sizeI = setupN.size();
 for(int i = 0; i < sizeI; i++){
   out+="<setup property=\"Vector\">\n";
   Vector tmp = (Vector)setupN.elementAt(i);
   int sizeJ = tmp.size();
   for(int j = 0; j < sizeJ; j++){
     out+="<Workingstep property=\"Workingstep\">\n";
     Workingstep wsTmp = (Workingstep)tmp.elementAt(j);
     FeatureDeUsinagem featureDoWorkingstep= wsTmp.featureDoWorkingstep;
     out+="<featureDoWorkingstep property=\"FeatureDeUsinagem\">\n";
     out+="<_featuresDaFU property=\"Vector\">\n";
     out+="</_featuresDaFU>\n";
     Ponto2D origem= featureDoWorkingstep.origem;
     out+="<origem property=\"Ponto2D\">\n";

     out+="<x property=\"double\">\n";
     double x = origem.x;
     out+=""+x+"\n";
     out+="</x>\n";
     out+="<z property=\"double\">\n";
     double z = origem.z;
     out+=""+z+"\n";
     out+="</z>\n";
     out+="</origem>\n";
     out+="<tipo property=\"int\">";
     int tipo = featureDoWorkingstep.tipo;
     out+=""+tipo+"\n";
     out+="</tipo>\n";
     out+="</featureDoWorkingstep>\n";
     out+="<operacaoDeUsinagem property=\"OperacaoDeUsinagem[]\">\n";
     OperacaoDeUsinagem[] operacaoDeUsinagem = wsTmp.operacaoDeUsinagem ;
     OperacaoDeUsinagem operacaoDeUsinagem0 = operacaoDeUsinagem[0];

     out+="<tipo property=\"int\">\n";
     //int
     tipo= operacaoDeUsinagem0.tipo;
     out+=""+tipo+"\n";
     out+="</tipo>\n";
     out+="<ferramentaUtilizada property=\"FerramentaUtilizada[]\">\n";
     FerramentaUtilizada[] ferramentaUtilizada = operacaoDeUsinagem0.ferramentaUtilizada ;
     FerramentaUtilizada ferramentaUtilizada0 = ferramentaUtilizada[0];
     out+="<ferramenta property=\"Ferramenta\">\n";
     Ferramenta ferramenta = ferramentaUtilizada0.ferramenta ;
     out+="</ferramenta>\n";
     out+="<numDaMagazine property=\"int\">\n";
     int numDaMagazine = ferramentaUtilizada0.numDaMagazine;
     out+=""+numDaMagazine+"\n";
     out+="</numDaMagazine>\n";
     out+="<numDeCompensacao property=\"int\">\n";
     int numDeCompensacao = ferramentaUtilizada0.numDeCompensacao;
     out+=""+numDeCompensacao+"\n";
     out+="</numDeCompensacao>\n";
     out+="<descricao property=\"String\">\n";
     String descricao = ferramentaUtilizada0.descricao;
     out+=""+descricao+"\n";
     out+="</descricao>\n";
     out+="</ferramentaUtilizada>\n";
     /**/
     out+="<tecnologiaDeUsinagem property=\"TecnologiaDeUsinagem\">\n";
     TecnologiaDeUsinagem tecnologiaDeUsinagem = operacaoDeUsinagem0.tecnologiaDeUsinagem;
     out+="<F property=\"double\">\n";
     out+=""+tecnologiaDeUsinagem.F+"\n";
     out+="</F>\n";
     out+="<Vc property=\"double\">\n";
     out+=""+tecnologiaDeUsinagem.Vc+"\n";
     out+="</Vc>\n";
     out+="<Ap property=\"double\">\n";
     out+=""+tecnologiaDeUsinagem.Ap+"\n";
     out+="</Ap>\n";
     out+="<numeroDePasses property=\"int\">\n";
     out+=""+tecnologiaDeUsinagem.numeroDePasses+"\n";
     out+="</numeroDePasses>\n";
     out+="<fluidoDeCorte property=\"boolean\">\n";
     out+=""+tecnologiaDeUsinagem.fluidoDeCorte+"\n";
     out+="</fluidoDeCorte>\n";
     out+="</tecnologiaDeUsinagem>\n";
     /***/
     out+="</operacaoDeUsinagem>\n";
     /**/
     out+="<ciclo property=\"int\">\n";
     out+=""+wsTmp.ciclo+"\n";
     out+="</ciclo>\n";
     out+="<planoDeSeguranca property=\"Ponto2D\">\n";
     Ponto2D planoDeSeguranca = wsTmp.planoDeSeguranca;
     out+="<x property=\"double\">\n";
     out+=""+planoDeSeguranca.x+"\n";
     out+="</x>\n";
     out+="<z property=\"double\">\n";
     out+=""+planoDeSeguranca.z+"\n";
     out+="</z>\n";
     out+="</planoDeSeguranca>\n";
     out+="<planoDeAproximacao property=\"Ponto2D\">\n";
     Ponto2D planoDeAproximacao = wsTmp.planoDeAproximacao;
     out+="<x property=\"double\">\n";
     out+=""+planoDeAproximacao.x+"\n";
     out+="</x>\n";
     out+="<z property=\"double\">\n";
     out+=""+planoDeAproximacao.z+"\n";
     out+="</z>\n";
     out+="</planoDeAproximacao>\n";

     out+="</Workingstep>\n";
   }
   out+="</setup>\n";
 }
 out+="<codigoG>";
 out+=codigoTxT ;
 out+="</codigoG>";
 out+="</setupN>\n";
 System.out.println("##############################################");
 System.out.println(out);
 System.out.println("##############################################");
 return out;
}
  static final void geraArquivo(String filepath, String texto) {
    String path;
   if (System.getProperty("os.name").startsWith("Windows")){
      path = "C:\\CAPP\\" + filepath;
   }else{
      path = "/srv/www/htdocs/CAPP/" + filepath;
    }
     try {
       java.io.FileWriter out = new FileWriter(path, false);
       out.write(texto);
       out.flush();
       out.close();
     }
     catch (Exception ee) {
      ee.printStackTrace();
      //      MessageBox b = new MessageBox("Save file error <" + file + "> " +
      //                                    ee.toString(), getFrame());
    }
  }
static final String codigoGTXTparaXML(String entrada){
  StringBuffer saida= new StringBuffer();

  saida.append("<LINHA><N>");
  saida.append(entrada.replaceAll("\n","</N></LINHA><LINHA><N>"));
  saida.append("</N></LINHA>");
  return saida.toString();
}
}
